package com.arsdigita.acs;

/**
 * Goes through and instantiates a bunch of classes to ensure that static
 * initializers are executed.  Must be a servlet so that it can be executed
 * at start-up, AFTER Parameters servlet is executed.  
 * 
 * NOTE: To ensure that Parameters is loaded first, the load-on-startup tag
 * in web.xml for Parameters must contain a lower value than for 
 * ModuleInitializer.
 */

import java.util.Enumeration;
import javax.servlet.*;
import javax.servlet.http.*;

public class ModuleInitializer extends HttpServlet { 
    public void init() throws ServletException {
	Enumeration e = Parameters.getInitClasses();
	while (e.hasMoreElements()) { 
	    String className = (String)e.nextElement(); 
	    try {
		Class.forName(className) ;
	    } catch (ClassNotFoundException ex) { 
		throw new ServletException("Error loading class: " + ex.getMessage());
	    }
	}
    }
}
