package com.arsdigita.acs;

import java.util.Vector;
import javax.servlet.jsp.*;

/**
 * When thrown, this exception is trapped by the error page 
 * where a human-readable message is displayed to the end-user's web
 * browser.
 */
public class PageValidationException extends JspTagException {
    private Vector complaints;

    public Vector getComplaints() {
	return complaints;
    }

    private static String asHtml(Vector complaints) {
	StringBuffer buf = new StringBuffer();
	buf.append("<ul>\n");
	int len = complaints.size();
	for (int i = 0; i < len; i++) {
	    String complaint = (String) complaints.elementAt(i);
	    buf.append("<li>" + complaint + "\n");
	}
	buf.append("</ul>");
	return buf.toString();
    }

    /**
     * Builds an exception out of a list of complaints.
     */
    public PageValidationException(Vector complaints) {
	super(asHtml(complaints));
	this.complaints = complaints;
    }

  public PageValidationException(String complaint) {
    super("<ul>\n" + complaint + "</ul>");
    Vector complaints = new Vector(1);
    complaints.add("<ul>\n" + complaint + "</ul>");
    this.complaints = complaints;
  }
}
