package com.arsdigita.acs;

import com.arsdigita.acs.db.*;
import java.sql.*;

class Permissions {

    private Database db;

    public Permissions() throws SQLException {
	db = new Database();
    }

    protected void finalize() throws Throwable {
	db.close();
    }

    public boolean userHasPermission(Integer userId, String permissionType, String onWhatId, String onWhichTable) 
	throws SQLException, ACSException {
	if (userId.intValue() == 0) {
	    return allUsersHavePermission(permissionType, onWhatId, onWhichTable);
	} else {
	    Object[] bind = new Object[4];
	    bind[0] = userId;
	    bind[1] = permissionType;
	    bind[2] = onWhatId;
	    bind[3] = onWhichTable;
	    String result = db.queryToString("select decode(ad_general_permissions.user_has_row_permission_p(?, ?, ?, ?), 't', 1, 0) from dual", bind);
	    return result.equals("1");
	}
    }

    public boolean allUsersHavePermission(String permissionType, String onWhatId, String onWhichTable) 
	throws SQLException, ACSException {
	Object[] bind = new Object[3];
	bind[0] = permissionType;
	bind[1] = onWhatId;
	bind[2] = onWhichTable;
	String hasPermission = db.queryToString("select decode(ad_general_permissions.all_users_permission_id(?, ?, ?), 0, 0, 1) from dual", bind);
	return hasPermission.equals("1");
    }
}
