package com.arsdigita.acs;

/**
 * Utility class for associating a record with a Runnable object
 * <p>
 * Typical usage is similar to Thread:
 * <pre>
 *  <code>ScheduledProcedure sp = new ScheduledProcedure() {
 *          public void run() {
 *              // do something
 *          } 
 *        };
 *  </code>
 * 
 * @author Bill Schneider (bschneid@arsdigita.com)
 * @see com.arsdigita.acs.Scheduler
 * @version $Version$
 */ 
abstract class ScheduledProcedure implements Runnable { 
    // package-visible instance variables
    boolean recurring; // run periodically? 
    long initialDelay; // how long before first execution?
    long period;       // time between executions in ms
    long nextTime;     // system time when we run next
    int  id;           // id number of this scheduled procedure, used 
                       // for unscheduling
}
