package com.arsdigita.acs.calendar;

import com.arsdigita.acs.UserInfo;

/**
 * Simple data-storage class for calendar info.
 *
 * TODO: add get/set methods, consider merging this into one proper "Calendar" class since this is not at all O-O, or else use "calendarParam" like PortalsParam is using.
 */
public class CalendarInfo {
    private static final Integer zero = new Integer(0);

    public UserInfo loggedInUser = null;
    public Integer viewedUserId = null;
    public String currentDate = null;
    public String prettyCurrentDate = null;
    public String type = null;
    public String groupName = null;
    public String prettyName = null;
    public boolean groupMemberP = false;
    public boolean groupAdminP = false;
    public Integer groupId = null;
    public String currentView = null;

    /**
     * "t" or "f".
     */
    public String compressDayViewP = null; 

    public String newItemsAge = null;

    public String title = null;

    public String viewMode = null;
    public String viewModeVar = null;
    public String action = null;
    public String addLink = null;
    public String currentViewLink = null;
    public String dayLink = null;  

  /**
   * Get the value of currentView.
   * @return value of currentView.
   */
  public String getCurrentView() {
    return currentView;
  }
  
  /**
   * Set the value of currentView.
   * @param v  Value to assign to currentView.
   */
  public void setCurrentView(String  v) {
    
    this.currentView = v;
  }
  

  /**
   * Get the value of groupId.
   * @return value of groupId.
   */
  public Integer getGroupId() {
    return groupId;
  }
  
  /**
   * Set the value of groupId.
   * @param v  Value to assign to groupId.
   */
  public void setGroupId(Integer  v) {
    
    this.groupId = v;
  }
  

  /**
   * Get the value of groupAdminP.
   * @return value of groupAdminP.
   */
  public boolean isGroupAdminP() {
    return groupAdminP;
  }
  
  /**
   * Set the value of groupAdminP.
   * @param v  Value to assign to groupAdminP.
   */
  public void setGroupAdminP(boolean  v) {
    
    this.groupAdminP = v;
  }
  

  /**
   * Get the value of groupMemberP.
   * @return value of groupMemberP.
   */
  public boolean isGroupMemberP() {
    return groupMemberP;
  }
  
  /**
   * Set the value of groupMemberP.
   * @param v  Value to assign to groupMemberP.
   */
  public void setGroupMemberP(boolean  v) {
    
    this.groupMemberP = v;
  }
  

  /**
   * Get the value of prettyName.
   * @return value of prettyName.
   */
  public String getPrettyName() {
    return prettyName;
  }
  
  /**
   * Set the value of prettyName.
   * @param v  Value to assign to prettyName.
   */
  public void setPrettyName(String  v) {
    
    this.prettyName = v;
  }
  

  /**
   * Get the value of groupName.
   * @return value of groupName.
   */
  public String getGroupName() {
    return groupName;
  }
  
  /**
   * Set the value of groupName.
   * @param v  Value to assign to groupName.
   */
  public void setGroupName(String  v) {
    
    this.groupName = v;
  }
  

  /**
   * Get the value of type.
   * @return value of type.
   */
  public String getType() {
    return type;
  }
  
  /**
   * Set the value of type.
   * @param v  Value to assign to type.
   */
  public void setType(String  v) {
    
    this.type = v;
  }
  

  /**
   * Get the value of prettyCurrentDate.
   * @return value of prettyCurrentDate.
   */
  public String getPrettyCurrentDate() {
    return prettyCurrentDate;
  }
  
  /**
   * Set the value of prettyCurrentDate.
   * @param v  Value to assign to prettyCurrentDate.
   */
  public void setPrettyCurrentDate(String  v) {
    
    this.prettyCurrentDate = v;
  }
  

  /**
   * Get the value of currentDate.
   * @return value of currentDate.
   */
  public String getCurrentDate() {
    return currentDate;
  }
  
  /**
   * Set the value of currentDate.
   * @param v  Value to assign to currentDate.
   */
  public void setCurrentDate(String  v) {
    
    this.currentDate = v;
  }
  

  /**
   * Get the value of compressDayViewP (t or f).
   * @return value of compressDayViewP.
   */
  public String getCompressDayViewP() {
    return compressDayViewP;
  }
  
  /**
   * Set the value of compressDayViewP (t or f).
   * @param v  Value to assign to compressDayViewP.
   */
  public void setCompressDayViewP(String  v) {
    
    this.compressDayViewP = v;
  }
  

  /**
   * Get the value of newItemsAge.
   * @return value of newItemsAge.
   */
  public String getNewItemsAge() {
    return newItemsAge;
  }
  
  /**
   * Set the value of newItemsAge.
   * @param v  Value to assign to newItemsAge.
   */
  public void setNewItemsAge(String  v) {
    
    this.newItemsAge = v;
  }
  

  /**
   * Get the value of title.
   * @return value of title.
   */
  public String getTitle() {
    return title;
  }
  
  /**
   * Set the value of title.
   * @param v  Value to assign to title.
   */
  public void setTitle(String  v) {
    
    this.title = v;
  }
  
  /**
   * Get the value of viewModeVar.
   * @return value of viewModeVar.
   */
  public String getViewModeVar() {
    return viewModeVar;
  }
  
  /**
   * Set the value of viewModeVar.
   * @param v  Value to assign to viewModeVar.
   */
  public void setViewModeVar(String  v) {
    
    this.viewModeVar = v;
  }
  
  /**
   * Get the value of action.
   * @return value of action.
   */
  public String getAction() {
    return action;
  }
  
  /**
   * Set the value of action.
   * @param v  Value to assign to action.
   */
  public void setAction(String  v) {
    
    this.action = v;
  }
  
  /**
   * Get the value of addLink.
   * @return value of addLink.
   */
  public String getAddLink() {
    return addLink;
  }
  
  /**
   * Set the value of addLink.
   * @param v  Value to assign to addLink.
   */
  public void setAddLink(String  v) {
    
    this.addLink = v;
  }
  

  /**
   * Get the value of viewMode.
   * @return value of viewMode.
   */
  public String getViewMode() {
    return viewMode;
  }
  
  /**
   * Set the value of viewMode.
   * @param v  Value to assign to viewMode.
   */
  public void setViewMode(String  v) {
    
    this.viewMode = v;
  }
  

  /**
   * Get the value of currentViewLink.
   * @return value of currentViewLink.
   */
  public String getCurrentViewLink() {
    return currentViewLink;
  }
  
  /**
   * Set the value of currentViewLink.
   * @param v  Value to assign to currentViewLink.
   */
  public void setCurrentViewLink(String  v) {
    
    this.currentViewLink = v;
  }
  

  /**
   * Get the value of loggedInUser.
   * @return value of loggedInUser.
   */
  public UserInfo getLoggedInUser() {
    return loggedInUser;
  }
  
  /**
   * Set the value of loggedInUser.
   * @param v  Value to assign to loggedInUser.
   */
  public void setLoggedInUser(UserInfo  v) {
    
    this.loggedInUser = v;
  }

  /**
   * Get the value of dayLink.
   * @return value of dayLink.
   */
  public String getDayLink() {
    return dayLink;
  }
  
  /**
   * Set the value of dayLink.
   * @param v  Value to assign to dayLink.
   */
  public void setDayLink(String  v) {
    
    this.dayLink = v;
  }

  /**
   * Get the value of loggedInUserId, or 0 if there is no logged in user.
   * @return value of loggedInUser or 0, as an Integer so it can be bound.
   */
  public Integer getLoggedInUserIdOr0() {
      if (loggedInUser != null) {
	  return loggedInUser.getUserId();
      } else {
	  return zero;
      }
  }  

  /**
   * Gets viewed user id.
   * There is supposed to be a distinction between viewed user id and logged in user id, but this
   * is not strictly enforced right now.
   */
  public Integer getViewedUserId() {
    return viewedUserId;
  }

  /**
   * Sets viewed user id.
   * There is supposed to be a distinction between viewed user id and logged in user id, but this
   * is not strictly enforced right now.
   */  
  public void setViewedUserId(Integer v) {
    this.viewedUserId = v;
  }

  public String toString() {
    return ("CalendarInfo: user=" + loggedInUser + ", date=" + currentDate + ", prettyDate=" + prettyCurrentDate + ", type=" + type + ", groupName=" + groupName + ", prettyName=" + prettyName + ", groupMemberP=" + groupMemberP + ", groupAdminP=" + groupAdminP + ", groupId=" + groupId + ", currentView=" + currentView + ", compressDayViewP=" + compressDayViewP + ", newItemsAge=" + newItemsAge + ", title=" + title + ", viewMode=" + viewMode + ", viewModeVar=" + viewModeVar + ", action=" + action + ", addLink=" + addLink + ", currentViewLink=" + currentViewLink + ", dayLink=" + dayLink);
  }
}

