package com.arsdigita.acs.chat;
import com.arsdigita.acs.*;
import com.arsdigita.acs.db.*;
import java.sql.*;
import java.io.IOException;

public class ChatRoom extends SingleSelection {

    ChatRoom(ResultSet rs) throws IOException, SQLException {
        super(rs);
    }

    public String getRoomId() throws DataSourceException {
        return get("room_id");
    }

    public String getName() throws DataSourceException {
        return get("pretty_name");
    }

    public boolean isModerated() throws DataSourceException {
        return get("moderated_p").equals("t");
    }

    public boolean isPrivate() throws DataSourceException {
        return !Utilities.emptyString(get("group_id"));
    }

    public String getGroupId() throws DataSourceException {
        return get("group_id");
    }
}
