package com.arsdigita.acs.db;

import java.sql.*;

/**
 * Wrapper class for SQLException, has extra info about the offending query.

 * @author jbank@arsdigita.com
 * @version $Version$
 */

public class SQLExceptionWrapper extends SQLException {
    String query;
    Object bind[];
    SQLException sqle;

    public SQLExceptionWrapper(SQLException sqle, String query, Object[] bind) {
        this.sqle = sqle;
        this.bind = bind;
        this.query = query;
    }

    public SQLExceptionWrapper(SQLException sqle, String query) {
        this(sqle, query, null);
    }

    public String getMessage() {
        String base_mess = sqle.getMessage();
        if (query != null) {
            base_mess += "\n\t" + query + "\n";
        }
        if (bind != null) {
            for (int i = 0; i<bind.length; i++) {
                base_mess += "\n\tBind " + i + "=" + bind[i];
            }
            base_mess += "\n";
        }
        return base_mess;
    }

    public String getSQLState() {
        return sqle.getSQLState();
    }
    public int getErrorCode() {
        return sqle.getErrorCode();
    }

    public SQLException getNextException() {
        return sqle.getNextException();
    }

    public void setNextException(SQLException ex) {
        sqle.setNextException(ex);
    }
}
