package com.arsdigita.acs.fs;

import com.arsdigita.acs.db.*;
import com.arsdigita.acs.*;
import java.sql.*;
import java.util.*;

/**
 * Represents a single version of a file in the file storage module.
 *
 * @author Bill Schneider
 * @version $Version$
 *
 */

public class StoredFileVersion {
    private Integer versionId;
    private String description;
    private String clientFileName;
    private int nKbytes;
    private int nBytes;
    private String creatorName;
    private String creationDate;
    private String fileType;
    private Integer authorId;
    private boolean canRead, canWrite, canAdminister;

    public StoredFileVersion(ResultSet rs) throws SQLException {
	versionId = new Integer(rs.getInt("version_id"));
	description = rs.getString("version_description");
	clientFileName = rs.getString("client_file_name");
	nKbytes = rs.getInt("n_kbytes");
	nBytes = rs.getInt("n_bytes");
	creatorName = rs.getString("creator_name");
	creationDate = rs.getString("pretty_creation_date");
	fileType = rs.getString("file_type");
	authorId = new Integer(rs.getInt("author_id"));
	canRead = (rs.getInt("read_p") > 0);
	canWrite = (rs.getInt("write_p") > 0);
	canAdminister = (rs.getInt("administer_p") > 0);
	
    }

    public int getKbytes() { return nKbytes; }
    public int getBytes() { return nBytes; }
    public String getCreatorName() { return creatorName; }
    public String getCreationDate() { return creationDate; }
    public String getFileType() { return fileType; }
    public Integer getAuthorId() { return authorId; }
    public boolean getReadable() { return canRead; }
    public boolean getWritable() { return canWrite; }
    public boolean getAdminable() { return canAdminister; }
    public String  getDescription() { return description; }
    public String  getClientFileName() { return clientFileName; }
    public Integer getVersionId() { return versionId; }
}


