package com.arsdigita.acs.generalcomments;

import com.arsdigita.acs.*;
import com.arsdigita.acs.db.*;
import java.sql.*;

public class GeneralCommentsDataSource extends Selection {

    public GeneralCommentsDataSource(SqlStatement sql, Database db) throws SQLException {
	super(sql, db);
    }

    public GeneralCommentsDataSource(ResultSet rs) throws SQLException {
	super(rs);
    }
    
    public String getDate(int time_format) throws DataSourceException {
	switch (time_format) {
	case GeneralComments.MODIFIED_LONG:
	    return "on " + get("pretty_modified_long");
	case GeneralComments.MODIFIED_TIME:
	    return "(" + get("pretty_modified_time") + ")";
	case GeneralComments.MODIFIED_DATE:
	    return "(" + get("pretty_modified_date") + ")";
	default:
	    return "";
	}
    }

    public int getInt(String column) throws DataSourceException, SQLException {
	return rs.getInt(column);
	// why should we have to re-implement this here in our sub-class I wonder?
    }

    public boolean getBoolean(String column) throws DataSourceException, SQLException {
	return get(column).toLowerCase().equals("t");
	// why should we have to re-implement this here in our sub-class I wonder?
    }

}

