package com.arsdigita.acs.html;

/**
 * implements an HTML choice bar
 */

public class ChoiceBar {

    String[] choices;
    String[] urls;
    String[] keys;
    String def;


    /** 
     * returns a new HTML line of links, with the currently selected 
     * link (indicated by keys[i] == def) in bold and not linked..
     */
    public ChoiceBar(String[] choices, 
		     String[] urls,
		     String[] keys,
		     String def) {
	if (choices.length != urls.length || keys.length != urls.length) {
	    throw new IllegalArgumentException("ChoiceBar: all arrays must be same length");
	}
	this.choices = choices;
	this.urls = urls;
	this.keys = keys;
	this.def = def;
    }

    public String toString() { 
	StringBuffer sb = new StringBuffer();
	for (int i = 0; i < choices.length; i++) { 
	    if (keys[i].equals(def)) { 
		sb.append("<b>");
	    } else {
		sb.append("<a href=\"");
		sb.append(urls[i]);
		sb.append("\">");
	    }
	    sb.append(choices[i]);
	    if (keys[i].equals(def)) { 
		sb.append("</b>");
	    } else {
		sb.append("</a>");
	    }
	    if (i < choices.length - 1) { 
		sb.append(" | ");
	    }
	}
	return sb.toString();
    }
}
	

    
