package com.arsdigita.acs.news;

import com.arsdigita.acs.*;
import com.arsdigita.acs.db.*;
import java.sql.*;
import org.apache.turbine.util.Log;


public class NewsDataSource extends Selection {

    
    public NewsDataSource(SqlStatement sql, Database db) throws SQLException {
	super(sql, db);
    }

    public NewsDataSource(ResultSet rs) throws SQLException {
	super(rs);
    }
    
    /*
      If this is not an archive show the body of the first 3 stories shorter
      than 300 characters.
      first parameter is the counter from the loop
      sec
     
     */
    public String getNewsItemForIndexList(int counter, String archive_p) 
	throws DataSourceException {
	if ( (archive_p == null || archive_p.equals("0")) &&
	     counter <=3 && get("body").length() < 300 &&
	     get("n_comments").equals("0") ) 
	    {
                String comment_html = "";
                if ( Parameters.getBoolean("SolicitCommentsP","news",true) ) {
                    try {
                    AdSet as = new AdSet(new Object[][] { {"on_which_table","news_items" },
                                                          {"on_what_id",get("news_item_id") },
                                                          {"item",get("title") },
                                                          {"module","news" },
                                                          {"return_url","/news/" } } );
                    comment_html = "<br><br><a href=\"/general-comments/comment-add?"+Utilities.exportURLVars(as)+"\">comment</a>";
                    } catch (Exception e) {
                        Log.note("getNewsItemForIndexList: " + e.getMessage());
                    }
                
                }
		return "<blockquote>" + get("body") + comment_html + "</blockquote>";
	    } else {
		return "<a href=item?news_item_id=" + get("news_item_id") + ">"
		    + get("title") + "</a>";
	    }
    }
    public String getBody() throws DataSourceException {
	if (get("html_p").equals("1")) {
	    return Utilities.textToHtml(get("body"));
	} else 
	    return get("body");
    } 
    
}
