package com.arsdigita.acs.search;

import java.util.Vector;
import java.sql.*;
import com.arsdigita.acs.*;
import com.arsdigita.acs.db.Database;
import javax.servlet.http.*;

/**
 * Utility classes and procedural abstractions for site wide search.
 * 
 * @author Joseph Bank (jbank@arsdigita.com)
 * @version $Id: Search.java,v 1.2 2000/10/11 22:24:56 jbank Exp $
 */

public class Search {

    public static boolean isAuthorized(UserInfo user) {
        //xxxx FIXME to use imUserIsAuthorized(user);
        return false;
    }

    public static String siteWideSearchWidget(UserInfo user, String query) throws SQLException {
        Database db = new Database();
        boolean isAuthorized = isAuthorized(user); 
        
        String sql_query = "select table_name from sws_properties ";
        if (!isAuthorized) {
            sql_query += " where public_p = 't'";
        }
        sql_query += " order by section_name";

        StringBuffer widget = new StringBuffer();
        widget.append("<form method=get action=\"/search/search\">\n");

        Vector tables = db.queryToList(sql_query, null);
        for (int i = 0; i<tables.size(); i++) {
            widget.append("<input type=hidden name=sections value=\"");
            widget.append((String)tables.elementAt(i));
            widget.append("\">\n");
        }
        widget.append("<input type=text size=20 name=query_string value=\"").append(query);
        widget.append("\"> <input type=submit value=\"Go\"></form>");
        return widget.toString();
    }

    public static String[] returnValidTables(UserInfo user, String[] sections) {
        /* FIXME: Filter for tables based on authorization. */
        return sections;
    }


    private static final String[] results = { "20", "50", "100", "200", "all" };
    public static String showNumResultsBar(String num_results, String display, String query_string, String sections_string) {
        StringBuffer widget = new StringBuffer();
        widget.append("Show [");
        for (int i = 0; i<results.length; i++) {
            if (i > 0) {
                widget.append(" | ");
            }
            if (num_results.equals(results[i])) {
                widget.append(results[i]);
            } else {
                widget.append("<a href=\"search?query_string=");
                widget.append(Utilities.URLEncode(query_string));
                widget.append(sections_string);
                widget.append("&rows=");
                widget.append(results[i]);
                widget.append("\">");
                widget.append(results[i]);
                widget.append("</a>");
            }
        }
        widget.append(" ]");
        if (display.equals("by_section")) {
            widget.append(" results per section.");
        } else {
            widget.append(" results per page.");
        }
        return widget.toString();
    }

    public static void recordQueryString(String query_string, String subsection, int n_results, UserInfo user) throws SQLException {
        Database db = new Database();
        Integer user_id = null;
        if ( user != null ) {
            user_id = user.getUserId();
        }
        db.dml("insert into query_strings (query_date, query_string, subsection, n_results, user_id) values " +
               "(sysdate, :query_string, :subsection, :n_results, :user_id)",
               new Object[] { query_string, subsection, new Integer(n_results), user_id });
    }
}
