package com.arsdigita.acs.search;

import com.arsdigita.acs.*;
import com.arsdigita.acs.db.*;
import java.sql.*;

public class SearchDataSource extends Selection {

    private int counter = 0;
    private int nRows;
    private boolean canDisplayMore = false;

    public SearchDataSource(SqlStatement sql, Database db, int nRows) throws SQLException {
	super(sql, db);
        this.nRows = nRows;
    }

    public SearchDataSource(ResultSet rs, int nRows) throws SQLException {
	super(rs);
	this.nRows = nRows;
    }

    public boolean next() throws DataSourceException {
	if (counter >= nRows) {
	    try {
		rs.close();
	    } catch (SQLException e) {
		throw new DataSourceException(e.getMessage());
	    }
	    return false;
	} else {
	    counter++;
	    return super.next();
	}	
    }

    public String getUserUrlStub() {
	try {
	    return rs.getString("user_url_stub");
	} catch (Exception e) {
	    return null;
	}
    }

    public String getTheKey() {
	try {
	    return rs.getString("the_key");
	} catch (Exception e) {
	    return null;
	}
    }

    public String getOneLineDescription() {
	try {
	    return rs.getString("one_line_description");
	} catch (Exception e) {
	    return null;
	}
    }

    public String getSectionName() {
	try {
	    return rs.getString("section_name");
	} catch (Exception e) {
	    return null;
	}
    }

}
