package com.arsdigita.acs.tags;

import com.arsdigita.acs.*;
import javax.servlet.jsp.*;
import javax.servlet.jsp.tagext.*;
import java.sql.*;

public class BindTag
    extends BodyTagSupport
    implements BodyTag
{
    private SqlTag sqltag; // enclosing SQL statement
    private String value;
    private String name; // for named binds

    private String var; 
    // for pulling value directly out of pageContext
    // attributes: rather than <ad:db_bind><%= var %></ad:db_bind>, 
    // allow <ad:db_bind var="var"/> instead, assuming var was passed
    // in through page_contract or is otherwise a pageContext attribute

    public int doStartTag() throws JspException {
	// Make sure we're within some sort of Sql statement.
	sqltag = (SqlTag) findAncestorWithClass(this, com.arsdigita.acs.tags.SqlTag.class);
	if (sqltag == null) {
	    throw new JspTagException("db_bind must be within a SQL statement");
	}

	value = null;

	// see if the name of a pageContext attribute was passed in
	if (var != null) { 
	    Object o = pageContext.getAttribute(var);
	    value = o==null? null: o.toString();
	    // already have a value, no need to evaluate body
	    return SKIP_BODY;
	}
	
	return EVAL_BODY_TAG;
    }

    public int doAfterBody() throws JspException {
	value = getBodyContent().getString();
	return SKIP_BODY;
    }

    public int doEndTag() throws JspException {
	if (name != null) 
	    sqltag.bind(name, value);
	else 
	    sqltag.bind(value);
	return EVAL_PAGE;
    }

    public void setName(String s) {
	name = s;
    }
    
    public void setVar(String s) { 
	var = s;
    }
}
