package com.arsdigita.acs.tags;

import com.arsdigita.acs.*;
import javax.servlet.jsp.*;
import javax.servlet.jsp.tagext.*;
import java.sql.*;

/**
 * Tag for instantating data source objects.
 */

public class DataSourceTag
    extends TagSupport
    implements Tag {
    
    private String className;
    private ResultSet rs;

    public int doStartTag() throws JspTagException {
	if (className == null) {
	    className = "com.arsdigita.acs.Selection";
	}
	String id = this.getId();
	try {
	    Class c = Class.forName(className); 
	    java.lang.reflect.Constructor cstr = 
		c.getConstructor(new Class[] { rs.getClass() });
	    Object o = cstr.newInstance(new Object[] {rs});
	    pageContext.setAttribute(id, o);
	} catch (Exception e) { 
	    throw new JspTagException("DataSourceTag: threw exception: " + e.getMessage());
	}
	return SKIP_BODY;
    }

    public void setClass(String s) { 
	className = s;
    }
 
    public void setRs(ResultSet rs) { 
	this.rs = rs;
    }
}

    

