package com.arsdigita.acs.tags;

import com.arsdigita.acs.*;
import javax.servlet.jsp.*;
import javax.servlet.jsp.tagext.*;
import java.sql.*;
import java.io.*;


public class DbStringTag
    extends SqlTag
    implements BodyTag
{
    private String default_value;
    private String obj;

    public int doAfterBody() throws JspException {
	sql.setSql(getBodyContent().getString());
	return SKIP_BODY;
    }
    
    public int doEndTag() throws JspException {
	JspWriter out = pageContext.getOut();
	
	try {
	    ResultSet rs = db.query(sql);
	    if (obj !=null) {
		String obj_value = new String();
		if (! rs.next()) {
		    if (default_value != null) {
			obj_value = default_value;
		    } else {
			throw new JspTagException("db_string failed to return a row for query: " + sql.getSql());
		    }
		} else {
		    obj_value=rs.getString(1);
		}
		if (obj_value != null) { 
		    pageContext.setAttribute(obj, obj_value);
		    pageContext.getRequest().setAttribute(obj, obj_value);
		}
	    } else  {
		if (! rs.next()) {
		    if (default_value != null) {
			out.print(default_value);
		    } else {
			throw new JspTagException("db_string failed to return a row for query: " + sql.getSql());
		    }
		} else {
		    out.print(rs.getString(1));
		}
	    }
	    rs.close();
	} catch (SQLException e) {
	    throw new JspTagException("db_string failed with database error for SQL '" + sql + "': " + e.getMessage());
	} catch (IOException e) {
	    throw new JspTagException("db_string failed while attempting to write to output: " + e.getMessage());
	}
	
	return EVAL_PAGE;
    }

    public void setDefault(String s) {
	default_value = s;
    }
    public void setObj(String s) {
	obj = s;
    }
}
