package com.arsdigita.acs.tags;

import javax.servlet.jsp.*;
import javax.servlet.jsp.tagext.*;
import java.sql.*;
import java.io.*;
import com.arsdigita.acs.*;

public class ExportTag
    extends TagSupport
    implements Tag
{
    private String type;
    private String vars;
    private DataSource ds;
    private ResultSet rs;
    private AdSet set;

    public void setType(String s) throws JspException {
	if (!"form".equals(s) && !"url".equals(s)) {
	    throw new JspTagException("type argument to export tag must be 'form' or 'url'");
	}
	type = s;
    }

    public void setVars(String s) {
	vars = s;
    }

    public void setSource(String s) throws JspException {
	Object o = pageContext.getAttribute(s);
	if (o instanceof com.arsdigita.acs.DataSource) {
	    ds = (DataSource) o;
	} else if (o instanceof java.sql.ResultSet) {
	    rs = (ResultSet) o;
	} else if (o instanceof com.arsdigita.acs.AdSet) {
	    set = (AdSet) o;
	} else {
            if (o == null) {
                throw new JspTagException("source argument to export tag is null; source= " + s);
            }
	    throw new JspTagException("source argument to export tag must be of type DataSource, ResultSet, or AdSet; received " + o.getClass().getName());
	}
    }

    public int doStartTag() throws JspException {
	try {
	    if ("form".equals(type)) {
		if (ds != null) {
		    pageContext.getOut().print(Utilities.exportFormVars(ds, vars));
		} else if (rs != null) { 
		    pageContext.getOut().print(Utilities.exportFormVars(rs, vars));
		} else {
		    pageContext.getOut().print(Utilities.exportFormVars(set));
		}
	    } else if ("url".equals(type)) {
		if (ds != null) {
		    pageContext.getOut().print(Utilities.exportURLVars(ds, vars));
		} else if (rs != null) { 
		    pageContext.getOut().print(Utilities.exportURLVars(rs, vars));
		} else {
		    pageContext.getOut().print(Utilities.exportURLVars(set));
		}
	    }
	} catch (IOException e) {
	    throw new JspTagException("export tag caught IOException while attempting to write out result");
	}
	return SKIP_BODY;
    }
}
