package com.arsdigita.acs.tags;

import javax.servlet.*;
import javax.servlet.jsp.*;
import javax.servlet.jsp.tagext.*;
import java.io.*;
import com.arsdigita.acs.*;

public class GetUserInfoTag
    extends TagSupport
    implements Tag
{
    private boolean redirect = true;
    
    public int doStartTag() {
	return SKIP_BODY;
    }

    public int doEndTag() throws JspException {
	String id = getId();
	try {
	    UserInfo user = Security.getVerifiedUserInfo(pageContext, redirect);
	    if (user == null && redirect) {
		return SKIP_PAGE;
	    }
	    if (user != null) {
		pageContext.setAttribute(id, user);
	    }
	} catch (IOException e) {
	    throw new JspTagException("get_user_info caught IOException while attempting to redirect for registration: " + e.getMessage());
	}
	return EVAL_PAGE;
    }

    public void setRedirect(String r) {
	redirect = new Boolean(r).booleanValue();
    }
}
