package com.arsdigita.acs.tags;

import javax.servlet.jsp.*;
import javax.servlet.jsp.tagext.*;
import javax.servlet.http.HttpServletRequest;
import com.arsdigita.acs.db.Database;
import com.arsdigita.acs.Parameters;
import com.arsdigita.acs.*;
import java.sql.*;

public class PageTag
    extends TagSupport
    implements Tag
{
    private Database db;
    private Parameters parameters;

    public int doStartTag() throws JspException {
	try {
	    db = new Database();
	    pageContext.setAttribute("db", db);
	    pageContext.getRequest().setAttribute("db", db);
	    parameters = new Parameters();
	    pageContext.setAttribute("parameters",parameters);

	    // set up form variables for use by pageContract
	    HttpServletRequest request = (HttpServletRequest) pageContext.getRequest();
	    try {
		AdSet form = new AdSet(request);
		pageContext.setAttribute("form", form);
		request.setAttribute("form", form);
	    } catch (Exception e) {
		pageContext.setAttribute("form", null);
		request.setAttribute("form", null);
		pageContext.getServletContext().log("Error parsing form variables: " + e.getMessage());
	    }

	    
	} catch (SQLException e) {
	    throw new JspTagException("Couldn't grab database connection: " + e.getMessage());
	}
	return EVAL_BODY_INCLUDE;
    }

    public int doEndTag() throws JspException {
	try {
	    db.close();
	    pageContext.removeAttribute("db");
	    pageContext.getRequest().removeAttribute("db");
	    db = null;
	} catch (SQLException e) {
	    throw new JspTagException("Couldn't release database connection: " + e.getMessage());
	}
	return EVAL_PAGE;
    }

    public Database getDatabase() {
	return db;
    }
}
