package com.arsdigita.acs.tags;

import com.arsdigita.acs.*;
import com.arsdigita.acs.db.*;
import javax.servlet.jsp.*;
import javax.servlet.jsp.tagext.*;
import java.sql.*;
import java.io.*;

public class QueryTag
    extends SqlTag
    implements BodyTag

{
    private String obj;
    private String type;

    public int doAfterBody() throws JspException {
	sql.setSql(getBodyContent().getString());
	return SKIP_BODY;
    }
    
    public int doEndTag() throws JspException {
	sql.bindFixup();
	String id = getId();
	
	if (obj != null) {
	    try { 
		Database db = (Database)pageContext.getAttribute("db");
		Selection sel;
		if (type == null) { 
		    sel = new Selection(sql, db);
		} else {
		    java.lang.reflect.Constructor cstr = 
			Class.forName(type).getConstructor(new Class[] {
			    com.arsdigita.acs.db.SqlStatement.class,
			    com.arsdigita.acs.db.Database.class
			});
		    sel = (Selection)cstr.newInstance(new Object[] {sql, db});
		}
		// cover all our bases
		pageContext.setAttribute(obj, sel);
		pageContext.getRequest().setAttribute(obj, sel);
	    }
	    catch (Exception e) { 
		e.printStackTrace();
		throw new JspException(e.toString() + ": " + e.getMessage());
	    }
	}
	return EVAL_PAGE;
    }

    public void setObj(String s) {
	obj = s;
    } 

    public void setType(String s) { 
	type = s;
    }
}
