package com.arsdigita.acs.tags;

import com.arsdigita.acs.*;
import com.arsdigita.acs.db.*;
import javax.servlet.jsp.*;
import javax.servlet.jsp.tagext.*;
import java.sql.*;
import java.util.Vector;

public abstract class SqlTag 
    extends BodyTagSupport
    implements BodyTag
{
    protected Database db;
    protected SqlStatement sql;

    public int doStartTag() throws JspException {
	PageTag page = (PageTag) findAncestorWithClass(this, com.arsdigita.acs.tags.PageTag.class);
	if (page == null) {
	    throw new JspTagException("SQL tag must be enclosed within a page tag");
	}
	db = page.getDatabase();
	sql = new SqlStatement();
	if (getId() != null) { 
	    pageContext.setAttribute(getId(), sql);
	}
	return EVAL_BODY_TAG;
    }

    public void bind(Object value) { 
	sql.bind(value);
    } 

    public void bind(String name, Object value) { 
	sql.bind(name, value);
    } 
}
