package com.arsdigita.acs.tags;

import java.util.*;
import javax.servlet.*;
import javax.servlet.jsp.*;
import javax.servlet.jsp.tagext.*;
import javax.servlet.http.*;
import com.arsdigita.acs.db.Database;
import com.arsdigita.acs.*;

public class TemplateContractTag
    extends TagSupport
    implements Tag
{
    private String vars;
    private Vector complaints = new Vector();

    public void setVars(String s) {
	vars = s;
    }

    public void addComplaint(String s) {
	complaints.addElement(s);
    }

    public int doStartTag() throws JspException {
	complaints.clear();

	String id = getId();
	if (id != null) {
	    pageContext.setAttribute(getId(), this);
	}

	// Get the names of the variables to create.
	Vector varDescs = TemplateContractTagExtraInfo.parseVars(vars);

	ServletRequest request = pageContext.getRequest();
	Enumeration e = varDescs.elements();
	while (e.hasMoreElements()) {
	    ContractVarDesc varDesc = (ContractVarDesc) e.nextElement();
	    
	    // Get value of this attribute from request.
	    Object value = request.getAttribute(varDesc.getName());
	    if (value == null) {
		// Not specified; let's see if it's optional.
		if (! varDesc.isOptional()) {
		    addComplaint("required parameter " + varDesc.getName() + " not supplied");
		}
	    }

	    // Record the value in the page context.
	    if (value != null) {
		pageContext.setAttribute(varDesc.getName(), value);
	    }
	}
	return EVAL_BODY_INCLUDE;
    }

    public int doEndTag() throws JspException {
	if (complaints.size() > 0) {
	    // There were validation errors. Report them
	    // by throwing an exception.
	    
	    // but first free up the database handle
	    Database db = (Database)pageContext.getAttribute("db");
	    try {
		db.close();
	    } catch(Exception e) { }
	    throw new PageValidationException(complaints);
	}
	return EVAL_PAGE;
    }
}
