package com.arsdigita.acs.tags;

import com.arsdigita.acs.*;
import com.arsdigita.acs.db.*;
import javax.servlet.jsp.*;
import javax.servlet.jsp.tagext.*;
import java.sql.*;

public class TransactionTag
    extends TagSupport
    implements Tag
{
    private Database db;

    public int doStartTag() throws JspException {
	PageTag page = (PageTag) findAncestorWithClass(this, com.arsdigita.acs.tags.PageTag.class);
	if (page == null) {
	    throw new JspTagException("db_transaction tag must be enclosed within a page tag");
	}
	db = page.getDatabase();
	try {
	    if (db.inTransaction()) {
		// Nested transactions not allowed.		
		throw new JspTagException("db_transaction called while already in a transaction");
	    }
	    db.beginTransaction();
	} catch (SQLException e) {
	    throw new JspTagException("db_transaction failed attempting to enter transaction: " + e.getMessage());
	}
	return EVAL_BODY_INCLUDE;
    }

    public int doEndTag() throws JspException {
	try {
	    db.endTransaction();
	} catch (SQLException e) {
	    throw new JspTagException("db_transaction failed attempting to exit transaction: " + e.getMessage());
	}

	return EVAL_PAGE;
    }
}
