package com.arsdigita.acs.ug;

import com.arsdigita.acs.*;
import com.arsdigita.acs.db.*;

/**
 * Record that describes a piece of data stored about groups that are 
 * in a certain group type.
 * 
 * @version $Version$
 * @author Bill Schneider (bschneid@arsdigita.com)
 */

public class GroupField extends Selection {

    public GroupField(SqlStatement sql, Database db) throws java.sql.SQLException {
	super(sql, db);
    }

    public String getColumnName() { 
	try {
	    return get("column_name"); 
	} catch (DataSourceException e) {
	    return null;
	}
    }

    public String getPrettyName() { 
	try {
	    return get("pretty_name"); 
	} catch (DataSourceException e) {
	    return null;
	}
    }

    public String getColumnType() { 
	try {
	    return get("column_type"); 
	} catch (DataSourceException e) {
	    return null;
	}
    }

    public String getColumnActualType() { 
	try {
	    return get("column_actual_type"); 
	} catch (DataSourceException e) {
	    return null;
	}
    }

    public String getColumnExtra() { 
	try {
	    return get("column_extra"); 
	} catch (DataSourceException e) {
	    return null;
	}
    }

    public String getSortKey() { 
	try {
	    return get("sort_key"); 
	} catch (DataSourceException e) {
	    return null;
	}
    }
}

