package com.arsdigita.acs.ug;

import com.arsdigita.acs.*;
import com.arsdigita.acs.db.*;
import com.oroinc.text.perl.*;
import java.sql.*;
import org.apache.turbine.util.Log;


/** 
 * Utility class for sending out a spam for a group id.
 */

public class GroupSpam { 
    
    /** 
     * Sends a spam message out of the group_spam_history table
     * to a set of users specified in that same table.
     * @param spam_id the id of the spam to send
     */
    public static int sendSpam(Integer spam_id) 
    throws Exception {
	Database db = null; 
	int actualReceivers = 0;
	try {
	    db = new Database() ;
	    Log.note("++++++++++ executing GroupSpam.sendSpam(" + spam_id + ")  ++++++++++");
	    // create a Pertl5Util for regexps
	    Perl5Util re = new Perl5Util();
	    final String query = 
		"select group_id, sender_id, from_address, subject, " + 
		"  body, send_to " + 
		"from group_spam_history " + 
		"where spam_id = :spam_id" + 
		" and approved_p = 't'" + 
		" and send_date is null";
	    ResultSet rs = db.query(query, new Object[] {spam_id});
	    if (!rs.next()) { 
		db.close();
		Log.note("sendSpam : no spam to send");
		return 0;
	    }
	    SingleSelection spam = new SingleSelection(rs);

	    rs = db.query("select group_name, admin_email " + 
			  "from user_groups " + 
			  "where group_id = ?",
			  new Object[] {rs.getString("group_id")});
	    rs.next();
	    SingleSelection group = new SingleSelection(rs);

	    String role_clause;
	    if (spam.get("send_to").equals("all")) {
		role_clause = "";
	    } else {
		role_clause = "ug.role='" + spam.get("send_to") + "'";
	    }

	    final String usersQuery = 
		"select distinct u.email as receiver_email, " + 
		"u.user_id as receiver_id , " + 
		"u.first_names as receiver_first_names, " +
		"u.last_name as receiver_last_name " + 
		"   from user_group_map ug, users_spammable u " +
		"   where ug.group_id = :group_id " + 
		role_clause + 
		"     and ug.user_id = u.user_id " + 
		"     and not exists ( select 1  " + 
		"                       from group_member_email_preferences" +
		"                       where group_id = :group_id " +
		"                          and user_id =  u.user_id " + 
		"                          and dont_spam_me_p = 't') " +
		"     and not exists ( select 1  " + 
		"                        from user_user_bozo_filter " +
		"                        where origin_user_id = u.user_id " + 
		" 	                  and target_user_id =  :sender_id)";
	    rs = db.query(usersQuery, 
			  new Object[] {
			      spam.get("group_id"),
			      spam.get("group_id"),
			      spam.get("sender_id")
			  });
	    // query sets email for each recipient

	    // strip cr's
	    String body = re.substitute("s@\\015@@g", spam.get("body"));

	    // loop over recipients
	    while (rs.next()) { 
		String  message_body = body;

		// This appends group-wide removal blurb
		// append message_body $group_spam_removal_string 
		
		// This appends site-wide bozo-filter blurb,
		//  so, the receiver doesn't get any more email from sender
		// append message_body "[bozo_filter_blurb $sender_id]"

		// substitute all user/group specific data in the message body
		message_body = re.substitute("s#<first_names>#" + rs.getString("receiver_first_names") + "#g", message_body);
		message_body = re.substitute("s#<last_name>#" + rs.getString("receiver_last_name") + "#g", message_body);
		message_body = re.substitute("s#<email>#" + rs.getString("receiver_email") + "#g", message_body);
		message_body = re.substitute("s#<group_name>#" + group.get("group_name") + "#g", message_body);
		message_body = re.substitute("s#<admin_email>#" + group.get("admin_email") + "#g", message_body);
		Utilities.sendMail(rs.getString("receiver_email"),
				   spam.get("from_address"),
				   spam.get("subject"),
				   message_body);
		actualReceivers++;
	    } // while 

	    // Log that the emails went out

	    db.dml("update group_spam_history " + 
		   "set n_receivers_actual=:n_receivers_actual, " +
		   "  send_date = sysdate " +
		   "  where spam_id = :spam_id ", 
		   new Object[] {new Integer(actualReceivers), spam_id});
	    
	    Log.note("sendSpam: finished sending group spam id " + spam_id);
	    return actualReceivers;
	}
	finally { 
	    db.close();
	}
    }
}
	    
