package com.arsdigita.acs.ug;

import com.arsdigita.acs.*;
import com.arsdigita.acs.db.*;

/**
 * Record that describes a piece of data stored about users who are members
 * in a particular group or group type.
 * 
 * @version $Version$
 * @author Bill Schneider (bschneid@arsdigita.com)
 */

public class MemberField extends Selection {

    public MemberField(SqlStatement sql, Database db) throws java.sql.SQLException {
	super (sql, db);
    }

    public String getFieldName() { 
	try {
	    return get("field_name"); 
	} catch (DataSourceException e) { 
	    return null;
	}
    }

    public String getFieldType() { 
	try {
	    return get("field_type"); 
	} catch (DataSourceException e) { 
	    return null;
	}
    }

    public String getSortKey() { 
	try {
	    return get("sort_key"); 
	} catch (DataSourceException e) { 
	    return null;
	}
    }
}
