package com.arsdigita.acs.ug;

import java.sql.*;
import java.util.*;
import com.arsdigita.acs.*;
import com.arsdigita.acs.db.*;

/** 
 * Represents a user group type. (e.g., administration, intranet, events)
 * 
 * @version $Version$
 */

public class SingleGroupTypeDataSource extends GroupTypeDataSource {

    Hashtable props; 

    public SingleGroupTypeDataSource (ResultSet rs) throws SQLException {
	super(rs);
	try {
	    props = freeze();
	} catch(java.io.IOException e) { 
	    props = new Hashtable();
	}
    }

    public SingleGroupTypeDataSource (String groupType) {
	props = new Hashtable();
	props.put ("group_type", groupType);
    }

    public String get(String key) throws DataSourceException {
	Object o = props.get(key);
	if (o == null)
	    throw new InvalidKeyException("Message does not contain field '" + key + "'");
	else 
	    return o.toString();
    }

    public boolean next() {
	return false;
    }

    public String[] keys() {
	Enumeration e = props.keys();
	Vector v = new Vector();
	while (e.hasMoreElements()) 
	    v.addElement(e.nextElement());
	String[] retval = new String[v.size()];
	v.copyInto(retval);
	return retval;
    }

    public boolean contains(String key) { 
	return (props.get(key) != null);
    }
}
    



