package org.apache.turbine.tools.torque;

import java.io.*;

import org.xml.sax.SAXException;
import org.apache.xalan.xslt.XSLTProcessorFactory;
import org.apache.xalan.xslt.XSLTInputSource;
import org.apache.xalan.xslt.XSLTResultTarget;
import org.apache.xalan.xslt.XSLTProcessor;

/**
 * Simple sample code to show how to run the XSL processor
 * from the API.
 */
public class XMLSchemaToHTML
{
    public static void main(String[] args) throws java.io.IOException, java.net.MalformedURLException, org.xml.sax.SAXException
    {
        // Have the XSLTProcessorFactory obtain a interface to a
        // new XSLTProcessor object.
        XSLTProcessor processor = XSLTProcessorFactory.getProcessor();

        // Have the XSLTProcessor processor object transform "foo.xml" to
        // System.out, using the XSLT instructions found in "foo.xsl".
	   
	   XSLTInputSource xmlSchema = new XSLTInputSource(args[0]);
	   XSLTInputSource transform = new XSLTInputSource(args[1]);
        
	   FileOutputStream fos = null;
	   
	   try
	   {
	       fos = new FileOutputStream(args[2]);
	   }
	   catch (IOException ioe)
	   {
	       System.out.println(ioe);
		  ioe.printStackTrace();
	   }
	   
        XSLTResultTarget target = new  XSLTResultTarget(fos);
        
	   processor.process(xmlSchema, transform, target);
	                     
    }
}
