package org.apache.turbine.util;

import java.util.*;

/**
A message class for holding information about message that relates to a 
specific form and field. Used together with FormMessages class.

@author <a href="mailto:neeme@one.lv">Neeme Praks</a>
@version $Id: FormMessage.java,v 1.1 2000/08/30 21:08:47 bschneid Exp $
*/
public class FormMessage
{
    private String message;
    private String formName;
    private Vector fieldNames;

    public FormMessage()
    {
        fieldNames = new Vector();
    }

    public FormMessage( String formName )
    {
        this();
        setFormName(formName);
    }

    public FormMessage( String formName, String fieldName )
    {
        this(formName);
        setFieldName(fieldName);
    }

    public FormMessage( String formName, String fieldName, String message)
    {
        this(formName, fieldName);
        setMessage(message);
    }

    public String getMessage()
    {
        return message;
    }

    public String getFormName()
    {
        return formName;
    }
    
    public String[] getFieldNames()
    {
        String[] result = new String[fieldNames.size()];
        fieldNames.copyInto(result);
        return result;
    }

    public void setMessage(String message)
    {
        this.message = message;
    }
    
    public void setFormName(String formName)
    {
        this.formName = formName;
    }
    
    public void setFieldName(String fieldName)
    {
        fieldNames.addElement( fieldName );
    }
}