package org.apache.turbine.util;

import java.util.*;
import java.io.*;

/**
Used for wrapping system errors (exceptions) that may occur in the application. 

@author <a href="mailto:neeme@one.lv">Neeme Praks</a>
@version $Id: SystemError.java,v 1.1 2000/08/30 21:08:49 bschneid Exp $
*/
public class SystemError
{
    private Exception e;
    private String message;

    public SystemError( Exception e)
    {
        setMessage(e.getMessage());
        setException(e);
    }
    public SystemError( Exception e, String message )
    {
        this(e);
        setMessage(message);
    }
    public SystemError( Exception e, long returncode )
    {
        this( e, new Long(returncode).toString() );
    }

    public String getMessage()
    {
        return message;
    }

    public void setMessage(String message)
    {
        this.message = message;
    }

    public Exception getException()
    {
        return e;
    }

    public void setException(Exception e)
    {
        this.e = e;
    }

    public String getStackTrace()
    {
        if (e != null)
        {
            ByteArrayOutputStream out = new ByteArrayOutputStream();
            e.printStackTrace( new PrintWriter(out,true) );
            return out.toString();
        }
        else 
            return "";
    }
}