<%
/*
# /www/admin/bboard/add-new-topic-2.tcl
ad_page_contract {
    Processes the new topic.

    @param topic the name of the new topic
    @param user_id_from_search the ID of the maintainer
    @param presentation_type the type of bboard (threaded, Q&A, etc)
    @param moderation_policy how the bboard is moderated
    @param notify_of_new_postings_p is the maintainer notified of all postings?
    @param group_id Group with which to associate this topic

    $cvs-id $Id: add-new-topic-2.jsp,v 1.3 2000/10/16 18:53:10 bschneid Exp $
*/
%>

<%@ include file="../../acs.jspi" %>

<ad:page>
<ad:get_user_info id="user"/>

<% 
if (!user.isSiteWideAdmin()) {
     throw new ForbiddenException("Not Site-Wide Admin", 
	"You must be a site-wide admin to view this page.");
 } 

ContextBar navbar = new ContextBar(ContextBar.ADMIN, user);
navbar.add("index", "BBoard Hyper-Administration");
navbar.add("Add Topic");
request.setAttribute("navbar", navbar);
%>

<ad:page_contract id="pc" vars="topic user_id_from_search:integer,notnull presentation_type moderation_policy notify_of_new_postings_p">
<%
if (topic.indexOf("\"") >= 0) {
    pc.addComplaint("Your topic name can't include string quotes.  It makes life too difficult for this collection of software.");
}

if (topic.length() == 0) { 
    pc.addComplaint("You must supply a topic name.");
}

String already_p =  db.queryToString("select count(*) from bboard_topics where topic = :topic", new Object[] {topic});
if (!already_p.equals("0")) {
    pc.addComplaint("There is already a discussion group named " + topic + " in the database.  If you think you are the owner of that group, you can go to its <a href=\"/bboard/admin-home?topic=" + Utilities.URLEncode(topic) + "\">admin page</a>.");
}
%>
</ad:page_contract>

<%
String extra_columns = "";
String extra_values = "";
String group_report = "";

String topic_id = db.queryToString("select bboard_topic_id_sequence.nextval from dual"); 
%>

<ad:db_query id="topic_insert">
    insert into bboard_topics 
    (topic_id,topic,primary_maintainer_id,presentation_type,
     moderation_policy,notify_of_new_postings_p)
    values
    (:topic_id,:topic,:user_id_from_search,:presentation_type,
     :moderation_policy,:notify_of_new_postings_p)
<ad:db_bind><%= topic_id %></ad:db_bind>
<ad:db_bind><%= topic %></ad:db_bind>
<ad:db_bind><%= user_id_from_search %></ad:db_bind>
<ad:db_bind><%= presentation_type %></ad:db_bind>
<ad:db_bind><%= moderation_policy %></ad:db_bind>
<ad:db_bind><%= notify_of_new_postings_p %></ad:db_bind>
</ad:db_query>



<ad:db_transaction>
<%
    db.dml(topic_insert);

    // create the administration group for this topic
    UserGroups.adminGroupAdd
     (db,
      "Administration Group for " + topic + " BBoard",
      "administration-group-for-" + topic.toLowerCase().replace(' ', '-') + "-bboard",
      "bboard", 
      topic_id,
      "/bboard/admin-home?" + Utilities.exportURLVars(request, "topic topic_id"));

    // add the current user as an administrator
    UserGroups.adminGroupAddUser(db, user_id_from_search, "administrator", "bboard", topic_id, user.getUserId().toString(), request.getRemoteAddr());


%>

<ad:header>Topic Added</ad:header>

<h2>Topic Added</h2>

There is now a discussion group for "<%= topic %>" in 
<a href="/bboard/index"><%= BBoard.getSystemName() %></a>

<hr>
Visit the <a href=/bboard/admin-home?topic=<%= Utilities.URLEncode(topic) %>&topic_id=<%= topic_id %>>admin page</a>
for <%= topic %>.
<p>

<%= group_report %>

<ad:footer/>

