<%
/*
# /www/admin/bboard/administrator-delete.tcl
ad_page_contract {
    Page to add an administrator to a bboard topic

    @param topic the name of the bboard topic
    @param topic_id the ID of the bboard topic
    @param admin_group_id the ID of the group associated with the topic
    @param user_id_from_search the ID of the user to remove
*/
%>

<%@ include file="../../acs.jspi" %>
<ad:page>
<ad:page_contract vars="topic topic_id:integer admin_group_id:integer user_id_from_search:integer"/>

<ad:get_user_info id="user"/>

<% 
if (!user.isSiteWideAdmin()) {
     throw new ForbiddenException("Not Site-Wide Admin", 
	"You must be a site-wide admin to view this page.");
 } 
%>

<ad:db_query id="add">
 insert into user_group_map 
   select :group_id, :user_id, 'administrator', sysdate, :mapping_user, 
   :ip 
   from dual
   where not exists (select 1 from user_group_map 
          where group_id = :group_id
	  and user_id = :user_id)
<ad:db_bind><%= admin_group_id %></ad:db_bind>
<ad:db_bind><%= user_id_from_search %></ad:db_bind>
<ad:db_bind><%= user.getUserId() %></ad:db_bind>
<ad:db_bind><%= request.getRemoteAddr() %></ad:db_bind>
<ad:db_bind><%= admin_group_id %></ad:db_bind>
<ad:db_bind><%= user_id_from_search %></ad:db_bind>
</ad:db_query>

<%
db.dml (add);

response.sendRedirect("topic-administrators?" + 
   Utilities.exportURLVars(request, "topic topic_id"));
%>