<%
/*
# /www/admin/bboard/topic-administrators.tcl
ad_page_contract {
    Displays the administrators for one bboard topic
    
    @param topic the name of the bboard topic
    @param topic_id the ID of the bboard topic

    @cvs-id $Id: topic-administrators.jsp,v 1.2 2000/09/26 18:42:22 bschneid Exp $
*/
%>

<%@ include file="../../acs.jspi" %>

<ad:page>
<ad:page_contract vars="topic topic_id:integer"/>

<ad:get_user_info id="user"/>

<% 
if (!user.isSiteWideAdmin()) {
     throw new ForbiddenException("Not Site-Wide Admin", 
	"You must be a site-wide admin to view this page.");
 } 

ContextBar navbar = new ContextBar(ContextBar.ADMIN, user);
navbar.add("index", "BBoard Hyper-Administration");
navbar.add("administer?topic=" + Utilities.URLEncode(topic), "One BBoard");
navbar.add("Administrators");
request.setAttribute("navbar", navbar);
%>

<ad:db_1row id="primary_maintainer_info" obj="primary_maintainer">
select users.user_id, first_names, last_name from
bboard_topics, users
where bboard_topics.primary_maintainer_id = users.user_id
and topic = :topic
<ad:db_bind><%= topic %></ad:db_bind>
</ad:db_1row>

<%
String admin_group_id = UserGroups.getAdminGroupId(db, "bboard", topic_id.toString());
request.setAttribute("admin_group_id", admin_group_id);
request.setAttribute("topic", new SingleTopicDataSource(db, topic_id));

if (Utilities.emptyString(admin_group_id)) {
    throw new ACSException("Missing administration group for this bboard topic.");
}
%>

<ad:db_query id="maintainers">
select distinct u.user_id, u.first_names, u.last_name
from users u, user_group_map ugm
where ugm.user_id = u.user_id
and ugm.group_id = :admin_group_id
order by u.last_name asc
<ad:db_bind><%= admin_group_id %></ad:db_bind>
</ad:db_query>

<%
request.setAttribute("maintainers", new Selection(maintainers, db));
%>
<ad:use_template/>

