<%@ include file="/acs.jspi" %>
<%@ page import="com.arsdigita.acs.chat.*" %>

<ad:page>
<ad:page_contract vars="chat_room_id:integer,notnull" />
<ad:get_user_info id="user" />

<%
ChatRoom dsRoomInfo = Chat.getRoomProperties(db, chat_room_id);
if (dsRoomInfo == null) {
    throw new WarningException("Not Found", "Could not find chat room " + chat_room_id);
}

String expiredSelectItem;
if (Utilities.emptyString(dsRoomInfo.get("expiration_days"))) {
    expiredSelectItem = ", 0 as n_expired_msgs";
} else {
    expiredSelectItem = ", sum(decode(sign((sysdate-" + dsRoomInfo.get("expiration_days") + 
	")-creation_date),1,1,0)) as n_expired_msgs";
}

ContextBar navbar = new ContextBar(pageContext); 
navbar.add("index", "Chat System");
navbar.add("One Room");

String moderatorGroupId = UserGroups.getAdminGroupId(db, "chat", chat_room_id.toString());
%>

<ad:db_query id="sqlGroups">
    select unique group_name, group_id 
    from user_groups
    where ad_group_member_p ( :user_id, group_id ) = 't'
      and user_groups.group_type <> 'administration'
    order by group_name
<ad:db_bind><%= user.getUserId() %></ad:db_bind>
</ad:db_query>

<ad:db_query id="sqlModerators">
    select users.user_id as moderator_id, 
	first_names, 
	last_name
    from users, user_group_map
    where group_id=:group_id 
    and users.user_id = user_group_map.user_id
<ad:db_bind><%= moderatorGroupId %></ad:db_bind>
</ad:db_query>

<ad:db_0or1row id="sqlRoomMessageInfo" obj="dsRoomMessageInfo">
    select min(creation_date) as min_date, 
           max(creation_date) as max_date, 
           count(*) as n_messages, 
           count(distinct creation_user) as n_users 
           <%= expiredSelectItem %>
    from chat_msgs
    where chat_room_id = :chat_room_id
<ad:db_bind><%= chat_room_id %></ad:db_bind>
</ad:db_0or1row>

<%
request.setAttribute("dsModerators", new Selection(sqlModerators, db));
request.setAttribute("dsGroups", new Selection(sqlGroups, db));
request.setAttribute("dsRoomInfo", dsRoomInfo);
request.setAttribute("navbar", navbar);
request.setAttribute("moderatorGroupId", moderatorGroupId);
%>

<ad:use_template />
</ad:page>
