<%@ include file="../../acs.jspi" %>

<ad:page>
<ad:page_contract vars="table_name rownum:optional,integer"/>

<ad:get_user_info id="user" redirect="false"/>

<%
// TO DO: should probably be a filter on /admin
if (user == null || !user.isSiteWideAdmin()) { 
    throw new ForbiddenException("Not Site-Wide Admin", "You must be a site-wide admin to view this page.");
}

int rows_per_page = 50;
Integer row_count = new Integer(db.queryToString("select count(*) from " + table_name));
table_name = table_name.toUpperCase();
%>

<ad:db_1row id="table_name_select" obj="tableName">
select pretty_table_name_singular, pretty_table_name_plural, 
 denorm_view_name, lower(id_column_name) as id_column_name, table_name
from general_table_metadata
where upper(table_name) = ?
<ad:db_bind><%= table_name %></ad:db_bind>
</ad:db_1row>

<% request.setAttribute("table_name", tableName); %>

<ad:db_query id="display_columns">
select column_pretty_name, column_name, is_date_p, use_as_link_p
    from table_metadata_denorm_columns
    where upper(table_name) = :table_name
    order by display_ordinal
<ad:db_bind><%= table_name %></ad:db_bind>
</ad:db_query>

<%
ContextBar navbar = new ContextBar(ContextBar.ADMIN, user);
navbar.add("index", "General Permissions");
navbar.add("One Table");
request.setAttribute("navbar", navbar);

//
// get the list of displayable columns
//
Vector column_list = new Vector();
Vector column_name_list = new Vector();
%>

<ad:db_foreach in="display_columns" row="rs">
<% 
// need this for later query
column_name_list.addElement(rs.getString("column_name"));
column_list.addElement(new SingleSelection(rs));
%>
</ad:db_foreach>

<%
//
// start at record one if not specified
//

int rownum_first_this_page = 1;
if (rownum != null) {
    rownum_first_this_page = rownum.intValue();
} 

// make sure the starting row isn't too high
if (rownum_first_this_page >= row_count.intValue()) {
    rownum_first_this_page =row_count.intValue() - rows_per_page;
} else {
    rownum_first_this_page = 1;
}

// figure out the last row number on this page

int rownum_last_this_page = rownum_first_this_page + rows_per_page - 1;
if (rownum_last_this_page > row_count.intValue()) {
    rownum_last_this_page = row_count.intValue();
}

//
// and the first on the next page, "" if there is no next page
//
int rownum_first_next_page = rownum_last_this_page + 1;
if (rownum_first_next_page > row_count.intValue()) {
    rownum_first_next_page = 0;
}

// finally the starting row number of the previous page, "" if no previous

int rownum_first_previous_page;
if (rownum_first_this_page == 1) {
    rownum_first_previous_page = 0;
} else {
    rownum_first_previous_page = rownum_first_this_page - rows_per_page;
    if (rownum_first_previous_page < 1) {
        rownum_first_previous_page = 1;
    }
}

request.setAttribute("row_count", row_count);
request.setAttribute("rows_per_page", new Integer(rows_per_page));
request.setAttribute("rownum_first_this_page", new Integer(rownum_first_this_page));
request.setAttribute("rownum_last_this_page", new Integer(rownum_last_this_page));
request.setAttribute("rownum_first_previous_page", new Integer(rownum_first_previous_page));
request.setAttribute("rownum_first_next_page", new Integer(rownum_first_next_page));

request.setAttribute("column_list", new VectorDataSource(column_list));
%>

<ad:db_query id="get_rows">
select * from (
   select <%= Utilities.join(column_name_list, ",") %>, 
      rownum as row_number 
   from <%= tableName.get("denorm_view_name") %>)
  where row_number >= :rownum_first_this_page 
    and row_number <= :rownum_last_this_page
<ad:db_bind><%= rownum_first_this_page %></ad:db_bind>
<ad:db_bind><%= rownum_last_this_page %></ad:db_bind>
</ad:db_query>

<%
request.setAttribute("rows", new Selection(get_rows, db));
%>

<ad:use_template/>
</ad:page>
