<%@ include file="../../acs.jspi" %>
<ad:page>
<ad:page_contract vars="on_what_id:integer on_which_table object_name return_url" />
<ad:get_user_info id="user" redirect="false"/>

<%
// check access
Integer user_id = user.getUserId();
if (!GeneralPermissions.userHasPermission(user.getUserId(), "administer", on_what_id.toString(), on_which_table)) { 
    if (user_id == null) {
	Security.redirectForRegistration(pageContext);
	return;
    } else {
	response.sendError(response.SC_FORBIDDEN, "Access denied!");
	return;
    }
}
%>

<ad:db_query id="get_groups">
<%
// Fetch all public and approved groups that do not have permission
// on this database row.
// 
%>
select g.group_id, 
g.group_name || ' (' || gt.pretty_name || ')' as name, 
ad_group_member_p(?, g.group_id) member_p,  
g.parent_group_id,  
user_group_name_from_id(g.parent_group_id) parent_group_name
from user_groups g, user_group_types gt
where g.active_p = 't'
and g.approved_p = 't'
and g.group_type = gt.group_type
order by member_p desc, g.group_type, parent_group_name, g.group_name
<ad:db_bind><%= user.getUserId() %></ad:db_bind>
</ad:db_query>

<%
request.setAttribute("groups", new GroupDataSource(get_groups,db));
request.setAttribute("return_url", return_url);
request.setAttribute("object_name", object_name);
%>

<ad:use_template/>

