<%@ include file="../../acs.jspi" %>

<% 
/*
Now that we've got a user to grant permissions to, ask the admin
which permissions we're going to grant.  The scope will be "user", 
and the admin can grant some subset of {read, write, comment, administer}

@param user_id_from_search: the user_id
@param on_which_table: the table
@param on_what_id
@param object_name
@param return_url
*/
%>

<ad:page>
<ad:page_contract vars="user_id_from_search:integer on_which_table on_what_id:integer object_name return_url"/>

<ad:get_user_info id="user"/>

<%

// first make sure we have adequate permissions
if (!user.isSiteWideAdmin()) {
     throw new ForbiddenException("Not Site-Wide Admin", 
	"You must be a site-wide admin to view this page.");
 } 

ContextBar navbar = new ContextBar(ContextBar.ADMIN, user);
navbar.add("index", "General Permissions");
navbar.add("one-table?table_name=" + on_which_table, on_which_table);
navbar.add("One Row");
request.setAttribute("navbar", navbar);

// ok, we're good, so forward to template
request.setAttribute("user", new UserInfo(user_id_from_search.intValue()));
request.setAttribute("return_url", return_url);
request.setAttribute("object_name", object_name);

// since we're granting to a user, we can assume "user" scope
request.setAttribute("scope", "user");
%>

<ad:use_template/>


