<% /*
    This script performs the actual insertion of rows into the
    general_permissions table. It is used to add user permissions,
    role permissions, group permissions, and public permissions
    (both for only registered users and all users).

    @author michael@arsdigita.com
    @creation-date 2000-02-27
    @cvs-id $Id: permission-grant.jsp,v 1.1 2000/09/15 15:49:45 bschneid Exp $
*/
%>

<%@ include file="../../acs.jspi" %>

<ad:page>
<ad:page_contract vars="on_what_id:integer on_which_table scope user_id_from_search:optional,integer group_id:integer,optional role:optional permission_types:multiple,optional return_url:optional" id="pc">

<%
if (permission_types.length== 0) { 
    pc.addComplaint ("You selected no permission types.");
} 

if (scope.equals("user")) {
    if (user_id_from_search == null) { 
	pc.addComplaint("missing user_id");
    } 
} else if (scope.equals("group_role")) { 
    if (group_id == null) {
	pc.addComplaint("missing group_id");
    }
    if (Utilities.emptyString(role))  {
	pc.addComplaint("missing role");
    }
} else if (scope.equals("group")) { 
        if (group_id == null) {
	pc.addComplaint("missing group_id");
    }
} else if (!scope.equals("registered_users") && !scope.equals("all_users")) { 
    pc.addComplaint("unknown scope: $scope");
}

%>

</ad:page_contract>

<ad:get_user_info id="user"/>

<%
// first make sure we have adequate permissions
if (!user.isSiteWideAdmin()) { 
     throw new ForbiddenException("Not Site-Wide Admin", 
	"You must be a site-wide admin to view this page.");
 } 
%>

<ad:db_transaction>
<%
// ok. now do the actual permission granting

for (int i=0; i<permission_types.length; i++) { 
    // check to see if permission has been granted first
    if (GeneralPermissions.getPermissionId(db, scope, user_id_from_search, 
    group_id, role, permission_types[i], on_what_id, 
    on_which_table).intValue() == 0) { 
	GeneralPermissions.grantPermission(db, scope, user_id_from_search, 
	group_id, role, permission_types[i], on_what_id, 
	on_which_table);
    }
}
%>

</ad:db_transaction>

<%

if (return_url == null) { 
    return_url = "/";
}
response.sendRedirect(return_url);

%>

