<%@ include file="/acs.jspi" %>

<ad:page>

<ad:get_user_info id="user"/>
<ad:page_contract vars="page_id:notnull glob_pattern:notnull pattern_id:notnull,integer">


<% 

String complete_page_id = "";
String pretty_page_id = "everywhere";
if (!page_id.equals("*")) {
    complete_page_id = page_id;
    pretty_page_id = "from " +
                     db.queryToString("select url_stub from static_pages where page_id = :page_id", new Object[] { page_id });
} 

request.setAttribute("title", "Blacklisting " + glob_pattern);
request.setAttribute("glob_pattern", glob_pattern);
request.setAttribute("pretty_page_id", pretty_page_id);
%>

<ad:db_query id="kill_insert">
insert into link_kill_patterns 
(pattern_id, page_id, user_id, date_added, glob_pattern) 
values
(:pattern_id, :complete_page_id, :admin_id, sysdate, :glob_pattern)
<ad:db_bind><%= pattern_id %></ad:db_bind>
<ad:db_bind><%= complete_page_id %></ad:db_bind>
<ad:db_bind><%= user.getUserId() %></ad:db_bind>
<ad:db_bind><%= glob_pattern %></ad:db_bind>
</ad:db_query>

<%
db.dml(kill_insert);
%>


<ad:db_query id="get_links" obj="links">
select   links.url, links.page_id, links.link_title, links.posting_time,
  links.originating_ip,  sp.url_stub,  users.user_id,
  users.first_names, users.last_name
  from links, static_pages sp, users 
  where links.page_id = sp.page_id
  and links.user_id = users.user_id 
  <% if (!page_id.equals("*")) { %>
  and links.page_id = :page_id
  <ad:db_bind><%= page_id %></ad:db_bind>    
  <% } %>
</ad:db_query>

<%
    Database db2 = new Database();
    StringBuffer kill_items = new StringBuffer();
    while (links.next()) {
        if (Utilities.stringGlobMatch(glob_pattern, links.get("url"))) {
            /* It matches, kill it.  Subquery for some info about what we're killing */
            %>
            <ad:db_query id="delete_link">
            delete from links
            where page_id=:page_id and url=:url
            <ad:db_bind><%= links.get("page_id") %></ad:db_bind>
            <ad:db_bind><%= links.get("url") %></ad:db_bind>            
            </ad:db_query>

            <ad:string id="item">
            <ad:scope sources="links">
            <li>Deleted <ad:sub var="url"/> (<ad:sub var="title"/>) from <ad:sub var="url_stub"/>, originally posted by <a href="/admin/users/one?user_id=<ad:sub var="user_id"/>"><ad:sub var="first_names"/> <ad:sub var="last_name"/></a> from <ad:sub var="originating_ip"/>
            </ad:scope>
            </ad:string>

            <%
            db2.dml(delete_link);
            kill_items.append(item);
        }
    }
request.setAttribute("kill_items", kill_items.toString());
%>


<ad:use_template/>
</ad:page>
