<%@ include file="/acs.jspi" %>

<ad:page>

<ad:get_user_info id="user"/>

<ad:page_contract vars="page_id:notnull verbose_p:optional">

<% 
boolean actually_send_email_p = true;
boolean verbose = false;
if (verbose_p != null) {
    verbose = true;
}

String scope_description = "all of the related links contributed to "+Parameters.get("SystemName", "");
if (!page_id.equals("all")) {
    String url_stub = db.queryToString("select url_stub from static_pages where page_id = :page_id",
                                       new Object[] { page_id });
    scope_description = "related links contributed to <a href=\"/admin/static/page-summary?page_id="+page_id+"\">"+
        url_stub + "</a>";
}

String title = "Sweeping";
ContextBar navbar = new ContextBar(ContextBar.ADMIN, user); 
navbar.add("index", "Links");
navbar.add("Sweeping");

request.setAttribute("title", title);
request.setAttribute("navbar", navbar);
%>

<ad:header><%= title %></i></ad:header>

<h2><%= title %></h2>

<%= navbar %>

<hr>

Scope:  <%= scope_description %>

<p>

This program cycles through links that 

<ol>
<li>haven't been checked in the last 24 hours
<li>aren't in the "removed" status
</ol>

Any link that is reachable is promoted to "live" status if it wasn't
already there.  Links that aren't reachable go through a life cycle of
live, coma, dead, and removed.  We test the coma and dead links first.

<ul>

<ad:db_query id="select_pages_or_pages_links" obj="pages">
select links.page_id, url, link_title, status, contact_p, sp.url_stub
from links, static_pages sp 
where links.page_id = sp.page_id
and links.status <> 'removed'
and (checked_date is null or checked_date + 1 < sysdate)
<% if (!page_id.equals("all")) { %>
and links.page_id = :page_id
<ad:db_bind><%= page_id %></ad:db_bind>
<% } %>
order by links.status, links.url
</ad:db_query>

<ad:loop ds="pages">
  <%
   String loop_page_id = pages.get("page_id");
   String url = pages.get("url");
   if (!Utilities.linkResponding(pages.get("url"))) {
      String new_status = "";
      if ( pages.get("status").equals("live")) {
          new_status = "coma";
          db.dml("update links set status='coma' where page_id = :page_id and url=:url", 
                 new Object[] { loop_page_id, url });
	} else if ( pages.get("status").equals("coma")) {
	    new_status = "dead";
	    db.dml("update links set status='dead' where page_id = :page_id and url=:url",
                   new Object[] { loop_page_id, url });
	    if (pages.get("contact_p").equals("t") && actually_send_email_p ) {
		StaticContent.linkNotify(url, "dead");
	    }
	} else if ( pages.get("status").equals("dead")) {
	    db.dml("update links set status='removed' where page_id = :page_id and url=:url",
                   new Object[] { loop_page_id, url });
	    if (pages.get("contact_p").equals("t") && actually_send_email_p ) {
		StaticContent.linkNotify(url, "removed");
	    }
	}
      %>
      <li>Could not reach <a href="<ad:sub var="url"/>"><ad:sub var="link_title"/></a>.  Status has gone from <ad:sub var="status"/> to <%= new_status %>.  
  <% } else {
      if (verbose) { %>
      <li>Successfully reached <a href="<ad:sub var="url"/>"><ad:sub var="link_title"/></a>.
      <% } 
      if (!pages.get("status").equals("live")) {
          db.dml("update links set status='live' where page_id = :page_id and url=:url",
                 new Object[] { loop_page_id, url });
          %>
          Updated status to "live" (from "<ad:sub var="status"/>").
          <%
      }
      %>
      
  <% } %>
</ad:loop>

</ul>
<ad:footer/>

</ad:page>
