<%
  /** 
    * /admin/portals/index.jsp
    * 
    * Main index page for the site owner administration of the portals system.
    * A site owner can create new portals and change the super administrators of
    * the system
    * 
    * @author aure@arsdigita.com 
    * @author dh@arsdigita.com
    * @creation-date 10/8/1999
    * @cvs-id $Id: index.jsp,v 1.5 2000/10/27 22:06:22 jbank Exp $
    */
%>

<%@ include file="/acs.jspi" %>
<%@ page import="com.arsdigita.acs.portals.*" %>

<ad:page>
<ad:get_user_info id="user" />

<% 
  // ----------------------------------------
  // get the group type for the Super Administrator group.
  String group_type = "portal_group";


  // --------------------------------------
  // make a list of the super administrators
%>

<ad:db_query id="super_admin">
    select u.first_names||' '||u.last_name as name, 
           u.user_id
   from    users u, user_groups ug
   where   ug.group_name = 'Super Administrators' 
   and     ug.group_type = :group_type
   and     ad_group_member_p ( u.user_id, ug.group_id ) = 't'
   order   by u.last_name
  <ad:db_bind><%=group_type%></ad:db_bind>
</ad:db_query>


<%
  // --------------------------------------
  // make  a list of all the portals
%>

<ad:db_query id="portals">
    select ug.group_id, ug.group_name
    from   user_groups ug
    where  ug.group_type = :group_type
    and    ug.group_name <> 'Super Administrators'
    order  by lower(ug.group_name)
  <ad:db_bind><%=group_type%></ad:db_bind>
</ad:db_query>


<%

   PortalsDataSource super_admin_ds = new PortalsDataSource(super_admin, db);
   PortalsDataSource portals_ds = new PortalsDataSource(portals, db);
 
   String title = parameters.get("SystemName","portals","Portals") + " Administration";
   ContextBar navbar = PortalsProcs.adminContextBar(pageContext, true);

   // set up request before including template
   request.setAttribute("title", title);
   request.setAttribute("group_type", group_type);
   request.setAttribute("navbar", navbar);
   request.setAttribute("super_admin", super_admin_ds);
   request.setAttribute("portals", portals_ds);
   request.setAttribute("db", db);

%>

<ad:use_template />

</ad:page>

