<%
    /*
    Modify daily spam table
    @param file_prefix filename prefix for a periodic spam entry
    @param subject subject for the spam message
    @param user_class_id user_class_id for target recipients of this spam
    @param template_p t if Tcl substitution should be performed on message body
    @param day_of_week day of week to send spam 
    @param period period to send spam (daily, weekly, monthly, yearly)
    @param day_of_month day of month to send spam
    @param from_address from address for email header
    @param user_class_name pretty name of target recipients user class 
    @author hqm@arsdigita.com
    @author phong@arsdigita.com (java port)
    @cvs-id $Id: modify-daily-spam.jsp,v 1.3 2000/10/17 17:12:08 luke Exp $
    */
%>

<%@ include file="/acs.jspi" %>
<%@ page import="com.arsdigita.acs.spam.*" %>

<ad:page>
<ad:page_contract id="pc" vars="file_prefix:array subject:array user_class_id:array template_p:array,optional day_of_week:array period:array day_of_month:array from_address:array" />

<ad:get_user_info id="user" />

<%

// empty out the daily_spam_files table
db.dml("delete from daily_spam_files");

for (int i=0; i<user_class_id.size(); i++) {

  // only insert entries that have a file_prefix and a subject
  if (!Utilities.emptyString(file_prefix.get("" + i)) && !Utilities.emptyString(subject.get("" + i))) {

    String user_class_name = db.queryToString("select name from user_classes where user_class_id = ?", new Object [] {user_class_id.get("" + i)});
    
    if (template_p.get("" + i)==null) {
       template_p.put("" + i, "f");
    }

    String sql = "" +
      "insert into daily_spam_files " +
      "  (from_address, " +
      "   target_user_class_id, " +
      "   user_class_description, " +
      "   subject, " +
      "   file_prefix, " +
      "   template_p, " +
      "   period, " +
      "   day_of_week, " +
      "   day_of_month) " +
      "values " +
      "  (?, ?, ?, ?, ?, ?, ?, ?, ?) ";

    db.dml(sql, new Object [] {from_address.get("" + i), user_class_id.get("" + i), user_class_name, subject.get("" + i), file_prefix.get("" + i), template_p.get("" + i), period.get("" + i), day_of_week.get("" + i), day_of_month.get("" + i)}); 

  }

} 

response.sendRedirect("show-daily-spam");

%>

</ad:page>



