<%
   /*
   Allow user to confirm the outgoing spam before queuing it for delivery.
   @param spam_id id of the message
   @param subject  subject line for header
   @param from_address  from address for header
   @param message text of the message
   @param message_html html version of the message
   @param message_aol aol_html dialect version of the message
   @param send_date when to schedule the message for delivery
   @param from_file_p flag to get message content from filesystem rather than from page vars
   @param users_sql_query custom SQL query to generate the list of target users
   @param users_description English description of target list of user
   @param user_class_id An id of a user-class, mutually exclusive with users_sql_query
   @param template_p If t, perform Tcl substitution on the message body
   @author hqm@arsdigita.com
   @author phong@arsdigita.com (java port)
   @cvs-id $Id: spam-confirm.jsp,v 1.4 2000/10/17 17:12:10 luke Exp $
   */
%>

<%@ include file="/acs.jspi" %>
<%@ page import="com.arsdigita.acs.spam.*" %>

<ad:page>
<ad:page_contract id="pc" vars="spam_id subject from_address message message_html:optional message_aol:optional send_date:optional,array from_file_p:optional users_sql_query:optional users_description:optional user_class_id:optional template_p:optional" />

<ad:get_user_info id="user" />


<%
if (message_html == null) { message_html = ""; }
if (message_aol == null) { message_aol = ""; }
if (Utilities.emptyString(from_file_p)) { from_file_p = "f"; }
if (users_sql_query == null) { users_sql_query = ""; }
if (users_description == null) { users_description = ""; }
if (user_class_id == null) { user_class_id = ""; }
if (Utilities.emptyString(template_p)) { template_p = "f"; }

// Generate the SQL query from the user_class_id, if supplied
String errmsg = "";
if (!Utilities.emptyString(user_class_id)) {

   AdSet setid = new AdSet();
   setid.put("user_class_id", user_class_id);
   users_sql_query = Spam.userClassQuery(setid);

   String sql_description = Spam.userClassDescription(setid);
   String class_name = db.queryToString("select name from user_classes where user_class_id = :user_class_id", new Object[] {user_class_id});
   users_description = class_name + ": " + sql_description;

}


// get user information
Integer user_id = user.getUserId();

// set page title and navigation bar
String title = "Confirm Sending Spam";
ContextBar navbar = new ContextBar(pageContext);
navbar.add("index", "Spam");
navbar.add(title);

if (from_file_p == "t") {
   message = Spam.getSpamFromFilesystem("plain");
   message_html = Spam.getSpamFromFilesystem("html");
   message_aol = Spam.getSpamFromFilesystem("aol");
}

String template_pretty = "Yes";
if (template_p != "t") {
   template_p = "f";
   template_pretty = "No";
}
   

String total_users = db.queryToString("select count(1) from (" + users_sql_query + ")");

String send_date_str = Spam.verifyDate(send_date);

// export variables to template
request.setAttribute("title", title);
request.setAttribute("navbar", navbar);
request.setAttribute("users_description", users_description);
request.setAttribute("send_date_str", send_date_str);
request.setAttribute("from_address", from_address);
request.setAttribute("template_pretty", template_pretty);
request.setAttribute("subject", subject);
request.setAttribute("message", message);
request.setAttribute("message_html", message_html);
request.setAttribute("message_aol", message_aol);
request.setAttribute("users_sql_query", users_sql_query);
request.setAttribute("total_users", total_users);
request.setAttribute("spam_id", spam_id);
request.setAttribute("user_class_id", user_class_id);
request.setAttribute("from_file_p", from_file_p);
request.setAttribute("template_p", template_p);
request.setAttribute("send_date", send_date);

%>

<ad:use_template />
</ad:page>

