<%
   /*
   View/modify status and content of a message
   @param spam_id ID of the message in the spam_history table
   @param subject Subject line for message
   @param from_address Value for the From: header of the message
   @param user_class_id An ID of a user class in the user_classes table
   @author hqm@arsdigita.com
   @author phong@arsdigita.com (java port)
   @cvs-id $Id: spam-edit.jsp,v 1.4 2000/10/17 17:12:11 luke Exp $
   */
%>

<%@ include file="/acs.jspi" %>
<%@ page import="com.arsdigita.acs.spam.*" %>

<ad:page>
<ad:page_contract id="pc" vars="spam_id subject:optional from_address:optional user_class_id:optional" />

<ad:get_user_info id="user" />

<%
if (Utilities.emptyString(subject)) {
   subject = "";
}
if (Utilities.emptyString(from_address)) {
   from_address = "";
}
if (Utilities.emptyString(user_class_id)) {
   user_class_id = "";
}


// get user information
Integer user_id = user.getUserId();

ContextBar navbar = new ContextBar(pageContext);
navbar.add("index", "Spam");
navbar.add("Edit Message #" + spam_id);

// Generate the SQL query from the user_class_id, if supplied
String errmsg = "";	  
if (!Utilities.emptyString(user_class_id)) {

   AdSet setid = new AdSet();
   setid.put("user_class_id", user_class_id);
   String users_sql_query = Spam.userClassQuery(setid);
   String sql_description = Spam.userClassDescription(setid);
   String spam_query = Spam.rewriteUserClassQuery(users_sql_query);

   String class_name = db.queryToString("select name from user_classes where user_class_id = :user_class_id", new Object[] {user_class_id});

   String sql_query = "" +
	 "update spam_history " +
	 "set user_class_description = :sql_description, " +
	     "user_class_query = :spam_query " +
	 "where spam_id = :spam_id ";	    		    

   try {
     db.dml(sql_query, new Object[] {sql_description, spam_query, spam_id});
   } catch (SQLException sqle) {
     errmsg = sqle.getMessage();
   }

}


if (!subject.equals("")) {
   try {
      db.dml("update spam_history set title = :subject where spam_id = :spam_id", new Object[] {subject, spam_id});
   } catch (SQLException sqle) {
      throw new SQLException(sqle.getMessage());
   }
}

if (!from_address.equals("")) {
   try {
      db.dml("update spam_history set from_address = :from_address where spam_id = :spam_id", new Object[] {from_address, spam_id});
   } catch (SQLException sqle) {
      throw new SQLException(sqle.getMessage());
   }		     
}

%>

<ad:db_query id="spam_info">
select to_char(sh.begin_send_time,'YYYY-MM-DD HH24:MI:SS') as begin_send_time,
                   to_char(sh.finish_send_time,'YYYY-MM-DD HH24:MI:SS') as finish_time,
                   sh.from_address,
                   sh.title,
                   sh.body_plain,
                   sh.body_html,
                   sh.body_aol,
                   sh.user_class_description,
                   to_char(sh.send_date,'YYYY-MM-DD') as send_date,
                   to_char(sh.creation_date, 'YYYY-MM-DD HH24:MI:SS') as creation_time,
                   sh.n_sent,
                   users.user_id,
                   users.first_names || ' ' || users.last_name as user_name,
                   users.email,
                   sh.status,
                   sh.last_user_id_sent,
                   to_char(sysdate-sh.begin_send_time) as nmins_running,
                   to_char(sh.finish_send_time-sh.begin_send_time) as nmins_completed,
                   sh.finish_send_time
              from spam_history sh, users
             where sh.creation_user = users.user_id
                   and sh.spam_id = ?
<ad:db_bind><%= spam_id %></ad:db_bind>
</ad:db_query>

<%

Selection spam_select = new Selection(spam_info, db);
String date_entry_widget = Spam.dateWidget("send_date");

String sql = "select user_class_id, name from user_classes order by name";
String userclass_options = Spam.htmlSelectValueOptions(sql, "name", "user_class_id", "");

// export variables to template
request.setAttribute("errmsg", errmsg);
request.setAttribute("spam_select", spam_select);
request.setAttribute("navbar", navbar);
request.setAttribute("spam_id", spam_id);
request.setAttribute("date_entry_widget", date_entry_widget);
request.setAttribute("userclass_options", userclass_options);

%>

<ad:use_template />
</ad:page>
