<%@ include file="/acs.jspi" %>

<ad:page>

<ad:page_contract vars="page_id:notnull,integer">

<ad:get_user_info id="user"/>

<% 
ContextBar navbar = new ContextBar(ContextBar.ADMIN, user); 
navbar.add("index", "Static Content");
navbar.add("One Page");

String n_deleted_comments = db.queryToString("select count(*) from comments where page_id = :page_id and deleted_p = 't'",
                                             new Object[] { page_id });

request.setAttribute("navbar", navbar);
request.setAttribute("n_deleted_comments", n_deleted_comments);

%>

<ad:db_0or1row id="get_info_for_page" obj="page_info">
select page_id, page_title, url_stub, draft_p, obsolete_p, accept_comments_p, accept_links_p, inline_comments_p, inline_links_p, index_p, last_updated, users.user_id, users.first_names, users.last_name
from static_pages sp, users
where sp.original_author = users.user_id(+)
and sp.page_id = :page_id
<ad:db_bind><%= page_id %></ad:db_bind>
</ad:db_0or1row>
<ad:if_no_rows><% throw new ACSException("This page id could not be found or was invalid."); %></ad:if_no_rows>

<ad:db_query id="get_page_links" obj="links">
select links.page_id, links.link_title, links.link_description, links.url, links.status,  posting_time,
users.user_id, first_names || ' ' || last_name as name 
from static_pages sp, links, users
where sp.page_id (+) = links.page_id
and users.user_id = links.user_id
and links.page_id = :page_id
order by posting_time asc
<ad:db_bind><%= page_id %></ad:db_bind>
</ad:db_query>


<ad:db_query id="get_page_comments" obj="comments">
select comments.page_id, posting_time, comments.comment_id,comments.message,  comments.comment_type, comments.rating, users.user_id, first_names || ' ' || last_name as name, client_file_name, html_p, file_type, original_width, original_height, caption
from static_pages sp, comments_not_deleted comments, users
where sp.page_id (+) = comments.page_id
and users.user_id = comments.user_id
and comments.page_id = :page_id
order by comment_type, posting_time asc
<ad:db_bind><%= page_id %></ad:db_bind>
</ad:db_query>

<ad:db_query id="get_page_views" obj="views">
select users.user_id, email, first_names || ' ' || last_name as name, page_title, url_stub
from static_pages, user_content_map, users
where static_pages.page_id = user_content_map.page_id
and users.user_id = user_content_map.user_id
and user_content_map.page_id = :page_id
order by last_name
<ad:db_bind><%= page_id %></ad:db_bind>
</ad:db_query>


<ad:use_template/>
</ad:page>