<%@ include file="/acs.jspi" %>

<ad:page>

<ad:page_contract id="pc" vars="group_type column_name pretty_name column_type column_actual_type after:integer,optional column_extra:optional"> 

<ad:db_query id="dupCheck">
select count(*) from user_group_type_fields 
where group_type = ?
 and lower(column_name) = lower(?)
<ad:db_bind><%= group_type %></ad:db_bind>
<ad:db_bind><%= column_name %></ad:db_bind>
</ad:db_query>

<% 
// validate input
com.oroinc.text.perl.Perl5Util re = new com.oroinc.text.perl.Perl5Util ();
if (column_name.length() == 0) { 
	pc.addComplaint("The column name cannot be empty.");
}
if (re.match("/[^A-Za-z0-9_]/", column_name)) {
	pc.addComplaint("The column name cannot contain any special characters.");
}
if (!db.queryToString(dupCheck).equals("0")) {
	pc.addComplaint("There is already a field of this name for this type.");
}
%>

</ad:page_contract>

<ad:db_1row id="get_group_type" obj="gt"
 type="com.arsdigita.acs.ug.SingleGroupTypeDataSource">
select group_type, pretty_name from user_group_types
where group_type = ?
<ad:db_bind><%= group_type %></ad:db_bind>
</ad:db_1row>

<%
int sort_key = 1;
if (after != null) {
	sort_key = after.intValue() + 1;
}
%>

<ad:db_query id="insert">
insert into user_group_type_fields
(group_type, column_name, pretty_name, column_type, column_actual_type, column_extra, sort_key)
values (?, ?, ?, ?, ?, ?, ?)
<ad:db_bind><%= group_type %></ad:db_bind>
<ad:db_bind><%= column_name %></ad:db_bind>
<ad:db_bind><%= pretty_name %></ad:db_bind>
<ad:db_bind><%= column_type %></ad:db_bind>
<ad:db_bind><%= column_actual_type %></ad:db_bind>
<ad:db_bind><%= Database.bindObj(column_extra) %></ad:db_bind>
<ad:db_bind><%= sort_key %></ad:db_bind>
</ad:db_query>

<ad:db_query id="addColumns"> 
alter table <%= gt.getHelperTableName(db) %>
add (<%= column_name %> <%= column_actual_type %> <%= column_extra %>)
</ad:db_query>

<ad:db_query id="pushOthersAhead">
update user_group_type_fields
set sort_key = sort_key + 1
where group_type = :group_type
and sort_key > :after
<ad:db_bind><%= group_type %></ad:db_bind>
<ad:db_bind><%= after %></ad:db_bind>
</ad:db_query>

<ad:db_transaction>
<%
// clear for insert
db.dml(insert);
db.dml(addColumns);
if (after != null) {
	db.dml(pushOthersAhead);
}
%>
</ad:db_transaction>

<ad:header>Field Added</ad:header>

<h2>Field Added</h2>

to <a href="group-type?group_type=<%= group_type %>">the <%= gt.getPrettyName() %> group type</a>

<hr>

The following action has been taken:

<ul>

<li>a column called "<%= column_name %>" has been added to the
table <%= gt.getHelperTableName(db) %> in the database.  The sql was
<P>
<code>
<blockquote>
<%= addColumns.getSql() %>
</blockquote>
</code>

<p>

<li>a row has been added to the SQL table user_group_type_fields
reflecting that 

<ul>

<li>this field has the pretty name (for user interface) of <%= pretty_name %>

</ul>
</ul>

<ad:footer />

</ad:page>