<%@ include file="../../acs.jspi"%>

<ad:page>
<ad:page_contract vars="group_id:integer group_name short_name admin_email new_member_policy spam_policy return_url:optional" id="pc">
<% 
if (group_name.length() == 0) { 
	pc.addComplaint("You must specify a group name.");
}
if (short_name.length() == 0) { 
	pc.addComplaint("You must specify a group short name.");
}
if (admin_email.length() == 0) { 
	pc.addComplaint("You must specify an admin email address.");
}
%>
</ad:page_contract>

<ad:db_query id="main_update">
update user_groups
 set group_name = ?, 
  short_name = ?,
  admin_email = ?, 
  new_member_policy = ?,
  spam_policy = ?
where group_id = ?
<ad:db_bind><%= group_name %></ad:db_bind>
<ad:db_bind><%= short_name %></ad:db_bind>
<ad:db_bind><%= admin_email %></ad:db_bind>
<ad:db_bind><%= new_member_policy %></ad:db_bind>
<ad:db_bind><%= spam_policy %></ad:db_bind>
<ad:db_bind><%= group_id %></ad:db_bind>
</ad:db_query>

<ad:db_1row id="get_group_type" obj="gt"
 type="com.arsdigita.acs.ug.SingleGroupTypeDataSource">
select group_type from user_groups 
where group_id = ?
<ad:db_bind><%= group_id %></ad:db_bind>
</ad:db_1row>

<% 
Vector cols = new Vector();
Vector vals = new Vector();

GroupField gf = gt.getGroupFields(db);
while (gf.next()) {
	cols.addElement(gf.getColumnName() + " = ?");
	String type = gf.getColumnType();
	String value;
	if (type.equals("date")) {
		Calendar c = Calendar.getInstance();
		c.set(Integer.parseInt(request.getParameter(gf.getColumnName() + "_year")),
		 Integer.parseInt(request.getParameter(gf.getColumnName() + "_month")),
 		 Integer.parseInt(request.getParameter(gf.getColumnName() + "_day")));
		value = new java.sql.Date(c.getTime().getTime()).toString();
	} else {
		value = request.getParameter(gf.getColumnName());
		if (type.equals("integer")) { 
			// better validate that it's an integer
			Perl5Util re = new Perl5Util();
			if (re.match("m/[^0-9]/", value)) { 
				Vector vec = new Vector();
				vec.addElement(gf.getColumnName() + " must be an integer.");
				throw new PageValidationException(vec);
			}
		}
	}
	// prevent string literal "null" from appearing in bind vars
	if (value == null) 
		value = "";
	vals.addElement(value);
}
%>

<ad:db_query id="extra_update">
update <%= gt.getHelperTableName(db) %>
 set <%= Utilities.join(cols, ", \n") %>
 where group_id = ?
<% for (int i = 0; i < vals.size(); i++) { %>
<ad:db_bind><%= vals.elementAt(i) %></ad:db_bind>
<% } %>
<ad:db_bind><%= group_id %></ad:db_bind>
</ad:db_query>

<ad:db_transaction>
<% 
db.dml(main_update);
if (cols.size() > 0) {
 db.dml (extra_update);
}
%>
</ad:db_transaction>

<% 
if (return_url == null) {
 return_url = "group?group_id=" + group_id;	
 response.sendRedirect(return_url);
}
%>




