<%@ include file="/acs.jspi" %>

<ad:page>

<ad:get_user_info id="user"/>

<ad:page_contract id="pc" vars="group_id field_name field_type after:integer,optional"> 

<ad:db_query id="dupCheck">
select count(*) from user_group_member_fields 
where group_id = ?
 and lower(field_name) = lower(?)
<ad:db_bind><%= group_id %></ad:db_bind>
<ad:db_bind><%= field_name %></ad:db_bind>
</ad:db_query>

<% 
// validate input
com.oroinc.text.perl.Perl5Util re = new com.oroinc.text.perl.Perl5Util ();
if (field_name.length() == 0) { 
	pc.addComplaint("The field name cannot be empty.");
}
if (re.match("/[^A-Za-z0-9_]/", field_name)) {
	pc.addComplaint("The field name cannot contain any special characters.");
}
if (!db.queryToString(dupCheck).equals("0")) {
	pc.addComplaint("There is already a field of this name for this group.");
}
%>

</ad:page_contract>

<%
int sort_key = 1;
if (after != null) {
	sort_key = after.intValue() + 1;
}
%>

<ad:db_query id="insert">
insert into user_group_member_fields
(group_id, field_name, field_type, sort_key)
values (?, ?, ?, ?)
<ad:db_bind><%= group_id %></ad:db_bind>
<ad:db_bind><%= field_name %></ad:db_bind>
<ad:db_bind><%= field_type %></ad:db_bind>
<ad:db_bind><%= sort_key %></ad:db_bind>
</ad:db_query>

<ad:db_query id="pushOthersAhead">
update user_group_member_fields
set sort_key = sort_key + 1
where group_id = :group_id
and sort_key > :after
<ad:db_bind><%= group_id %></ad:db_bind>
<ad:db_bind><%= after %></ad:db_bind>
</ad:db_query>

<ad:db_1row id="getName" obj="dsGroupInfo">
select group_id, group_name from user_groups
where group_id = ?
<ad:db_bind><%= group_id %></ad:db_bind>
</ad:db_1row>

<ad:db_transaction>
<%
// clear for insert
db.dml(insert);
if (after != null) {
	db.dml(pushOthersAhead);
}
%>
</ad:db_transaction>

<ad:header>Field Added</ad:header>

<h2>Field Added</h2>

to <a href="group?group_id=<%= dsGroupInfo.get("group_id") %>">the <%= dsGroupInfo.get("group_name")  %> group</a>.

<ad:footer />

</ad:page>