<%@ include file="/acs.jspi" %>

<ad:page>
<ad:get_user_info id="user" />

<ad:page_contract id="pc" vars="group_type" />

<ad:db_1row id="get_group_type" obj="gt"
 type="com.arsdigita.acs.ug.SingleGroupTypeDataSource">
select pretty_name, pretty_plural, approval_policy, 
 default_new_member_policy, group_module_administration
from user_group_types
where group_type = ?
<ad:db_bind><%= group_type %></ad:db_bind>
</ad:db_1row>

<%
String title = gt.getPrettyName();
%>

<ad:header>Edit <%= title %></ad:header>
<h2>Edit Group Type: <%= title %></h2>

one of <a href=index>the group types</a> on this system
<hr>

<form action=group-type-edit-2 method=post>

<%= Utilities.exportFormVars(request, "group_type") %>

<table>
<blockquote>
<tr>
  <th valign=top align=left>Pretty Name
  <td><INPUT type=text name=pretty_name size=20 value=<%= gt.getPrettyName() %>
</tr>
<tr>
  <th valign=top align=left>Plural Version of Name
  <td><INPUT type=text name=pretty_plural size=20 value="<%= gt.getPrettyPlural() %>">
</tr>
<tr>
<th valign=top align=left>Approval Policy
<td><select name=approval_policy>
<% 
	String[] keys = new String[] {"open", "wait", "closed"};
	String[] text = new String[] {
		"Open: Users can create groups of this type",
		"Wait: Users can suggest groups",
		"Closed: Only administrators can create groups"
	};
%>
<%= HtmlWidgets.htmlOptions(keys, text, gt.getApprovalPolicy()) %>
</select>
</tr>

<tr>
<th valign=top align=left>Default New Member Policy
<td><select name=default_new_member_policy>
<%
	keys = new String[] {"open", "wait", "closed"};
	text = new String[] {
		"Open: Users will be able to join Administration Groups",
		"Wait: Users can apply to join Administration Groups",
		"Closed: Only administrators can put users in Administration Groups"
	};
%>
<%= HtmlWidgets.htmlOptions(keys, text, gt.getDefaultNewMemberPolicy()) %>
</select>
</tr>

<tr>
<th valign=top align=left>Group Module Administration
<td><select name=group_module_administration>
<%
	keys = new String[] {"full", "enabling", "none"};
	text = new String[] {"Complete", "Enabling/Disabling", "None"};
%>
<%= HtmlWidgets.htmlOptions(keys, text, gt.getGroupModuleAdministration()) %>
</select>
</tr>

</table>

<p>
<center>
<input type=submit value="Update">
</center>
</blockquote>
</form>

<ad:footer />

</ad:page>
