<%@ include file="/acs.jspi" %>

<ad:page>

<ad:get_user_info id="user"/>

<ad:page_contract id="pc" vars="group_type field_name field_type after:integer,optional"> 

<ad:db_query id="dupCheck">
select count(*) from user_group_type_member_fields 
where group_type = ?
 and lower(field_name) = lower(?)
<ad:db_bind><%= group_type %></ad:db_bind>
<ad:db_bind><%= field_name %></ad:db_bind>
</ad:db_query>

<% 
// validate input
com.oroinc.text.perl.Perl5Util re = new com.oroinc.text.perl.Perl5Util ();
if (field_name.length() == 0) { 
	pc.addComplaint("The field name cannot be empty.");
}
if (re.match("/[^A-Za-z0-9_]/", field_name)) {
	pc.addComplaint("The field name cannot contain any special characters.");
}
if (!db.queryToString(dupCheck).equals("0")) {
	pc.addComplaint("There is already a field of this name for this type.");
}
%>

</ad:page_contract>

<ad:db_1row id="get_group_type" obj="gt" 
 type="com.arsdigita.acs.ug.SingleGroupTypeDataSource">
select group_type, pretty_name from user_group_types
where group_type = ?
<ad:db_bind><%= group_type %></ad:db_bind>
</ad:db_1row>

<% 
int sort_key = 1;
if (after != null) {
	sort_key = after.intValue() + 1;
}
%>

<ad:db_query id="insert">
insert into user_group_type_member_fields
(group_type, field_name, field_type, sort_key)
values (?, ?, ?, ?)
<ad:db_bind><%= group_type %></ad:db_bind>
<ad:db_bind><%= field_name %></ad:db_bind>
<ad:db_bind><%= field_type %></ad:db_bind>
<ad:db_bind><%= sort_key %></ad:db_bind>
</ad:db_query>

<ad:db_query id="pushOthersAhead">
update user_group_type_member_fields
set sort_key = sort_key + 1
where group_type = :group_type
and sort_key > :after
<ad:db_bind><%= group_type %></ad:db_bind>
<ad:db_bind><%= after %></ad:db_bind>
</ad:db_query>

<ad:db_transaction>
<%
// clear for insert
db.dml(insert);
if (after != null) {
	db.dml(pushOthersAhead);
}
%>
</ad:db_transaction>

<ad:header>Field Added</ad:header>

<h2>Field Added</h2>

to <a href="group-type?group_type=<%= group_type %>">the <%= gt.getPrettyName() %> group type</a>.

<ad:footer />

</ad:page>