<%@ include file="/acs.jspi" %>

<ad:page>
<ad:get_user_info id="user" />

<ad:page_contract id="pc" vars="group_id:integer" />

<ad:db_1row id="get_group" obj="g" 
 type="com.arsdigita.acs.ug.SingleGroupDataSource">
select g.group_type, g.parent_group_id, g.group_name, g.creation_user, 
 first_names, last_name, g.new_member_policy, g.spam_policy, g.group_id,
  to_char(g.registration_date, 'Month fmdd, yyyy') as pretty_date,
  g.email_alert_p, g.multi_role_p, g.short_name, g.approved_p, 
  g.existence_public_p, parent.group_name as parent_group_name
from user_groups g, users, user_groups parent
where 
 g.creation_user = users.user_id
 and g.group_id = ?
 and parent.group_id(+) = g.parent_group_id
<ad:db_bind><%=group_id%></ad:db_bind>
</ad:db_1row>

<ad:db_string obj="group_module_administration">
select group_module_administration
from user_group_types
where group_type = ?
<ad:db_bind><%= g.getGroupType() %></ad:db_bind>
</ad:db_string>

<ad:db_string obj="modules_available">
    select count(*)
    from acs_modules
    where supports_scoping_p='t'
    and module_key not in (select module_key
			   from content_sections
			   where scope='group' and group_id=:group_id
			   and (section_type='system' or section_type='admin'))
<ad:db_bind><%= group_id %></ad:db_bind>
</ad:db_string>

<ad:db_query id="get_group_modules" obj="modules">
    select module_key, pretty_name_from_module_key(module_key) as module_pretty_name
    from content_sections
    where scope='group' and group_id=:group_id and (section_type='system' or section_type='admin')
<ad:db_bind><%= group_id %></ad:db_bind>
</ad:db_query>

<%
Integer user_id = user.getUserId();

ContextBar navbar = new ContextBar(pageContext);

if (g.getParentGroupId() == null) {
    navbar.add("index", "User Groups");
    navbar.add("group-type?group_type=" + g.getGroupType(), "One Group Type");
    navbar.add("One Group");
} else {
    navbar.add("index", "User Groups");
    navbar.add("group-type?group_type=" + g.getGroupType(), "One Group Type");
    navbar.add("group-type?group_type=" + g.getParentGroupId(), "One Group Type");
    navbar.add("One Subgroup");
}

// TO DO: should be admin header, admin context bar

request.setAttribute("group", g);
request.setAttribute("group_id", group_id);
request.setAttribute("navbar", navbar);

// determine if there are any special helper tables
SingleGroupTypeDataSource gt = new SingleGroupTypeDataSource(g.getGroupType());

SingleSelection set = g.getSupplementalGroupInfo(db);

request.setAttribute("group_type", gt);
request.setAttribute("supplemental_data", set);
MemberField mf = gt.getMemberFields(db);
request.setAttribute("member_fields_from_group_type", mf);
mf = g.getMemberFields(db);
request.setAttribute("member_fields_from_group", mf);
request.setAttribute("member_field_count", new Integer(g.getMemberFieldCount(db)));
%>

<ad:db_query id="get_users_awaiting_approval" obj="pending_users">
select queue.user_id, first_names || ' ' || last_name as name, 
 to_char(queue_date, 'Mon-dd-yyyy') as pretty_queue_date, 
 group_id
from users, user_group_map_queue queue
where users.user_id = queue.user_id
 and group_id = ? 
order by queue_date asc
<ad:db_bind><%= group_id %></ad:db_bind>
</ad:db_query>

<ad:db_query id="group_members" obj="members">
select users.user_id, first_names || ' ' || last_name as name, 
 role, group_id
from users, user_group_map
where users.user_id = user_group_map.user_id
and group_id = ?
order by role, last_name, first_names
<ad:db_bind><%= group_id %></ad:db_bind>
</ad:db_query>

<ad:use_template />
</ad:page>
