<%@ include file="/acs.jspi" %>

<ad:page>

<ad:page_contract id="pc" vars="user_id">
  <% if (user_id != null && Utilities.emptyString(user_id)) pc.addComplaint("No User ID was specified");%>
</ad:page_contract>

<ad:get_user_info id="user"/>

<%
 /* user_id datasource, default 0, 
    no redirect for registration */
 Integer admin_id = new Integer(0);
 if (user != null) {
   admin_id = user.getUserId();
 }
%>

<ad:db_0or1row id="user_info_query" obj="user_info">
select first_names || ' ' || last_name as name, 
       user_state, 
       email_verified_date, 
       email 
from   users 
where  user_id = :user_id
<ad:db_bind><%= user_id %></ad:db_bind>
</ad:db_0or1row>
<ad:if_no_rows><% throw new WarningException("User not found","User not found");%></ad:if_no_rows>

<%
// Update the database based on the user's current state
if (user_info.get("user_state").equals("need_admin_approv")) {%>
  <ad:db_query id="set_user_state">
	update users 
	set    approved_date  = sysdate, 
	       user_state     = 'authorized',
	       approving_user = :admin_id
	where  user_id        = :user_id
    <ad:db_bind><%=admin_id%></ad:db_bind>
    <ad:db_bind><%=user_id%></ad:db_bind>
  </ad:db_query>

<% db.dml(set_user_state);


} else if (user_info.get("user_state").equals("need_email_verification_and_admin_approv")) {%>
  <ad:db_query id="set_user_state">
	update users 
	set    approved_date  = sysdate, 
               user_state     = 'need_email_verification',
	       approving_user = :admin_id
	where  user_id        = :user_id
    <ad:db_bind><%=admin_id%></ad:db_bind>
    <ad:db_bind><%=user_id%></ad:db_bind>
  </ad:db_query>

<% db.dml(set_user_state);


} else if (user_info.get("user_state").equals("rejected")) {
  if (parameters.getBoolean("RegistrationRequiresEmailVerificationP", "", false) && 
      user_info.get("email_verified_date").equals("")) { %>
       <ad:db_query id="set_user_state">
	    update users 
	    set    approved_date  = sysdate, 
                   user_state     = 'need_email_verification',
	           approving_user = :admin_id
	    where  user_id        = :user_id
        <ad:db_bind><%=admin_id%></ad:db_bind>
        <ad:db_bind><%=user_id%></ad:db_bind>
       </ad:db_query>

      <%  db.dml(set_user_state);


        } else { %>
          <ad:db_query id="set_user_state">
	    update users 
	    set    approved_date  = sysdate, 
	           user_state     = 'authorized',
	           approving_user = :admin_id
	    where  user_id        = :user_id
             <ad:db_bind><%=admin_id%></ad:db_bind>
             <ad:db_bind><%=user_id%></ad:db_bind>
           </ad:db_query>
	<% db.dml(set_user_state);


 }
 } else {
	throw new WarningException("Invalid User State",
	                  "The user account you are attempting to approve is currently in an unrecognized state in the database.");
 }

Utilities.sendMail(user_info.get("email"), Parameters.get("NewRegistrationEmailAddress", "", ""), 
                   "Welcome to " + Parameters.get("SystemName", "", "this server"), 
                   "Welcome to " + Parameters.get("SystemName", "", "this server") + 
                   "Your membership to " + Parameters.get("SystemName", "", "this server") +   
                   "has been approved. Please return to " + Parameters.get("URL", "", "this server"));

// Redirect back to the need_admin_approv page so the administrator can
// continue with other users if necessary

response.sendRedirect("view?user_state=need_admin_approv");

%>

</ad:page>
