<%@ include file="/acs.jspi" %>

<ad:page>
<ad:get_user_info id="user" />
<ad:page_contract id="pc" vars="target passthrough:optional email:optional last_name:optional"> 

<%
// this page will look up users either by email or last name
if (Utilities.emptyString(email) && Utilities.emptyString(last_name)) {
	pc.addComplaint("You must supply either a last name or e-mail.");
}
%>
</ad:page_contract>

<%

// get passthroughs for export
// the actual extra vars passed through are unknown to us in the page
// contract, so we have to pull them out manually from the request
String passthroughVars = Utilities.exportURLVars(request, passthrough);

String like = "";
String column = "";

if (!Utilities.emptyString(email)) {
	like = "%" + email + "%";
	column = "email";
} else {
  	like = "%" + last_name + "%";
	column = "last_name";
}
%>

<ad:db_query id="lookup">
select user_id, email, first_names || ' ' || last_name as name
from users 
where lower(<%= column %>) like lower(?)
order by last_name
<ad:db_bind><%= like %></ad:db_bind>
</ad:db_query>

<ad:header>User Search</ad:header>
<h2>Search Results</h2>
<hr>

Your search returned the following results:

<p>
<ul>
<ad:db_foreach in="lookup" row="rs"> 
 <li>
<a href="<%= target %>?user_id_from_search=<%= rs.getString("user_id") %>&<%= passthroughVars %>"><%= rs.getString("name") %> (<%= rs.getString("email") %>)</a>
</ad:db_foreach>
<ad:if_no_rows>
 Your search did not return any users.
</ad:if_no_rows>




