<%@ include file="/acs.jspi" %>
<ad:page>
<ad:page_contract id="pc" vars="user_id email password password_confirmation first_names last_name"> 
<%
 if (!Utilities.emailValidP(email)) {
    pc.addComplaint("<li>The email address that you typed doesn't look right to us.  Examples of valid email addresses are <ul><li>Alice1234@aol.com<li>joe_smith@hp.com<li>pierre@inria.fr</ul>");
 }
 if (Utilities.emptyString(user_id)) {
    pc.addComplaint("User ID is empty");
 }
 if (Utilities.emptyString(first_names)) {
    pc.addComplaint("First name is empty");
 }
 if (Utilities.emptyString(last_name)) {
    pc.addComplaint("Last name is empty");
 }
 if (first_names.indexOf('<') >= 0) {
    pc.addComplaint("You can't have a &lt; in your first name because it will look like an HTML tag and confuse other users.");
 }
 if (last_name.indexOf('<') >= 0) {
    pc.addComplaint(" You can't have a &lt; in your last name because it will look like an HTML tag and confuse other users.");
 }
 if (!password.equals(password_confirmation)) {
    pc.addComplaint("Your two password entries do not match.");
 }
%>
</ad:page_contract>

<ad:get_user_info id="user"/>
<%
 /* user_id datasource, default 0  */
 Integer admin_user_id = new Integer(0);
 if (user != null) {
   admin_user_id = user.getUserId();
 }
%>
<ad:db_string obj="email_count" default="0">
	select count(email)
	from   users where upper(email) = upper(:email) 
	and    user_id <> :user_id
<ad:db_bind><%= email %></ad:db_bind>
<ad:db_bind><%= user_id %></ad:db_bind>
</ad:db_string>

<% if (!request.getAttribute("email_count").equals("0")) {
	throw new WarningException("Email already in database", "<li> " + email+ " was already in the database.");
   }

if (Utilities.emptyString(password)) {
    password = Utilities.generateRandomString();    
}

String registration_ip=request.getRemoteAddr();

 ContextBar navbar = new ContextBar(pageContext); 
 navbar.add("index", "Users");
 navbar.add("Notify Added  User");
%>

<ad:db_query id="insert_user">
    insert into users 
    (user_id,
     email,
     password,
     first_names,
     last_name,
     registration_date,
     registration_ip, 
     user_state) 
    values 
    (:user_id,
     :email,
     :password, 
     :first_names,
     :last_name, 
      sysdate, 
     :registration_ip, 
     'authorized')
<ad:db_bind> <%=user_id %></ad:db_bind>
<ad:db_bind> <%=email %></ad:db_bind>
<ad:db_bind> <%=password %></ad:db_bind>
<ad:db_bind> <%=first_names %></ad:db_bind>
<ad:db_bind> <%=last_name %></ad:db_bind>
<ad:db_bind> <%=registration_ip%></ad:db_bind>
</ad:db_query>
<% db.dml(insert_user); %>

<ad:db_string obj="administration_name">
select first_names || ' ' || last_name 
from   users 
where  user_id = :admin_user_id
<ad:db_bind><%= admin_user_id %></ad:db_bind>
</ad:db_string>

<ad:header>Added user</ad:header>

<h2>Added user <%= first_names%> <%=last_name%></h2>

<%= navbar %>

<hr>

<%= first_names%> <%=last_name%> has been added to <a href="index">all users of <%=Parameters.get("SystemName", "", "this server")%></a> 
Edit the message below and hit "Send Email" to 
notify this user.

<p>
<form method=POST action="user-add-3">
<%=Utilities.exportFormVars(request, "email first_names last_name user_id")%>

<p>Message:

<blockquote>

<textarea name=message rows=10 cols=70 wrap=hard>
<%= first_names%> <%=last_name%>, 

You have been added as a user to <%=Parameters.get("SystemName", "", "this server")%>
at <%=Parameters.get("SystemUrl", "", "URL not specified")%>

Login information:
Email: <%=email%>
Password: <%=password%> 
(you may change your password after you log in)

Thank you,
<%= request.getAttribute("administration_name")%>
</textarea>
</blockquote>

<p>

<center>

<input type=submit value="Send Email">

</center>

</form>

<p>

<ad:footer />
</ad:page>

