<%@ include file="../acs.jspi" %>

<ad:page>

<ad:page_contract id="pc" vars="msg_id deletion_ids:optional,multiple">

<%
if (deletion_ids == null) {
    pc.addComplaint("You must select at least one message to delete.");
} else {
	// each deletion_id has to be a base-64 number
	// verify here so we can safely avoid using bind vars
	// (yeah, this sucks)
	Perl5Util re = new Perl5Util();
	for (int i = 0; i < deletion_ids.length; i++) { 
		if (re.match("/[^0-9a-zA-z]/", deletion_ids[i])) {
			pc.addComplaint("Invalid msg id: " + deletion_ids[i]);
		}
	}
}
%>
</ad:page_contract>

<ad:get_user_info id="user"/>

<%
SingleTopicDataSource theTopic = new SingleTopicDataSource(db, msg_id);
request.setAttribute("topic", theTopic);
if (!theTopic.authorizeUser(user,pageContext)
  || !theTopic.adminAuthorize(user, pageContext)) { 
    return;
}
 
// OK, user is authorized to edit the root message
// let's check the messages to be deleted

String deletion_str = "'" + Utilities.join(deletion_ids, "','") + "'";

%>

<ad:db_query id="getSortKeys">
select sort_key from bboard 
where msg_id in (<%= deletion_str %>)
</ad:db_query>

<%
Vector sort_keys = db.queryToList(getSortKeys);
String thread_start_msg_id = "";
for (int i = 0; i<sort_keys.size(); i++) { 
    String sort_key = (String)sort_keys.elementAt(i);
    if (sort_key.indexOf(".") == -1) {
	// there is no period in the sort key so this is the start of a thread
	thread_start_msg_id = sort_key;
    } else {
	// strip off the stuff before the period
	thread_start_msg_id = sort_key.substring(0, sort_key.indexOf("."));
    }
    if (!thread_start_msg_id.equals(msg_id)) {
	response.sendError(response.SC_INTERNAL_SERVER_ERROR, "bug in my software, and/or someone has been tampering with the deletion_ids\n<hr>One of the messages to be deleted doesn't seem to be part of the thread that you were just editing.  This is probably a bug in my code. But I'm still not going to do the deletion because it is too much of a security risk.");
	return;
    }
}

// we're authorized for all the submessages too

%>

<ad:db_transaction>

<ad:db_query id="getFiles">
select filename_stub 
from bboard_uploaded_files 
where msg_id IN (<%= deletion_str %>)
</ad:db_query>

<%
if (parameters.getBoolean("FileUploadingEnabledP", "bboard")) { 
    Vector list_of_files_to_delete = db.queryToList(getFiles);

    db.dml("delete from bboard_uploaded_files where msg_id in (" + deletion_str + ")");
    
    // ADD THE ACTUAL DELETION OF FILES
    File pathToFiles = new File(parameters.get("FilePath", "bboard"));
    for (int i = 0; i < list_of_files_to_delete.size(); i++) {

	File f = new File(pathToFiles, (String)list_of_files_to_delete.elementAt(i));
	if (!f.delete()) {
	    Log.error("admin-bulk-delete: could not delete file: " + f);
	}
    }
}

db.dml ("delete from bboard_thread_email_alerts where thread_id in (" + deletion_str + ")");

db.dml("delete from bboard where msg_id in (" + deletion_str + ")");

%>

</ad:db_transaction>

<ad:header>Success</ad:header>
</head>

<h2>Success</h2>

<hr>

<%= deletion_ids.length %> message(s) have been removed from the database.

<ad:footer/>
