<%--
# /www/bboard/admin-community-pick.tcl
ad_page_contract {
    Randomly picks some people

    @param topic the name of the forum we are picking posters from
    @param topic_id the ID of the bboard forum
    @param n_postings the minimum number of postings to qualify
    @param n_winners the number of people to pick
    
    @cvs-id $Id: admin-community-pick.jsp,v 1.1 2000/09/22 16:29:13 bschneid Exp $
--%>

<%@ include file="../acs.jspi" %>
<ad:page>
<ad:page_contract vars="topic topic_id:integer n_postings:integer start_date:date end_date:date n_winners:integer"/>

<ad:get_user_info id="user"/>

<%
SingleTopicDataSource theTopic = new SingleTopicDataSource(db, topic_id);
request.setAttribute("topic", theTopic);

if (!theTopic.authorizeUser(user, pageContext) || !theTopic.adminAuthorize(user, pageContext)) { 
    return;
} 
%>

<ad:db_query id="pick_winner">
    select distinct email, 
    	   upper(email) as upper_email, 
    	   count(*) as how_many_posts
    from   bboard, users
    where  bboard.user_id = users.user_id
    and    topic_id = :topic_id
    and    posting_time >= to_date(:ora_start,'YYYY-MM-DD')
    and    posting_time <= to_date(:ora_end,'YYYY-MM-DD')
    and    bboard.user_id = users.user_id
    group by email
<% if (n_postings.intValue() >= 2) { %>
    having count(*) >= :n_postings
<ad:db_bind name="n_postings"><%= n_postings %></ad:db_bind>
<% } %>
    order by upper_email
<ad:db_bind><%= topic_id %></ad:db_bind>
<ad:db_bind><%= start_date %></ad:db_bind>
<ad:db_bind><%= end_date %></ad:db_bind>
</ad:db_query>

<%
String last_upper_email = "";
AdSet distinct_emails = new AdSet();

// let's build up an ns_set so that we don't give unfair advantage
// to people who vary their capitalization
%>

<ad:db_foreach in="pick_winner" row="rs">
<%
    if (!last_upper_email.equals(rs.getString("upper_email"))) {
	distinct_emails.put(rs.getString("email"), rs.getString("how_many_posts"));
    } 
    last_upper_email = rs.getString("upper_email");
%>
</ad:db_foreach>

<%
int n_users = distinct_emails.size();
request.setAttribute("n_users", new Integer(n_users));
Vector winner_emails = new Vector();
if (n_users >= n_winners.intValue()) {
    // enough people
    // seed the random number generator
    Random r = new Random();
    for (int i = 0; i < n_winners.intValue(); i++) {
	// pick an index
	int index = r.nextInt(distinct_emails.size());
	String[] keys = distinct_emails.keys();
	AdSet winner = new AdSet();
	winner.put("email", keys[index]);
	winner.put("n_postings", distinct_emails.get(keys[index]));
	winner_emails.addElement(winner);
	distinct_emails.deleteKey(keys[index]);
    }
}
request.setAttribute("winners", new VectorDataSource(winner_emails));
request.setAttribute("n_postings", n_postings);
request.setAttribute("n_winners", n_winners);
request.setAttribute("start_date", start_date);
request.setAttribute("end_date", end_date);
%>

<ad:use_template/>
</ad:page>