<%--
# /www/bboard/admin-expired-threads-delete.tcl
ad_page_contract {
    deletes old threads

    @cvs-id $Id: admin-expired-threads-delete.jsp,v 1.1 2000/09/22 16:29:13 bschneid Exp $
--%>

<%@ include file="../acs.jspi" %>
<ad:page>
<ad:page_contract vars="topic topic_id:integer"/>

<ad:get_user_info id="user"/>

<%
SingleTopicDataSource theTopic = new SingleTopicDataSource(db, topic_id);
request.setAttribute("topic", theTopic);

if (!theTopic.authorizeUser(user, pageContext) || !theTopic.adminAuthorize(user, pageContext)) { 
    return;
} 
request.removeAttribute("topic");
%>

<ad:header>Deleting expired threads in <%= topic %></ad:header>


<h2>Expired Threads</h2>

in the <a href="admin-home?<%= Utilities.exportURLVars(request, "topic topic_id") %>"><%= topic %> question and answer forum</a>

<hr>

<ul>

<ad:db_query id="old_threads">
select msg_id, one_line, sort_key
from   bboard 
where  topic_id = :topic_id
and    (posting_time + expiration_days) < sysdate
and    refers_to is null
order by sort_key <%= theTopic.get("q_and_a_sort_order") %>
<ad:db_bind><%= topic_id %></ad:db_bind>
</ad:db_query>

<ad:db_foreach in="old_threads" row="rs">
 <li>working on <%= rs.getString("one_line") %> and its dependents...
<%
String msg_id = rs.getString("msg_id");
String dependent_key_form = BBoard.dependentSortKeyForm(msg_id);
Vector dependent_ids = db.queryToList 
 ("select msg_id from bboard where sort_key like :dependent_key_form",
 new Object[] {dependent_key_form});
String deletion_list = Utilities.join(dependent_ids, "','");
%>

<ad:db_transaction>

<ad:db_query id="get_file_list">
select filename_stub 
from bboard_uploaded_files 
where msg_id in ('<%= msg_id %>', '<%= deletion_list %>')
</ad:db_query>

<% 
if (parameters.getBoolean("FileUploadingEnabledP", "bboard")) { 
    Vector list_of_files_to_delete = db.queryToList(get_file_list);
    db.dml("delete from bboard_uploaded_files where msg_id in ('" + deletion_list + "')");
    File pathToFiles = new File(parameters.get("FilePath", "bboard"));
    for (int i = 0; i < list_of_files_to_delete.size(); i++) {
	File f = 
	  new File(pathToFiles, (String)list_of_files_to_delete.elementAt(i));
	if (!f.delete()) {
	    Log.error("admin-expired-threads-delete: could not delete file: " + f);
	}
    }
}

db.dml("delete from bboard_thread_email_alerts where thread_id in ('" + msg_id + "', '" + deletion_list + "')");

db.dml("delete from bboard where msg_id in ('" + msg_id + "', '" + deletion_list + "')");
%>
</ad:db_transaction>
... success! killed <%= dependent_ids.size() %> dependents.
</ad:db_foreach>

<ad:if_no_rows>
<li> There were no expired messages to delete.
</ad:if_no_rows>
</ul>

<ad:footer/>