<%@ include file="../acs.jspi" %>
<%
/*
# /www/bboard/admin-q-and-a.tcl
ad_page_contract {
    actually shows the questions so that an admin can choose 
    some to view/moderate; Q&A style presentation

    @param topic_id the ID of the bboard topic

    @author philg@mit.edu
    @creation-date 1995
*/
%>

<ad:page>
<ad:page_contract vars="topic_id:integer"/>
<ad:get_user_info id="user"/>

<%
SingleTopicDataSource theTopic = new SingleTopicDataSource(db, topic_id);
request.setAttribute("topic", theTopic);
if (!theTopic.authorizeUser(user, pageContext) || !theTopic.adminAuthorize(user, pageContext)) { 
    return;
} 
// the administrator can always post a new question
%>

<ad:db_query id="get_messages">
select msg_id, 
       one_line, 
       sort_key, 
       email,
       first_names || ' ' || last_name as name, 
       interest_level
from   bboard, 
       users
where  users.user_id = bboard.user_id 
and    topic_id = :topic_id
and    refers_to is null
order by sort_key <%= theTopic.get("q_and_a_sort_order") %>
<ad:db_bind><%= topic_id %></ad:db_bind>
</ad:db_query>

<%
ContextBar navbar = new ContextBar(ContextBar.PERSONAL_OR_INDEX, user); 
navbar.add("index", BBoard.getSystemName());
navbar.add(theTopic.getBackLink(), theTopic.get("topic"));
navbar.add("admin-home?" + Utilities.exportURLVars(theTopic, "topic topic_id"),
"Administer");
navbar.add("By Question");

request.setAttribute("navbar", navbar);
request.setAttribute("messages", new MessagesDataSource(get_messages, db));
%>

<ad:use_template/>

</ad:page>