<%@ include file="../acs.jspi" %>

<ad:page>
<ad:page_contract vars="msg_id"/>
<ad:get_user_info id="user"/>

<%
// now we know the topic for this message, make sure the user is
// authorized
SingleTopicDataSource theTopic = new SingleTopicDataSource(db, msg_id);
request.setAttribute("topic", theTopic);
if (!theTopic.authorizeUser(user, pageContext)) {
    return;
}
if (!theTopic.adminAuthorize(user, pageContext)) {
    return;
}
%>

<ad:db_query id="msg_info_with_file">
select b.posting_time as posting_date,
       to_char(b.posting_time, 'Month fmdd, yyyy') as pretty_date,
       b.one_line, 
       b.msg_id,
       b.message,
       b.originating_ip,
       b.epa_region,
       b.usps_abbrev,
       b.fips_county_code,
       b.interest_level,
       b.category,
       b.html_p,
       b.expiration_days,
       bt.topic,
       u.email,
       u.first_names || ' ' || u.last_name as name, 
       buf.bboard_upload_id,
       buf.file_type,
       buf.n_bytes,
       buf.client_filename,
       buf.caption,
       buf.original_width,
       buf.original_height
from   bboard b, 
       bboard_topics bt, 
       users u, 
       bboard_uploaded_files buf
where  bt.topic_id = b.topic_id
and    b.user_id = u.user_id
and    b.msg_id = buf.msg_id(+)
and    b.msg_id = :msg_id
<ad:db_bind><%= msg_id %></ad:db_bind>
</ad:db_query>

<ad:db_query id="msg_info">
select to_char(posting_time,'YYYY-MM-DD') as posting_date,
       to_char(b.posting_time, 'Month fmdd, yyyy') as pretty_date,
       b.one_line, 
       b.message,
       b.originating_ip,
       b.epa_region,
       b.usps_abbrev,
       b.fips_county_code,
       b.interest_level,
       b.category,
       b.html_p,
       b.expiration_days,
       u.first_names || ' ' || u.last_name as name, 
       u.email, 
       bt.topic
from   bboard b, 
       users u, 
       bboard_topics bt
where  u.user_id = b.user_id
and    b.topic_id = bt.topic_id
and    msg_id = :msg_id
<ad:db_bind><%= msg_id %></ad:db_bind>
</ad:db_query>

<% 
ResultSet rs;
if (parameters.getBoolean("FileUploadingEnabledP", "bboard")) {
 rs = db.query(msg_info_with_file) ;
} else { 
 rs = db.query(msg_info);
}
SingleMessageDataSource theMessage = null;
if (rs.next()) {
 theMessage = new SingleMessageDataSource(rs);
} else {
%>
 Couldn't find message <%= msg_id %>.  Probably it was deleted by the forum 
 maintainer.
 <% out.close(); %>
<% } %>

<ad:db_query id="get_replies">
select decode(email,'<%= theTopic.get("maintainer_email") %>','f','t') as not_maintainer_p, 
       to_char(posting_time,'YYYY-MM-DD') as posting_date,
       to_char(b.posting_time, 'Month fmdd, yyyy') as pretty_date,
       b.originating_ip,
       b.one_line,
       b.message,
       b.html_p,
       b.msg_id,
       users.first_names || ' ' || users.last_name as name, 
       users.email
from   bboard b, 
       users
where  b.user_id = users.user_id
and    sort_key like :msg_id_base
and    msg_id <> :msg_id
order by not_maintainer_p, sort_key
<ad:db_bind><%= msg_id %>%</ad:db_bind>
<ad:db_bind><%= msg_id %></ad:db_bind>
</ad:db_query>

<%
if (theTopic.get("q_and_a_categorized_p").equals("t")) { 
%>
<ad:db_query id="get_categories">
    select distinct category, upper(category) 
    from bboard_q_and_a_categories 
    where topic_id = :topic_id 
    order by 2
<ad:db_bind><%= theTopic.get("topic_id") %></ad:db_bind>
</ad:db_query>
<% 
 request.setAttribute("categories", new Selection(get_categories, db));
}

request.setAttribute("message", theMessage);
request.setAttribute("replies", new MessagesDataSource(get_replies, db));
%>

<ad:use_template/>


</ad:page>