<%@ include file="/acs.jspi" %>

<ad:page>

<ad:get_user_info id="user" />

<% Integer user_id = user.getUserId(); 
String sort_key = "";
TopicsDataSource theTopic = null;
com.oroinc.text.perl.Perl5Util re = new com.oroinc.text.perl.Perl5Util();
String msg_id = "";
%>

<ad:page_contract vars="message one_line notify html_p:optional topic_id:integer,optional topic category:optional refers_to custom_sort_key:optional custom_sort_key_pretty:optional urgent_p:optional caption:optional upload_file:optional,file" id="pc">

<% 

/*
####################
#
# Input validation
#
####################


# message, one_line, notify, html_p
# topic_id, topic are hidden vars
# refers_to is "NEW" or a msg_id (six characters)

# we MAY get an image or other file along with this msg, which means
# we'd get the file name in "upload_file" and can get out the temp file
# with ns_queryget

# we're going to need to subquery for instant keyword matching
# and/or looking around for state and county from tri_id
*/

// TO DO: HTML security check

// check the user input first
// Unfortunately not so well suited to using page_validation
%>

<ad:db_query id="selection">
    select the_regexp, scope, message_to_user
    from bboard_bozo_patterns
    where topic_id = ?
<ad:db_bind><%= topic_id %></ad:db_bind>
</ad:db_query>

<%
ResultSet rs = db.query(selection);
while(rs.next()) {
    String scope = rs.getString("scope");
    if (scope != null && (scope.equals("one_line") || scope.equals("both"))) {
	// let's check the subject line for this regexp
	if (re.match("/" + rs.getString("the_regexp") + "/", one_line)) {
	    pc.addComplaint(rs.getString("message_to_user"));
	    break;
	}
    }
    if (scope != null && (scope.equals("message") || scope.equals("both"))) {
	if (re.match("/" + rs.getString("the_regexp") + "/", message)) {
	    pc.addComplaint(rs.getString("message_to_user"));
	    break;
	}
    }
}
%>

<ad:db_query id="dup_check">
select count(*) from bboard 
where topic_id = ?
and one_line = ?
and dbms_lob.instr(message,?) > 0
<ad:db_bind><%= topic_id %></ad:db_bind>
<ad:db_bind><%= one_line %></ad:db_bind>
<ad:db_bind><%= message %></ad:db_bind>
</ad:db_query>

<ad:db_query id="dup_list">
		select u.first_names
		, u.last_name
		, u.email
		, bb.posting_time 
		from bboard bb
		, users u
		where bb.user_id= u.user_id
		and bb.topic_id = :topic_id
		and bb.one_line = :one_line
		and dbms_lob.instr(message,:message) > 0
<ad:db_bind><%= topic_id %></ad:db_bind>
<ad:db_bind><%= one_line %></ad:db_bind>
<ad:db_bind><%= message %></ad:db_bind>
</ad:db_query>

<%
try {
    theTopic = new SingleTopicDataSource(db, topic_id);
} catch(java.sql.SQLException ex) {
    pc.addComplaint("Could not find topic.");
}

// authorize user
if (!theTopic.authorizeUser(user, pageContext)) { 
	return;
}

if (message.length() < 4000) {
    // For now, we only check for duplicates if the message is shorter
    // than 4000 bytes.

    String count = db.queryToString(dup_check);
    if (!count.equals("0")) {
	String complaint = "There are already " + count + " messages in the database with the same subject line and body.  Perhaps you already posted this?  Here are the messages: <ul>";
	rs = db.query(dup_list);
	while (rs.next()) {
	    complaint += "<li>" + rs.getString("posting_time") + " by " + rs.getString("first_names") + " " + rs.getString("last_name") + " (" + rs.getString("email") + ")\n";
	}
	complaint += "</ul>\nIf you are sure that you also want to post this message, then back up and change at least one character in the subject or message area, then resubmit.";
	pc.addComplaint(complaint);
    }
}
%>

</ad:page_contract>

<% 
/*
###################
# Email Queue proc
#
####################

# email_queue is a list; each elementof the list is an ns_set 
# containing information about an email to be sent
#
# The keys in each ns_set:
# to: to email
# from: from email
# subject:  subject heading
# body:  body
# user_message: message to output to the Web user about this email
# extraheaders: ns_set containing header name/content pairs for ns_sendmail
*/

EmailQueue emailQueue = new EmailQueue();

/*
####################
#
# Insert message into database
#
####################
*/

%>

<ad:db_transaction>

<% 
// Ugh.  This is a huge amount of stuff to do in a transaction. 
String new_id = BBoard.getNextId(db);
String final_refers_to = "";

if ("NEW".equals(refers_to)) {
    // this is a new message
    sort_key = new_id;
    final_refers_to = "";
} else {
    // we are referring to some older message
    final_refers_to = refers_to;
    String sort_key_of_referred_to_msg = db.queryToString("select unique sort_key  from bboard where msg_id = ?", new Object[] {refers_to});
    String new_sort_key_form = BBoard.newSortKeyForm(sort_key_of_referred_to_msg);

    String highest_current_sort_key_at_this_level = db.queryToString(
    "select max(sort_key) from bboard where sort_key like ?",
    new Object[] {new_sort_key_form});
    
    sort_key = BBoard.newSortKey(sort_key_of_referred_to_msg, highest_current_sort_key_at_this_level);

}

msg_id = sort_key.substring(0,6); 
    
// sometimes an optional $category variable is included
String category_target = "";
String category_value = "";
if (!Utilities.emptyString(category))  {
    category_target =  ",category";
    category_value = ",:category";
}
    
String custom_target = "";
String custom_value  = "";

// sometimes an optional custom_sort_key and custom_sort_key_pretty
// other vars come from bboard_topics
if (!Utilities.emptyString(custom_sort_key) ||
 (theTopic.get("custom_sort_key_p").equals("t"))  && 
 (theTopic.get("custom_sort_solicit_p").equals("t")) && 
 (theTopic.get("custom_sort_key_type").equals("date"))) {
     // there was a form var called "custom_sort_key" or we're looking 
     // for a magically encoded date
     custom_target = ",custom_sort_key";

     if (theTopic.get("custom_sort_key_type").equals("date")) {
	 // have to decode from widget
	 // ns_dbformvalue [ns_conn form] custom_sort_key date custom_sort_key
     }

     custom_value = ",:custom_sort_key";

     if (!Utilities.emptyString(custom_sort_key_pretty)) {
	 custom_target += ",custom_sort_key_pretty";
	 custom_value += ",:custom_sort_key_pretty";
     }
} 

// No longer need sub handle, release it here so we don't keep it through
// image uploading below.

String urgent_p_target = "";
String urgent_p_value = "";
if (!Utilities.emptyString(urgent_p)) {
    urgent_p_target = ", urgent_p";
    urgent_p_value = ", :urgent_p";
}

// to provide some SPAM-proofing, we record the IP address
String originating_ip = request.getRemoteAddr();

%>

<ad:db_query id="insert_msg_clob">
begin
  insert into bboard 
        ( msg_id
	, refers_to
	, topic_id
	, originating_ip
	, user_id
	, one_line
	, message
	, html_p
	, sort_key
	, posting_time<%= category_target %><%= custom_target %><%= urgent_p_target %>)
	values (:new_id
	, :final_refers_to
	, :topic_id
	, :originating_ip
	, :user_id
	, :one_line
	, empty_clob()
	, :html_p
	, :sort_key
	, sysdate<%= category_value %><%= custom_value %><%= urgent_p_value %>
        )
	returning message into ?;
end;
<ad:db_bind><%= new_id %></ad:db_bind>
<ad:db_bind><%= final_refers_to %></ad:db_bind>
<ad:db_bind><%= topic_id %></ad:db_bind>
<ad:db_bind><%= originating_ip %></ad:db_bind>
<ad:db_bind><%= user_id %></ad:db_bind>
<ad:db_bind><%= one_line %></ad:db_bind>
<ad:db_bind><%= html_p %></ad:db_bind>
<ad:db_bind><%= sort_key %></ad:db_bind>
<% if (category_value.length() > 0) { %>
  <ad:db_bind><%= category %></ad:db_bind>
<% } 
if (custom_value.length() > 0) { %>
  <ad:db_bind><%= custom_sort_key %></ad:db_bind>
<%    if (custom_value.indexOf("pretty") > 0) { %>
         <ad:db_bind><%= custom_sort_key_pretty %></ad:db_bind>
<%    } 
} 
if (urgent_p_value.length() > 0) { %>
  <ad:db_bind><%= urgent_p %></ad:db_bind>
<% } %>
</ad:db_query>

<ad:db_query id="insert_msg_no_clob">
  insert into bboard 
        ( msg_id
	, refers_to
	, topic_id
	, originating_ip
	, user_id
	, one_line
	, message
	, html_p
	, sort_key
	, posting_time<%= category_target %><%= custom_target %><%= urgent_p_target %>)
	values (:new_id
	, :final_refers_to
	, :topic_id
	, :originating_ip
	, :user_id
	, :one_line
	, :message
	, :html_p
	, :sort_key
	, sysdate<%= category_value %><%= custom_value %><%= urgent_p_value %>
        )
<ad:db_bind><%= new_id %></ad:db_bind>
<ad:db_bind><%= final_refers_to %></ad:db_bind>
<ad:db_bind><%= topic_id %></ad:db_bind>
<ad:db_bind><%= originating_ip %></ad:db_bind>
<ad:db_bind><%= user_id %></ad:db_bind>
<ad:db_bind><%= one_line %></ad:db_bind>
<ad:db_bind><%= message %></ad:db_bind>
<ad:db_bind><%= html_p %></ad:db_bind>
<ad:db_bind><%= sort_key %></ad:db_bind>
<% if (category_value.length() > 0) { %>
  <ad:db_bind><%= category %></ad:db_bind>
<% } 
if (custom_value.length() > 0) { %>
  <ad:db_bind><%= custom_sort_key %></ad:db_bind>
<%    if (custom_value.indexOf("pretty") > 0) { %>
         <ad:db_bind><%= custom_sort_key_pretty %></ad:db_bind>
<%    } 
} 
if (urgent_p_value.length() > 0) { %>
  <ad:db_bind><%= urgent_p %></ad:db_bind>
<% } %>
</ad:db_query>

<ad:db_query id="insert_category">
	insert into bboard_q_and_a_categories 
	(topic_id, category) 
	select :topic_id, :category 
	from dual 
	where :category not in 
          (select category from bboard_q_and_a_categories)
<ad:db_bind><%= topic_id %></ad:db_bind>
<ad:db_bind><%= category %></ad:db_bind>
<ad:db_bind><%= category %></ad:db_bind>
</ad:db_query>

<%
// we can't bind string literals longer than 4000 bytes, but we can put them
// in as strings
if (message.length() > 4000) { 
 db.clobDml(insert_msg_clob, message);
} else {
 db.dml(insert_msg_no_clob);
}

// (bran Apr 4 2000)
// Add new category if necessary

String user_extensible_p = theTopic.get("q_and_a_cats_user_extensible_p");
if (user_extensible_p.equals("t") && !Utilities.emptyString(category)) {
    // a semi-perverse way of checking that the category doesn't
    // already exist
    db.dml(insert_category);
}

// Insert thread notifications
if (notify.equals("t")) {
    // (bran Feb 13 2000)
    String notify_thread_id = sort_key.substring(0,6);
    // Check for existing notifications for same thread.
    String n_alerts = db.queryToString(
    "select count(*) from bboard_thread_email_alerts where thread_id = :notify_thread_id and user_id = :user_id",
    new Object[] {notify_thread_id, user_id});
    if (n_alerts.equals("0")) {
	db.dml("insert into bboard_thread_email_alerts ( thread_id, user_id) values ( :notify_thread_id , :user_id  )",
	new Object[] { notify_thread_id, user_id });
    }
}

// Handle image uploading
if (parameters.getBoolean("FileUploadingEnabledP", "bboard") && !Utilities.emptyString(upload_file)) { 
    java.io.File uploadFile = new java.io.File(upload_file_tmpfile);
    String new_upload_id = db.queryToString("select bboard_upload_id_sequence.nextval from dual");
    
    re.match("/(\\.[^\\.]+)/", upload_file);
    String fileExt = re.group(1).toLowerCase();
    String localFilename = new_id + "-" + new_upload_id + fileExt;
    String full_local_path = parameters.get("FilePath", "bboard") + "/" + localFilename;
    
    long n_bytes = uploadFile.length();
    if (n_bytes > 0) { 
	// we have a real image
	Utilities.copyFile(uploadFile, new java.io.File(full_local_path));

	String extra_uf_columns = "";
	String extra_uf_values = "";
	String file_type = "not a photo";
	if (!Utilities.emptyString(caption)) {
	    // we have a photo 
	    extra_uf_columns = ", caption";
	    extra_uf_values = ", :caption";
	    file_type = "photo";
	}

	String original_width = "";
	String original_height = "";

	try {
	    ImageSize imageSize = new ImageSize(full_local_path);
	    original_width = Integer.toString(imageSize.getWidth());
	    original_height = Integer.toString(imageSize.getHeight());
	} catch (Exception e) {
	    Log.error("get image size failed: " + e.getMessage());
	} 

	// strip off the C:\directories... crud and just get the file name
	// (branimir 2000/04/09)
	// For some reason the earlier regexp {([^//\]+)$} doesn't
	// work any more in Tcl 8.2.  The new {([^//\\]+)$} works
	// everywhere.

	String client_filename = upload_file;
	if (re.match("@([^//\\\\]+)$@", upload_file)) {
	    client_filename = re.group(1);
	} 
%>

<ad:db_query id="file_insert">
insert into bboard_uploaded_files 
    ( bboard_upload_id
    , msg_id
    , file_type
    , file_extension
    , n_bytes
    , client_filename
    , filename_stub <%= extra_uf_columns %>
    , original_width
    , original_height)
values 
 ( :new_upload_id
 , :new_id 
 , :file_type
 , :file_extension 
 , :n_bytes
 , :client_filename
 , :local_filename <%= extra_uf_values %>
 , :original_width 
 , :original_height)
<ad:db_bind><%= new_upload_id %></ad:db_bind>
<ad:db_bind><%= new_id %></ad:db_bind>
<ad:db_bind><%= file_type %></ad:db_bind>
<ad:db_bind><%= fileExt %></ad:db_bind>
<ad:db_bind><%= n_bytes %></ad:db_bind>
<ad:db_bind><%= client_filename %></ad:db_bind>
<ad:db_bind><%= localFilename %></ad:db_bind>
<ad:db_bind><%= original_width %></ad:db_bind>
<ad:db_bind><%= original_height %></ad:db_bind>
<ad:db_bind name="caption"><%= caption %></ad:db_bind>
</ad:db_query>
<%  
            db.dml(file_insert);
         } // if n_bytes > 0
}          // if file uploading enabled
%>
</ad:db_transaction>

<% 
request.setAttribute("msg_id", msg_id);
request.setAttribute("topic", theTopic);

/*
####################
#
# Email notifications
#
####################
*/

String fromEmail = parameters.get("SenderEmail", "bboard", "bboard@arsdigita.com");
String subjectLine = "";

if (topic.length() < 10) {
    subjectLine = topic + " forum:  " + one_line;
} else {
    subjectLine = one_line;
}

String body_top = "Posted by: " + user.getFullName() + "(" + user.getEmail() + ")\n";
body_top += "Topic    : " + topic + "\n";
body_top += "Subject  : " + one_line +"\n\n";
body_top += Utilities.maybeHtmlToText(message, html_p);
body_top += "\n\n--------------------\n\n";

/*
####################
#
# Notify maintainer
#
####################
*/

if (theTopic.get("notify_of_new_postings_p").equals("t")) {
    // administrator has requested notification of every new posting

    String body = body_top + "\n";
    body += "If you want to delete the message, come to the administration page:\n " + BBoard.urlStub() + "admin-q-and-a-fetch-msg?msg_id=" + msg_id + "\n";
    emailQueue.add(emailQueue.ALERT_MAINTAINER,
	theTopic.get("maintainer_email"),
     fromEmail, one_line, body, user.getEmail());
}

/*
####################
#
# Thread alerts
#
####################
*/

if (!refers_to.equals("NEW")) {
%>

<ad:db_query id="thread_alerts">
	select ua.email as notify_email, ea.rowid
	from bboard_thread_email_alerts ea, users_alertable ua
	where ea.thread_id = :msg_id
	and ea.user_id = ua.user_id
<ad:db_bind><%= msg_id %></ad:db_bind>
</ad:db_query>

<ad:db_foreach row="row" in="thread_alerts">
 <% 
   String body = body_top + "\nTo post a response, come back to the bulletin board at\n\n" + BBoard.urlStub() + "q-and-a-fetch-msg?msg_id=" + msg_id;
   body += "\n\nIf you are no longer interested in this thread, simply go to the\nfollowing URL and you will no longer get these notifications:\n\n";
   body += BBoard.urlStub() + "shut-up?row_id=" + row.getString("rowid");
   emailQueue.add(emailQueue.ALERT_THREAD, row.getString("notify_email"), fromEmail, one_line, body, user.getEmail());
 %>
</ad:db_foreach>

<%
}

/*
####################
# 
# Instant alerts with keywords
#
####################
*/

%>

<ad:db_query id="instant_alerts">
    select distinct bboard_email_alerts.user_id, lower(keywords) as lkeywords,
      bboard_email_alerts.rowid, email as notify_email
    from bboard_email_alerts, users_alertable
    where topic_id= :topic_id
    and frequency='instant'
    and keywords is not null
    and valid_p = 't'
    and users_alertable.user_id = bboard_email_alerts.user_id
<ad:db_bind><%= topic_id %></ad:db_bind>
</ad:db_query>

<ad:db_foreach in="instant_alerts" row="row">
 <%
 Vector v = re.split(row.getString("lkeywords"));
 String indexedStuff = user.getEmail() + user.getFullName() + one_line + message;
 for (int i = 0; i<v.size(); i++) {
  if (indexedStuff.indexOf((String)v.elementAt(i)) >= 0) {
      String body = body_top + "\nIf you are annoyed by this message then just enter the following URL\ninto a browser and you'll disable the alert that generated this mail:\n\n" + BBoard.urlStub() + "alert-disable?rowid=" + row.getString("rowid");
      emailQueue.add(emailQueue.ALERT_INSTANT, row.getString("notify_email"), fromEmail, one_line, body, user.getEmail());
      break;
  }
}
%>

</ad:db_foreach>

<%
/*
####################
# 
# Instant alerts without keywords
#
####################
*/
%>

<ad:db_query id="instant_alerts_no_keys">
    select distinct bboard_email_alerts.user_id, 
      bboard_email_alerts.rowid, email as notify_email
    from bboard_email_alerts, users_alertable
    where topic_id= :topic_id
    and frequency='instant'
    and keywords is null
    and valid_p = 't'
    and users_alertable.user_id = bboard_email_alerts.user_id
<ad:db_bind><%= topic_id %></ad:db_bind>
</ad:db_query>

<ad:db_foreach in="instant_alerts_no_keys" row="row">
 <%
      String body = body_top + "\nIf you are annoyed by this message then just enter the following URL\ninto a browser and you'll disable the alert that generated this mail:\n\n" + BBoard.urlStub() + "alert-disable?rowid=" + row.getString("rowid");
      emailQueue.add(emailQueue.ALERT_INSTANT, row.getString("notify_email"), fromEmail, one_line, body, user.getEmail());
 %>
</ad:db_foreach>

<%

// SEND EMAIL ALERTS!
emailQueue.send();
request.setAttribute("alerts", emailQueue);
%>
<ad:use_template />


