<%@ include file="/acs.jspi" %>

<ad:page>
<ad:page_contract id="pc" vars="msg_id" />

<ad:get_user_info id="user" redirect="false"/>

<% 
// authorize user

SingleTopicDataSource theTopic = new SingleTopicDataSource(db, msg_id);

if (!theTopic.authorizeUser(user, pageContext)) { 
	return;
}
%>

<ad:db_query id="get_question">
select one_line, bboard.topic_id, topic, bboard.user_id, html_p, message, 
  first_names || ' ' || last_name as name, msg_id,
  to_char(posting_time, 'Month fmdd, yyyy') as pretty_time
from bboard, users, bboard_topics
where users.user_id = bboard.user_id
 and bboard.topic_id = bboard_topics.topic_id
 and msg_id = ?
<ad:db_bind><%= msg_id %></ad:db_bind>
</ad:db_query>

<ad:db_query id="get_question_with_file">
select 
  to_char(posting_time, 'Month fmdd, yyyy') as pretty_time,
 bboard.msg_id,
 bboard.topic_id,
 bboard_topics.topic,
 bboard.one_line,
 bboard.message,
 bboard.html_p,
 users.user_id as poster_id,  
 users.first_names || ' ' || users.last_name as name, 
 buf.bboard_upload_id,
 buf.file_type,
 buf.n_bytes,
 buf.client_filename,
 buf.caption,
 buf.original_width,
 buf.original_height
from bboard, bboard_topics, users, bboard_uploaded_files buf
where bboard_topics.topic_id = bboard.topic_id
and bboard.user_id = users.user_id
and bboard.msg_id = buf.msg_id(+)
and bboard.msg_id = ?
<ad:db_bind><%= msg_id %></ad:db_bind>
</ad:db_query>

<ad:db_query id="already_alert">
select count(*)
   from   bboard_thread_email_alerts 
   where  user_id = :user_id
   and    thread_id = :this_msg_id
<ad:db_bind><%= user == null? new Integer(0) : user.getUserId() %></ad:db_bind>
<ad:db_bind><%= msg_id %></ad:db_bind>
</ad:db_query>

<% 
MessagesDataSource question = null;
if (parameters.getBoolean("FileUploadingEnabledP", "bboard")) {
	question = new SingleMessageDataSource(get_question_with_file, db);
} else { 
	question = new SingleMessageDataSource(get_question, db);
}

request.setAttribute("question", question);

ContextBar navbar = new ContextBar(ContextBar.PERSONAL_OR_INDEX, user);
navbar.add("/bboard/index", BBoard.getSystemName());
navbar.add("/bboard/q-and-a?" + Utilities.exportURLVars(question, "topic topic_id"), question.get("topic"));
navbar.add("One Thread");
request.setAttribute("navbar", navbar);

boolean show_alert_link = false;
if (user != null && parameters.getBoolean("EnableThreadEmailAlerts", "bboard", true)) { 
	show_alert_link = db.queryToString(already_alert).equals("0");
}
request.setAttribute("show_alert_link", new Boolean(show_alert_link));

// rs = db.query("select bt.*, u.email as maintainer_email from bboard_topics bt, users u where bt.topic_id=? and bt.primary_maintainer_id = u.user_id");

// TO DO: bboard_return_cannot_find_topic_page
%>

<ad:db_query id="get_replies">
select msg_id, one_line, topic_id, bboard.user_id, html_p, message,
 first_names || ' ' || last_name as name, 
 to_char(posting_time, 'Month fmdd, yyyy') as pretty_time
from bboard, users
where users.user_id = bboard.user_id
 and sort_key like ?
 and msg_id <> ?
<ad:db_bind><%= msg_id %>%</ad:db_bind>
<ad:db_bind><%= msg_id %></ad:db_bind>
</ad:db_query>

<ad:db_query id="get_replies_with_file">
select bboard.msg_id, one_line, topic_id, bboard.user_id, html_p, message,
 first_names || ' ' || last_name as name, 
 to_char(posting_time, 'Month fmdd, yyyy') as pretty_time,
 buf.bboard_upload_id,
 buf.file_type,
 buf.n_bytes,
 buf.client_filename,
 buf.caption,
 buf.original_width,
 buf.original_height
from bboard, users, bboard_uploaded_files buf
where users.user_id = bboard.user_id
 and sort_key like ?
 and bboard.msg_id = buf.msg_id(+)
 and bboard.msg_id <> ?
<ad:db_bind><%= msg_id %>%</ad:db_bind>
<ad:db_bind><%= msg_id %></ad:db_bind>
</ad:db_query>

<% 
if (parameters.getBoolean("FileUploadingEnabledP", "bboard")) {
 request.setAttribute("replies", new MessagesDataSource(get_replies_with_file, db)) ;
} else {
 request.setAttribute("replies", new MessagesDataSource(get_replies, db)) ;
}
%>

<ad:use_template />

</ad:page>