<%@ include file="../acs.jspi" %>

<ad:page>
<ad:page_contract vars="topic topic_id:integer"/>
<ad:get_user_info id="user"/>

<%
SingleTopicDataSource theTopic = new SingleTopicDataSource(db, topic_id);
if (!theTopic.authorizeUser(user, pageContext)) {
    return;
}

String secondToLastVisit = Utilities.getCookieValue(request, "second_to_last_visit");

String title, explanation, query_time_limit;
java.util.Date lastVisit = null;

if (Utilities.emptyString(secondToLastVisit)) {
    title = "postings in the last seven days";
    explanation = "";
    query_time_limit = "sysdate - 7";
} else {
    title = "postings since your last visit";
    lastVisit = new java.util.Date(Integer.parseInt(secondToLastVisit));
    explanation = "These are discussions in which there has been a contribution since your last visit, which we think was " + lastVisit;
    query_time_limit = ":last_visit";
}
%>

<ad:db_query id="get_new_answers">
select bnah.root_msg_id,
       count(*) as n_new,max(bnah.posting_time) as max_posting_time, 
       to_char(max(bnah.posting_time),'YYYY-MM-DD') as max_posting_date, 
       to_char(max(bnah.posting_time),'Month fmdd, yyyy') as pretty_max_posting_date, 
       bboard.one_line as subject_line
from   bboard_new_answers_helper bnah, 
       bboard
where  bnah.posting_time > <%= query_time_limit %>
and    bnah.root_msg_id = bboard.msg_id
and    bnah.topic_id = :topic_id
group by root_msg_id, bboard.one_line
order by max_posting_time desc
<ad:db_bind><%= topic_id %></ad:db_bind>
<% if (query_time_limit.length() > 0) { %>
<ad:db_bind name="last_visit"><%= lastVisit %></ad:db_bind>
<% } %>
</ad:db_query>

<%
ContextBar navbar = new ContextBar(ContextBar.PERSONAL_OR_INDEX, user);
navbar.add("index", BBoard.getSystemName());
navbar.add(theTopic.getBackLink(), topic);
navbar.add("New Postings");

request.setAttribute("new_answers", new MessagesDataSource(get_new_answers,db));
request.setAttribute("topic", topic);
request.setAttribute("title", title);
request.setAttribute("navbar", navbar);
request.setAttribute("explanation", explanation);
%>

<ad:use_template/>

</ad:page>