<%@ include file="../acs.jspi" %>

<ad:page>
<ad:get_user_info id="user" redirect="false"/>
<ad:page_contract id="pc" vars="query_string topic topic_id:integer">

<% 
if (Utilities.emptyString(query_string)) {
    pc.addComplaint("You must supply a query string.");
}
%>

</ad:page_contract>

<% 
SingleTopicDataSource theTopic = new SingleTopicDataSource(db, topic_id);
if (!theTopic.authorizeUser(user, pageContext)) {
    return;
}
String final_query_string = null;
try {
    final_query_string = db.queryToString("select im_convert(:query_string) from dual", new Object[] {query_string});
}  catch (SQLException sqle) { 
    throw new WarningException("Query Failed", "Query failed; you probably don't have site-wide-search installed.");
}
%>

<ad:db_query id="search_results">
    select /*+ FIRST_ROWS */ score(10) as the_score, 
              bboard.*, 
              users.first_names || ' ' || users.last_name as name, 
              users.email
    from bboard, 
         users, 
         site_wide_index sws
    where contains(sws.datastore, :final_query_string, 10) > 0
    and   sws.table_name = 'bboard'
    and   bboard.msg_id = sws.the_key
    and   bboard.user_id = users.user_id
    and   topic_id = :topic_id
    order by 1 desc
<ad:db_bind><%= final_query_string %></ad:db_bind>
<ad:db_bind><%= topic_id %></ad:db_bind>
</ad:db_query>

<% 
ContextBar navbar = new ContextBar(ContextBar.PERSONAL_OR_INDEX, user);
navbar.add("index", BBoard.getSystemName());
navbar.add(theTopic.getBackLink(), topic);
navbar.add("Search Results");

try {
    request.setAttribute("search_results", new MessagesDataSource(search_results,db));
} catch (SQLException sqle) { 
    throw new WarningException("Query Failed", "Query failed; you probably don't have site-wide-search installed.");
}

request.setAttribute("navbar", navbar);
request.setAttribute("query_string", query_string);
request.setAttribute("topic", theTopic);
%>

<ad:use_template/>











