<%@ include file="/acs.jspi" %>

<% // show all of the questions in a Q&A forum %>

<ad:page>
<ad:page_contract vars="topic_id:integer topic" />

<ad:get_user_info id="user" redirect="false"/>

<% 
SingleTopicDataSource theTopic = new SingleTopicDataSource(db, topic_id);

// authorize user
if (!theTopic.authorizeUser(user, pageContext)) { 
	return;
}
 
ContextBar navbar = new ContextBar(ContextBar.PERSONAL_OR_INDEX, user); 
navbar.add("/bboard/index", 
	parameters.get("SystemName", "bboard", "Discussion Forums"));
navbar.add(topic);

request.setAttribute("navbar", navbar);
request.setAttribute("topic_id", topic_id);
request.setAttribute("topic", topic);
%>

<ad:db_query id="get_all_messages">
select msg_id, one_line
 from bboard 
 where topic_id = ?
  and refers_to is null
 order by sort_key <%= theTopic.get("q_and_a_sort_order") %>
<ad:db_bind var="topic_id"/>
</ad:db_query>

<ad:db_query id="get_new_messages">
select msg_id, one_line
 from bboard 
 where topic_id = ?
  and refers_to is null
  and posting_time >  (sysdate - <%= theTopic.get("q_and_a_new_days") %>)
 order by sort_key <%= theTopic.get("q_and_a_sort_order") %>
<ad:db_bind><%= topic_id %></ad:db_bind>
</ad:db_query>

<ad:db_query id="get_old_messages">
select msg_id, one_line, 
 decode(category,null,'t','','t','f') as uncategorized_p,
 category
from bboard 
where topic_id = ?
  and refers_to is null
  and posting_time <= (sysdate - <%= theTopic.get("q_and_a_new_days") %>)
order by uncategorized_p, 
   category, sort_key <%= theTopic.get("q_and_a_sort_order") %>
<ad:db_bind><%= topic_id %></ad:db_bind>
</ad:db_query>

<ad:db_query id="get_category_list">
select category, count(*) as n_threads
from bboard 
where refers_to is null
and topic_id = :topic_id
and category is not null
and category <> 'Don''t Know'
group by category 
order by 1
<ad:db_bind><%= topic_id %></ad:db_bind>
</ad:db_query>

<% 
// get new messages, and get older messages (categorized) separately
if ("t".equals(theTopic.get("q_and_a_categorized_p"))) {
 request.setAttribute("new_messages", new MessagesDataSource(get_new_messages, db));
 if ("t".equals(theTopic.get("q_and_a_show_cats_only_p"))) { 
  request.setAttribute("category_list", new Selection(get_category_list, db));
 } else {
  request.setAttribute("old_messages", new MessagesDataSource(get_old_messages, db));
 }
} else { 
 MessagesDataSource m = new MessagesDataSource(get_all_messages, db);
 request.setAttribute("message_list", m);
}
%>
	
<ad:use_template />

</ad:page>




