<%@ include file="../acs.jspi" %>

<ad:page>
<ad:get_user_info id="user" redirect="false"/>
<ad:page_contract id="pc" vars="query_string">

<% 
if (Utilities.emptyString(query_string)) {
    pc.addComplaint("You must supply a query string.");
}
%>

</ad:page_contract>

<% 
String final_query_string = null;
try {
    final_query_string = db.queryToString("select im_convert(:query_string) from dual", new Object[] {query_string});
}  catch (SQLException sqle) { 
    throw new WarningException("Query Failed", "Query failed; you probably don't have site-wide-search installed.");
}
%>

<ad:db_query id="search_results">
select /*+ FIRST_ROWS */ score(10) as the_score,                                       msg_id, 
                           one_line, 
                           sort_key, 
                           bboard_topics.topic_id,
                           bboard_topics.topic, 
                           bboard_topics.presentation_type
                   from   bboard,
                          bboard_topics, 
                          users, 
                          site_wide_index swi
                   where contains(swi.datastore, :final_query_string, 10) > 0
                   and   swi.table_name = 'bboard'
                   and   bboard.msg_id = swi.the_key
                   and   bboard.user_id = users.user_id
                   and   bboard_topics.topic_id = bboard.topic_id 
                   and (bboard_topics.moderation_policy is null or bboard_topics.moderation_policy != 'private')
                   and (bboard_topics.group_id is null or bboard_topics.group_id in (select group_id from user_group_map where user_id = :user_id))
                   and (active_p = 't' or active_p is null)
                   order by 1 desc
<ad:db_bind><%= final_query_string %></ad:db_bind>
<ad:db_bind><%= user.getUserId() %></ad:db_bind>
</ad:db_query>

<% 
ContextBar navbar = new ContextBar(ContextBar.PERSONAL_OR_INDEX, user);
navbar.add("index", BBoard.getSystemName());
navbar.add("Search Results");

try {
    request.setAttribute("search_results", new MessagesDataSource(search_results,db));
} catch (SQLException sqle) { 
    throw new WarningException("Query Failed", "Query failed; you probably don't have site-wide-search installed.");
}

request.setAttribute("navbar", navbar);
request.setAttribute("query_string", query_string);
%>

<ad:use_template/>

</ad:page>










