<%
/*
    Displays statistics for the bboard system

    @param topic bboard topic to restrict to
    @param topic_id the ID of the topic
    @param show_total_bytes_p whether to display the total size of all 
           messages

    @cvs-id $Id: statistics.jsp,v 1.4 2000/09/26 15:34:43 bschneid Exp $
*/
%>

<%@include file="../acs.jspi"%>

<ad:page>
<ad:page_contract vars="topic:optional topic_id:optional,integer show_total_bytes_p:integer,optional"/>
<ad:get_user_info id="user" redirect="false"/>

<%
String where_clause = "";
String and_clause = "";
ContextBar context_bar;
if (topic_id == null) {
    request.setAttribute("page_title", BBoard.getSystemName() + " Statistics");
    request.setAttribute("page_headline", BBoard.getSystemName() + " Statistics");
    context_bar = new ContextBar(ContextBar.PERSONAL_OR_INDEX, user);
    context_bar.add("index", BBoard.getSystemName());
    context_bar.add("Statistics");
    // set calendar_html [calendar_small_month -day_number_template "<a href=\"threads-one-day-across-system?julian_date=\$julian_date\"><font size=-1>\$day_number</font></a>"
} else {
    request.setAttribute("page_title", topic + " Statistics");
    request.setAttribute("page_headline", "Statistics for the " + topic + " Forum");
    SingleTopicDataSource theTopic = new SingleTopicDataSource(db, topic_id);
    if (!theTopic.authorizeUser(user, pageContext)) {
	// bboard_get_topic_info will have returned an error page
	return;
    }

    where_clause = "where topic_id = :topic_id";
    and_clause = "and topic_id = :topic_id";
    context_bar = new ContextBar(ContextBar.PERSONAL_OR_INDEX, user);
    context_bar.add("index", BBoard.getSystemName());
    context_bar.add(theTopic.getBackLink(), topic);
    context_bar.add("Statistics");
    request.setAttribute("topic", theTopic.get("topic"));
    // set calendar_html [calendar_small_month -day_number_template "<a href=\"threads-one-day?[export_url_vars topic_id topic]&julian_date=\$julian_date\"><font size=-1>\$day_number</font></a>"] 
}

String kbytes_item = "";
if (show_total_bytes_p != null && show_total_bytes_p.intValue() == 1) {
    kbytes_item = ", to_char(round(sum(dbms_lob.getlength(message))/1000,2), '999G999G999G999') as n_kbytes";
}

%>

<ad:db_1row id="get_dates_msgs" obj="dates_msgs">
select max(posting_time) as max_date, 
       min(posting_time) as min_date, 
       to_char(count(*), '999G999G999G999') as n_msgs <%= kbytes_item %>
from bboard <%= where_clause %>
<ad:db_bind name="topic_id"><%= topic_id %></ad:db_bind>
</ad:db_1row>

<ad:db_query id="active_users">
select bboard.user_id, 
       first_names, 
       last_name, 
       count(*) as n_contributions 
from   bboard, users
where  bboard.user_id = users.user_id <%= and_clause %>
group  by bboard.user_id, first_names, last_name
having count(*) > trunc(:n_msgs / 200)
order by n_contributions desc
<ad:db_bind><%= dates_msgs.get("n_msgs") %></ad:db_bind>
<ad:db_bind name="topic_id"><%= topic_id %></ad:db_bind>
</ad:db_query>

<%
request.setAttribute("navbar", context_bar);
request.setAttribute("active_users", new Selection(active_users, db));
%>

<ad:use_template/>


