<%@ include file="../acs.jspi" %>
<% 
/*
# /www/bboard/threads-by-day.tcl
ad_page_contract {
    shows number of threads in a forum initiated on a particular day,
    either all or limit to last 60 days


    @author philg@mit.edu
    @creation-date 26 June 1999
    @cvs-id $Id: threads-by-day.jsp,v 1.1 2000/09/19 15:25:32 bschneid Exp $
*/ 
%>

<ad:page>
<ad:page_contract vars="topic_id:integer topic all_p:boolean,optional" />

<ad:get_user_info id="user" redirect="false"/>

<% 
SingleTopicDataSource theTopic = new SingleTopicDataSource(db, topic_id);

// authorize user
if (!theTopic.authorizeUser(user, pageContext)) { 
	return;
}
 
ContextBar navbar = new ContextBar(ContextBar.PERSONAL_OR_INDEX, user); 
navbar.add("/bboard/index", 
	parameters.get("SystemName", "bboard", "Discussion Forums"));
navbar.add(theTopic.getBackLink(), topic);
navbar.add("Threads by Day");

request.setAttribute("navbar", navbar);
request.setAttribute("topic_id", topic_id);
request.setAttribute("topic", topic);
if (all_p != null) request.setAttribute("all_p", all_p);
%>

<ad:db_query id="threads_by_day">
select trunc(posting_time) as kickoff_date, 
 to_char(trunc(posting_time), 'fmMonth dd, yyyy') as pretty_kickoff_date,
 count(*) as n_msgs
from bboard
where topic_id = :topic_id
and refers_to is null
<% if (all_p != null && all_p.booleanValue()) { %>
and posting_time >= sysdate - 60
<% } %>
group by trunc(posting_time)
order by 1 desc
<ad:db_bind><%= topic_id %></ad:db_bind>
</ad:db_query>

<% request.setAttribute("threads_by_day", new Selection(threads_by_day, db)); %>
	
<ad:use_template />

</ad:page>




