<%
/*
# /www/bboard/threads-one-day.tcl
ad_page_contract {

    @cvs-id $Id: threads-one-day.jsp,v 1.1 2000/09/19 15:25:32 bschneid Exp $
} {
    topic_id:integer
    topic
    kickoff_date
    julian_date:optional
}
*/
%>

<%@ include file="../acs.jspi" %>
<ad:page>
<ad:page_contract vars="topic_id:integer topic kickoff_date"/>
<ad:get_user_info id="user" redirect="false"/>

<% 
SingleTopicDataSource theTopic = new SingleTopicDataSource(db, topic_id);

// authorize user
if (!theTopic.authorizeUser(user, pageContext)) { 
	return;
}
 
ContextBar navbar = new ContextBar(ContextBar.PERSONAL_OR_INDEX, user); 
navbar.add("/bboard/index", 
	parameters.get("SystemName", "bboard", "Discussion Forums"));
navbar.add(theTopic.getBackLink(), topic);
navbar.add("/bboard/threads-by-day?" + Utilities.exportURLVars(request, "topic_id topic"), "Threads by Day");
navbar.add("One Day");

request.setAttribute("navbar", navbar);
%>

<ad:db_query id="threads_one_day">
select msg_id, 
       one_line, 
       sort_key, 
       email, 
       first_names || ' ' || last_name as name, 
       users.user_id as poster_id
from   bboard, 
       users 
where  topic_id = :topic_id
and    bboard.user_id = users.user_id 
and    refers_to is null
and    trunc(posting_time) = :kickoff_date
order by sort_key
<ad:db_bind><%= topic_id %></ad:db_bind>
<ad:db_bind><%= kickoff_date %></ad:db_bind>
</ad:db_query>

<% 
request.setAttribute("threads_one_day", new Selection(threads_one_day, db));
request.setAttribute("pretty_date", db.queryToString("select to_char(to_date(?), 'fmMonth dd, yyyy') from dual", new Object[] {kickoff_date}));
request.setAttribute("topic_id", topic_id);
request.setAttribute("topic", topic);
%>

<ad:use_template/>
</ad:page>