<%@ include file="../acs.jspi" %>
<%@ page import="com.arsdigita.acs.calendar.*" %>

<% org.apache.turbine.util.Log.note ("XXXXXXXXXXXXXXXXXXXXXXX Loading calendar index.jsp XXXXXXXXXXXXXXXXXXXXXXXXXXXX");%>
<ad:page>
<% /* The first var is unique to this page, and I'm not sure why it exists.
     The rest should be read but optional for all calendar pages.  Most
     are set to default values in initializeCalendarParemters.

     The only non-obvious parameter is that if you want to have the no time
     checkbox on the item editing page default to checked you must set the end_date to ""
*/ %>

<% String itemTitle = null;%>
<ad:page_contract id="pc" vars="scope:optional group_id:integer,optional current_view:optional current_date:optional compress_day_view_p:optional view_mode:optional action:optional item_id:integer,optional instance_id:integer,optional title:optional description:optional start_date:optional end_date:optional duration:integer,optional return_url:optional">
<%
if (!Utilities.emptyString(current_view) && !(current_view.equals("list") || current_view.equals("day") || current_view.equals("week") || current_view.equals("month") || current_view.equals("year"))) {
    pc.addComplaint("Invalid view: " + current_view);
}
%>
</ad:page_contract>

<%
// This has to be done OUTSIDE of the page_contract to avoid having the values overwritten
if (scope==null) {
    // TODO: Should be more restrictive, force scope to a set of valid values?
    scope="public";
    //request.setAttribute("scope", scope); // Have to reset this in order to keep it from being overwritten on tag exit.
}
if (description == null) {
    description = "";
    //request.setAttribute("description", description); // Have to reset this in order to keep it from being overwritten on tag exit.
}
// title is a bad name, renaming to itemTitle and clearing old title value
if (title == null) {
    itemTitle = "";
    //request.setAttribute("itemTitle", itemTitle); // Just to be consistent w/ previous two
} else {
    itemTitle = title;
    title = "DO NOT USE THIS VARIABLE, USE ITEMTITLE INSTEAD";
    //request.setAttribute("itemTitle", itemTitle); // Just to be consistent w/ previous two
    //request.setAttribute("title", null);
}
%>

<ad:get_user_info id="user" redirect="true"/>

<%
com.arsdigita.acs.calendar.CalendarInfo calendarInfo=com.arsdigita.acs.calendar.CalendarProcs.initializeCalendarParameters(request, user.getUserId(), user, group_id, current_view, current_date, compress_day_view_p, "full", action);
request.setAttribute("calendarInfo", calendarInfo);
Log.note("calendarInfo= " + calendarInfo);
%>

<% Integer startHour = new Integer(00), endHour = new Integer(23); Log.note("calendarInfo= " + calendarInfo); Log.note("userid=" + calendarInfo.getLoggedInUserIdOr0()); %>
<ad:db_1row id="hours_span_select" obj="hoursSpanSelect">
select nvl(hours_span, '0023') as hours_span from cal_user_prefs where user_id=:userId
<ad:db_bind><%= calendarInfo.getLoggedInUserIdOr0() %></ad:db_bind>
</ad:db_1row>
<%
String span = hoursSpanSelect.get("hours_span");
startHour = new Integer(span.substring(0,2));
endHour = new Integer(span.substring(2,4));
request.setAttribute("startHour", startHour);
request.setAttribute("endHour", endHour);
%>

<ad:db_1row id="current_year_select" obj="currentYearSelect">
select to_char(to_date(:currentDate), 'YYYY') as current_year from dual
<ad:db_bind><%= calendarInfo.getCurrentDate()%></ad:db_bind>
</ad:db_1row>

<%
ContextBar navbar = new ContextBar(pageContext);
navbar.add("Calendar");
request.setAttribute("navbar", navbar);
%>

<%
StringBuffer returnUrl = HttpUtils.getRequestURL(request);
String query = request.getQueryString();
if (query != null) {
  returnUrl.append("?").append(query);
}
request.setAttribute("returnUrl", returnUrl.toString());

StringBuffer returnUrlForToggle = HttpUtils.getRequestURL(request).append("?group_id=").append(calendarInfo.getGroupId().toString()).append("&current_view=").append(calendarInfo.getCurrentView()).append("&current_date=").append(calendarInfo.getCurrentDate()).append("&view_mode=").append(Utilities.URLEncode(calendarInfo.getViewMode())).append("&action=").append(calendarInfo.getAction());
request.setAttribute("returnUrlForToggle", returnUrlForToggle.toString());
%>

<%
// Title is only used in non-list-view.
if (!calendarInfo.currentView.equals("list")) {
    String viewTitle=CalendarProcs.calendarViewTitle(request);
    request.setAttribute("viewTitle", viewTitle);
}
%>

<%
/*********************************************************************************/
   // Queries that are only used for weeks 
   if (calendarInfo.currentView.equals("week")) {
%>
    <ad:db_1row id="cal_week_display_vars" obj="calWeekDisplayVars">
    select to_char(next_day(to_date(:current_date) - 7, 'SUNDAY'), 'YYYY-MM-DD') as this_begin,
           to_char(next_day(to_date(:current_date) - 1, 'SATURDAY'), 'YYYY-MM-DD') as this_end,
           to_char(next_day(to_date(:current_date) - 7, 'SUNDAY'), 'J') as first_julian_date,
           to_char(next_day(to_date(:current_date) - 1, 'SATURDAY'), 'J') as last_julian_date,
           to_char(next_day(to_date(:current_date), 'SUNDAY'), 'YYYY-MM-DD') as next_begin,
           to_char(next_day(to_date(:current_date) + 7, 'SATURDAY'), 'YYYY-MM-DD') as next_end,
           to_char(next_day(to_date(:current_date) - 14, 'SUNDAY'), 'YYYY-MM-DD') as previous_begin,
           to_char(next_day(to_date(:current_date) - 7, 'SATURDAY'), 'YYYY-MM-DD') as previous_end
    from dual
    <ad:db_bind name="current_date"><%=calendarInfo.getCurrentDate()%></ad:db_bind>
    </ad:db_1row>

    <ad:db_query id="cal_week_list">
    select to_char(to_date(:this_begin) + day_num, 'YYYY-MM-DD') as day, 
           to_char(to_date(:this_begin) + day_num, 'fmMonth fmDD, YYYY') as pretty_day,
           to_char(to_date(:this_begin) + day_num, 'fmDay') as day_name
    from cal_week_days
    order by day
    <ad:db_bind name="this_begin"><%=calWeekDisplayVars.get("this_begin")%></ad:db_bind>
    </ad:db_query>

<%
Vector weekDays = new Vector(7);
%>
<ad:db_foreach in="cal_week_list" row="rs">
<%
String[] info = new String[3];
info[0] = rs.getString("day");
info[1] = rs.getString("pretty_day");
info[2] = rs.getString("day_name");
weekDays.add(info);
%>
</ad:db_foreach>
<%
request.setAttribute("calWeekDays", weekDays);
%>

<%  String userOrGroupSQL;
    if (calendarInfo.getGroupId().intValue() == 0) {
        // user calendar
        userOrGroupSQL= "and (m.user_id = :logged_in_user_id " +
                " or m.group_id in  " +
                "   (select ugm.group_id " +
                "    from user_group_map ugm, cal_user_update_prefs ugp " +
                "    where ugm.user_id = :logged_in_user_id " +
                "      and ugp.user_id = ugm.user_id " +
                "      and ugm.group_id = ugp.group_id " +
                "      and ugp.update_type = 'automatically') " +
                " )";
    } else {
        // Group calendar
        userOrGroupSQL = "and m.group_id = :group_id";
    }
%>
<ad:db_query id="cal_week_items" obj="calWeekItems">
    select i.item_id, ii.instance_id, 
      decode(m.group_id, NULL, 'f', 't') as group_p,
      to_char(start_date, 'J') as julian_date,
      to_char(start_date, 'YYYY-MM-DD HH24:MI') as start_time,
      to_char(start_date, 'fmHH:fmMIam') as pretty_start_time,
      to_char(end_date, 'YYYY-MM-DD HH24:MI') as end_time,
      to_char(end_date, 'fmHH:fmMIam') as pretty_end_time,
      nvl(ii.title, i.title) as title,
      nvl(ii.related_url, i.related_url) as related_url, 
      nvl(ii.related_url_text, i.related_url_text) as related_url_text, 
      nvl(ii.related_url_p, i.related_url_p) as related_url_p,
      ug.short_name as group_name
    from cal_items i, cal_item_instances ii, cal_item_map m, 
      user_groups ug
    where  i.item_id = ii.item_id
      and trunc(start_date) between 
            to_date(:this_begin) and
            to_date(:this_end) 
      and i.item_id = m.item_id 
      and m.group_id=ug.group_id(+)
      <%=userOrGroupSQL%>
    order by start_date
    <ad:db_bind name="this_begin"><%=calWeekDisplayVars.get("this_begin")%></ad:db_bind>
    <ad:db_bind name="this_end"><%=calWeekDisplayVars.get("this_end")%></ad:db_bind>
    <ad:db_bind name="group_id"><%=calendarInfo.getGroupId()%></ad:db_bind>
    <ad:db_bind name="logged_in_user_id"><%=calendarInfo.getLoggedInUserIdOr0()%></ad:db_bind>
</ad:db_query>

<%
  }
  // End week-only queries
/*********************************************************************************/
%> 

<%
/*********************************************************************************/
   // Queries that are only used for months
   if (calendarInfo.currentView.equals("month")) {
%>
<ad:db_1row id="date_select" obj="dateSelect">
    select to_char(to_date(:date), 'fmMonth') as month, 
           to_char(to_date(:date), 'YYYY') as year, 
           to_char(trunc(last_day(to_date(:date))), 'YYYY-MM-DD') as last_day_of_month,
           to_char(last_day(to_date(:date)), 'DD') as num_days_in_month,
           to_char(trunc(add_months(to_date(:date), 1)), 'YYYY-MM-DD') as next_month,
           to_char(trunc(add_months(to_date(:date), -1)), 'YYYY-MM-DD') as prev_month,
           to_char(trunc(to_date(:date), 'yyyy'), 'YYYY-MM-DD') as beginning_of_year,
           to_char(last_day(add_months(to_date(:date), -1)), 'DD') as days_in_last_month,
           to_char(trunc(last_day(add_months(to_date(:date), -1))), 'YYYY-MM-DD') as last_day_last_month,
           to_char(trunc(add_months(to_date(:date), 1)), 'YYYY-MM-DD') as first_day_next_month,
           to_char(add_months(to_date(:date), 1), 'fmMonth') as next_month_name,
           to_char(add_months(to_date(:date), -1), 'fmMonth') as prev_month_name,
           to_char(next_day(trunc(to_date(:date), 'Month') - 7, 'SUNDAY'), 'J') as first_julian_date,
           to_char(next_day(trunc(to_date(:date), 'Month') - 7, 'SUNDAY'), 'YYYY-MM-DD') as first_displayed_date,
           to_char(next_day(last_day(to_date(:date)), 'SATURDAY'), 'J') as last_julian_date,
           to_char(next_day(last_day(to_date(:date)), 'SATURDAY'), 'YYYY-MM-DD') as last_displayed_date
    from dual
<ad:db_bind name="date"><%=calendarInfo.getCurrentDate()%></ad:db_bind>
</ad:db_1row>

<% /* month_list_of_lists */ %>
<ad:db_query id="months_select">
    select to_char(to_date(:first_displayed_date) + day_num, 'YYYY-MM-DD') as the_date,
           to_char(to_date(:first_displayed_date) + day_num, 'fmMonth') as the_month,
           to_char(to_date(:first_displayed_date) + day_num, 'fmDD') as pretty_date,
           to_char(to_date(:first_displayed_date) + day_num, 'fmDay') as weekday
    from cal_month_days
    where to_date(:first_displayed_date) + day_num < = to_date(:last_displayed_date)
    order by day_num
<ad:db_bind name="first_displayed_date"><%=dateSelect.get("first_displayed_date")%></ad:db_bind>
<ad:db_bind name="last_displayed_date"><%=dateSelect.get("last_displayed_date")%></ad:db_bind>
</ad:db_query>

<%
Vector monthsList = new Vector();
%>
<ad:db_foreach in="months_select" row="rs">
<%
// This should really be replaced with a frozen Selection object...
String[] info = new String[5];
info[0] = rs.getString("the_date");
info[1] = rs.getString("the_month");
info[2] = rs.getString("pretty_date");
info[3] = rs.getString("weekday");
monthsList.add(info);
%>
</ad:db_foreach>
<%
request.setAttribute("monthsList", monthsList);
%>

    <% String userOrGroupSql;
    String userOrGroupBindVars;
    if (calendarInfo.getGroupId().intValue() == 0) {
        // user calendar
        userOrGroupSql = "and (m.user_id = :logged_in_user_id " +
                "or m.group_id in " +
                "   (select ugm.group_id " +
                "    from user_group_map ugm, cal_user_update_prefs ugp " +
                "    where ugm.user_id = :logged_in_user_id " +
                "      and ugp.user_id = ugm.user_id " +
                "      and ugm.group_id = ugp.group_id " +
                "      and ugp.update_type = 'automatically') " +
                ") ";
    } else {
        // Group calendar
        userOrGroupSql = "and m.group_id = :group_id";
    } %>

    <ad:db_query id="cal_month_items" obj="calMonthItems">
    select i.item_id, ii.instance_id, 
      combine_category_names(ii.instance_id, ', ') as category_list,
      ug2.group_id as item_group_id, ug2.short_name as item_group_name, 
      ug2.short_name as item_group_short_name, ug2.group_type as item_group_type,
      first_names || ' ' || substr(last_name, 1, 1) as name,
      decode(m.group_id, NULL, 'f', 't') as group_p,
      to_char(start_date, 'J') as julian_date,
      to_char(start_date, 'YYYY-MM-DD HH24:MI') as start_time,
      to_char(start_date, 'fmHH:fmMIam') as pretty_start_time,
      to_char(end_date, 'YYYY-MM-DD HH24:MI') as end_time,
      to_char(end_date, 'fmHH:fmMIam') as pretty_end_time,
      nvl(ii.title, i.title) as title,
      nvl(ii.related_url, i.related_url) as related_url, 
      nvl(ii.related_url_text, i.related_url_text) as related_url_text, 
      nvl(ii.related_url_p, i.related_url_p) as related_url_p
    from cal_items i, cal_item_instances ii, cal_item_map m, 
      user_groups ug2, users u
    where i.item_id = ii.item_id
      and trunc(start_date) between 
            to_date(:first_displayed_date) and
            to_date(:last_displayed_date) 
      and i.item_id = m.item_id 
      and m.group_id = ug2.group_id(+)
      and m.user_id = u.user_id(+)
      <%=userOrGroupSql%>
    order by start_date
    <ad:db_bind name="first_displayed_date"><%=dateSelect.get("first_displayed_date")%></ad:db_bind>
    <ad:db_bind name="last_displayed_date"><%=dateSelect.get("last_displayed_date")%></ad:db_bind>
    <ad:db_bind name="group_id"><%=calendarInfo.getGroupId()%></ad:db_bind>
    <ad:db_bind name="logged_in_user_id"><%=calendarInfo.getLoggedInUserIdOr0()%></ad:db_bind>
    </ad:db_query>

<%
 }
 // End month-only queries
/*********************************************************************************/
%>

<%
/*********************************************************************************/
   // Queries that are only used for list
   if (calendarInfo.currentView.equals("list")) {
%>
   <ad:db_1row id="upcoming_items_select" obj="upcomingItemsDays">
   select upcoming_items_days, upcoming_items_length
       from cal_user_prefs
       where user_id = <%=calendarInfo.getLoggedInUserIdOr0()%>
   </ad:db_1row>

<%
 }
 // End list-only queries
/*********************************************************************************/
%>

<%
// Item AEV-only queries
if (calendarInfo.action.equals("item-add") || calendarInfo.action.equals("item-edit") || calendarInfo.action.equals("item-view") || calendarInfo.action.equals("item-repeat")) {
%>

<%
// Passed in: item_id = 0, instance_id = 0, title = "", description = "", start_date, end_date, duration, return_url=""
// also need current_view, current_date, user_id, group_id, group_member_p, group_admin_p from calendarInfo earlier in the file
// read_only_p needs to be calculated.
%>

    <%
    Perl5Util re = null;
    String dateFormatString = "'YYYY-MM-DD HH24:MI'";
    String SQL = "";
    Integer itemId = item_id;
    Integer instanceId = instance_id;

    // Temporarily hard-coded to 0
    boolean supportsJavascript = false;
    boolean newItemP = false;
    Boolean readAccessP = Boolean.FALSE;
    Boolean writeAccessP = Boolean.FALSE;
    Integer calOwnerId; // This used to be just "id" in the TCL, but that was confusing.
    
    if (itemId == null || itemId.equals(new Integer(0))) {
        newItemP = true;
        %>
        <ad:db_1row id="cal_item_id_sequence_nextval" obj="calItemIdSequenceNextval">
        select cal_item_id_sequence.nextval as item_id, cal_instance_id_sequence.nextval as instance_id from dual
        </ad:db_1row>
        <% itemId = Integer.valueOf(calItemIdSequenceNextval.get("item_id"));
        instanceId = Integer.valueOf(calItemIdSequenceNextval.get("instance_id"));
    } else {
        newItemP = false;
    }

    if ( calendarInfo.getGroupId() == null || calendarInfo.getGroupId().intValue() == 0 ) {
        // personal calendar
        scope = "user";
        calOwnerId = calendarInfo.getLoggedInUserIdOr0();
    } else {
        // group calendar
        scope = "group";
        calOwnerId = calendarInfo.getGroupId();
    }
    request.setAttribute("scope", scope);
    request.setAttribute("calOwnerId", calOwnerId);

    // Do we have write access to this calendar?  Are we even allowed to view it?
    // We do this now because we want to be checking against raw database values.
    // write_access_p implies read_access_p
    if (newItemP) {
        // we have to check whether user can add new item; 
        // this will be true in two cases:
        // 1. user adding item to his/hew own calendar
        // 2. user is administrator of the group to which the calendar belongs
        if ( calendarInfo.getGroupId() == null || calendarInfo.getGroupId().intValue() == 0) {
            // it's a personal calendar
            writeAccessP = Boolean.TRUE;
        } else {
            // group calendar
            writeAccessP = new Boolean(calendarInfo.getLoggedInUser().isGroupAdmin(calendarInfo.getGroupId()));
        }
    } else {
        writeAccessP = new Boolean(CalendarProcs.isWriteAccessAllowed(calendarInfo.getLoggedInUser(), itemId, calendarInfo.getGroupId()));
    }

    if (!writeAccessP.booleanValue()) { %>
        <ad:db_string obj="readAccess">
                             SELECT 't'
                               FROM cal_user_read_privilege
                              WHERE user_id=:logged_in_user_id
                                AND item_id=:item_id
        <ad:db_bind><%=calendarInfo.getLoggedInUserIdOr0()%></ad:db_bind>
        <ad:db_bind><%=itemId%></ad:db_bind>
        </ad:db_string>
        <% readAccessP = new Boolean(request.getAttribute("readAccess").equals("t"));
    } else { 
        readAccessP = Boolean.TRUE;
    }
    request.setAttribute("writeAccessP", writeAccessP);

    // if we can't read or write, return error.
    if (!writeAccessP.booleanValue() && !readAccessP.booleanValue()) {
        // Note that this condition will also occur if there is no calendar item with this item_id...
        // Do we need another error message?
        throw new ForbiddenException ("Insufficient Permissions", "You are not allowed to view or edit this calendar item");
    }

    // We get defaults and *then* data.  Why?  We might need to get an item_id.
    // We could get fewer defaults sometimes, for instance if a duration doesn't
    // need to be calculated we could sometimes skip default lookup entirely,
    // but in practice we usually need to calculate the duration so there's no point
    // in adding the complexity right now.
    // We explicitly check for empty strings in case user has deleted these or in case
    // a TCL server is used to generate a URL.

    // Some of the below code is somewhat confusing.
    // Basically, duration needs to be end date - start date, but end date and start
    // date may be calculated.  So, strings for end date and start date are set
    // and maybe used later in duration.  Also, the end of all this SQL
    // will be used in the "defaults" SqlStatement, so any variables that may
    // show up in the SQL are put into defaults with a named bind as
    // the strings containing them are created even though they may not all be used
    // or may be used more than once.

    SqlStatement defaults = new SqlStatement ();
    StringBuffer defaults_sql = new StringBuffer ();
    String startDateSQL;
    String endDateSQL;
    if (start_date == null || Utilities.emptyString(start_date)) {
        startDateSQL = "trunc(sysdate, 'MI')";
        CalendarProcs.utilAddToSQLBuffer(defaults_sql, "to_char(" + startDateSQL + ", " + dateFormatString + ") as start_date");
    } else {
        re = new Perl5Util();
        String startDateBindValue = start_date;
        if (re.match("/^[0-9][0-9][0-9][0-9]-[0-9]?[0-9]-[0-9]?[0-9]$/", start_date)) {
            // Just date specified, default to 12 noon rather than 12 midnight
            start_date = start_date + " 12:00";
        }
        startDateSQL = "trunc(to_date(':start_date', " + dateFormatString + "), 'MI')";
        // Not actually using startDateSQL in defaults_sql right now, but may add it in later, so do a named bind just in case
        defaults.bind("start_date", start_date);
    }
    if (Utilities.emptyString(end_date)) {
        String sqlDuration;
        String sqlEndDateSource;
        if (duration == null || duration.intValue() == 0) {
            // Add one hour if no default duration specified
           sqlDuration = "1/24";
        } else {
           // Add duration # of minutes.
           sqlDuration = "(:duration)/(24*60)";
            defaults.bind("duration", duration);
        }

        if (Utilities.emptyString(start_date)) {
            sqlEndDateSource = "sysdate";
        } else {
            sqlEndDateSource = "to_date(:start_date_for_end, " + dateFormatString + ")";
            defaults.bind("start_date_for_end", start_date);
        }
        endDateSQL = "trunc(" + sqlEndDateSource + ", 'MI') + " + sqlDuration;
        CalendarProcs.utilAddToSQLBuffer(defaults_sql, "to_char(" + endDateSQL + ", " + dateFormatString + ") as end_date");
    } else {
        endDateSQL = "trunc(to_date(:end_date, " + dateFormatString + "), 'MI')";
        // Not actually using endDateSQL right now, but may add it in later, so do a named bind just in case.
        defaults.bind("end_date", end_date);
    }

    // We only initialize duration if javascript is supported, since
    // otherwise it will take over the calculation.
    if (supportsJavascript || !writeAccessP.booleanValue()) {
        if (duration == null || duration.intValue() == 0) {
             if (Utilities.emptyString(end_date)) {
                // end date is calculated, we decide duration is an hour
                duration = new Integer(60);
             } else {
                // This calculates the # of minutes between end date and start date
                // Note that this will come up null if the start date or end date is blank, which is good, because
                // that's an no time event and duration would be silly.
                CalendarProcs.utilAddToSQLBuffer(defaults_sql, "(" + endDateSQL + "-" + startDateSQL + ")*24*60 as duration");
             }
        }
    } else if (writeAccessP.booleanValue()) {
        // clear out duration so it doesn't dominate the setting of end time
        duration = null;
    }
    // Go fetch defaults ...
    if (defaults_sql.length() > 0) {
            defaults_sql.append(" FROM dual");
        defaults.setSql(defaults_sql.toString());
        ResultSet rs = db.query(defaults);
        rs.next();
        SingleSelection calDefaults = new SingleSelection(rs);
        if (calDefaults.contains("duration")) {
             duration = Integer.valueOf(calDefaults.get("duration"));
        }
        if (calDefaults.contains("end_date")) {
             end_date = calDefaults.get("end_date");
        }
        if (calDefaults.contains("start_date")) {
             start_date = calDefaults.get("start_date");
        }
    }
    %>

    <ad:db_0or1row id="item_select" obj="itemSelect">
    select nvl(ii.title, i.title) as title, 
           nvl(ii.description, i.description) as description, 
           nvl(ii.html_p, i.html_p) as html_p,
           i.item_id, 
           ii.instance_id,
           ug.group_id as item_group_id, 
           ug.short_name as item_group_name,
           ug.short_name as item_group_short_name, 
           ug.group_type as item_group_type, 
           ugt.pretty_name as item_group_type_pretty_name,
           nvl(ii.related_url, i.related_url) as related_url, 
           nvl(ii.related_url_text, i.related_url_text) as related_url_text, 
           to_char(start_date, <%=dateFormatString%>) as start_date,
           to_char(end_date, <%=dateFormatString%>) as end_date,
           editable_p,
           interval_type
    from cal_items i, cal_item_instances ii, cal_item_map m, cal_repeat_items ri,
         user_groups ug, user_group_types ugt
    where ug.group_id(+) = m.group_id
      and i.item_id = ii.item_id
      and ri.item_id(+) = i.item_id
    and ugt.group_type(+) = ug.group_type
    and i.item_id = :item_id
    and m.item_id = i.item_id
    and ii.instance_id = :instance_id
    <ad:db_bind name="item_id"><%=itemId%></ad:db_bind>
    <ad:db_bind name="instance_id"><%=instanceId%></ad:db_bind>
    </ad:db_0or1row>
    <%
    // We transfer each of these fields into the request attribute list
    // so that the page logic doesn't need to deal with considering where to get
    // each from, since some may come from default values and others not.
    String allDayCheckedString = "";

    if (itemSelect == null) {
        // If no rows found...
        if (Utilities.emptyString(end_date)) {
            // no end date, set it to be the same as start date and check all day option.
            int[] sd_parsed = CalendarProcs.parseDateTimeString(start_date);
            end_date = "" + sd_parsed[0] + "-" + sd_parsed[1] + "-" + sd_parsed[2];
            allDayCheckedString = "CHECKED";
        }
    } else {
        // Things that default to null/empty string - none of these should be used later in this code, so we can go ahead and set them here.
        // TODO: Double check that this assertation is true... :)
        request.setAttribute("htmlP", itemSelect.get("html_p"));
        request.setAttribute("itemGroupName", itemSelect.get("item_group_name"));
        request.setAttribute("itemGroupShortName", itemSelect.get("item_group_short_name"));
        request.setAttribute("itemGroupType", itemSelect.get("item_group_type"));
        request.setAttribute("itemGroupTypePrettyName", itemSelect.get("item_group_type_pretty_name"));
        request.setAttribute("relatedUrl", itemSelect.get("related_url"));
        request.setAttribute("relatedUrlText", itemSelect.get("related_url_text"));
        request.setAttribute("editableP", itemSelect.get("editable_p"));
        request.setAttribute("intervalType", itemSelect.get("interval_type"));

        // We want to overwrite the default values with actual values from the query.
        itemTitle = itemSelect.get("title");
        description = itemSelect.get("description");
        start_date = itemSelect.get("start_date");
        end_date = itemSelect.get("end_date");

        if (Utilities.emptyString(end_date)) {
            // we need to set the checked option.  We should consider keeping end_date null, perhaps.
            int[] sd_parsed = CalendarProcs.parseDateTimeString(start_date);
            end_date = "" + sd_parsed[0] + "-" + sd_parsed[1] + "-" + sd_parsed[2];
            allDayCheckedString = "CHECKED";
        }
    }

    Vector defaultCategoryIdList = db.queryToList("select category_id from cal_category_map where instance_id = :instance_id", new Object[] {instanceId});
Log.note("defaultList: " + defaultCategoryIdList);
    request.setAttribute("defaultCategoryIdList", defaultCategoryIdList);

    if ( newItemP ) {
        request.setAttribute("submitValue", "Add Item");
    } else {
        request.setAttribute("submitValue", "Update Item");
    }

    Boolean showEndDate = Boolean.FALSE;
    // If the two dates don't match, show end date.
    if (end_date != null) {
        if (Utilities.emptyString(allDayCheckedString) && !Utilities.emptyString(end_date)) {
            int[] startInfo = CalendarProcs.parseDateTimeString(start_date);
            int[] endInfo = CalendarProcs.parseDateTimeString(end_date);
            if ( ! (startInfo[0]==endInfo[0] && startInfo[1]==endInfo[1] && startInfo[2]==endInfo[2])) {
                showEndDate = Boolean.TRUE;
            }
        }
    }

    // TODO: Temporarily done for item-view action until item-view display is completed.
    //if (! calendarInfo.getAction().equals("item-view")) {
        AdSet exports = new AdSet();
        exports.put("current_view", current_view);
        exports.put("group_id", calendarInfo.getGroupId().toString());
        exports.put("item_id", itemId.toString());
        exports.put("instance_id", instanceId.toString());
        exports.put("current_date", current_date);
        exports.put("user_id", calendarInfo.getLoggedInUserIdOr0());
        exports.put("scope", scope);
        exports.put("new_item_p", new Boolean(newItemP));
        exports.put("return_url", return_url);
        request.setAttribute("passThroughVars", Utilities.exportFormVars(exports));
    //}

    // TODO: the || calendarInfo.getAction().equals("item-view") here is temporary until item-view is completed.
    if (calendarInfo.getAction().equals("item-add") || calendarInfo.getAction().equals("item-edit") || calendarInfo.getAction().equals("item-view")) {
        if ( writeAccessP.booleanValue() ) {
            if (! Utilities.emptyString(description)) {
                // take out pre tags
                if (re == null) {
                    re = new Perl5Util();
                }
                description = re.substitute("s|</?pre.*?>||g", description);
            }
        }
    }

        /*} else if (item-repeat) {
            append result "
            <h2>$title</h2>
            <form name=\"$form_name\" action=\"$form_destination\" method=\"post\">"
            append result [cal_item_view $start_date $title \
                    $group_id $all_day_checked_string \
                    $end_date $show_end_date $description]
            
            # Fetch month date and month day pieces
            # See DATE-NOTE at top of file
            set SQL_start_date "trunc(to_date('$start_date', $date_format_string), 'MI')"
            db_1row date_select "select to_char($SQL_start_date, 'fmDdth') as month_date,
            to_char($SQL_start_date, 'wth') as nth_week, 
            to_char($SQL_start_date, 'd') - 1 as day_num, 
            to_char($SQL_start_date, 'fmDay') as week_day
            from dual"

            # Set defaults
            set every_nth_interval 1
            set never_checked ""
            set day_checked ""
            set week_checked ""
            set month_by_date_checked ""
            set month_by_day_checked ""
            set last_of_month_checked ""
            set year_checked ""
            set indefinitely_checked ""
            set nth_week_string ""
            set last_weekday_string ""

            # Fetch repeat info if it exists
            db_0or1row repeat_items_select "
            SELECT interval_type, every_nth_interval as nth_interval, 
                   days_of_week, repeat_until
            FROM cal_repeat_items
            WHERE item_id = :item_id
            "

            # Fill in info
            if {![exists_and_not_null interval_type]} {
                set interval_type "never"
            }
            if {![exists_and_not_null repeat_until]} {
                set repeat_until $start_date
            }
            set repeat_until_widget \
                    [calendar_widget_datetime repeat_until $repeat_until days]

            if {![exists_and_not_null days_of_week]} {
                set days_of_week [list $day_num]
            }

            set ${interval_type}_checked " checked"

            set repeat_rowspan 6
            set month_rowspan 2

            if {$nth_week != "5th"} {
                incr repeat_rowspan
                incr month_rowspan
                set nth_week_string "<tr>
                <td></td>
                <td></td>
                <td>
                &nbsp;&nbsp;&nbsp;&nbsp;<input name=\"interval_type\" type=\"radio\" value=\"month_by_day\"${month_by_day_checked}>
                On the $nth_week $week_day of the month
                </td>
                </tr>
                "
            }

            if {$nth_week == "4th" || $nth_week == "5th"} {
                incr repeat_rowspan
                incr month_rowspan
                set last_weekday_string "<tr>
                <td></td>
                <td></td>
                <td>
                &nbsp;&nbsp;&nbsp;&nbsp;<input name=\"interval_type\" type=\"radio\" value=\"last_of_month\"${last_of_month_checked}>
                On the Last $week_day of the month
                </td>
                </tr>"
            }

            append result "
            <table border=0>
            <tr>
            <td align=\"right\" rowspan=$repeat_rowspan>
            <b>Repeat<br>Every<b>
            </td>
            <td rowspan=$repeat_rowspan>
             <input name=nth_interval type=text size=3 value=${every_nth_interval}>
            </td>
            </tr>
            <tr>
            <td></td>
            <td></td>
            <td colspan=2>
            <input name=\"interval_type\" type=\"radio\" value=\"day\"${day_checked}>
            Day(s)
            </td>
            </tr>
            <tr>
            <td></td>
            <td></td>
            <td colspan=2>
            <input name=\"interval_type\" type=\"radio\" value=\"week\"${week_checked}>
            Week(s) on
            [calendar_days_of_week $days_of_week]
            </td>
            </tr>
            <tr>
            <td></td>
            <td></td>
            <td rowspan=$month_rowspan>
            Month(s)
            </td>
            </tr>
            <tr>
            <td></td>
            <td></td>
            <td>
            &nbsp;&nbsp;&nbsp;&nbsp;<input name=\"interval_type\" type=\"radio\" value=\"month_by_date\"${month_by_date_checked}>
            On the $month_date of the month
            </td>
            </tr>
            $nth_week_string
            $last_weekday_string
            <tr>
            <td></td>
            <td></td>
            <td>
            <input name=\"interval_type\" type=\"radio\" value=\"year\"${year_checked}>
            Year(s)
            </td>
            </tr>
            </table>
            <table>
            <tr>
            <td align=right><b>Repeat<br>Until</b></td>
            <td>$repeat_until_widget 
            <!-- Disabled
            <b>or</b>
            <input name=indefinitely_p type=checkbox value=t${indefinitely_checked}> Indefinitely
            -->
            </td>
            </tr>
            <tr>
            <td>&nbsp;</td>
            <td align=\"center\"><br>
            <input type=submit value=\"Set Repeat\">
            </td>
            </table>
            [calendar_widget_hidden pass_through_current_view $pass_through_current_view]
            [calendar_widget_hidden group_id $group_id]
            [calendar_widget_hidden item_id $item_id]
            [calendar_widget_hidden instance_id $instance_id]
            [calendar_widget_hidden pass_through_current_date $pass_through_current_date]
            [calendar_widget_hidden user_id $user_id]
            [calendar_widget_hidden new_item_p $new_item_p]
            [export_form_vars return_url]
            </form>"    
        }
        item-view {
            # Display related_url
            set related_url_widget ""
            if ![empty_string_p $related_url] {
                set related_url_widget "
                <tr>
             <th align=right bgcolor=\"#FFFFFF\"><font size=-1 face=\"Arial, Helvetica, sans-serif\">URL:</font></th>
             <td><font size=-1 face=\"Arial, Helvetica, sans-serif\">
                <a href=\"$related_url\">
                "
                if [empty_string_p $related_url_text] {
                    append related_url_widget "$related_url"
                } else {
                    append related_url_widget "$related_url_text"
                }
                append related_url_widget "</a></font></td>"
            }

            # Pull out repeat information 
            # Display if it exists
            set repeat_info ""
            set interval_type "never"
            if { [db_0or1row items_repeat_items_select "
            SELECT nvl(interval_type, 'never') as interval_type,
                   every_nth_interval as nth_interval, days_of_week, 
                   to_char(repeat_until, 'fmMonth fmDD, YYYY') as repeat_until
            FROM cal_items i, cal_repeat_items ri
            WHERE i.item_id = :item_id
              and ri.item_id(+) = i.item_id
            "] } {
                if {$interval_type != "never"} {
                    # Generate the display string
                    set interval_detail ""
                    switch $interval_type {
                        day {
                            set interval_name "Day"
                        }
                        week {
                            set interval_name "Week"
                            set interval_detail "on \
                                    [translate_numeric_list $days_of_week \
                                    {Sunday Monday Tuesday Wednesday Thursday Friday Saturday}]"
                        }
                        month_by_date -
                        month_by_day -
                        last_of_month {
                            # Fetch month date and month day pieces
                            # See DATE-NOTE at top of file
                            set SQL_start_date "trunc(to_date('$start_date', $date_format_string), 'MI')"
                            db_1row cal_month_week_day "
                            SELECT to_char($SQL_start_date, 'fmDdth') as month_date,
                            to_char($SQL_start_date, 'wth') as nth_week, 
                            to_char($SQL_start_date, 'fmDay') as week_day
                            FROM dual"
                            set interval_name "Month"
                            switch $interval_type {
                                month_by_date {
                                    set interval_detail "on the $month_date."
                                }
                                month_by_day {
                                    set interval_detail "on the $nth_week $week_day"
                                }
                                last_of_month {
                                    set interval_detail "on the last $week_day"
                                }
                            }
                        }
                        year {
                            set interval_name "Year"
                        }
                    }
                    set interval_plural [util_decode $nth_interval 1 "" "s"]
                    # Eventually have to handle "indefinitely"
                    append repeat_info "
                    <tr>
                    <td align=right><b>Repeat</b></td> <td>Every $nth_interval $interval_name$interval_plural $interval_detail</td>
                    </tr>
                    <tr>
                    <td align=right><b>Until</b></td> <td>$repeat_until</td>
                    </tr>
                    "
                }
            
            }
            # This needs to be updated to deal with single vs. all instances
            if { $write_access_p } {
                # Need to add a link to update repeat info

                # Delete link depends on repeating or not
                if {$interval_type == "never"} {
                    set delete_link [list "?action=item-delete&[export_url_vars group_id item_id instance_id title]&repeat_p=0&current_view=$pass_through_current_view&current_date=$pass_through_current_date\" onclick=\"if(confirm('Are you sure you want to delete \\\'$title\\\'?'))this.href='/calendar/item-delete-2?&[export_url_vars group_id item_id instance_id title]&current_view=$pass_through_current_view&current_date=$pass_through_current_date'; else this.href='javascript:()';" "Delete"]              
                } else {
                    set delete_link [list "?action=item-delete&[export_url_vars group_id item_id instance_id title]&repeat_p=1&current_view=$pass_through_current_view&current_date=$pass_through_current_date" "Delete"]
                }
                # Certain special items, e.g. those inserted by absences
                # or reservations, will not be editable, but can be deleted
                # and have attachments.
                if {$editable_p == "t"} {
                    set navbar "[ad_navbar [list "?action=item-edit&[export_url_vars group_id item_id instance_id return_url]&current_view=$pass_through_current_view&current_date=$pass_through_current_date" Edit] \
                        [list "?action=attachment-add&[export_url_vars group_id item_id instance_id return_url]&current_view=$pass_through_current_view&current_date=$pass_through_current_date" "Add Attachment"]\
                        $delete_link]" 
                } else {
                    set navbar "[ad_navbar \
                        [list "?action=attachment-add&[export_url_vars group_id item_id instance_id return_url]&current_view=$pass_through_current_view&current_date=$pass_through_current_date" "Add Attachment"]\
                        $delete_link]"
                }
                append result "
                <p><font face=arial,helvetica size=-1 color=black> 
                $navbar
                </font></p>"
            }
            set item_date [calendar_format_date_time_string $start_date days]
            set current_date $item_date
            set category_list [calendar_display_categories $instance_id]
            set num_categories [llength $category_list]

            # We're simplifying the ACS way of dealing 
            # w/ text input because it's potentially confusing.
            if {$html_p == "t"} {
                set description_html $description
            } else {
                ## right now, no difference, because it screw up font
                set description_html "$description"
            }

            if {[ad_calendar type] != "group"} {
                set group_html "
                <tr>
                <th align=right>$item_group_type_pretty_name</th>
                <td>
                [cal_group_home_link $item_group_type \
                        $item_group_short_name $item_group_name]
                </td>
                </tr>"
            } else {
                set group_html ""
            }

            if {[empty_string_p $all_day_checked_string_for_view]} {
                set date_header "Date and Time"
                set time_html " ; [calendar_format_date_time_string -use_am_pm 1 -show_date 0 $start_date minutes] to [calendar_format_date_time_string -use_am_pm 1 -show_date $show_end_date $end_date minutes]"
            } else {
                set date_header "Date"
                set time_html ""
            }

            # ejc@arsdigita.com was here 7-27-2000
            if !$num_categories {
                set category_cell "
                <th align=right><font size=-1 face=\"Arial, Helvetica, sans-serif\">Category:</font></th>
                <td><font size=-1 face=\"Arial, Helvetica, sans-serif\">none</font></td>"
            } elseif {$num_categories == 1} {
                set category_cell "
                <th align=right><font size=-1 face=\"Arial, Helvetica, sans-serif\">Category:</font></th>
                <td><font size=-1 face=\"Arial, Helvetica, sans-serif\">$category_list</font></td>"
            } else {
                set category_cell "
                <th align=right><font size=-1 face=\"Arial, Helvetica, sans-serif\">Categories:</font></th>
                <td><font size=-1 face=\"Arial, Helvetica, sans-serif\">[join $category_list ", "]</font></td>"
            }

            append result "
            <h3><font face=arial,helvetica color=black>$description_html</font></h3>
            <table border=0 cellpadding=2>
            $group_html
            <tr valign=top>
             <th align=right bgcolor=\"#FFFFFF\"><font size=-1 face=\"Arial, Helvetica, sans-serif\">$date_header:</font></th>
             <td><font size=-1 face=\"Arial, Helvetica, sans-serif\"><a href=?current_view=day&[export_url_vars current_date group_id]>$item_date</a>$time_html</font></td>
            </tr>
            <tr valign=top>
             <th align=right bgcolor=\"#FFFFFF\"><font size=-1 face=\"Arial, Helvetica, sans-serif\">Title:</font></th>
             <td><font size=-1 face=\"Arial, Helvetica, sans-serif\">$title</font></td>
            </tr>
            $related_url_widget
            <tr>
             $category_cell
            </tr>
            "

            ## commented out for now
            #append result "$repeat_info<br>"

            set file_attachments_html ""
            db_foreach cal_instance_db_row_map_fs_select "
            select c.on_what_id as file_id, 
                   fs.file_title as file_title,
                   fs.parent_id as parent_id,
                   fs2.file_title as parent_title,
                   fsvl.version_id as version_id,
                   fsvl.client_file_name,
                   fsvl.n_bytes,
                   fsvl.url,
                   lower(fsvl.file_type) as file_type
            from cal_instance_db_row_map c, fs_files fs, fs_versions_latest fsvl, fs_files fs2
            where fs2.file_id (+)= fs.parent_id
            and fs2.deleted_p = 'f'
            and c.instance_id=:instance_id
            and c.on_what_id=fs.file_id
            and fs.file_id=fsvl.file_id
            and c.on_which_table='FS_FILES'
            and (ad_general_permissions.user_has_row_permission_p ( :logged_in_user_id, 'read', fsvl.version_id, 'FS_VERSIONS' ) = 't'
                 or fs.owner_id = :logged_in_user_id)
            and fs.deleted_p='f'
            " {
                # write out folder name
                if {[info exists parent_id] && ![empty_string_p $parent_id]} {
                    append file_attachments_html "
                    <a href=/file-storage/one-folder?file_id=$parent_id&[export_url_vars group_id return_url]>$parent_title</a>:"                   
                }
                if { [empty_string_p $n_bytes] } {
                    append file_attachments_html "
                    <a href=$url>$file_title</a>"
                } else {
                    regsub -all {[^-_.0-9a-zA-Z]+} $client_file_name "_" pretty_file_name
                    append file_attachments_html "
                    <a href=/file-storage/download?[export_url_vars version_id]>$file_title</a>"
                }
                #giving file adminstration priveleges to people who can write to it
                if { $write_access_p } {
                    if {$group_id==0} {
                        set export_url_vars [export_url_vars file_id]
                    } else {
                        set export_url_vars [export_url_vars group_id file_id]
                    }
                    append file_attachments_html " \[<a href=\"/file-storage/one-file?$export_url_vars\">manage</a>\]"
                    if {![string compare $file_type "text/html"] || ![string compare $file_type "text/plain"]} {
                        set return_url [ns_conn url]
                        set query [ns_conn query]
                        if {[info exists query] && ![empty_string_p $query]} {
                            append return_url "?$query"
                        }
                        append file_attachments_html " \[<a href=\"/calendar/edit-html-attachment?[export_url_vars file_id group_id return_url]\">edit</a>\]"
                    }
                }
                append file_attachments_html "<br>"
            }
            if ![empty_string_p $file_attachments_html] {
                
                append result "
                <tr>
                <th align=right valign=top bgcolor=\"#FFFFFF\"><font size=-1 face=\"Arial, Helvetica, sans-serif\">Attachments:</font></th>
                <td align=left valign=top bgcolor=\"#FFFFFF\">
                 <font size=-1 face=\"Arial, Helvetica, sans-serif\">$file_attachments_html</font>
                </td>
                </tr>
                "
            }
        append result "</table>"
    }  
*/
    // We're all done with variable setup.  Now, we need to transfer the variables we've been working on over to the request's attributes.
    request.setAttribute("showEndDate", showEndDate);
    request.setAttribute("itemTitle", itemTitle);
    request.setAttribute("description", description);
    request.setAttribute("startDate", start_date);
    // Duration needs to be treated as an empty string on the next page if it doesn't exist here, so we convert to string
    if (duration != null) {
         request.setAttribute("duration", duration.toString());
    } else {
         request.setAttribute("duration", "");
    }
    request.setAttribute("instanceId", instanceId);
    request.setAttribute("itemId", itemId);
    request.setAttribute("endDate", end_date);
    request.setAttribute("allDayCheckedString", allDayCheckedString);
%>

<%
}
// End item AEV-only queries
%>

<ad:use_template />

</ad:page>
