<%@ include file="/acs.jspi" %>
<%@ page import="com.arsdigita.acs.chat.*" %>

<ad:page>
<ad:page_contract vars="chat_room_id:integer, n_rows:optional" />

<ad:get_user_info id="user" />

<%--
 this page will be the most frequently requested in the entire ACS
 it must be super efficient
 it must not query the RDBMS except in unusual cases (e.g., private chat) 
--%>

<%

if (Utilities.emptyString(n_rows) || (!n_rows.equals("short") && !n_rows.equals("medium") && !n_rows.equals("long"))) {
    n_rows = "short";
}

ChatRoom roomInfo = Chat.getRoomProperties(db, chat_room_id);

if (roomInfo.isPrivate() && !user.isGroupMember(roomInfo.getGroupId())) {
    Utilities.sendRedirect(response, "bounced-from-private-room?chat_room_id=" + chat_room_id.toString());
}
String prettyName = roomInfo.getName();
Boolean roomIsModerated = new Boolean(roomInfo.isModerated());
Boolean userIsModerator = new Boolean(roomIsModerated.booleanValue() && user.isAdministrationGroupMember("chat", chat_room_id.toString()));

String cacheKey = "chat_entire_page " + chat_room_id + " " + n_rows + 
	(userIsModerator.booleanValue() ? " moderator" : "");

String cachedPage = (String)MemoizeCache.lookup(cacheKey);
if (cachedPage != null) {
    out.write(cachedPage);
    return;
}

%>


<%

String exitURL = "exit-room?chat_room_id=" + chat_room_id + "&newlocation=";
String pageName = userIsModerator.booleanValue() ? "Moderation" : "One Room";

ContextBar navbar = new ContextBar(pageContext);
navbar.add(exitURL + "index", Chat.getSystemName());
navbar.add(pageName);
%>


<%-- Generate the list of people who've posted in the last 10 minutes.
     Including recentUsers.jspi creates a request attribute named recentUsers.
     It does not produce any output. --%>

<%@ include file="recentUsers.jspi" %>




<%-- Generate the moderation interface, if necessary.
     Including getPostsToModerate creates a request attribute named messagesToApprove.
     It does not produce any output. --%>

<% 
if (userIsModerator.booleanValue()) { 
%>

<%@ include file="getPostsToModerate.jspi" %>

<% 
} else { 
    request.setAttribute("messagesToApprove", " ");
}
%>



<%-- Create the list of actions. --%>

<% 
ActionList actions = new ActionList();
request.setAttribute("actions", actions);
actions.add("chat?chat_room_id=" + chat_room_id + "&n_rows=" + n_rows, "Refresh");
%>



<%-- Generate the list of recent chat room messages.
     Including getPosts.jspi has two side effects: it adds elements to 
     actions and it creates a request attribute named recentMessages. 
     It does not produce any output. --%>

<%@ include file="getPosts.jspi" %>



<% 
if (Parameters.get("ExposeChatHistoryP", "chat", "true").equals("true")) {
    actions.add("history?chat_room_id=" + chat_room_id, "View old messages");
}

actions.add("javascript:helpWindow('js-chat?chat_room_id=" + chat_room_id + "')", "JavaScript Version");

actions.add("exit-room?chat_room_id=" + chat_room_id + "&newlocation=index", "Exit this room");

Boolean mostRecentOnTop = new Boolean(Parameters.get("MostRecentOnTopP", "chat", "true"));    

request.setAttribute("roomIsModerated", roomIsModerated);
request.setAttribute("userIsModerator", userIsModerator);
request.setAttribute("mostRecentOnTop", mostRecentOnTop);
request.setAttribute("prettyName", prettyName);
request.setAttribute("navbar", navbar);
request.setAttribute("n_rows", n_rows);	
request.setAttribute("MemoizeTagKey", cacheKey);
request.setAttribute("n_rows", n_rows);
%>

<ad:use_template method="include" />

</ad:page>

