<%@ include file="../acs.jspi" %>
<%@ page import="com.arsdigita.acs.chat.*" %>

<ad:page>
<ad:page_contract vars="chat_room_id:integer,notnull the_date:notnull" />
<ad:get_user_info id="user" />

<% 
ChatRoom roomInfo = Chat.getRoomProperties(db, chat_room_id); 
if (roomInfo.isPrivate() && !user.isGroupMember(roomInfo.getGroupId())) {
    Utilities.sendRedirect(response, "bounced-from-private-room?chat_room_id=" + chat_room_id.toString());
}
%>

<ad:db_query id="sqlHistoryOneDay">
    select to_char(creation_date, 'HH24:MI:SS') as time, 
           nvl(msg_bowdlerized, msg) as filtered_msg, 
           first_names, 
           last_name, 
           creation_user
    from   chat_msgs, users
    where  chat_msgs.creation_user = users.user_id
    and    chat_room_id = :chat_room_id
    and    chat_msgs.approved_p = 't'
    and    trunc(creation_date) = :the_date
    and    system_note_p <> 't'
    order by creation_date
<ad:db_bind><%= chat_room_id %></ad:db_bind>
<ad:db_bind><%= the_date %></ad:db_bind>
</ad:db_query>


<%
String roomName = roomInfo.get("pretty_name");
ContextBar navbar = new ContextBar(pageContext);
navbar.add("index", Chat.getSystemName());
navbar.add("chat?chat_room_id=" + chat_room_id,  "One Room");
navbar.add("history?chat_room_id=" + chat_room_id, "History");
navbar.add("One Day");

request.setAttribute("chat_room_id", chat_room_id);
request.setAttribute("the_date", the_date);
request.setAttribute("roomName", roomName);
request.setAttribute("navbar", navbar);
request.setAttribute("dsHistoryOneDay", new Selection(sqlHistoryOneDay, db)); 
%>

<ad:use_template />
</ad:page>

