<%@ include file="../acs.jspi" %>
<%@ page import="com.arsdigita.acs.chat.*" %>

<ad:page>
<ad:page_contract vars="chat_room_id:integer,notnull" />
<ad:get_user_info id="user" />

<%

ChatRoom roomInfo = Chat.getRoomProperties(db, chat_room_id); 
if (roomInfo.isPrivate() && !user.isGroupMember(roomInfo.getGroupId())) {
    Utilities.sendRedirect(response, "bounced-from-private-room?chat_room_id=" + chat_room_id.toString());
}

String cacheKey = "chat_history " + chat_room_id;

String cachedPage = (String)MemoizeCache.lookup(cacheKey);
if (cachedPage != null) {
    out.write(cachedPage);
    return;
}

%>


<ad:db_query id="sqlHistory">
    select 
      to_char(trunc(creation_date), 'YYYY-MM-DD') as the_date, 
      count(*) as n_msgs
    from chat_msgs 
    where chat_room_id = :chat_room_id
      and approved_p = 't' 
      and system_note_p <> 't'
    group by trunc(creation_date)
    order by trunc(creation_date) desc
<ad:db_bind><%= chat_room_id %></ad:db_bind>
</ad:db_query>


<% 
String pageTitle = roomInfo.getName() + " History";
ContextBar navbar = new ContextBar(pageContext);
navbar.add("index", Chat.getSystemName());
navbar.add("chat?chat_room_id=" + chat_room_id,  "One Room");
navbar.add(pageTitle);

request.setAttribute("chat_room_id", chat_room_id);
request.setAttribute("pageTitle", pageTitle);
request.setAttribute("navbar", navbar);
request.setAttribute("dsHistory", new Selection(sqlHistory, db)); 
request.setAttribute("MemoizeTagKey", cacheKey);
%>

<ad:use_template />

</ad:page>

