<%--
  /www/comments/comment-add.tcl

    @author teadams@mit.edu 
    @creation-date mid-1998
    @cvs-id $Id: comment-add.jsp,v 1.3 2000/10/24 21:17:43 jbank Exp $
--%>

<%@ include file="../acs.jspi" %>
<ad:page>
<ad:page_contract vars="page_id:integer message comment_type comment_id:integer rating:optional,integer html_p:optional,boolean"/>

<ad:get_user_info id="user" />
<%
if (rating == null) rating = new Integer(0);
if (html_p == null) html_p = new Boolean(false);

if ( parameters.getBoolean("ReadOnlyP","",false) ) {
    throw new ReadOnlyException();
}

String originating_ip = request.getRemoteAddr();

// check for the user cookie
Integer user_id = user.getUserId();
boolean already_submitted_p = false;

%>
    <ad:db_query id="comment_insert">
      begin
        insert into comments (
          comment_id,
          page_id, 
          user_id, 
          comment_type, 
          message, 
          rating, 
          originating_ip, 
          posting_time, 
          html_p
       ) values ( 
          :comment_id,
          :page_id,
          :user_id,
          :comment_type,
          empty_clob(),
          :rating,
          :originating_ip,
          sysdate,
          :html_p
       ) 
       returning message into :1;
     end;
     <ad:db_bind><%= comment_id %></ad:db_bind>     
     <ad:db_bind><%= page_id %></ad:db_bind>     
     <ad:db_bind><%= user_id %></ad:db_bind>     
     <ad:db_bind><%= comment_type %></ad:db_bind>     
     <ad:db_bind><%= rating %></ad:db_bind>     
     <ad:db_bind><%= originating_ip %></ad:db_bind>     
     <ad:db_bind><%= (html_p.booleanValue() ? "t" : "f") %></ad:db_bind>     
    </ad:db_query>
<%

try {
    db.clobDml(comment_insert,message);
} catch (Exception e) {
    String count = db.queryToString("select count(*) from comments where comment_id = :comment_id", new Object[] { comment_id });
    if (!count.equals("0")) {
        already_submitted_p = true;
    } else {
        throw new ACSException ("There was an error with the comment insert:" + e.getMessage() );
    }
}

// comment is submitted, find out the page information
// if there is no title, we use the url stub
// if there is no author, we use the system owner

String owner = Parameters.get("SystemOwner","staticcontent","");

%>
<ad:db_0or1row id="page_data_get" obj="page_data">
    select nvl(page_title,url_stub) as page_title,
           url_stub, 
           nvl(email,'<%= owner %>') as author_email
      from static_pages, users
     where static_pages.original_author = users.user_id (+)
       and page_id = :page_id
<ad:db_bind><%= page_id %></ad:db_bind>
</ad:db_0or1row>
<ad:if_no_rows><% throw new ACSException("Page id could not be found."); %></ad:if_no_rows>

<%
String adurl = Parameters.get("URL", "");
String author_email = page_data.get("author_email");
String page_title = page_data.get("page_title");
String url_stub = page_data.get("url_stub");
String name = user.getFullName();
String email = user.getEmail();
String wrapped_message = message; /* FIXME: Do line wrapping on this. */
String subject = "";
String email_body = "";
String confirm_body = "";

if (comment_type.equals("unanswered_question")) {
    subject = "question about " + url_stub;
    email_body = name + "("+email+") asked a question about\n"+
        adurl+url_stub+"\n"+
        "("+page_title+"):\n\n"+
        "QUESTION:\n\n"+
        wrapped_message;
    confirm_body = "Your question, as appears below, has been recorded and will be considered for page modifications or new site content.";
} else if (comment_type.equals("alternative_perspective")) {
    subject = "comment on " + url_stub;
    email_body = name + "("+email+") gave an alternative perspective on\n"+
        adurl+url_stub+"\n"+
        "("+page_title+"):\n\n"+
        wrapped_message;
    confirm_body = "Your comment, as it appears below, has been added and will be seen as part of the <a href=\""+
        url_stub+"\">"+page_title+"</a> page.";
} else if (comment_type.equals("rating")) {
    subject = url_stub + " rated " + rating;
    email_body = name + "("+email+") rated\n"+
        adurl+url_stub+"\n"+
        "("+page_title+"):\n\n"+
        "RATING: "+rating+"\n\n"+
        wrapped_message;
    confirm_body = "Your rating of \"<b>"+rating+"</b>\" has been submitted along with the comment below and will be considered for page modifications or new site content.";
}

String message_for_presentation = message;
if (!html_p.booleanValue()) {
    message_for_presentation = Utilities.textToHtml(message);
}

if (!already_submitted_p && StaticContent.sendAuthorComment(comment_type, "add")) {
    Log.note("Sending email to: " + author_email + " email: " + email + " subject: " + subject + " body: " + email_body);
    Utilities.sendMail(author_email, email, subject, email_body);
}

request.setAttribute("url_stub", url_stub );
request.setAttribute("page_title", page_title );
request.setAttribute("confirm_body", confirm_body );
request.setAttribute("message_for_presentation", message_for_presentation );

%>

<ad:use_template/>
