<%--
  /www/comments/comment-add.tcl

    @author teadams@mit.edu 
    @creation-date mid-1998
    @cvs-id $Id: comment-edit.jsp,v 1.1 2000/10/24 21:17:43 jbank Exp $
--%>

<%@ include file="../acs.jspi" %>
<ad:page>
<ad:page_contract vars="page_id:integer message comment_type comment_id:integer rating:optional,integer html_p:optional,boolean"/>

<ad:get_user_info id="user" />
<%
if (rating == null) rating = new Integer(0);
if (html_p == null) html_p = new Boolean(false);

if ( parameters.getBoolean("ReadOnlyP","",false) ) {
    throw new ReadOnlyException();
}

String originating_ip = request.getRemoteAddr();

// check for the user cookie
Integer user_id = user.getUserId();

%>
    <ad:db_query id="comment_update">
      begin
      update  comments 
          set  message = empty_clob(), rating=:rating, posting_time = SYSDATE, 
          html_p=:html_p
      where comment_id = :comment_id  and user_id=:user_id
      returning message into :1;
      end;
     <ad:db_bind><%= rating %></ad:db_bind>     
     <ad:db_bind><%= (html_p.booleanValue() ? "t" : "f") %></ad:db_bind>     
     <ad:db_bind><%= comment_id %></ad:db_bind>     
     <ad:db_bind><%= user_id %></ad:db_bind>     
     </ad:db_query>
<%

try {
    db.clobDml(comment_update,message);
} catch (Exception e) {
    throw new ACSException ("There was an error with the comment insert:" + e.getMessage() );
}

// comment is submitted, find out the page information
// if there is no title, we use the url stub
// if there is no author, we use the system owner

String owner = Parameters.get("SystemOwner","staticcontent","");

%>
<ad:db_0or1row id="page_data_get" obj="page_data">
    select nvl(page_title,url_stub) as page_title,
           url_stub, 
           nvl(email,'<%= owner %>') as author_email
      from static_pages, users
     where static_pages.original_author = users.user_id (+)
       and page_id = :page_id
<ad:db_bind><%= page_id %></ad:db_bind>
</ad:db_0or1row>
<ad:if_no_rows><% throw new ACSException("Page id could not be found."); %></ad:if_no_rows>

<%
String adurl = Parameters.get("URL", "");
String author_email = page_data.get("author_email");
String page_title = page_data.get("page_title");
String url_stub = page_data.get("url_stub");
String name = user.getFullName();
String email = user.getEmail();
String wrapped_message = message; /* FIXME: Do line wrapping on this. */
String subject = "";
String email_body = "";
String confirm_body = "";

if (comment_type.equals("unanswered_question")) {
    subject = "edited question about " + url_stub;
    email_body = name + "("+email+") edited a question about\n"+
        adurl+url_stub+"\n"+
        "("+page_title+"):\n\n"+
        "QUESTION:\n\n"+
        wrapped_message;
    confirm_body = "Your modified question, as it appears below, has been recorded and will be considered for page modifications or new site content.";
} else if (comment_type.equals("alternative_perspective")) {
    subject = "edited comment on " + url_stub;
    email_body = name + "("+email+") edited an alternative perspective on\n"+
        adurl+url_stub+"\n"+
        "("+page_title+"):\n\n"+
        wrapped_message;
    confirm_body = "Your modified comment, as it appears below, has been added and will be seen as part of the <a href=\""+
        url_stub+"\">"+page_title+"</a> page.";
} else if (comment_type.equals("rating")) {
    subject = "modified rating for " + url_stub + "(to " + rating + ")";
    email_body = name + "("+email+") modified rating of\n"+
        adurl+url_stub+"\n"+
        "("+page_title+"):\n\n"+
        "RATING: "+rating+"\n\n"+
        wrapped_message;
    confirm_body = "Your modified rating of \"<b>"+rating+"</b>\" has been submitted along with the comment below and will be considered for page modifications or new site content.";
}

String message_for_presentation = message;
if (!html_p.booleanValue()) {
    message_for_presentation = Utilities.textToHtml(message);
}

if (StaticContent.sendAuthorComment(comment_type, "edit")) {
    Log.note("Sending email to: " + author_email + " email: " + email + " subject: " + subject + " body: " + email_body);
    Utilities.sendMail(author_email, email, subject, email_body);
}

request.setAttribute("url_stub", url_stub );
request.setAttribute("page_title", page_title );
request.setAttribute("confirm_body", confirm_body );
request.setAttribute("message_for_presentation", message_for_presentation );

%>

<ad:use_template/>
