<%@ include file="/acs.jspi" %>

<ad:page>

<ad:get_user_info id="user"/>

<ad:page_contract id="pc" vars="comment_id:integer,notnull url_stub caption upload_file:file"/>

<%

String comment_owner = db.queryToString("select user_id from comments where comment_id = :comment_id",
                                        new Object[] { comment_id }, "");
if (user.getUserId().equals(comment_owner)) {
    throw new ACSException("Ouch.  We think that you're not authorized to attach a file to this comment.  Unless you've been playing around with the HTML, this is probably our programming bug.");
}

Perl5Util re =  new com.oroinc.text.perl.Perl5Util();

File uploadFile = new File(upload_file_tmpfile);

String fileExt = "";
if ( re.match("/(\\.[^\\.]+)/", upload_file) )
    fileExt = re.group(1).toLowerCase();

String guessed_file_type =
    (getServletContext().getMimeType(upload_file) == null)?"":getServletContext().getMimeType(upload_file);

long n_bytes = uploadFile.length();

// strip off the C:\directories... crud and just get the file name
String client_filename = upload_file;
if (re.match("@([^//\\\\]+)$@", upload_file))
    client_filename = re.group(1);

int max_n_bytes = parameters.getInt("MaxAttachmentSize", "comments", -1);
if ( max_n_bytes != -1 && n_bytes > max_n_bytes ) {
    throw new ACSException("Your file is too large.  The publisher of " + parameters.get("SystemName","","this system") + "has chosen to limit attachments to " + max_n_bytes + " bytes.\n");
}

if ( n_bytes == 0 ) {
    Vector v = new Vector();
    v.add("Your file is zero-length. Either you attempted to upload a zero length file, a file which does not exist, or something went wrong during the transfer.");
    throw new PageValidationException(v);
}

// all this just to find the image size:
int original_height = -1;
int original_width = -1;
if ( guessed_file_type.equals("image/gif") || guessed_file_type.equals("image/jpeg") ) {
    try {
	Utilities.copyFile(uploadFile, new java.io.File("/tmp/myFile.jpg"));

	ImageSize imageSize = new ImageSize("/tmp/myFile.jpg");
	original_width = imageSize.getWidth();
	original_height = imageSize.getHeight();
    } catch (Exception e) {
	Log.error("get image size failed: " + e.getMessage());
    } 
}

%>

<ad:db_query id= "comment_attachment_update">
  begin
  update comments 
  set attachment = empty_blob(),
        client_file_name = :client_filename,
        file_type = :guessed_file_type,
        file_extension = :file_extension,
        caption = :caption,
        original_width = :original_width,
        original_height = :original_height
  where comment_id = :comment_id
  returning attachment into :1;
  end;
<ad:db_bind><%= client_filename %></ad:db_bind>
<ad:db_bind><%= guessed_file_type %></ad:db_bind>
<ad:db_bind><%= fileExt %></ad:db_bind>
<ad:db_bind><%= caption %></ad:db_bind>
<ad:db_bind><%= original_width %></ad:db_bind>
<ad:db_bind><%= original_height %></ad:db_bind>
<ad:db_bind><%= comment_id %></ad:db_bind>
</ad:db_query>


<%
db.blobDmlFile(comment_attachment_update,uploadFile);

response.sendRedirect(url_stub);
%>


