<%--
  /errors.tpl

  @author jsc@arsdigita.com
  @creation-date 07/292000
  @cvs-id $Id: errors.tpl,v 1.5 2000/10/18 20:43:09 jbank Exp $ 

--%>

<%@ taglib uri="/tlds/acs-tags.tld" prefix="ad" %>
<%@ page import="com.arsdigita.acs.*,
                 com.arsdigita.acs.db.Database,
                 java.io.*" %>

<%

Exception e = (Exception) request.getAttribute("javax.servlet.jsp.jspException");
String title = "Error";
String header = "Error";
String message = (e == null)?"No exception":e.getMessage();

///////////////////////
// Caution:
//    All Exceptions need to be instanceof checked before their parents since
//    instanceof will return true for a child.
//////////////////////

//special case, dont need to do database clean-up
if (e instanceof PageValidationException) {
    request.setAttribute("page_validation_p",new Boolean(true));
    title = "Input Problems";
    header = "Input Problems";
} else {
    // get database handle out of request context if there is one
    Database myDB = (Database) request.getAttribute("db");
    if (myDB != null) {
	// roll back transaction if we're in one
	if (myDB.inTransaction()) {
	    myDB.abortTransaction();
	    // System.out.println("rolled back!");
	    myDB.close();
	}
    }

    /** Presumably the people customizing the toolkit will add more else-if clauses here for
     *  different errors that the publisher will want to display. The publisher can then edit
     *  the .tpl file to display any type of content and/or formatting for these different
     *  scenarios. (see Caution above)
     */
    if (e instanceof ReadOnlyException) {
	request.setAttribute("read_only_p",new Boolean(true));
	title = "System Maintenance";
	header = "We're Maintaining the Database";
    } else if (e instanceof ACSException) {
	request.setAttribute("acs_p",new Boolean(true));
	ACSException ae = (ACSException) e;
	// response.setStatus(ae.getHttpStatus());
	title = ae.getTitle();
	header = ae.getTitle();
	message = ae.getMessage();
	if (ae.getHttpStatus() == 500) {
	    StringWriter sw = new StringWriter();
	    PrintWriter pw = new PrintWriter(sw);
	    e.printStackTrace(pw);
	    message += "<pre>\n" + sw.toString() + "\n</pre>\n";
	}
    } else if (e instanceof java.sql.SQLException) {
	request.setAttribute("acs_p",new Boolean(true));
        java.sql.SQLException sqle = (java.sql.SQLException) e;
	title = "SQL Exception";
	header = "SQL Exception";
	message = "";
        StringWriter sw = new StringWriter();
        PrintWriter pw = new PrintWriter(sw);
        e.printStackTrace(pw);
        message += "<pre>\n" + sw.toString() + "\n</pre>\n";
    } else {
	// don't know what this is; let the servlet container handle it.
	throw (e);
    }
}

request.setAttribute("title",title);
request.setAttribute("header",header);
request.setAttribute("message",message);

%>
    
<%@ include file="templates/errors.tpl" %>

