<%-- 
Example of the database tag API usage
--%>

<%@ include file="/acs.jspi" %>

<ad:page>
<ad:page_contract vars="topic_id:integer"/>

<ad:db_0or1row id="theTopic" type="com.arsdigita.acs.bboard.SingleTopicDataSource">
 select * from bboard_topics 
 where topic_id = ?
<ad:db_bind><%= topic_id %></ad:db_bind>
</ad:db_0or1row>

<%-- 
theTopic (type SingleTopicDataSource) is now available, initialized
with the row from the query; or null if non-existent.  It is also
stuffed into the request attributes for use with ad:scope and ad:sub 
tags.
--%>

<ad:if_no_rows>
 <% throw new ACSException("You did not supply a valid topic."); %>
</ad:if_no_rows>

<%-- get messages --%>
<ad:db_query id="messages" type="com.arsdigita.acs.bboard.MessagesDataSource">
 select msg_id, one_line from bboard
 where topic_id = ?
 order by posting_time
<ad:db_bind><%= topic_id %></ad:db_bind>
</ad:db_query>

<%-- 
messages is now a valid variable  of type MessagesDataSource;
it is also stuffed into the request attributes so it can immediately
be referenced from ad:sub and ad:loop tags
--%>

<%-- 
serve the page: 
this would normally be done in a template but do it all here for the sake
of example
--%>

<ad:scope sources="theTopic">

<ad:header>All messages in <ad:sub var="theTopic"/></ad:header>
<h2>All messages in <ad:sub var="theTopic"/></h2>
<hr>
<ul>
<ad:loop ds="messages">
 <li><a href="<ad:sub var="msg_id"/>"><ad:sub var="one_line" /></a>
</ad:loop>
</ul>
</ad:loop>

<ad:footer/>

</ad:page>
