<%--
# /file-storage/public-one-group.jsp
    show the public files owned by a group

    @author philg@mit.edu
    @creation-date July 24, 1999
    @cvs-id $Id: all-public.jsp,v 1.1 2000/10/27 19:05:37 jbank Exp $
--%>

<%@ include file="/acs.jspi" %>
<ad:page>

<ad:get_user_info id="user"/>

<%

String title = "Public files summary";

ContextBar contextBar = new ContextBar(ContextBar.PERSONAL, user);
contextBar.add("", parameters.get("SystemName", "fs"));
contextBar.add( "Publically accessible files");

request.setAttribute("title", title);
request.setAttribute("contextBar", contextBar);

%>

<%--
# get the names of users who have stuff in their personal space
--%>

<ad:db_query id="person_query" obj="persons">
   select u.user_id,
            u.first_names,
            u.last_name,
            count ( distinct fsf.file_id ) as n_files,
            round ( sum ( fsvl.n_bytes ) / 1024 ) as n_kbytes
       from users u,
            fs_files fsf,
            fs_versions_latest fsvl
      where fsf.file_id = fsvl.file_id
        and fsf.owner_id = u.user_id
        and ( fsf.public_p = 't' or fsf.public_p is null )
        and fsf.group_id is null
        and ( fsf.folder_p = 'f' or fsf.folder_p is null )
        and fsf.deleted_p = 'f'
        and ad_general_permissions.user_has_row_permission_p ( :local_user_id, 'read', fsvl.version_id, 'FS_VERSIONS' ) = 't'
   group by u.user_id,
            u.first_names,
            u.last_name
   order by upper ( last_name ), upper ( first_names )
   <% person_query.bind("local_user_id", user.getUserId()); %>
</ad:db_query>

<ad:db_query id="group_query" obj="groups">
    select ug.group_id,
            ug.group_name,
            round ( sum ( fsvl.n_bytes ) / 1024 ) as n_kbytes
       from user_groups ug,
            fs_files fsf,
            fs_versions_latest fsvl
      where fsf.file_id = fsvl.file_id
        and ( fsf.public_p = 't' or fsf.public_p is null )
        and fsf.deleted_p = 'f'
        and ( fsf.folder_p = 'f' or fsf.folder_p is null )
        and fsf.group_id = ug.group_id
        and ad_general_permissions.user_has_row_permission_p ( :local_user_id, 'read', fsvl.version_id, 'FS_VERSIONS' ) = 't'
   group by ug.group_id,
            ug.group_name
   <% group_query.bind("local_user_id", user.getUserId()); %>
</ad:db_query>


<ad:use_template/>

</ad:page>
