<%
/*
    this file creates a new folder
 
    @author aure@arsdigita.com
    @creation-date July, 1999
    @cvs-id $Id: create-folder-2.jsp,v 1.3 2000/10/17 17:12:21 luke Exp $

    modified by randyg@arsdigita.com, January, 2000 to use the
    general permissions module
*/
%>

<%@ include file="/acs.jspi" %>
<%@ page import="com.arsdigita.acs.fs.*" %>

<ad:page>

<ad:get_user_info id="user" />
<% Integer user_id = user.getUserId(); %>

<ad:page_contract id="pc" vars="file_id:integer,optional file_title:optional group_id:integer,optional parent_id:integer,optional public_p:optional return_url:optional version_id:integer">

<%
// check the user input first

if (Utilities.emptyString(file_title)) {
    pc.addComplaint("<li>You must give a title to the folder\n");
}

if (public_p.equals("t") && !parameters.getBoolean("PublicDocumentTreeP","fs")) {
    pc.addComplaint(parameters.get("SystemName", "acs") + " does not support a public directory tree.");
}

if (group_id != null) {
    try {
	if (!user.isGroupMember(group_id)) {
	    pc.addComplaint("You are not a member of this group " + group_id + "\n");
	}
    } catch (ACSException e) {
	throw new JspException(e.getMessage());
    }
}

%>

</ad:page_contract>

<%
if (public_p == null) {
    public_p = "f";
}
if (return_url == null) {
    return_url = "index";
}
%>
<ad:db_query id="file_insert">
insert into fs_files (
    file_id, 
    file_title, 
    owner_id, 
    parent_id, 
    folder_p,  
    sort_key, 
    depth, 
    public_p, 
    group_id)
values (?, ?, ?, ?, 't', 0, 0, ?, ?)
<ad:db_bind><%= file_id %></ad:db_bind>
<ad:db_bind><%= file_title %></ad:db_bind>
<ad:db_bind><%= user_id %></ad:db_bind>
<ad:db_bind><%= db.bindObj(parent_id) %></ad:db_bind>
<ad:db_bind><%= public_p %></ad:db_bind>
<ad:db_bind><%= db.bindObj(group_id) %></ad:db_bind>
</ad:db_query>

<%
// now we want to insert a "dummy" version so that we can also create the permission
// records
%>

<ad:db_query id="version_insert">
    insert into fs_versions
    (version_id, file_id, creation_date, author_id)
    values
    (?, ?, sysdate, ?)
<ad:db_bind><%= version_id %></ad:db_bind>
<ad:db_bind><%= file_id %></ad:db_bind>
<ad:db_bind><%= user_id %></ad:db_bind>
</ad:db_query>
 
<ad:db_transaction>

<%

try {
    db.dml(file_insert);
    db.dml(version_insert);
    GeneralPermissions.grantPermission(db, "all_users", null, null, null, 
     "read", version_id, "FS_VERSIONS");
    GeneralPermissions.grantPermission(db, "all_users", null, null, null, 
     "comment", version_id, "FS_VERSIONS");
}
catch (SQLException sqle) {
    // insert failed; let's see if it was because of duplicate submission
    try {
	Integer count = new Integer(db.queryToString("select count(*) from fs_files where file_id = ?", new Object[] {file_id}));
	if (count.intValue() == 0) {
	    // there is no duplicate, so we have an error to log
	    log("/file-storage/create-folder-2.tcl choked:  " + sqle.getMessage());
	    response.sendError(response.SC_INTERNAL_SERVER_ERROR, 
	    "The Database did not like what you typed. " +
	    "This is probably a bug in our code.  " +
	    "Here's what the database said: <blockquote><pre>" + 
	    sqle.getMessage() + "</pre></blockquote>");
	    return;
	}
    }
    catch (ACSException acse) {
	throw new JspException(acse.getMessage());
    }
}

// we don't bother to handle the cases where there is a dupe submission
// because the user should be thanked or redirected anyway
response.sendRedirect(return_url);

FileStorageProcs.orderFiles(db);

%>
</ad:db_transaction>

<%
response.sendRedirect(return_url);
%>

</ad:page>