<% 
/*
    /file-storage/create-folder.tcl

    this file allows a user to select a title and location for
    a new folder

    @author aure@arsdigita.com
    @creation-date July, 1999
    @cvs-id $Id: create-folder.jsp,v 1.3 2000/10/17 17:12:21 luke Exp $

    modified by randyg@arsdigita.com, January, 2000 to use the general
    permissions module
*/
%>

<%@ include file="/acs.jspi" %>
<%@ page import="com.arsdigita.acs.fs.*" %>

<ad:page>

<ad:get_user_info id="user" />

<%
Integer user_id = user.getUserId();
ContextBar navbar = new ContextBar(pageContext);
String title = "Create New Folder";
%>

<ad:page_contract id="pc" vars="return_url:optional group_id:integer,optional public_p:optional this_folder:optional,integer">

<%

// Determine if we are uploading to a Group or to our personal area
// this is based if no group_id was sent - then we are uploading
// to our personal area - otherwise the default group defined by group_id

if ("t".equals(public_p) && !parameters.getBoolean("PublicDocumentTreeP","fs")) {
    pc.addComplaint(parameters.get("SystemName", "acs") + " does not support a public directory tree.");
}

if (group_id != null) {

    String group_name = null;
    try {
	group_name = db.queryToString("select group_name from user_groups where  group_id = ?", new Object[] {group_id});

        //  we are in the group tree
	if (!user.isGroupMember(group_id)) {
	    pc.addComplaint("You are not a member of group <cite>" + group_name+ "</cite>\n");
	    
	} else {
	    navbar.add("", parameters.get("SystemName", "fs"));
	    navbar.add(return_url, group_name + " document tree");
	    navbar.add(title);
	}
    }
    catch(ACSException e) {
	throw new JspException(e.getMessage());
    }

    public_p = "f";

} else if ("t".equals(public_p)) {

    // we are in the public document tree

    navbar.add("", parameters.get("SystemName", "fs"));
    navbar.add(title);
    group_id = null;

} else {

    // we are in the personal document tree

    navbar.add("", parameters.get("SystemName", "fs"));
    navbar.add("private-one-person", "Personal document tree");
    navbar.add(title);
    
    group_id = null;
    public_p = "f";

}
// return errors

Integer file_id = null;
Integer version_id = null;

try {
     file_id = new Integer(db.queryToString("select fs_file_id_seq.nextval from dual"));
     version_id = new Integer(db.queryToString("select fs_version_id_seq.nextval from dual"));
} catch (ACSException e) {
    throw new JspException(e.getMessage());
}

%>

<ad:header><%= title %></ad:header>

<h2><%= title %></h2>

<%= navbar.getHTML() %>

<hr align=left>
<form  method=POST action=create-folder-2>
<%
AdSet set = new AdSet();
set.put("version_id", version_id);
if (return_url != null)  
   set.put("return_url", return_url);
set.put("group_id", group_id);
set.put("public_p", public_p);
set.put("file_id", file_id);
%>

<%= Utilities.exportFormVars(set) %>

<table>
<tr>
<td align=right>Folder Name: </td>
<td><input size=30 name=file_title></td>
</tr>

<tr>
<td align=right>Location:</td>
<td><%= FileStorageProcs.fsFolderDefSelection(db,user_id,group_id,"t".equals(public_p),null,this_folder) %></td>
</tr>

<tr>
<td>&nbsp;</td>
<td><input type=submit value="Create">
</td>
</tr>

</table>

</form>

<!-- [ad_footer [fs_system_owner]]" -->
</ad:page_contract>
</ad:page>
