<%
/* /file-storage/file-delete-2.tcl
ad_page_contract {
    marks a file deleted (but does not actually remove anything 
    from the database); if a folder, marks the entire subtree deleted
    
    @author aure@arsdigita.com
    @creation-date July 1999
    @cvs-id $Id: file-delete-2.jsp,v 1.3 2000/10/17 17:12:21 luke Exp $

    modified by randyg@arsdigita, January, 2000 to use the general permissions module
*/
%>

<%@ include file="/acs.jspi" %>
<%@ page import="com.arsdigita.acs.fs.*" %>

<ad:page>

<ad:get_user_info id="user" />

<% Integer user_id = user.getUserId(); %>

<ad:page_contract id="pc" vars="file_id:integer group_id:integer,optional source:optional" >

<%
// Determine if we are working in a Group, or our personal space
// this is based if no group_id was sent - then we are in
// our personal area - otherwise the group defined by group_id

Integer version_id = new Integer(db.queryToString(
"select version_id from fs_versions_latest where file_id = ?",
new Object[] {file_id}));

if (!FileStorageProcs.checkWrite(user, version_id)) {
    pc.addComplaint("You do not own this file");
}

// return errors
%>

</ad:page_contract>

<%

String folder_p = "f";

// is this a folder ? Get all its children
folder_p = db.queryToString(
"select folder_p from fs_files where file_id=?",
new Object[] {file_id});

%>

<ad:db_query id="children_query">
        select file_id
        from   fs_files
        connect by prior file_id = parent_id
        start with file_id = ?
<ad:db_bind><%= file_id %></ad:db_bind>
</ad:db_query>

<ad:db_query id="sql_delete_single">

<ad:db_bind><%= file_id %></ad:db_bind>
</ad:db_query>

<ad:db_transaction>
<%
if (folder_p.equals("t")) {

    // note that the "children" list includes the top-level folder
    Vector children_list = db.queryToList(children_query);
    String sql_faux_delete = "update fs_files set deleted_p = 't' " +
    " where  file_id in ( " + 
    Utilities.join(children_list, ", ") + 
    " ) ";
    db.dml(sql_faux_delete);
} else {
    db.dml("update fs_files set deleted_p = 't' where file_id = ?", 
    new Object[] {file_id});
}

FileStorageProcs.orderFiles(db);

%>
</ad:db_transaction>

<%
String return_url = "";

    AdSet set = new AdSet();
    if ("private_individual".equals(source)) {
	set.put("user_id", user_id);
	return_url = "private-one-person?" + Utilities.exportURLVars(set);
    } else if ("private_group".equals(source)) {
	set.put("group_id", group_id);
	return_url = "private-one-group?" + Utilities.exportURLVars(set);
    } else if  ("public_individual".equals(source)) {
	set.put("user_id", user_id);
	return_url = "public-one-person?" + Utilities.exportURLVars(set);
    } else if ("public_group".equals(source)) {
	set.put("group_id", group_id);
	return_url = "public-one-group?" + Utilities.exportURLVars(set);
    } else if (Utilities.emptyString(return_url)) {
	// the original redirected to empty string--with no form variables
	return_url = "index";
    }

    response.sendRedirect(return_url);
%>



