<% 
/* /file-storage/file-delete.tcl
    this page makes sure that a user wants to delete a file or a folder.  
    If a folder is deleted, all of the children are also deleted.

    @author aure@arsdigita.com
    @creation-date July 1999
    @cvs-id $Id: file-delete.jsp,v 1.4 2000/10/17 17:12:21 luke Exp $

    modified by randyg@arsidgita.com, January, 2000 to use the general permissions system

*/
%>

<%@ include file="/acs.jspi" %>
<%@ page import="com.arsdigita.acs.fs.*" %>

<ad:page>

<% String title = null; %>

<ad:page_contract vars="file_id:integer,optional return_url group_id:integer,optional object_type:optional source:optional" id="pc">

<ad:get_user_info id="user" />

<%
Integer user_id = user.getUserId();

title = "Delete " + object_type;

if (file_id == null) {
    pc.addComplaint("No file was specified");
} else {
    Integer version_id = FileStorageProcs.latestVersion(db, file_id);

    if (!FileStorageProcs.checkWrite(user, version_id)) {
	pc.addComplaint("You do not own this file");
	// some additional exception text:
	// $user_id $version_id $group_id [ad_g_write_p [ad_g_permissions_id $version_id FS_VERSIONS] $user_id]
    }
}

if (Utilities.emptyString(object_type)) {
    pc.addComplaint("This page may only be accessed from the edit page");
}

// return errors
%>
</ad:page_contract>
<%

String file_title = db.queryToString(
"select file_title from fs_files where file_id=?",
new Object[] {file_id});

ContextBar navbar = new ContextBar(pageContext);
navbar.add("", parameters.get("SystemName", "fs"));
navbar.add(title);

%>

<ad:header><%= title %></ad:header>

<h2> <%= title %> </h2>

<%= navbar.getHTML() %>

<hr align=left>

<blockquote>

<%

int number_of_children = 0;

// if this is a folder - get the number of childern

%>

<ad:db_query id="sql_child_count">
        select count(*)-1
        from   fs_files
        connect by prior file_id = parent_id
        start with file_id = ?
<ad:db_bind><%= file_id %></ad:db_bind>
</ad:db_query>

<%
if (object_type.equals("Folder")) {
    number_of_children = new Integer(db.queryToString(sql_child_count)).intValue();
    %>
        
    This folder has <%= number_of_children %> sub-folders/files. <p>
    
    <%
}

if (number_of_children > 0) {
%>
    Are you sure you want to delete <%= file_title %> and all of it sub-folders/files?
<%
} else {
%>
     Are you sure you want to delete <%= file_title %>?
<%
}

%>

<form action=<%= return_url %> method=post>
<input type=submit value="No, Don't Delete" >
</form>

<form action=file-delete-2 method=post>
<% 
AdSet set  = new AdSet();
set.put("group_id", group_id);
set.put("file_id", file_id);
set.put("source", source);
%>
<%= Utilities.exportFormVars(set) %>
<input type=submit value="Yes, Delete!" >
</form>

</blockquote>
<!-- [ad_footer [fs_system_owner]] -->

</ad:page>

