<% 
/*
    file-edit.jsp
    $Id: file-edit.jsp,v 1.4 2000/10/17 17:12:21 luke Exp $
*/
%>

<%@ include file="/acs.jspi" %>
<%@ page import="com.arsdigita.acs.fs.*" %>

<ad:page>

<% 
String title = "Edit Properties";
Integer version_id = null;
%>

<ad:get_user_info id="user" />

<ad:page_contract id="pc" vars="return_url:optional file_id:integer,optional group_id:integer,optional">

<% 
if (file_id == null) {
    pc.addComplaint("No file was specified");
}

version_id = FileStorageProcs.latestVersion(db, file_id);

if (version_id == null) {
    pc.addComplaint("The file you have requested does not exist.");
} else if (!FileStorageProcs.checkWrite(user,version_id)) {
    pc.addComplaint("You do not own this file");
}
%>

</ad:page_contract>

<ad:db_query id="file_information"> 
    select fsf.file_title,
           decode ( fsf.folder_p, 't', 'Folder', 'File') as object_type,
           fsvl.file_type,
           ad_general_permissions.user_has_row_permission_p (?, 'read', fsvl.version_id, 'FS_VERSIONS' ) as public_read_p,
           fsf.public_p,
	   url
    from   fs_files fsf,
           fs_versions_latest fsvl
    where  fsf.file_id = ?
    and    fsf.file_id = fsvl.file_id
<ad:db_bind><%= user.getUserId() %></ad:db_bind>
<ad:db_bind><%= file_id %></ad:db_bind>
</ad:db_query>

<%
ResultSet rs = db.query(file_information);
rs.next();
String file_title = rs.getString("file_title");
String file_type = rs.getString("file_type");
String object_type = rs.getString("object_type");
String public_p = rs.getString("public_p");
String url = rs.getString("url");

ContextBar navbar = new ContextBar(pageContext);
if (group_id != null) {
    String group_name = db.queryToString("select group_name from user_groups where group_id=?", new Object[] {group_id});
        
    navbar.add("", parameters.get("SystemName","fs"));
    navbar.add("private-one-group?group_id=" + group_id, group_name);
    navbar.add(return_url, "One File");
    navbar.add(title);
} else {
    navbar.add("", parameters.get("SystemName","fs"));
    navbar.add(return_url, "One File");
    navbar.add(title);
}

%>

<ad:header><%= title %></ad:header>

<h2><%= title %></h2>

<%= navbar %>

<hr align=left>
<blockquote>
<form method=POST action=file-edit-2>

<%
AdSet set = new AdSet();
set.put("file_id", file_id);
set.put("version_id", version_id);
set.put("return_url", return_url);
set.put("group_id", group_id);
set.put("object_type", object_type);
%>
<%= Utilities.exportFormVars(set) %>

<table>
<tr>
<td align=right><%= object_type %> Title: </td>
<td><input size=30 name=file_title value="<%= file_title %>"></td>
</tr>

<%
String fileOrUrl = "file";
if (!Utilities.emptyString(url)) {
	fileOrUrl = "url";
%>
	<tr>
	<td align=right>URL: </td>
	<td><input size=40 name=url value="<%= url %>"></td>
<%
} else if ("File".equals(object_type)) { 
%>
    <tr>
    <td align=right>File Type: </td>
    <td><input size=30 name=file_type value="<%= file_type %>"></td>
<% } %>

<tr>
<td align=right>Location:</td>
<td><%= FileStorageProcs.fsFolderDefSelection(db, user.getUserId(),group_id,"t".equals(public_p),file_id,null) %></td>
</tr>

<tr>
<td></td>
<td><input type=submit value="Update">
</td>
</tr>
</table>

</form>

<h3>Severe actions</h3>

<ul>
<% set.deleteKey("version_id"); %>
<li><a href=<%= fileOrUrl %>-delete?<%= Utilities.exportURLVars(set) %>>Delete this <%= object_type %></a>

</ul>
</blockquote>

<!-- [ad_footer [fs_system_owner]] -->


