<%@ include file="/acs.jspi" %>
<%@ page import="com.arsdigita.acs.fs.*" %>

<ad:page>
<ad:get_user_info id="user" />

<%
Integer userId = user.getUserId();
String foldersOpenP = Utilities.getCookieValue(request, "folders_open_p");
if (foldersOpenP == null) {
    foldersOpenP = "1";
}

String title = Parameters.get("SystemName", "acs") + " Shared Document Tree";
%>

<ad:header><%= title %></ad:header>

<h2><%= title %></h2>

<%= Parameters.get("SystemName", "fs") %>

<hr align=left>

<ul>
<li> <a href="upload-new?public_p=t&return_url=<%= Utilities.URLEncode("") %>">Add a URL / Upload a file</a>
<li> <a href="create-folder?public_p=t">Create New Folder</a>

<form action=search method=GET>
<li> Search file names for:
<input name=search_text type=text size=20> <input type=submit value=Search>
</ul>
</form>

<blockquote>

<%
    String depthRestriction = "";
    if (! foldersOpenP.equals("1")) {
	depthRestriction = "\nand depth < 1\n";
    }
%>

<ad:db_query id="sorted_query">
    select fsf.file_id,
           fsf.file_title,
           fsvl.url,
           fsf.folder_p,
           fsf.depth * 24 as n_pixels_in,
           round ( fsvl.n_bytes / 1024 ) as n_kbytes,
           n_bytes,
           to_char ( fsvl.creation_date, 'YYYY-MM-DD HH24:MI' ) as creation_date,
           nvl ( fsvl.file_type, upper ( fsvl.file_extension ) || ' File' ) as file_type,
           fsf.sort_key,
           fsvl.version_id,
           fsvl.client_file_name
    from   fs_files fsf,
           fs_versions_latest fsvl
    where  fsf.file_id = fsvl.file_id
    and    fsf.public_p = 't'
    and    group_id is NULL
    and    deleted_p = 'f' <%= depthRestriction %>
    and    (ad_general_permissions.user_has_row_permission_p ( ?, 'read', fsvl.version_id, 'FS_VERSIONS' ) = 't' or fsf.owner_id = ?)
    order by fsf.sort_key
<ad:db_bind><%= userId %></ad:db_bind>
<ad:db_bind><%= userId %></ad:db_bind>
</ad:db_query>

<%
String font = "<nobr>" + Parameters.get("FileInfoDisplayFontTag", "fs");
String headerColor = Parameters.get("HeaderColor", "fs");
FolderBox fs = new FolderBox(userId, FileStorageProcs.sharedOption(), db);
String webRoot = request.getContextPath();
%>

<li><%= fs %>

<table border=1 bgcolor=white  cellpadding=0 cellspacing=0>
 <tr>
 <td><table bgcolor=white cellspacing=1 border=0 cellpadding=0>
    <%= FileStorageProcs.headerRowForFiles(title, false) %>


<ad:db_foreach row="rs" in="sorted_query">
    <%= FileStorageProcs.rowForOneFile(rs, "file_id=" + rs.getString("file_id") + "&source=shared") %>
</ad:db_foreach>
<ad:if_no_rows>
    <tr>
    <td>There are no files. </td>
    </tr>
</ad:if_no_rows>

</table></td></tr></table></blockquote>
</html>

</ad:page>

<!-- Powered by ArsDigita -->
