<%
/*
Display a summary of one file, with options to download, edit properties, 
or upload new version.

    @author aure@arsdigita.com
    @creation-date July 1999 
    @cvs-id $Id: one-file.jsp,v 1.15 2000/10/27 19:05:37 jbank Exp $
    @param file_id The id of the requested file.
    @param group_id The id of the group that owns the file.
    @param owner_id An id for the owner of the file.
    @param source Where the file is stored.
    @param view Which versions of the file should be viewed.  Valid values are "latest" and "all."
*/
%>

<%@ include file="/acs.jspi" %>
<%@ page import="com.arsdigita.acs.fs.*" %>

<ad:page>
<ad:get_user_info id="user" />

<% 
Integer latest_version_id = null;
Integer local_user_id = user.getUserId();
%>

<ad:page_contract id="pc" vars="file_id:integer, group_id:integer,optional owner_id:integer,optional source:optional view:optional">

<%

if (db.queryToString("select count(*) from fs_files where file_id = ?", 
new Object[] {file_id}).equals("0")) {
    pc.addComplaint("The given file ID does not exist");
} else {
    latest_version_id = FileStorageProcs.latestVersion(db, file_id);
    if (!FileStorageProcs.checkRead(local_user_id,latest_version_id)) {
	pc.addComplaint("You can't read this file");
    }
}

if (group_id != null && "0".equals(db.queryToString(
"select count(*) from user_groups where group_id=?", new Object[] {group_id}))) {
    pc.addComplaint("The given group ID does not exist");
}

// return errors
%>

</ad:page_contract>

<% 
String on_which_table = "FS_VERSIONS";
if (view == null)  {
    view = "latest";
} 

StoredFile sf = new StoredFile();
sf.select(db, file_id, local_user_id); 
owner_id = sf.getOwnerId();
if (sf.getDeleted()) {
    String owner = db.queryToString(
    "select '<a href=mailto:' || email || '>' || first_names || ' ' || last_name || '</a>' from users where user_id = ?", new Object[] {owner_id});
    response.sendError(response.SC_INTERNAL_SERVER_ERROR, 
    "The file " + file_id + " has been marked as deleted. You can contact the owner of the file (" + owner + "), if you want.");
    return;
}

if (sf.getIsFolder()) {
    // we got here by mistake, push them out into the right place 
    // (this shouldn't happen!)
    log("User was sent to /file-storage/one-file.tcl to view a FOLDER (#" + file_id + ")");
    response.sendRedirect("one-folder?" + Utilities.exportURLVars(form));
    return;
}

String object_type = "File";

String title = sf.getTitle();

String parent_title = sf.getParentTitle();
if (Utilities.emptyString(parent_title)) {
    parent_title = "Root (Top Level)";
}

// the navbar is determined by where they just came from

ContextBar navbar = sf.getNavbar(pageContext, db, source);

if (Utilities.emptyString(source)) {
    source = FileStorageProcs.guessSource(db, sf.getIsPublic(), sf.getOwnerId(), sf.getGroupId(), user);
}

// We use return_url to create links to other pages that should
// return back here.
//
String return_url = request.getRequestURI() + "?" + request.getQueryString();

// We pass the title of this file to /gp/administer-permissions.tcl as
// object_name.
//
String object_name = title;

%>

<ad:header><%= title %></ad:header>

<h2> <%= title %></h2>

<%= navbar %>
<hr align=left>

<%

Vector action_list = new Vector();

if (Utilities.emptyString(sf.getUrl()) && sf.getOlderVersions(db) != 0) {
    AdSet vs = form;
    vs.deleteKey("view");
    if ("all".equals(view)) {
	action_list.addElement("<a href=\"one-file?" + Utilities.exportURLVars(vs) + "&view=latest\">show only latest version</a>");
    } else {
	action_list.addElement("<a href=\"one-file?" + Utilities.exportURLVars(vs) + "&view=all\">show all versions</a>");
    }
}

if (FileStorageProcs.checkWrite(user, latest_version_id)) {
    if (Utilities.emptyString(sf.getUrl())) {
	AdSet vars = new AdSet();
	vars.put("return_url", return_url);
	vars.put("file_id", file_id);
        action_list.addElement("<a href=\"version-upload?" + Utilities.exportURLVars(vars) + "\">upload new version</a>");
	vars.put("group_id", sf.getGroupId());
        action_list.addElement("<a href=\"file-edit?" + Utilities.exportURLVars(vars) + "\">edit file</a>");
	vars.put("source", source);
	vars.put("object_type", object_type);
        action_list.addElement("<a href=\"file-delete?" + Utilities.exportURLVars(vars) + "\">delete this file (including all versions)</a>");
    } else {
	AdSet vars = new AdSet();
	vars.put("return_url", return_url);
	vars.put("file_id", file_id);
	vars.put("group_id", sf.getGroupId());
	vars.put("owner_id", sf.getOwnerId());
	vars.put("source", source);
        action_list.addElement("<a href=\"url-delete?" + Utilities.exportURLVars(vars) + "\">delete</a>");
	vars.deleteKey("owner_id");
	action_list.addElement("<a href=\"file-edit?" + Utilities.exportURLVars(vars) + "\">edit</a>");
    }
}

%>

<ul>
<li> Title: <%= sf.getTitle() %>
<li> Owner: <%= sf.getOwnerName() %>
<li> Located in: <%= sf.getTreeName() %> / <%= parent_title %>

<%
if (action_list.size() > 0) {
%>
    <p>
    <li>Actions:  <%= Utilities.join(action_list, " | ") %>
<%
}
%>

</ul>
<blockquote>

<%

int version_count = 0;

// this query replaces the monster that follows.
// its purpose is to extract all versions of this file (with some extra information)
// and also with permission information

StoredFileVersion[] versionList = null;
String table_title = "Latest Version of " + sf.getTitle();

if ("all".equals(view)) {
    table_title = "All Versions of " + sf.getTitle();
    versionList = sf.getAllVersions(db, local_user_id);
} else {
    versionList = new StoredFileVersion[1];
    versionList[0] = sf.getLatestVersion(db, local_user_id);
}

String font = "<font face=arial,helvetica>";

String header_color = parameters.get("HeaderColor", "fs");
String graphic = null;

if (Utilities.emptyString(sf.getUrl())) {
    com.oroinc.text.perl.Perl5Util re = new com.oroinc.text.perl.Perl5Util();
    graphic =  "<img border=0 align=top src=/graphics/file-storage/ftv2doc.gif>";
%>

    <table border=1 bgcolor=white  cellpadding=0 cellspacing=0>
    <tr>
    <td><table bgcolor=white cellspacing=1 border=0 cellpadding=2>
        <tr>
        <td colspan=8 bgcolor=#666666><%= font %> &nbsp;<font color=white>
         <%= table_title %>
        </td></tr>
        <tr>
        <td colspan=2 bgcolor=<%= header_color %>><%= font %> &nbsp; Name &nbsp;</td>
        <td bgcolor=<%= header_color %>><%= font %> &nbsp; Author &nbsp;</td>
        <td bgcolor=<%= header_color %> align=right><%= font %> &nbsp; Size &nbsp;</td>
        <td bgcolor=<%= header_color %>><%= font %> &nbsp; Type &nbsp;</td>
        <td bgcolor=<%= header_color %>><%= font %> &nbsp; Modified &nbsp;</td>
        <td bgcolor=<%= header_color %>><%= font %> &nbsp; Version Notes &nbsp;</td>
        <td bgcolor=<%= header_color %>><%= font %> &nbsp; Permissions &nbsp;</td>
        </tr>

<%
    for (int i = 0; i<versionList.length; i++) {
	version_count ++;
	String page_name = sf.getTitle() + ": version " + (sf.getVersionCount() - version_count + 1);

	String client_file_name = versionList[i].getClientFileName();
	if (re.match("/.*\\\\([^\\\\]+)/", client_file_name)) {
	    client_file_name = re.group(1);
	}
	String pretty_file_name = re.substitute("s/[^-_.0-9a-zA-Z]+/_/g", client_file_name);
	Vector permissions_list = new Vector();
	
	if (versionList[i].getReadable()) {
	    permissions_list.addElement("<a href=\"download/" + versionList[i].getVersionId() + "/" + pretty_file_name + "\">read</a>");
%>

<tr>
<td valign=top>&nbsp;<a href="download?version_id=<%= versionList[i].getVersionId() %>"><%= graphic %></a></td>
<td valign=top><%= font %> <a href="download?version_id=<%= versionList[i].getVersionId() %>"><%= client_file_name %></a> &nbsp;</td>

<%
     } else {
%>
	    <tr><td valign=top>&nbsp; <%= font %> <%= graphic %></td>
	    <td valign=top><%= font %><%= client_file_name %> &nbsp;</td>
<%
     }
     if (versionList[i].getWritable()) {
	 AdSet vars = new AdSet();
	 vars.put("return_url", return_url);
	 vars.put("file_id", file_id);
	 permissions_list.addElement("<a href=\"version-upload?" + Utilities.exportURLVars(vars) + "\">write</a>");
     }

     if (versionList[i].getAdminable()) {
	 AdSet vars = new AdSet();
	 vars.put("return_url", return_url);
	 vars.put("object_name", object_name);
	 vars.put("on_which_table", on_which_table);
	 permissions_list.addElement("<a href=\"/gp/administer-permissions?on_what_id=" + latest_version_id + "&" + Utilities.exportURLVars(vars) + "\">administer</a>");
     }
     
     String size_string = versionList[i].getBytes() + " bytes";
     if (versionList[i].getKbytes() > 0) {
	 size_string = versionList[i].getKbytes() + " KB";
     }
     
     String permissions_string = "None";
     if (permissions_list.size() > 0) {
	 permissions_string = Utilities.join(permissions_list, " | ");
     } 
%>

	    <td valign=top><%= font %> <%= versionList[i].getCreatorName() %></td>
	    <td align=right valign=top><%= font %> <%= size_string %></td>
	    <td valign=top align=center><%= font %> <%= versionList[i].getFileType() %></td>
	    <td valign=top><%= font %> <%= versionList[i].getCreationDate() %></td>
	    <td valign=top><%= font %> <%= db.bindObj(versionList[i].getDescription()) %></td>
	    <td valign=top align=center><%= font %> <%= permissions_string %></td>
	    </tr>

<% 
     } // for
%>

</table>

<%

} else {

%>

<a href="<%= sf.getUrl() %>"><%= sf.getUrl() %></A>

<% 

} 

%>

</td></tr></table></blockquote>

</ul>

<!-- [ad_footer [fs_system_owner]] -->

</ad:page>

<!-- Powered by ArsDigita -->
