<% 
/*

/file-storage/one-folder

    summary of one folder

    @author philg@mit.edu 
    @creation-date July 23 1999 
    @cvs-id $Id: one-folder.jsp,v 1.6 2000/10/17 17:12:22 luke Exp $

    modified by randyg@arsdigita.com January, 2000 to use 
    the general permissions system
*/
%>

<%@ include file="/acs.jspi" %>
<%@ page import="com.arsdigita.acs.fs.*" %>

<ad:page>
<ad:get_user_info id="user" />

<%
String return_url = "one-folder?" + request.getQueryString(); 
Integer local_user_id = user.getUserId();
String user_name = null;
Integer version_id = null;
%>

<ad:page_contract id="pc" vars="file_id:integer,optional group_id:integer,optional source:optional owner_id:integer,optional">

<%

user_name = user.getFullName();

if (file_id == null) {
    pc.addComplaint("No folder was specified");
}

version_id = FileStorageProcs.latestVersion(db,file_id);

try {
    if (!FileStorageProcs.checkRead(local_user_id, version_id)) {
	pc.addComplaint("You don't have authority to read this folder");
    }
} catch(ACSException acse) {
    throw new JspException(acse.getMessage());
}

%>

</ad:page_contract>

<ad:db_query id="main"> 
    select fsf1.file_title,
           fsf2.file_title as parent_title,
           fsf1.folder_p,
           fsf1.parent_id,
	   fsf1.public_p,
	   fsf1.owner_id,
	   fsf1.group_id,
	   u.first_names || ' ' || u.last_name as owner_name,
           ad_general_permissions.user_has_row_permission_p ( fsf1.owner_id, 'read', fsvl.version_id, 'FS_VERSIONS' ) as public_read_p
    from   fs_files fsf1,
           fs_files fsf2,
           fs_versions_latest fsvl,
           users u
    where  fsf1.file_id = ?
    and    fsf1.file_id = fsvl.file_id
    and    fsf1.parent_id = fsf2.file_id (+)
    and    fsf1.owner_id = u.user_id
<ad:db_bind><%= file_id %></ad:db_bind>
</ad:db_query>
 
<%
ResultSet rs = db.query(main);
if (!rs.next()) {
    response.sendError(response.SC_INTERNAL_SERVER_ERROR, 
    "Could not find folder " + file_id + "; it may have been deleted.");
    return;
}

if (!"t".equals(rs.getString("folder_p"))) {
    // we got here by mistake, push them out into the right place 
    // (this shouldn't happen!)
    log ("User was sent to /file-storage/one-file to view a FILE (#" + file_id + ")");
    response.sendRedirect("one-file?" + Utilities.exportURLVars(form));
    return;
}

String object_type = "Folder";
String title = rs.getString("file_title");
String parent_title = rs.getString("parent_title");
String owner_name = rs.getString("owner_name");
owner_id = new Integer(rs.getInt("owner_id"));
String file_title = rs.getString("file_title");
String f_group_id = rs.getString("group_id");
String public_p = rs.getString("public_p");
if (Utilities.emptyString(parent_title)) {
    parent_title = "Root (Top Level)";
}

try {
    if (Utilities.emptyString(source)) {
	source = FileStorageProcs.guessSource(db, "t".equals(public_p), owner_id, new Integer(f_group_id), user);
    }
// the navbar is determined by where the just came from
ContextBar navbar = new ContextBar(pageContext);
String tree_name = "";
FolderBox fb = null;

if (source.equals("private_individual")) {
    tree_name = "Your personal document tree";
    navbar.add("", parameters.get("SystemName", "fs"));
    navbar.add("private-one-person", tree_name);
    navbar.add("One Folder");
    fb = new FolderBox(local_user_id, FileStorageProcs.privateIndividualOption(), db);
    public_p = "f";
} else if (source.equals("private_group")) {
    String group_name = db.queryToString("select group_name from user_groups where group_id=?", new Object[] {f_group_id});
    tree_name = group_name + " group document tree";
    navbar.add("",parameters.get("SystemName", "fs"));
    navbar.add("private-one-group?group_id=" + f_group_id, tree_name);
    navbar.add("One Folder");
    fb = new FolderBox(local_user_id, FileStorageProcs.privateGroupOption(new Integer(f_group_id), group_name), db);
    public_p = "t";
} else if (source.equals("public_individual")) {
    tree_name = owner_name + "'s document tree";
    navbar.add("", parameters.get("SystemName", "fs"));
    navbar.add("all-public", "Publically accessible files");
    navbar.add("public-one-person?user_id=" + owner_id, tree_name);
    navbar.add("One Folder");
    fb = new FolderBox(local_user_id, FileStorageProcs.publicIndividualOption(owner_id, owner_name), db);
    public_p = "t";
} else if (source.equals("public_group")) {
    String group_name = db.queryToString("select group_name from user_groups where group_id=?", new Object[] {f_group_id});
    tree_name = group_name + " group public document tree";
    navbar.add("", parameters.get("SystemName", "fs"));
    navbar.add("all-public", "Publically accessible files");
    navbar.add("public-one-group?group_id=" + f_group_id, tree_name);
    navbar.add("One Folder");
    fb = new FolderBox(local_user_id, FileStorageProcs.publicGroupOption(new Integer(f_group_id), group_name), db);
    public_p = "t";
} else {
    tree_name = "Shared " + parameters.get("SystemName", "acs") + " document tree";
    navbar.add("", parameters.get("SystemName","fs"));
    navbar.add("One Folder");
    fb = new FolderBox(local_user_id, FileStorageProcs.sharedOption(), db);
    public_p = "t";
}
%>

<ad:header><%= title %></ad:header>

<h2> <%= title %> </h2>

<%= navbar.getHTML() %>

<hr align=left>

<%
// determine if the user owns the folder - user_id is the owner_id?
Vector action_list = new Vector();

if (FileStorageProcs.checkWrite(user,version_id)) {
    // If she owns it, provide links for folder editing, file upload and
    // creation of subfolders.

    AdSet vars = new AdSet();
    vars.put("return_url", return_url);
    vars.put("public_p", public_p);
    vars.put("this_folder", file_id);

    if (f_group_id != null)  {
	vars.put("group_id", f_group_id);
    }

    String url_vars = Utilities.exportURLVars(vars);
    
    AdSet vars2 = new AdSet();
    if (f_group_id != null)  {
	vars2.put("group_id", f_group_id);
    }
    vars2.put("file_id", file_id);
    vars2.put("return_url", return_url);
        
    action_list.addElement("<a href=file-edit?" + Utilities.exportURLVars(vars2) + ">edit</a>");
    action_list.addElement("<a href=upload-new?" + url_vars + ">Add a URL / Upload a file</a>");
    action_list.addElement("<a href=create-folder?" + url_vars + ">Create New Folder</a>");
}

String actions_option = "";
if (action_list.size() > 0) {
    actions_option = "<p><li>Actions: " + Utilities.join(action_list, " | ");
} 

%>

<ul>
<li> <%= object_type %> Title: <%= file_title %>
<li> Owner: <%= owner_name %>
<li> Located in: <%= tree_name %> / <%= parent_title %>

<%= actions_option %>

<% 
// unfortunately we can't use bind vars here because this is used as an 
// on the fly view 
%>

<ad:db_query id="tree_walk">
select file_id,	
       file_title,
       sort_key,
       depth,   
       folder_p,
       owner_id,
       group_id,
       public_p,
       parent_id,
       level as the_level
from   fs_files
where  deleted_p = 'f'
connect by parent_id = prior file_id start with file_id = <%= file_id %>
</ad:db_query>

<%
// get the files from the database and parse 
// the output to reflect the folder stucture
// Only show files the user has permission to read
%>

<ad:db_query id="sorted_query">
    select desired.file_id,
           file_title,
           folder_p,
           depth * 24 as n_pixels_in,
           round (fsvl.n_bytes / 1024) as n_kbytes,
           n_bytes,
           to_char (fsvl.creation_date, '<%= FileStorageProcs.datePicture() %>') as creation_date,
           nvl (fsvl.file_type, upper (fsvl.file_extension) || ' File') as file_type,
           sort_key,
           fsvl.version_id,
           fsvl.client_file_name,
           fsvl.url
    from   fs_versions_latest fsvl,
	   (<%= tree_walk.getSql() %>) desired
    where  fsvl.file_id = desired.file_id
    and    (ad_general_permissions.user_has_row_permission_p (?, 'read', fsvl.version_id, 'FS_VERSIONS') = 't' or owner_id = ? or folder_p = 't')
    order by sort_key
<ad:db_bind><%= local_user_id %></ad:db_bind>
<ad:db_bind><%= local_user_id %></ad:db_bind>
</ad:db_query>

<%
String file_html = "";
int file_count = 0;
String font = "<nobr><font face=arial,helvetica size=-1>";
String header_color = parameters.get("HeaderColor","fs");
%>

<li><%= fb %></li>

<blockquote>
<table border=1 bgcolor=white  cellpadding=0 cellspacing=0>
 <tr>
 <td><table bgcolor=white cellspacing=1 border=0 cellpadding=0>
     <%= FileStorageProcs.headerRowForFiles("Files in " + file_title, false) %>

<ad:db_foreach row="row" in="sorted_query">
    <%
    // We ignore the first element's indentation and shift all rows left by
    //that many pixels.
    int initial_pixels = 0;
    if (file_count == 0) {
	initial_pixels = row.getInt("n_pixels_in");
    }
    AdSet set = new AdSet();
    set.put("file_id", row.getString("file_id"));
    set.put("group_id", f_group_id);
    set.put("owner_id", owner_id);
    set.put("source", source);
    String exports = Utilities.exportURLVars(set);
    file_count++;
    %>
    <%= FileStorageProcs.rowForOneFile(row, exports) %>
</ad:db_foreach>

<ad:if_no_rows>
    <tr>
    <td>You don't have any files stored in this folder. </td>
    </tr>
</ad:if_no_rows>

</table></td></tr></table></blockquote>

</ul>

<%
} catch(ACSException acse) {
    throw new JspException(acse.getMessage());
}
%>

<!-- [ad_footer [fs_system_owner]] -->
</ad:page>
