<%--
# /file-storage/private-one-group.tcl

    This file shows the private group tree.
 
    @author randyg@arsdigita.com
    @creation-date January, 2000
    @cvs-id $Id: private-one-group.jsp,v 1.1 2000/10/27 16:42:38 bschneid Exp $
--%>

<%@ include file="/acs.jspi" %>

<ad:page>
<ad:page_contract vars="group_id:integer"/>
<ad:get_user_info id="user"/>

<%
String return_url = "private-one-group?" + request.getQueryString();

if (!user.isGroupMember(group_id)) {
    throw new ForbiddenException("Unauthorized", "You're not a member of this group");
}

String group_name = UserGroups.getGroupName(db, group_id);
String title = group_name + "'s group document tree";
request.setAttribute("title", title);
ContextBar navbar = new ContextBar(ContextBar.PERSONAL, user);
request.setAttribute("navbar", navbar);
navbar.add("", parameters.get("SystemName","fs"));
navbar.add("One Group");

// get the group's files from the database and parse the output 
// to reflect the folder stucture

%>

<ad:db_query id="sorted_query">
    select fsf.file_id,
           fsf.file_title,
           fsf.folder_p,
           fsf.depth * 24 as n_pixels_in,
           round ( fsvl.n_bytes / 1024 ) as n_kbytes,
           n_bytes,
           to_char ( fsvl.creation_date, '<%= FileStorageProcs.datePicture() %>' ) as creation_date,
	   nvl ( fsvl.file_type, upper ( fsvl.file_extension ) || ' File' ) as file_type,
           fsf.owner_id,
           u.first_names || ' ' || u.last_name as owner_name,
           fsf.sort_key,
           fsvl.version_id,
           fsvl.client_file_name, 
           fsvl.url
    from   fs_files fsf,
           fs_versions_latest fsvl,
           users u
    where  fsf.file_id = fsvl.file_id
    and    fsf.owner_id = u.user_id
    and    deleted_p = 'f'
    and    fsf.group_id = :group_id
    and    (ad_general_permissions.user_has_row_permission_p (:user_id, 'read', fsvl.version_id, 'FS_VERSIONS') = 't' or fsf.owner_id = :user_id)
    order by fsf.sort_key
<% 
sorted_query.bind("user_id", user.getUserId());
sorted_query.bind("group_id", group_id);
%>
</ad:db_query>

<%
request.setAttribute("fb", new FolderBox(user.getUserId(), FileStorageProcs.privateGroupOption(group_id,group_name), db));
request.setAttribute("sorted_query", sorted_query);
request.setAttribute("return_url", return_url);
%>

<ad:use_template/>
</ad:page>



