<%--
    /*
# /file-storage/private-one-person.tcl

    this file displays all files in the user's personal folder
 
    @author aure@arsdigita.com
    @creation-date July, 1999
    @cvs-id $Id: private-one-person.jsp,v 1.2 2000/10/27 19:05:37 jbank Exp $
    */
--%>

<%@ include file="/acs.jspi" %>

<ad:page>
<ad:page_contract vars="user_id:optional"/>
<ad:get_user_info id="user"/>

<%
if (user_id != null) {
    response.sendRedirect("public-one-person?"  + request.getQueryString());
}

String return_url = "private-one-person";

String public_p = "f";
String title = user.getFullName() + "'s document tree";
request.setAttribute("title", title);
ContextBar navbar = new ContextBar(ContextBar.PERSONAL, user);
request.setAttribute("navbar", navbar);
navbar.add("", parameters.get("SystemName","fs"));
navbar.add("Personal document tree");

// get the group's files from the database and parse the output 
// to reflect the folder stucture

%>

<ad:db_query id="sorted_query">
    select fsf.file_id,
           fsf.file_title,
           fsf.folder_p,
           fsf.depth * 24 as n_pixels_in,
           round ( fsvl.n_bytes / 1024 ) as n_kbytes,
           n_bytes,
           to_char ( fsvl.creation_date, '<%= FileStorageProcs.datePicture() %>' ) as creation_date,
	   nvl ( fsvl.file_type, upper ( fsvl.file_extension ) || ' File' ) as file_type,
           fsf.owner_id,
           fsf.sort_key,
           fsvl.version_id,
           fsvl.client_file_name, 
           fsvl.url
    from   fs_files fsf,
           fs_versions_latest fsvl
    where  fsf.file_id = fsvl.file_id
    and    deleted_p = 'f'
    and    fsf.owner_id = :user_id
    and    fsf.group_id is null
    and    (fsf.public_p = 'f' or fsf.public_p is null)
    order by fsf.sort_key
<% 
sorted_query.bind("user_id", user.getUserId());
%>
</ad:db_query>

<%
request.setAttribute("fb", new FolderBox(user.getUserId(), FileStorageProcs.privateIndividualOption(), db));
request.setAttribute("sorted_query", sorted_query);
request.setAttribute("return_url", return_url);
request.setAttribute("public_p", public_p);
%>

<ad:use_template/>
</ad:page>



