<%--
# /file-storage/public-one-group.jsp
    show the public files owned by a group

    @author philg@mit.edu
    @creation-date July 24, 1999
    @cvs-id $Id: public-one-group.jsp,v 1.2 2000/10/27 16:42:39 bschneid Exp $
--%>

<%@ include file="/acs.jspi" %>
<ad:page>
<ad:page_contract vars="group_id:integer" />

<ad:get_user_info id="user"/>

<%
String return_url = "public-one-group?" + request.getQueryString();

String group_name = UserGroups.getGroupName(db, group_id);

String title = group_name + "'s public group document tree";

ContextBar contextBar = new ContextBar(ContextBar.PERSONAL, user);
contextBar.add("", parameters.get("SystemName", "fs"));
contextBar.add("all-public", "Publically accessible files");
contextBar.add("One Group");

request.setAttribute("title", title);
request.setAttribute("contextBar", contextBar);

%>

<%--
# get the user's files from the database and parse the 
# output to reflect the folder stucture

# walk the tree from all nodes with permissions up to the root.
# we do this walk so that we can show all of the folders leading
# up to the files that the user has permission to see
--%>

<ad:string id="backwards_tree_walk">
select file_id,	
       file_title,
       sort_key,
       depth,   
       folder_p,
       owner_id,
       deleted_p,
       group_id,
       public_p,
       parent_id,
       level as the_level
from   fs_files
connect by fs_files.file_id = prior parent_id
start with fs_files.file_id in (
    select distinct fs_files.file_id 
    from   fs_files, 
           fs_versions_latest ver
    where  fs_files.public_p = 't'
    and    fs_files.group_id = :group_id
    and    folder_p = 'f'
    and    fs_files.deleted_p='f'            
    and    fs_files.file_id=ver.file_id
    and    ad_general_permissions.user_has_row_permission_p (:local_user_id, 'read', ver.version_id, 'FS_VERSIONS') = 't')
</ad:string>

<ad:db_query id="sorted_query">
    select distinct desired_files.file_id, 
           desired_files.sort_key,
           file_title, 
           folder_p, 
           depth * 24 as n_pixels_in, 
           to_char(fsvl.creation_date,'<%= FileStorageProcs.datePicture() %>') as creation_date,
           round(n_bytes/1024) as n_kbytes,
           n_bytes,
           nvl(file_type,upper(file_extension)||' File') as file_type,
	   desired_files.owner_id,
           first_names||' '||last_name as owner_name,
           fsvl.client_file_name,
           fsvl.url,
           fsvl.version_id
    from   (<%= backwards_tree_walk %>) desired_files, 
           fs_versions_latest fsvl,
           users
    where  fsvl.file_id = desired_files.file_id
    and    desired_files.owner_id = users.user_id
    order by desired_files.sort_key
<% 
sorted_query.bind("group_id", group_id);
sorted_query.bind("local_user_id", user.getUserId());
%>
</ad:db_query>

<%
request.setAttribute("sorted_query", sorted_query);
request.setAttribute("fb", 
   new FolderBox(user.getUserId(), FileStorageProcs.publicGroupOption(group_id, group_name), db));
%>
<ad:use_template/>

</ad:page>
