<%--
# /file-storage/public-one-person.jsp
    list the public files of one user

    @author philg@mit.edu
    @creation-date July 24, 1999
    @cvs-id $Id: public-one-person.jsp,v 1.1 2000/10/27 19:05:37 jbank Exp $
--%>

<%@ include file="/acs.jspi" %>
<ad:page>
<ad:page_contract vars="user_id:integer" />

<ad:get_user_info id="user"/>

<%
String return_url = "public-one-person?" + request.getQueryString();

UserInfo owner_user = new UserInfo(user_id.intValue());

String title = owner_user.getFullName() + "'s public document tree";

ContextBar contextBar = new ContextBar(ContextBar.PERSONAL, user);
contextBar.add("", parameters.get("SystemName", "fs"));
contextBar.add("all-public", "Publically accessible files");
contextBar.add("One Person's");

request.setAttribute("title", title);
request.setAttribute("contextBar", contextBar);

%>

<%--
    /*# get the user's files from the database and parse the 
# output to reflect the folder stucture

# walk the tree from all nodes with permissions up to the root.
# we do this walk so that we can show all of the folders leading
# up to the files that the user has permission to see
    */
--%>

<ad:string id="backwards_tree_walk">
select file_id,	
       file_title,
       sort_key,
       depth,   
       folder_p,
       owner_id,
       deleted_p,
       group_id,
       public_p,
       parent_id,
       level as the_level
from   fs_files
connect by fs_files.file_id = prior parent_id
start with fs_files.file_id in (
    select distinct fs_files.file_id 
    from   fs_files, 
           fs_versions_latest ver
    where  owner_id = :user_id
    and    folder_p = 'f'
    and    fs_files.file_id=ver.file_id
    and    fs_files.group_id is null
    and    (fs_files.public_p = 't' or
            ad_general_permissions.user_has_row_permission_p (:local_user_id, 'read', ver.version_id, 'FS_VERSIONS') = 't')
    and    fs_files.deleted_p='f')
</ad:string>

<ad:db_query id="sorted_query">
select   distinct desired_files.file_id, 
         desired_files.sort_key,
         file_title, 
         folder_p, 
         depth * 24 as n_pixels_in, 
         to_char(fs_versions_latest.creation_date,'<%= FileStorageProcs.datePicture() %>') as creation_date,
         round(n_bytes/1024) as n_kbytes,
         n_bytes, 
         nvl(file_type,upper(file_extension)||' File') as file_type,
         client_file_name,
         url,
         version_id
from     (<%= backwards_tree_walk %>) desired_files, 
         fs_versions_latest
where    fs_versions_latest.file_id = desired_files.file_id
order by desired_files.sort_key, desired_files.file_title
<% 
sorted_query.bind("user_id", user_id);
sorted_query.bind("local_user_id", user.getUserId());
%>
</ad:db_query>

<%
request.setAttribute("sorted_query", sorted_query);
request.setAttribute("owner_id", user_id);
request.setAttribute("fb", 
   new FolderBox(user.getUserId(), FileStorageProcs.publicIndividualOption(user_id, owner_user.getFullName()), db));
%>
<ad:use_template/>

</ad:page>
