<%
/*
/file-storage/search.jsp
    looks through file names, version descriptions, client file names
    case-insensitive but stupid
 
    @author aure@arsdigita.com
    @creation-date July 1999
    @cvs-id $Id: search.jsp,v 1.3 2000/10/17 17:12:22 luke Exp $

    modified by randyg@arsdigita.com to use the general permissions system
*/
%>

<%@ include file="/acs.jspi" %>
<%@ page import="com.arsdigita.acs.fs.*" %>

<ad:page>

<ad:get_user_info id="user" />

<ad:page_contract id="pc" vars="search_text:optional return_url:optional group_id:integer,optional" />

<% 
Integer userId = user.getUserId();
if (search_text == null) {
    search_text = "";
}
String title = "Search for " + search_text;
ContextBar navbar = new ContextBar(pageContext);
navbar.add(return_url, parameters.get("SystemName", "fs"));
navbar.add(title);
%>

<ad:header><%= title %></ad:header>
<h2><%= title %></h2>

<%= navbar %>
<hr align=left>
<blockquote>

<% 

// Parameterize for interMedia
String score_column = null;
String intermedia_clause = null;
String order_clause = null;
String search_explanation = null;

if (parameters.getBoolean("UseIntermediaP","fs",false)) {
    score_column = "score(1) as the_score,";
    intermedia_clause = " or contains(fsvl.version_content, ?, 1) > 0";
    order_clause = "order by decode(owner_id, ?, 0, 1), 1 desc";
    search_explanation = "We do a case-insensitive phrase search through " +
    "file titles, client filenames (what these files were called on the " +
    "original system), and any version descriptions or comments.\n\n" + 
    "<p>\nIn addition, we do a full-text search through the bodies of all " +
    "uploaded documents.\n\n<p>\n"; // [ad_intermedia_text_searching_hints]
} else {
    score_column = "";
    intermedia_clause = "";
    order_clause = "order by decode(fsf.owner_id, ?, 0, 1), fsf.file_title";
    // user_id
    search_explanation = "We do a case-insensitive phrase search through " +
    "file titles, client filenames (what these files were called on the " +
    "original system), and any version descriptions or comments.";
}

// this select gets readable files that match user's request 
// (one's belonging to the user first)

// the ways a user can see a file
//
// 1. the user is the owner (f.owner_id = $user_id)
// 2. the public is allowed to read the file (public_read_p = 't')
// 3. there is a permissions record to allow someone to read (pum.read_p = 't')
//    4. and that somone is the user (map.user_id = $user_id)
//    5. and that somone if a group that the user belongs to

String search_pattern = "%" + search_text + "%";

%>

<ad:db_query id="search">
select fsf.file_title, <%= score_column %> 
       fsf.file_id, 
       round(fsvl.n_bytes/1024) as n_kbytes, 
       nvl ( fsvl.file_type, upper ( fsvl.file_extension ) || ' File' ) as file_type,
       to_char(fsvl.creation_date,'<%= FileStorageProcs.datePicture() %>') as creation_date,
       fsf.owner_id,
       u.first_names || ' ' || u.last_name as owner_name,
       fsf.folder_p,
       decode(fsf.owner_id,?,0,1) as belongs_to_someone_else_p, 
       fsvl.url,
       fsvl.version_id,
       fsvl.client_file_name
from   fs_files fsf,
       fs_versions_latest fsvl,
       users u
where  fsf.file_id = fsvl.file_id
and    fsf.owner_id = u.user_id
and    ad_general_permissions.user_has_row_permission_p (?, 'read', fsvl.version_id, 'FS_VERSIONS') = 't'
and fsf.deleted_p='f'
and (upper(fsvl.version_description) like upper(?)
     or upper(fsf.file_title) like upper(?)
     or upper(fsvl.client_file_name) like upper(?))
     <%= intermedia_clause%>
<%= order_clause %>

<ad:db_bind><%= userId %></ad:db_bind>
<ad:db_bind><%= userId %></ad:db_bind>
<ad:db_bind><%= search_pattern %></ad:db_bind>
<ad:db_bind><%= search_pattern %></ad:db_bind>
<ad:db_bind><%= search_pattern %></ad:db_bind>
<% if (intermedia_clause.length() > 0) { %>
  <ad:db_bind><%= search_text %></ad:db_bind>
<% } %>
<ad:db_bind><%= userId %></ad:db_bind>
</ad:db_query>

<%
int file_count = 0;
String file_html = "";
String font = "<nobr>" + parameters.get("FileInfoDisplayFontTag","fs");
String header_color = parameters.get("HeaderColor","fs");
// we start with an outer table to get little white lines in 
// between the elements 

boolean wrotePersonalHeader = false;
boolean wroteOtherHeader = false;

%>

<table border=1 bgcolor=white  cellpadding=0 cellspacing=0>
<tr>
  <td>
  <table bgcolor=white cellspacing=1 border=0 cellpadding=0>

<ad:db_foreach row="rs" in="search">
<%
    boolean belongsToSomeoneElse = rs.getBoolean("belongs_to_someone_else_p");
    if (!belongsToSomeoneElse && !wrotePersonalHeader) {
	wrotePersonalHeader = true;
%>
	<%= FileStorageProcs.headerRowForFiles("Personal files matching \"" + search_text + "\"", true) %>
<%
    }
    if (belongsToSomeoneElse && !wroteOtherHeader) {
	wroteOtherHeader = true;
%>
        <%= FileStorageProcs.headerRowForFiles("Other readable files matching \"" + search_text + "\"", true) %>
<%
    }
    Integer file_id = new Integer(rs.getInt("file_id"));
    AdSet set = new AdSet();
    set.put("file_id", file_id);
    set.put("group_id", group_id);
    String exports = Utilities.exportURLVars(set);
    file_count++;
%>

<%= FileStorageProcs.rowForOneFile (rs, exports) %>
</ad:db_foreach>
<db:if_no_rows>
   <tr><td>No files matched your search. </td></tr>
</db:if_no_rows>

</table></td></tr></table></blockquote>

<p>

<blockquote>
<%= search_explanation %>
</blockquote>

<!-- [ad_footer [fs_system_owner]] -->

