<% /* /file-storage/upload-new.tcl 
   Serve the user a form to upload a new file or URL

    @author aure@arsdigita.com
    @creation-date July 1999
    @cvs_id $Id: upload-new.jsp,v 1.6 2000/10/17 17:12:22 luke Exp $

    modified by randyg@arsdigita.com, January 2000 to use the general permisisons system
*/ %>

<%@ include file="/acs.jspi" %>
<%@ page import="com.arsdigita.acs.fs.*" %>

<ad:page>

<%
ContextBar navbar = new ContextBar(pageContext);
String title = "Upload New File/URL";
%>

<ad:get_user_info id="user" />
<% Integer user_id = user.getUserId(); %>

<ad:page_contract id="pc" vars="return_url group_id:optional,integer this_folder:optional,integer public_p:optional">
<%
if (public_p == null) {
	public_p = "f";
}
// Determine if we are uploading to a Group, the public area, or personal area

// if public_p = 't', we are uploading to the public area
// if  a group_id was sent - then we are uploading to a group defined
//           by group_id
// otherwise, to our personal area

if (public_p.equals("t") && !Parameters.getBoolean("PublicDocumentTreeP", "fs")) {
    pc.addComplaint(Parameters.get("SystemName","acs") + " does not support a public directory tree.");
}

if (group_id != null) {
    try {
	String group_name = db.queryToString("select group_name from user_groups where group_id = ?", new Object[] {group_id});

	// we are in the group tree
	
	if (!user.isGroupMember(group_id)) {
	    pc.addComplaint("You are not a member of group <cite>" + group_name + "</cite>");
	} else {
	    navbar.add("", parameters.get("SystemName","fs"));
	    navbar.add(return_url, group_name + " document tree");
	    navbar.add(title);
	}
    }
    catch (com.arsdigita.acs.ACSException acse) {
	pc.addComplaint("Caught an ACSException: " + acse.getMessage());
    }
    
    public_p = "f";

} else if (public_p.equals("t")) {
 
    // we are in the public tree

    navbar.add("", parameters.get("SystemName","fs"));
    navbar.add(title);
    group_id = null;

} else  {

    // we are in the personal tree
    navbar.add("", parameters.get("SystemName","fs"));
    navbar.add("private-one-person", "Personal document tree");
    navbar.add(title);

    group_id = null;
    public_p = "f";
}
%>
</ad:page_contract>

<% 

// get the next sequence values for double click protection

String file_id = null;
String version_id = null;

try {
    file_id = db.queryToString("select fs_file_id_seq.nextval from dual");
    version_id = db.queryToString("select fs_version_id_seq.nextval from dual");
} 
catch (ACSException acse) {
    out.println("Oops: " + acse.getMessage());
}

%>

<ad:header><%= title %></ad:header>

<h2><%= title %></h2>

<%= navbar.getHTML() %>

<hr align=left>

<form enctype=multipart/form-data method=POST action=upload-new-2>

<% AdSet varsToExport = new AdSet();
 varsToExport.put("file_id", file_id);
 varsToExport.put("version_id", version_id);
 varsToExport.put("return_url", return_url);
 varsToExport.put("group_id", group_id);
 varsToExport.put("public_p", public_p);
%>

<%= Utilities.exportFormVars(varsToExport) %>

<table border=0>
<tr>
<td align=right>URL: </td>
<td><input type=input name=url size=40></td>
</tr>

<tr>
<td align=right><EM>or</EM> filename: </td>
<td><input type=file name=upload_file size=20></td>
</tr>

<tr>
<td>&nbsp;</td>
<td><font size=-1>Use the "Browse..." button to locate your file, 
    then click "Open". </font></td>
</tr>

<tr>
<td>&nbsp;</td>
<td>&nbsp;</td>
</tr>

<tr>
<td align=right> Title: </td>
<td><input size=30 name=file_title></td>
</tr>

<tr>
<td valign=top align=right> Description: </td>
<td colspan=2><textarea rows=5 cols=50 name=version_description wrap></textarea></td>
</tr>

<tr>
<td align=right>Location:</td>
<td><%= FileStorageProcs.fsFolderDefSelection(db,user_id,group_id,"t".equals(public_p),null,this_folder) %></td>
</tr>

<tr>
<td></td>
<td><input type=submit value="Submit and Upload">
</td>
</tr>

</table>

</form>

<!-- [ad_footer [fs_system_owner]] -->



