<%@ include file="/acs.jspi" %>
<%@ page import="com.arsdigita.acs.fs.*" %>

<ad:page>

<ad:page_contract id="pc" vars="file_id:integer,optional return_url:optional group_id:integer,optional owner_id:integer,optional source:optional" >

<ad:get_user_info id="user" /> 

<%
Integer user_id = user.getUserId();

// Determine if we are working in a Group, or our personal space
// this is based if no group_id was sent - then we are in
// our personal area - otherwise the group defined by group_id

if (file_id == null) {
    pc.addComplaint("No file was specified");
}

try {
    Integer version_id = new Integer(db.queryToString("select version_id from fs_versions_latest where file_id = ?", new Object[] {file_id}));
    
    if (!FileStorageProcs.checkWrite(user, version_id)) {
	pc.addComplaint("You do not own this file");
    }

    db.dml("update fs_files set deleted_p = 't' where file_id = ?", new Object[] {file_id});

    AdSet set = new AdSet();
    if ("private_individual".equals(source)) {
	set.put("owner_id", owner_id);
	return_url = "private-one-person?" + Utilities.exportURLVars(set);
    } else if ("private_group".equals(source)) {
	set.put("group_id", group_id);
	return_url = "private-one-group?" + Utilities.exportURLVars(set);
    } else if  ("public_individual".equals(source)) {
	set.put("owner_id", owner_id);
	return_url = "public-one-person?" + Utilities.exportURLVars(set);
    } else if ("public_group".equals(source)) {
	set.put("group_id", group_id);
	return_url = "public-one-group?" + Utilities.exportURLVars(set);
    } else if (Utilities.emptyString(return_url)) {
	// the original redirected to empty string--with no form variables
	return_url = "index";
    }

    response.sendRedirect(return_url);
}
catch(ACSException acse) {
    throw new JspException(acse.getMessage());
}

%>

</ad:page_contract>

</ad:page>
