<%
/*
    /file-storage/version-upload-2

    @author aure@arsdigita.com
    @creation-date July, 1999
    @cvs-id $Id: version-upload-2.jsp,v 1.5 2000/10/18 15:35:23 luke Exp $

    extended in January 2000 by randyg@arsdigita.com
    to accomodate general permission system
*/
%>

<%@ include file="/acs.jspi" %>
<%@ page import="com.arsdigita.acs.fs.*" %>

<ad:page>

<ad:get_user_info id="user"/>

<%
Integer local_user_id = user.getUserId();
Integer old_version_id = null;
Integer old_author_id = null;
%>

<ad:page_contract id="pc" vars="file_id:integer,optional group_id:integer,optional return_url:optional upload_file:file,optional version_id:integer,optional version_description:optional">

<%
// check the user input first

if (file_id == null) {
    pc.addComplaint("No file was specified");
}

%>

<ad:db_query id="versions">
    select version_id as old_version_id, author_id as old_author_id
    from fs_versions_latest
    where file_id = ?
<ad:db_bind><%= file_id %></ad:db_bind>
</ad:db_query>

<% 
ResultSet rs = db.query(versions);
rs.next();
old_version_id = new Integer(rs.getInt("old_version_id"));
old_author_id = new Integer(rs.getInt("old_author_id"));

try {
    if (!FileStorageProcs.checkWrite(user, old_version_id)) {
	pc.addComplaint("You can't write into this file");
    }
} catch (ACSException e) {
    throw new JspException (e.getMessage());
}

if (Utilities.emptyString(upload_file)) {
    pc.addComplaint("You need to upload a file\n");
}

// return errors
%>

</ad:page_contract>

<%

String client_filename = null;
String guessed_file_type = null;
String file_extension = null;
java.io.File tmp_file = null;
long n_bytes = 0;

// get the file from the user.
// number_of_bytes is the upper-limit
// on the size of the file we will read. 1024*1024*2= 2097142
int max_n_bytes = parameters.getInt("MaxNumberOfBytes", "fs", -1);
tmp_file = new java.io.File(upload_file_tmpfile);

if (max_n_bytes != -1 && (tmp_file.length() > max_n_bytes)) {
    out.println("Your file is larger than the maximum permissible upload size:  " + max_n_bytes + "bytes");
    return;
}

file_extension = upload_file.substring(upload_file.lastIndexOf('.')+1);

// Guess a mime type for this file. If it turns out to be null (the
// default for anything getMimeType doesn't understand), retain the old
// file type on the assumption that the user has edited the type.

guessed_file_type = getServletContext().getMimeType(upload_file_tmpfile);

try {
    if (guessed_file_type == null) {
	guessed_file_type = db.queryToString("select file_type from fs_versions_latest where file_id = ?", new Object[] {file_id});
    }
}
catch (ACSException e) {
    throw new JspException (e.getMessage());
}

n_bytes = tmp_file.length();

// strip off the C:\directories... crud and just get the file name
com.oroinc.text.perl.Perl5Util re =  new com.oroinc.text.perl.Perl5Util();
    
if (re.match("@([^//\\\\]+)$@", upload_file)) {
    client_filename = re.group(1);
} else {
    client_filename = upload_file;
}

%>

<ad:db_query id="version_insert">
begin
    insert into fs_versions
    (version_id, file_id, version_description, creation_date, author_id, 
     client_file_name, file_type, file_extension, n_bytes, version_content)
    values
    (?, ?, ?, sysdate, ?, ?, ?, ?, ?, empty_blob())
    returning version_content into ?;
end;
<ad:db_bind><%= version_id %></ad:db_bind>
<ad:db_bind><%= file_id %></ad:db_bind>
<ad:db_bind><%= db.bindObj(version_description) %></ad:db_bind>
<ad:db_bind><%= local_user_id %></ad:db_bind>
<ad:db_bind><%= client_filename %></ad:db_bind>
<ad:db_bind><%= db.bindObj(guessed_file_type) %></ad:db_bind>
<ad:db_bind><%= db.bindObj(file_extension) %></ad:db_bind>
<ad:db_bind><%= n_bytes %></ad:db_bind>
</ad:db_query>

<ad:db_transaction>
<%
try {
    db.blobDmlFile(version_insert, tmp_file);
} catch (SQLException sqle) {
    // insert failed; let's see if it was because of duplicate submission

    Integer count = new Integer(0);
    try {
	count = new Integer(db.queryToString("select count(*) from fs_versions where version_id = ?", new Object[] {version_id}));
    } catch (ACSException e) {
	throw new JspException (e.getMessage());
    }
    if (count.intValue() == 0) {
	// no duplicates, so it was an error
	log("/file-storage/create-folder-2.tcl choked:  " + sqle.getMessage());
	response.sendError(response.SC_INTERNAL_SERVER_ERROR, 
	"The Database did not like what you typed.  This is probably " +
	"a bug in our code.  Here's what the database said: " +
	"<blockquote><pre>" + sqle.getMessage() + "</pre></blockquote>");
	return;
    }

    // we don't bother to handle the cases where there is a dupe 
    // submission because the user should be thanked or 
    // redirected anyway
    
    if (return_url == null)  {
	return_url = "index";
    }
    response.sendRedirect(return_url);
    return;
}

db.dml("update fs_versions set superseded_by_id = ? where file_id = ? and version_id <> ?", new Object[] {version_id, file_id, version_id});

// now that the version has been inserted, lets set up the permissions

// we don't need double-click protection here since we already did 
// that for previous statement

// Copy the previous version's permissions, except for rows regarding
// the current user and the previous version's owner.

db.plsql("begin ad_general_permissions.copy_permissions (?, ?, 'FS_VERSIONS', ?, ?); end;", 
new Object[] {old_version_id, version_id, local_user_id, old_author_id});

GeneralPermissions.grantPermission(db, "user", local_user_id, null, null, 
 "read", version_id, "FS_VERSIONS");
GeneralPermissions.grantPermission(db, "user", local_user_id, null, null, 
 "write", version_id, "FS_VERSIONS");
GeneralPermissions.grantPermission(db, "user", local_user_id, null, null, 
 "comment", version_id, "FS_VERSIONS");
GeneralPermissions.grantPermission(db, "user", local_user_id, null, null, 
 "administer", version_id, "FS_VERSIONS");
%>

</ad:db_transaction>

<%

String object_name = null;
try {
    object_name = db.queryToString("select file_title from fs_files where file_id = ?", new Object[] {file_id});
}
catch (ACSException e) {
    throw new JspException (e.getMessage());
}

Integer on_what_id = version_id;
String on_which_table = "FS_VERSIONS";

AdSet set = new AdSet();
set.put("return_url", return_url);
set.put("object_name", object_name);
set.put("on_what_id", on_what_id);
set.put("on_which_table", on_which_table);

return_url = "/gp/administer-permissions?" + Utilities.exportURLVars(set);
response.sendRedirect(return_url);

%>

</ad:page>