<%--
  /general-comments/admin/delete-2.jsp

  @author philg@mit.edu
  @author tarik@mit.edu
  @author rory@arsdigita.com (Java port)
  @creation-date 01/06/1999
  @cvs-id $Id: delete-2.jsp,v 1.2 2000/10/17 17:12:24 luke Exp $ 
  @param comment_id The comment to delete
  @param return_url The page to return to after the transaction
  @param submit Whether or not to proceed with the transaction ('proceed','cancel')

--%>

<%@ include file="/acs.jspi" %>
<%@ page import="com.arsdigita.acs.generalcomments.*" %>

<ad:page>
<ad:page_contract id="pc" vars="comment_id:integer return_url:optional submit"/>

<%

if ( Utilities.emptyString(return_url) )
    return_url = "index";

if ( parameters.getBoolean("ReadOnlyP","",false) )
    throw new ReadOnlyException();

//set user_id [general_comments_admin_authorize $comment_id]

if (submit.toLowerCase().equals("cancel")) {
    pageContext.forward(return_url);
    return;
}

String ip_addr = request.getRemoteAddr();

try { 
    // <%-- insert into the audit table --%>
%>
<ad:db_transaction>

  <ad:db_query id="comment_insert">
    insert into general_comments_audit
      (comment_id, user_id, ip_address, audit_entry_time, modified_date, content)
      select comment_id, user_id, :ip_addr, sysdate, modified_date, content 
        from general_comments 
       where comment_id = :comment_id
      <ad:db_bind><%= ip_addr %></ad:db_bind>
      <ad:db_bind><%= comment_id %></ad:db_bind>
  </ad:db_query>
<%
      db.dml(comment_insert);
%>
  <ad:db_query id="comment_delete">
    delete from general_comments where
     comment_id = :comment_id
    <ad:db_bind><%= comment_id %></ad:db_bind>
  </ad:db_query>
<%
    db.dml(comment_delete);
%>
   </ad:db_transaction>
<%
} catch (SQLException e) {
    // there was some other error with the comment update
    String msg = "We couldn't update your comment. Here is what the database returned:\n";
    msg += "<p><blockquote><pre>\n";
    msg += e.getMessage() + "\n</pre>\n</blockquote>\n";
    throw new SQLException(msg);
}

pageContext.forward(return_url);

%>


