<%--
  /general-comments/admin/index.jsp

  @author philg@mit.edu
  @author tarik@mit.edu
  @author rory@arsdigita.com (Java port)
  @creation-date 01/06/1999
  @cvs-id $Id: index.jsp,v 1.6 2000/10/17 17:12:24 luke Exp $ 

--%>

<%@ include file="/acs.jspi" %>
<%@ page import="com.arsdigita.acs.generalcomments.*" %>

<ad:page>
<ad:page_contract id="pc" vars="time_dimension_value:optional section_dimension_value:optional approval_dimension_value:optional">

<%

if ( Utilities.emptyString(time_dimension_value) )
    time_dimension_value = "30";
if ( Utilities.emptyString(section_dimension_value) )
    section_dimension_value = "all";
if ( Utilities.emptyString(approval_dimension_value) )
    approval_dimension_value = "all";

// the idea here is to present the newer comments, separated by 
// section, with dimensional controls up top to control
// how much is displayed within each section, we sort by date descending

// return_url to be passed to various helper pages so that we return to
// this page with the proper parameters
AdSet as = new AdSet();
as.put("time_dimension_value",time_dimension_value);
as.put("section_dimension_value",section_dimension_value);
as.put("approval_dimension_value",approval_dimension_value);
String return_url = "index.jsp?" + Utilities.exportURLVars(as);

// the dimensions:
//  time (limit to 1 7 30 days or "all")
//  section ("all" or limit to one section), presented as a select box
//  approval ("all" or "unapproved only") 

Vector time_widget_items = new Vector();

String[] n_days_possible = {"1", "7", "30", "all"};
for (int i = 0; i < n_days_possible.length ; i ++) {
    if ( n_days_possible[i].equals(time_dimension_value) ) {
	// current choice, just the item
	time_widget_items.add(n_days_possible[i]);
    } else {
	as.deleteKey("time_dimension_value");
	String twi = "<a href=\"index?time_dimension_value=" + n_days_possible[i] + "&" + Utilities.exportURLVars(as) + "\">" + n_days_possible[i] + "</a>";
	time_widget_items.add(twi);
    }
}

String time_widget = Utilities.join(time_widget_items," ");

String individual_section_options = "";
%>
    <ad:db_query id="option_get">
	select section_name, table_name 
	  from table_acs_properties
	 order by upper(section_name)
    </ad:db_query>
    <ad:db_foreach in="option_get" row="rs">
<% {
    Selection s = new Selection(rs);
    String item = s.get("section_name");
    String value = s.get("table_name");
    if ( value.equals(section_dimension_value) ) {
	individual_section_options += "<option SELECTED value=\"" + value + "\">" + item + "\n";
    } else {
	individual_section_options += "<option value=\"" + value + "\">" + item + "\n";
    }
} %>
   </ad:db_foreach>
<%

String where_clause_for_section;
String all_sections_option;
if ( section_dimension_value.equals("all") ) {
    where_clause_for_section = "";
    all_sections_option = "<option value=\"all\" SELECTED>All Sections</option>\n";
} else {
    where_clause_for_section = "and gc.on_which_table = '" + section_dimension_value + "'";
    all_sections_option = "<option value=\"all\">All Sections</option>\n";
}

as = new AdSet();
as.put("time_dimension_value",time_dimension_value);
as.put("approval_dimension_value",approval_dimension_value);
String section_widget = "<form action=\"index\" method=POST>";
section_widget += Utilities.exportFormVars(as);
section_widget += "<select name=section_dimension_value>" + all_sections_option + individual_section_options;
section_widget += "</select><input type=submit value=\"Go\"></form>";

String approval_widget;
String where_clause_for_approval;
if ( approval_dimension_value.equals("all") ) {
    where_clause_for_approval = "";
    approval_widget = "all | <a href=\"index?approval_dimension_value=unapproved_only&";
    as = new AdSet();
    as.put("time_dimension_value",time_dimension_value);
    as.put("approval_dimension_value",approval_dimension_value);
    approval_widget += Utilities.exportURLVars(as) + "\">unapproved only</a>";
} else {
    // we're currently looking at unapproved
    as = new AdSet();
    as.put("time_dimension_value",time_dimension_value);
    as.put("section_dimension_value",section_dimension_value);
    where_clause_for_approval = "and gc.approved_p = 'f'";
    approval_widget = "<a href=\"index?approval_dimension_value=all&" + Utilities.exportURLVars(as);
    approval_widget += "\">all</a> | unapproved only";
}
/** Ignoring scoping for now
[ad_scope_admin_header "General Comments Administration"]
[ad_scope_admin_page_title "General Comments Administration"]
[ad_scope_admin_context_bar "General Comments"]
*/

ContextBar navbar = new ContextBar(pageContext);
navbar.add("General Comments");

%>
<ad:header>General Comments Administration</ad:header>
<h2>General Comments Administration</h2>
<%= navbar.getHTML() %>

<hr>
<p>

<table width=100%><tr><td align=left valign=top><%= section_widget %>
<td align=center valign=top><%= approval_widget %>
<td align=right valign=top><%= time_widget %>
</table>

<%

String where_clause_for_time;
if ( time_dimension_value.equals("all") ) {
    where_clause_for_time = "";
} else {
    where_clause_for_time = "and gc.comment_date > sysdate - " + time_dimension_value;
}

String the_comments = "";
String last_section_name = "";
String best_item_description = "";
%>
<ad:db_query id="comment_list">
select on_which_table,
       on_what_id,
       one_line_item_desc,
       content,
       client_file_name,
       file_type,
       file_extension,
       original_width,
       original_height,
       caption,
       html_p,
       comment_id,
       comment_date,
       approved_p,
       gc.user_id as user_id,
       first_names || ' ' || last_name as commenter_name,
       tm.admin_url_stub,
       tm.section_name as section_name
  from general_comments gc,
       users,
       table_acs_properties tm
 where users.user_id = gc.user_id 
   and gc.on_which_table = tm.table_name(+)
   <%= where_clause_for_section %>
   <%= where_clause_for_approval %>
   <%= where_clause_for_time %>
 order by gc.on_which_table, gc.comment_date desc
</ad:db_query>

<ad:db_foreach in="comment_list" row="rs">
<%



Selection mySel = new Selection(rs);
if ( mySel.get("section_name").equals(last_section_name) ) {
	if ( !Utilities.emptyString(mySel.get("section_name")) ) {
	    the_comments += "<h3>Comments within " + mySel.get("section_name") + "</h3>\n";
	} else {
	    the_comments += "<h3>Comments on " + mySel.get("on_which_table") + "</h3>\n";
	}
	last_section_name = mySel.get("section_name");
    }
    if ( Utilities.emptyString(mySel.get("one_line_item_desc")) ) {
	best_item_description = mySel.get("section_name") + " ID#" + mySel.get("on_what_id");
    } else { 
	best_item_description = mySel.get("one_line_item_desc");
    }
    the_comments += "<table width=90% >\n<tr><td><blockquote>";

    int original_width;
    int original_height;

    try  {
	original_width = Integer.parseInt(mySel.get("original_width"));
	original_height = Integer.parseInt(mySel.get("original_height"));
    } catch (NumberFormatException e) {
	original_width = -1;
	original_height = -1;
    }

the_comments += GeneralComments.formatGeneralComment(request, Integer.parseInt(mySel.get("comment_id")),
						     mySel.get("client_file_name"),
						     mySel.get("file_type"), original_width, original_height,
						     mySel.get("caption"),
						     mySel.get("content"),
						     mySel.get("html_p").equals("t"),
						     mySel.get("one_line_item_desc") );
the_comments += "<br><br>-- <a href=\"/admin/users/one?user_id="+ mySel.get("user_id") + "\">";
the_comments += mySel.get("commenter_name") + "</a>  ("+ mySel.get("comment_date") + ")  ";
the_comments += "on <a href=\"" + mySel.get("admin_url_stub") + mySel.get("on_what_id") + "\">" + best_item_description + "</a>";
the_comments += "</blockquote>\n</td>\n<td align=right>\n";

if ( mySel.get("approved_p").equals("f") ) {
    the_comments += "<a href=\"toggle-approved-p?comment_id=" + mySel.get("comment_id") + "&return_url=" + return_url + "\">Approve</a>\n<br>\n";
}
the_comments += "<a href=\"edit?comment_id=" + mySel.get("comment_id") + "&return_url=";
the_comments += return_url + "\" target=working>edit</a>\n<br>";
the_comments += "<a href=\"delete?comment_id=" + mySel.get("comment_id") + "&return_url=";
the_comments += return_url + "\" target=working>delete</a></td>\n</table>\n";

%>
</ad:db_foreach>

    <ad:header>General Comments Admin</ad:header>
    <h2>General Comments Admin</h2>
<%

if ( Utilities.emptyString(the_comments) ) {
    %> "there aren't any comments in this ACS installation that fit your criteria" <%
} else {
    %> <%= the_comments %> <%
}
%>
<ad:footer/>

