<%--
  /general-comments/comment-add-3.jsp

  @author philg@mit.edu
  @author tarik@mit.edu
  @author rory@arsdigita.com (Java port)
  @creation-date 01/21/2000
  @cvs-id $Id: comment-add-3.jsp,v 1.4 2000/10/17 17:12:23 luke Exp $
--%>

<%@ include file="/acs.jspi" %>
<%@ page import="com.arsdigita.acs.generalcomments.*" %>

<ad:page>
<ad:page_contract id="pc" vars="scope:optional group_id:optional on_which_group:optional comment_id content:html,optional html_p item module one_line:optional return_url:optional on_which_table on_what_id:integer">
<%

// check for bad input
if ( content == null || content.equals("") ) {
    pc.addComplaint("the comment field was empty");
    return;
}

%>
</ad:page_contract>
<ad:get_user_info id="user" />
<%

// assign necessary data for insert
// check for the user cookie
Integer user_id = user.getUserId();

String originating_ip = request.getRemoteAddr();

if ( parameters.getBoolean("ReadOnlyP","",false) ) {
    throw new ReadOnlyException();
}

if ( scope == null || scope.equals("") ) {
    scope = "public";
}

// Get the default approval policy for the site
String approval_policy = parameters.get("DefaultCommentApprovalPolicy","general-comments","wait");
// Override the site approval policy if there is a different approval policy for the module.
approval_policy = parameters.get("CommentApprovalPolicy",module,approval_policy);

// is this already approved or is it awaiting administrators approval?
Boolean approved_p = new Boolean(approval_policy.equals("open"));
request.setAttribute("approved_p", approved_p);

// this little guy's been trailing along for a while now
request.setAttribute("return_url",return_url);

// let's limit this to 200 chars so we don't blow out our column
String one_line_item_description = item.substring(0, (item.length()<199)?item.length():199 );
%>
<ad:db_query id="comment_add_clob">
  begin
    insert into general_comments
      (comment_id,
       on_what_id,
       user_id,
       on_which_table,
       one_line_item_desc,
       content,
       ip_address, 
       comment_date,
       approved_p,
       html_p,
       one_line)
    values
      (:comment_id,
       :on_what_id,
       :user_id,
       :on_which_table,
       :one_line_item_description,
       empty_clob(),
       :ip_address,
       sysdate,
       :approved_p,
       :html_p, 
       :one_line)
    returning content into :1;
  end;
<ad:db_bind><%= comment_id %></ad:db_bind>
<ad:db_bind><%= on_what_id %></ad:db_bind>
<ad:db_bind><%= user_id %></ad:db_bind>
<ad:db_bind><%= on_which_table %></ad:db_bind>
<ad:db_bind><%= one_line_item_description %></ad:db_bind>
<ad:db_bind><%= originating_ip %></ad:db_bind>
<ad:db_bind><%= approved_p.toString().charAt(0) %></ad:db_bind>
<ad:db_bind><%= html_p.toString().charAt(0) %></ad:db_bind>
<ad:db_bind><%= one_line %></ad:db_bind>
</ad:db_query>

<ad:db_query id="comment_check">
  select count(*) from general_comments where comment_id = :comment_id
<ad:db_bind><%= comment_id %></ad:db_bind>
</ad:db_query>

<%

if ( parameters.getBoolean("LogCLOBdmlP","",false) )
    Log.note("Notice: About to use " + comment_add_clob.getSql() + "\n -- to put --  \n" + content + "\n\n -- into the database -- \n");

// how should this work?
try {
    db.clobDml(comment_add_clob,content);
} catch (SQLException e) {
    if ( db.queryToString(comment_check).equals("0") ) {
	throw new ACSException ("There was an error inserting the comment for '" + item + "'.");

	/*
	  AdSet as = new AdSet();
	  as.put("title","Error inserting comment");
	  as.put("error_message","There was an error inserting the comment for '" + item + "'. You lose.");
	  as.put("return_url",return_url);
	  as.put("item",item);
	  // too big?
	  //	as.put("error_message","We were unable to insert your comment in the database.  Here is the error that was returned:\n<p>\n<blockquote>\n<pre>\n"+e.getMessage()+"\n</pre>\n</blockquote>");
	  pageContext.forward("/acs-error-message.jsp?" + Utilities.exportURLVars(as) );
	  return;
	*/
    }
}

// at this point, either we were successful in doing the insert or the user hit submit
// twice and we don't really care

if ( !parameters.getBoolean("AcceptAttachmentsP","general-comments",false) ) {
    // we don't accept attachments, so return immediately
    response.sendRedirect(return_url);
    return;
}

// Exported form vars to pass on to the next page
AdSet t = new AdSet(); {
    t.put("comment_id",  comment_id);
    t.put("return_url", return_url);
    t.put("item", item);
}
request.setAttribute("exported_form_vars",Utilities.exportFormVars(t));

// Context bar HTML
ContextBar navbar = new ContextBar(pageContext);
navbar.add(return_url, item);
navbar.add("Comment Inserted");
request.setAttribute("navbar_html", navbar.getHTML());

%>

<ad:use_template />
