<%--
  /general-comments/image-attachment.jsp

  Purpose:  Present a pretty page with caption and image info with an IMG tag.
            This page should only get called for image attachments; any other
            attachments should be sent directly to 
            /general-comments/attachment/[comment_id]/[filename]

  @author philg@mit.edu
  @author tarik@mit.edu
  @author rory@arsdigita.com (Java port)
  @creation-date 01/21/2000
  @cvs-id $Id: image-attachment.jsp,v 1.4 2000/10/18 15:35:23 luke Exp $ 

--%>

<%@ include file="/acs.jspi" %>
<%@ page import="com.arsdigita.acs.generalcomments.*" %>

<ad:page>
<ad:page_contract id="pc" vars="comment_id return_url:optional"/>

<ad:db_1row id="sqlCommentInfo" obj="dsCommentInfo">
    select one_line_item_desc,
           file_type,
           caption,
           original_width,
           original_height,
           client_file_name, 
           users.user_id,
           users.first_names,
           users.last_name,
           users.email,
           on_what_id
      from general_comments,
           users
     where comment_id = :comment_id
       and users.user_id = general_comments.user_id
<ad:db_bind><%= comment_id %></ad:db_bind>
</ad:db_1row>

<%

String width_and_height = "";
if ( !dsCommentInfo.get("original_width").equals("") && !dsCommentInfo.get("original_height").equals("") ) {
    width_and_height = "width=" + dsCommentInfo.get("original_width") + " height=" + dsCommentInfo.get("original_height");
}
request.setAttribute("width_and_height",width_and_height);

ContextBar navbar = new ContextBar(pageContext);
if ( return_url != null && !return_url.equals("") )
    navbar.add(return_url, dsCommentInfo.get("one_line_item_desc"));
navbar.add("Image Attachment");
request.setAttribute("navbar_html", navbar.getHTML());

request.setAttribute("caption",dsCommentInfo.get("caption"));
request.setAttribute("comment_id",comment_id);
request.setAttribute("client_file_name",dsCommentInfo.get("client_file_name"));
request.setAttribute("user_id",dsCommentInfo.get("user_id"));

request.setAttribute("name",dsCommentInfo.get("first_names")+dsCommentInfo.get("last_name"));

%>

<ad:use_template />
