<%--
    /general-comments/upload-attachment.jsp
    adds (or replaces) an attachment to a comment

    @author philg@mit.edu
    @author tarik@mit.edu
    @author rory@arsdigita.com (Java port)
    @creation-date September 7, 1999
    @cvs-id $Id: upload-attachment.jsp,v 1.3 2000/10/17 17:12:24 luke Exp $
    @param upload_file  a multipart file upload
--%>

<%@ include file="/acs.jspi" %>
<%@ page import="com.arsdigita.acs.generalcomments.*" %>

<ad:page>
<ad:page_contract id="pc" vars="scope:optional group_id:integer,optional on_which_group:optional on_what_id:optional comment_id return_url item caption upload_file:file" />

<ad:get_user_info id="user" />
<%
// let's first check to see if this user is authorized to attach
Integer user_id = user.getUserId();
%>

<ad:db_query id="comment_owner_id_get">
  select user_id
    from general_comments 
   where comment_id = :comment_id
<ad:db_bind><%= comment_id %></ad:db_bind>
</ad:db_query>

<%

// if we're not accepting attachments, then we don't know how the they possibly got here.
if ( !parameters.getBoolean("AcceptAttachmentsP","general-comments",false) )
    throw new ACSException("We don't accept attachments on general-comments at this time.");

Integer comment_owner_id = new Integer(0);
try {
    comment_owner_id = new Integer(db.queryToString(comment_owner_id_get));
} catch (NumberFormatException e) {
}

if ( user_id.intValue() != comment_owner_id.intValue() ) {
    AdSet as = new AdSet();
    as.put("title","Unauthorized");
    as.put("error_message","Ouch.  We think that you're not authorized to attach a file to this comment.  Unless you've been playing around with the HTML, this is probably our programming bug.");
    as.put("return_url",return_url);
    as.put("item",item);
    return;
}

// user is authorized

Perl5Util re =  new com.oroinc.text.perl.Perl5Util();

File uploadFile = new File(upload_file_tmpfile);

String fileExt = "";
if ( re.match("/(\\.[^\\.]+)/", upload_file) )
    fileExt = re.group(1).toLowerCase();

String guessed_file_type =
    (getServletContext().getMimeType(upload_file) == null)?"":getServletContext().getMimeType(upload_file);

long n_bytes = uploadFile.length();

// strip off the C:\directories... crud and just get the file name
String client_filename = upload_file;
if (re.match("@([^//\\\\]+)$@", upload_file))
    client_filename = re.group(1);

int max_n_bytes = parameters.getInt("MaxAttachmentSize", "general-comments", -1);
if ( max_n_bytes != -1 && n_bytes > max_n_bytes ) {
    out.write("Your file is too large.  The publisher of " + parameters.get("SystemName","","this system") + "has chosen to limit attachments to " + max_n_bytes + " bytes.\n");
    return;
    // write util_commify_number
}

if ( n_bytes == 0 ) {
    Vector v = new Vector();
    v.add("Your file is zero-length. Either you attempted to upload a zero length file, a file which does not exist, or something went wrong during the transfer.");
    throw new PageValidationException(v);
}

// all this just to find the image size:
int original_height = -1;
int original_width = -1;
if ( guessed_file_type.equals("image/gif") || guessed_file_type.equals("image/jpeg") ) {
    try {
	Utilities.copyFile(uploadFile, new java.io.File("/tmp/myFile.jpg"));

	ImageSize imageSize = new ImageSize("/tmp/myFile.jpg");
	original_width = imageSize.getWidth();
	original_height = imageSize.getHeight();
    } catch (Exception e) {
	Log.error("get image size failed: " + e.getMessage());
    } 
}
%>
<ad:db_query id= "file_insert">
  begin
    update general_comments 
    set attachment = empty_blob(),
        client_file_name = :client_filename,
        file_type = :guessed_file_type,
        file_extension = :file_extension,
        caption = :caption,
        original_width = :original_width,
        original_height = :original_height
    where comment_id = :comment_id
    returning attachment into :1;
  end;
<ad:db_bind><%= client_filename %></ad:db_bind>
<ad:db_bind><%= guessed_file_type %></ad:db_bind>
<ad:db_bind><%= fileExt %></ad:db_bind>
<ad:db_bind><%= caption %></ad:db_bind>
<ad:db_bind><%= original_width %></ad:db_bind>
<ad:db_bind><%= original_height %></ad:db_bind>
<ad:db_bind><%= comment_id %></ad:db_bind>
</ad:db_query>
<%

db.blobDmlFile(file_insert,uploadFile);

response.sendRedirect(return_url);

%>
