<%--
  /general-comments/view-one.jsp

    View one comment.
    @author philg@mit.edu
    @author tarik@mit.edu
    @author rory@arsdigita.com (Java port)
    @creation-date 01/21/2000
    @cvs-id $Id: view-one.jsp,v 1.4 2000/10/18 15:35:23 luke Exp $

--%>

<%@ include file="/acs.jspi" %>
<%@ page import="com.arsdigita.acs.generalcomments.*" %>

<ad:page>
<ad:page_contract id="pc" vars="comment_id:integer item return_url:optional on_what_id" />

<%
if ( parameters.getBoolean("ReadOnlyP","",false) )
    throw new ReadOnlyException();
%>

<ad:get_user_info id="user" />

<%
// check for the user cookie
Integer user_id = user.getUserId();
%>

<ad:db_1row id="sqlCommentInfo" obj="dsCommentInfo">
    select comment_id,
           content,
           general_comments.html_p as comment_html_p,
           general_comments.user_id as comment_user_id,
           client_file_name,
           file_type,
           original_width,
           original_height,
           caption,
           one_line,
           first_names || ' ' || last_name as commenter_name
      from general_comments,
           users
     where comment_id = :comment_id
       and users.user_id = general_comments.user_id
  <ad:db_bind><%= comment_id.intValue() %></ad:db_bind>
</ad:db_1row>

<%
ContextBar navbar = new ContextBar(pageContext);
if ( return_url != null && !return_url.equals("") )
    navbar.add(return_url, item);
navbar.add("Comment");
request.setAttribute("navbar_html", navbar.getHTML());

int original_width;
int original_height;
try {
    original_width = Integer.parseInt(dsCommentInfo.get("original_width"));
    original_height = Integer.parseInt(dsCommentInfo.get("original_height"));
} catch (NumberFormatException e) {
    original_width = -1;
    original_height = -1;
}

request.setAttribute("comment_html",
		     GeneralComments.formatGeneralComment( request,
							   Integer.parseInt(dsCommentInfo.get("comment_id")),
							   dsCommentInfo.get("client_file_name"),
							   dsCommentInfo.get("file_type"),
							   original_width,
							   original_height,
							   dsCommentInfo.get("caption"), dsCommentInfo.get("content"),
							   dsCommentInfo.get("comment_html_p").toLowerCase().equals("t"),
							   dsCommentInfo.get("one_line") )
		     );

Boolean editable_p;
String exported_url_vars = "";

// if the user posted the comment, they are allowed to edit it
if ( user_id.intValue() == Integer.parseInt(dsCommentInfo.get("comment_user_id")) ) {
    editable_p = new Boolean(true);

    AdSet as = new AdSet();
    as.put("comment_id",comment_id);
    as.put("on_what_id",on_what_id);
    as.put("item",item);

    if ( return_url != null && !return_url.equals("") )
	// check whether return_url was provided; we don't want to pass return_url if it wasn't provided
	as.put("return_url",return_url);

    exported_url_vars = Utilities.exportURLVars(as);
} else {
    editable_p = new Boolean(false);
}

request.setAttribute("editable_p",new Boolean(true) ); //editable_p);
request.setAttribute("exported_url_vars",exported_url_vars);

request.setAttribute("item",item);
request.setAttribute("comment_user_id",new Integer(dsCommentInfo.get("comment_user_id")));
request.setAttribute("commenter_name",dsCommentInfo.get("commenter_name"));

%>

<ad:use_template />
