<%
/*
    Given form input that identifies a specific permission,
    deletes the permission if it already exists or inserts
    it if it does not.

    @author michael@arsdigita.com
    @creation-date 2000-02-25
    @cvs-id $Id: permission-toggle.jsp,v 1.1 2000/09/08 22:02:55 bschneid Exp $
*/
%>

<%@ include file="../acs.jspi" %>
<ad:page>

<ad:page_contract id="pc" vars="on_what_id:integer on_which_table object_name scope user_id:integer,optional group_id:integer,optional role:optional permission_type return_url">

<%
if (scope.equals("user")) { 
    if (user_id == null) {
	pc.addComplaint("\"user_id\" required but not supplied");
    }
} else if (scope.equals("group_role")) {
    if (group_id == null) {
	pc.addComplaint("\"group_id\" required but not supplied");
    } 
    if (Utilities.emptyString(role)) {
	pc.addComplaint("\"role\" required but not supplied");
    }
} else if (scope.equals("group")) {
    if (group_id == null) {
	pc.addComplaint("\"group_id\" required but not supplied");
    } 
} else if (!scope.equals("registered_users") && !scope.equals("all_users")) {
    pc.addComplaint("unknown scope: " + scope);
}
%>

</ad:page_contract>

<ad:get_user_info id="user" redirect="false"/>

<% 
Integer local_user_id = null;
if (user != null)
  local_user_id = user.getUserId();
if (!GeneralPermissions.userHasPermission(local_user_id, "administer", on_what_id.toString(), on_which_table)) { 
    if (local_user_id == null) {
	Security.redirectForRegistration(pageContext);
	return;
    } else {
	throw new ForbiddenException("Access denied", "You do not have permissions to administer the selected object.");
    }
}

// Does the specified permission exist?
//
Integer permission_id = GeneralPermissions.getPermissionId(db, scope,
 user_id, group_id, role, permission_type, on_what_id, on_which_table);

if (permission_id.intValue() != 0) {
    // If the permission exists, then check to see if it's the last
    // 'administer' permission. If it is, then present a confirmation
    // page. Otherwise, revoke it.
    //
    if (permission_type.equals("administer") 
    && (GeneralPermissions.permissionCount(db, on_what_id, on_which_table, permission_type) == 1)) {
	response.sendRedirect("revoke-only-administer-permission?" + Utilities.exportURLVars(request, "on_what_id on_which_table object_name return_url") + "&permission_id=" + permission_id);
	return;
    } else {
	db.dml("begin ad_general_permissions.revoke_permission(" + permission_id + "); end;");
    }
} else {
    // Otherwise, grant the permission.
    //
    GeneralPermissions.grantPermission(db, scope, user_id, group_id, role,
     permission_type, on_what_id, on_which_table);
}

response.sendRedirect(return_url);
%>

</ad:page>
