<%@ include file="/acs.jspi" %>

<%--  Note: group_id and other group related variables are already set as
      request attributes by UserGroupFilter.  Using template_contract rather
      than page_contract so as to set variables from request attributes.
--%>

<ad:page>
<ad:template_contract vars="group_id group_public_root_url:notnull group_admin_url:notnull">

<ad:get_user_info id="user" />

<%
if (!user.isGroupAdmin(group_id)) {
    throw new ForbiddenException("Not Authorized", "You are not authorized to see this page.");
}        
%>
        
<ad:db_query id="sqlSectionInfo" obj="dsSectionInfo">
select section_id,section_key, section_pretty_name, section_type, module_key
from content_sections 
where scope='group' 
and group_id=:group_id
and (section_type!='static')
order by sort_key
<ad:db_bind><%= group_id %></ad:db_bind>
</ad:db_query>

<ad:db_1row id="sqlGroupInfo" obj="dsGroupInfo">
select ug.approved_p, ug.creation_user, ug.registration_date, 
       ug.new_member_policy, ug.email_alert_p, ug.group_type, 
       ug.multi_role_p, ug.group_admin_permissions_p, ug.group_name,
       first_names, last_name
from user_groups ug, users u
where ug.group_id = :group_id
and ug.creation_user = u.user_id
<ad:db_bind><%= group_id %></ad:db_bind>
</ad:db_1row>

<%
request.setAttribute("return_url", group_admin_url + "/");
ContextBar navbar = new ContextBar(pageContext);
navbar.add("One Group Admin");
request.setAttribute("navbar", navbar);
request.setAttribute("page_title", dsGroupInfo.get("group_name") + " Administration");
%>

<ad:use_template />
</ad:page>
