<%@ include file="/acs.jspi" %>

<ad:page>
<ad:get_user_info id="user" />

<ad:page_contract id="pc" vars="user_id:integer role" />

<% 
String group_id = (String)request.getAttribute("group_id"); 

if (!user.isGroupAdmin(group_id)) {
    throw new ForbiddenException("Not Authorized", "You are not authorized to see this page.");
}        
%>

<ad:db_query id="get_info">
    select 
        first_names || ' ' || last_name as name, 
        group_name
    from 
        users, 
        user_group_map, 
        user_groups 
    where 
       users.user_id = :user_id
       and user_group_map.user_id = users.user_id
       and user_groups.group_id = user_group_map.group_id
       and user_group_map.group_id = :group_id and
       user_group_map.role = :role
<ad:db_bind><%= user_id %></ad:db_bind>
<ad:db_bind><%= group_id %></ad:db_bind>
<ad:db_bind><%= role %></ad:db_bind>
</ad:db_query>

<% 
ResultSet rs = db.query(get_info);
if (!rs.next()) {
%>
<ad:header>User could not be found in the specified role.</ad:header>
<h2>User could not be found in the specified role.</h2>
<hr>
The user could not be removed from the role because he or she is no longer in it.
<ad:footer />
<% 
return;
}
String name = rs.getString ("name");
%>

<ad:header>Really remove <%= name %> from the role <%= role %>?</ad:header>

<h2>Really remove <%= name %> from the role <%= role %>?</h2>

in <a href="members"><%= rs.getString("group_name") %></a>

<hr>

<center>
<table>
<tr><td>
<form method=get action="members">
<input type=submit name=submit value="No, Cancel">
</form>
</td><td>
<form method=get action="member-remove-2">
<%= Utilities.exportFormVars(request, "user_id role") %>
<input type=submit name=submit value="Yes, Proceed">
</form>
</td></tr>
</table>
</center>

<ad:footer />
</ad:page>
