<%@ include file="/acs.jspi" %>
<ad:template_contract vars="group_id" />

<ad:page>
<ad:get_user_info id="user" />

<%
if (!user.isGroupAdmin(group_id)) {
    throw new ForbiddenException("Not Authorized", "You are not authorized to see this page.");
}        
%>

<ad:db_query id="sqlPendingUsers" obj="dsPendingUsers">
select queue.user_id, first_names || ' ' || last_name as name, 
 to_char(queue_date, 'Mon-dd-yyyy') as pretty_queue_date, 
 group_id
from users, user_group_map_queue queue
where users.user_id = queue.user_id
 and group_id = ? 
order by queue_date asc
<ad:db_bind><%= group_id %></ad:db_bind>
</ad:db_query>

<ad:db_1row id="sqlGroupInfo" obj="dsGroupInfo" 
 type="com.arsdigita.acs.ug.SingleGroupDataSource">
select ug.approved_p, ug.creation_user, ug.registration_date, ug.group_name,
       ug.new_member_policy,ug.spam_policy, ug.email_alert_p, ug.group_type, 
       ug.multi_role_p, ug.group_admin_permissions_p,
       first_names, last_name
from user_groups ug, users u
where ug.group_id = :group_id
and ug.creation_user = u.user_id
<ad:db_bind><%= group_id %></ad:db_bind>
</ad:db_1row>

<ad:db_query id="sqlMembers" obj="dsMembers">
select users.user_id, first_names || ' ' || last_name as name, 
 role, group_id
from users, user_group_map
where users.user_id = user_group_map.user_id
and group_id = ?
order by role, last_name, first_names
<ad:db_bind><%= group_id %></ad:db_bind>
</ad:db_query>

<%
ContextBar navbar = new ContextBar(pageContext);
navbar.add("Membership Administration");
request.setAttribute("page_title", "Membership Administration");
request.setAttribute("navbar", navbar);
%>

<ad:use_template />

</ad:page>
