<%@ include file="/acs.jspi" %>

<ad:page>
<ad:page_contract vars="user_id:integer"/>
<ad:get_user_info id="user"/>

<% 
String group_id = (String)request.getAttribute("group_id"); 
if (!user.isGroupAdmin(group_id)) {
    throw new ForbiddenException("Not Authorized", "You are not authorized to see this page.");
}        
%>

<ad:db_transaction>

<ad:db_query id="insert_ugm_permission">
insert into user_group_map (user_id, group_id, mapping_ip_address, role, 
mapping_user) 
select user_id, group_id, ip_address, 'member', ? 
 from user_group_map_queue 
 where user_id = :user_id 
   and group_id = :group_id 
   and not exists (select user_id from user_group_map 
      where user_id = :user_id and group_id = :group_id and role = 'member')
<ad:db_bind><%= user.getUserId() %></ad:db_bind>
<ad:db_bind name="user_id"><%= user_id %></ad:db_bind>
<ad:db_bind name="group_id"><%= group_id %></ad:db_bind>
</ad:db_query>

<ad:db_query id="delete_from_queue">
delete from user_group_map_queue 
where user_id = :user_id and group_id = :group_id
<ad:db_bind name="user_id"><%= user_id %></ad:db_bind>
<ad:db_bind name="group_id"><%= group_id %></ad:db_bind>
</ad:db_query>

<% 
db.dml(insert_ugm_permission);
db.dml(delete_from_queue);
%>
</ad:db_transaction>

<% Utilities.sendRedirect(response, "members"); %>

</ad:page>