<%--
    @param spam_id the ID of the spam
    @param sendto the recipient
    @param subject the subject
    @param message the message itself

    @cvs-id $Id: spam-send.jsp,v 1.2 2000/10/16 20:00:47 luke Exp $
--%>

<%@ include file="/acs.jspi" %>
<ad:page>
<ad:page_contract vars="spam_id:integer from_address sendto subject message"/>
<ad:template_contract vars="group_id group_public_url"/>

<ad:get_user_info id="user"/>

<%
if (!user.isGroupAdmin(group_id)) {
    throw new ForbiddenException("Not Authorized", "You are not authorized to see this page.");
}        
%>

<ad:db_query id="get_count_emails">
    select count(*) from ( select  distinct email 
    from user_group_map ug, users_spammable u
	where ug.group_id = :group_id
        <% if (!sendto.equals("all")) { %>
            and (ug.role = :role)
            <ad:db_bind name="role"><%= sendto %></ad:db_bind>
        <% } %>
	and ug.user_id = u.user_id
	and not exists ( select 1 
	                 from group_member_email_preferences
                         where group_id = :group_id
	                 and user_id =  u.user_id 
                         and dont_spam_me_p = 't')
        and not exists ( select 1 
	                 from user_user_bozo_filter
                         where origin_user_id = u.user_id 
	                 and target_user_id =  :sender_id))
<ad:db_bind name="group_id"><%= group_id %></ad:db_bind>
<ad:db_bind name="sender_id"><%= user.getUserId() %></ad:db_bind>
</ad:db_query>

<%
String n_receivers_intended = db.queryToString(get_count_emails);
%>

<ad:db_query id="insert_into_spam_history">
begin insert into group_spam_history
            ( spam_id, group_id, from_address, approved_p, subject, 
              body, send_date,  creation_date, sender_id,
              sender_ip_address, send_to,
              n_receivers_intended, n_receivers_actual)
            values
              (:spam_id, :group_id, :from_address, 't', :subject, 
               empty_clob(), null, sysdate, :user_id, 
               ?, :sendto, 
               :n_receivers_intended ,0)
             returning body into ?;
end;
<ad:db_bind><%= spam_id %></ad:db_bind>
<ad:db_bind><%= group_id %></ad:db_bind>
<ad:db_bind><%= from_address %></ad:db_bind>
<ad:db_bind><%= subject %></ad:db_bind>
<ad:db_bind><%= user.getUserId() %></ad:db_bind>
<ad:db_bind><%= request.getRemoteAddr() %></ad:db_bind>
<ad:db_bind><%= sendto %></ad:db_bind>
<ad:db_bind><%= n_receivers_intended %></ad:db_bind>
</ad:db_query>

<%
try {
 db.clobDml(insert_into_spam_history, message);
} 
catch (Exception e) { 
    // choked; let's see if it is because 
    String isDouble = db.queryToString("select count(*) from group_spam_history where spam_id = :spam_id", new Object[] {spam_id});
    if (!isDouble.equals("0")) { 
	throw new WarningException("Double Click?", "This spam has already been sent.  Perhaps you double clicked?  In any case, you can check the progress of this spam on <a href=\"spam-item?spam_id=" + spam_id + "\">the history page</a>.");
    } else {
	throw e;
    }
}

Utilities.sendRedirect(response, "spam-index");

Log.note("/groups/group/spam-send.jsp:  sending group spam " + spam_id);

GroupSpam.sendSpam(spam_id);

Log.note("/groups/group/spam-send.jsp: group spam " + spam_id + " sent");
%>

</ad:page>