<%@ include file="/acs.jspi" %>

<%--  Note: groups_public_dir, group_type_url_p, group_type, group_type_pretty_name, 
       group_type_pretty_plural, group_public_root_url and group_admin_root_url
       are added as request attributes by UserGroupFilter. If group_type_url_p
       is 0, then group_type, group_type_pretty_name and group_type_pretty_plural
       won't exist.  We use template_contract instead of page_contract so as to 
       set these variables up from request attributes.
--%>

<ad:page>
<ad:template_contract vars="group_type_url_p:class=Boolean group_public_root_url:notnull group_admin_root_url:notnull group_type:optional group_type_pretty_plural:optional group_type_pretty_name:optional">

<ad:get_user_info id="user" />

<%
    String page_title = (group_type_url_p.booleanValue() ? 
        group_type_pretty_name + " Administration" : "Group Administration");

    request.setAttribute("page_title", page_title);

    ContextBar navbar = new ContextBar(pageContext);
    navbar.add(page_title);
    request.setAttribute("navbar", navbar);

    request.setAttribute("groupsDirectory", Parameters.get("GroupsDirectory", "ug", "groups"));    

    String group_type_sql = (group_type_url_p.booleanValue() ? 
        "and ugt.group_type = :group_type" : "");
%>

<ad:db_query id="sqlGroupInfo" obj="dsGroupInfo">
select ug.short_name, ug.group_name, ugt.group_type, ugt.pretty_plural
from user_groups ug, user_group_types ugt, users u
where u.user_id=:user_id
and ad_user_has_role_p ( :user_id, ug.group_id, 'administrator' ) = 't'
and ug.approved_p = 't'
<%= group_type_sql %>
and ugt.group_type= ug.group_type
order by upper(ug.group_type)
<% 
    sqlGroupInfo.bind("user_id", user.getUserId());
    if (group_type_url_p.booleanValue())
        sqlGroupInfo.bind(group_type);
%>
</ad:db_query>

<ad:use_template />
</ad:page>