<%@ include file="../acs.jspi" %>

<ad:page>
<ad:get_user_info id="user" />

<ad:page_contract id="pc" vars="group_id:integer group_type group_name short_name admin_email new_member_policy spam_policy return_url:optional" />

<ad:db_1row id="get_group_type" obj="gt"
 type="com.arsdigita.acs.ug.SingleGroupTypeDataSource">
select group_type, approval_policy from user_group_types
where group_type = ?
<ad:db_bind><%= group_type %></ad:db_bind>
</ad:db_1row>

<% 
Integer user_id = user.getUserId();

// get the additional fields for this group type
GroupField gf = gt.getGroupFields(db);
String extraFields = "";
String extraBinds = "";
java.util.Vector extraValues =  new java.util.Vector();
while (gf.next()) {
	extraFields += ", ";
	extraFields += gf.getColumnName();
	extraBinds += ", ?";
	String type = gf.getColumnType();
	String value;
	if (type.equals("date")) {
		Calendar c = Calendar.getInstance();
		c.set(Integer.parseInt(request.getParameter(gf.getColumnName() + "_year")),
		 Integer.parseInt(request.getParameter(gf.getColumnName() + "_month")),
 		 Integer.parseInt(request.getParameter(gf.getColumnName() + "_day")));
		value = new java.sql.Date(c.getTime().getTime()).toString();
	} else {
		value = request.getParameter(gf.getColumnName());
		if (type.equals("integer")) { 
			// better validate that it's an integer
			Perl5Util re = new Perl5Util();
			if (re.match("m/[^0-9]/", value)) { 
				Vector vec = new Vector();
				vec.addElement(gf.getColumnName() + " must be an integer.");
				throw new PageValidationException(vec);
			}
		}
	}
	// prevent string literal "null" from appearing in bind vars
	if (value == null) {
		value = "";
	}
	extraValues.addElement(value);
}

String approved_p = "f";
if (user.isSiteWideAdmin() || gt.getApprovalPolicy().equals("open")) {
	approved_p = "t";
}
%>

<ad:db_query id="insert_group">
insert into user_groups
 (group_id, group_type, group_name, short_name, admin_email, 
  new_member_policy, spam_policy, creation_user, creation_ip_address,
  registration_date, approved_p)
 values (?, ?, ?, ?, ?, ?, ?, ?, ?, sysdate, ?)
<ad:db_bind><%= group_id %></ad:db_bind>
<ad:db_bind><%= group_type %></ad:db_bind>
<ad:db_bind><%= group_name %></ad:db_bind>
<ad:db_bind><%= short_name %></ad:db_bind>
<ad:db_bind><%= admin_email %></ad:db_bind>
<ad:db_bind><%= new_member_policy %></ad:db_bind>
<ad:db_bind><%= spam_policy %></ad:db_bind>
<ad:db_bind><%= user_id %></ad:db_bind>
<ad:db_bind><%= request.getRemoteAddr() %></ad:db_bind>
<ad:db_bind><%= approved_p %></ad:db_bind>
</ad:db_query>

<ad:db_query id="dup_check">
select count(*) from user_groups where group_id = ? 
<ad:db_bind><%= group_id %></ad:db_bind>
</ad:db_query>

<ad:db_query id="insert_extra">
insert into <%= gt.getHelperTableName(db) %>
(group_id <%= extraFields %>)
values (? <%= extraBinds %>)
<ad:db_bind><%= group_id %></ad:db_bind>
<% for (int i = 0; i < extraValues.size(); i++) { %>
<ad:db_bind><%= extraValues.elementAt(i) %></ad:db_bind>
<% } %>
</ad:db_query>

<ad:db_transaction>
<% 
String dups = db.queryToString (dup_check);
if (dups.equals("0")) {
	db.dml(insert_group);
	db.dml(insert_extra);
}
%>
</ad:db_transaction>

<%
if (Utilities.emptyString(return_url)) {
	return_url = "index";
}
response.sendRedirect(return_url);
%>

</ad:page>