<%@ include file="/acs.jspi" %>

<% // request attributes have been set up by group filter %>

<ad:page>

<ad:get_user_info id="user" redirect="false"/>

<% 
Integer group_id = new Integer((String)request.getAttribute("group_id"));
Integer user_id = new Integer(0);
if (user != null) 
 user_id = user.getUserId();
%>

<ad:db_1row id="group_get_ug_info" obj="group" 
 type="com.arsdigita.acs.ug.SingleGroupDataSource">
select ug.approved_p, ug.creation_user, ug.registration_date, ug.group_type, 
 ug.new_member_policy, u.first_names, u.last_name 
 from user_groups ug, users u 
 where group_id = :group_id 
 and ug.creation_user = u.user_id
<ad:db_bind><%= group_id %></ad:db_bind>
</ad:db_1row>

<ad:db_query id="sqlAdmins" obj="dsAdmins">
    select u.user_id as admin_user_id, 
     u.first_names || ' ' || u.last_name as name 
    from user_group_map ugm, users u 
    where ugm.user_id = u.user_id 
    and ugm.group_id = :group_id 
    and ugm.role = 'administrator' 
<ad:db_bind><%= group_id %></ad:db_bind>
</ad:db_query>

<ad:db_string obj="dont_spam_me_p" default="f">
select dont_spam_me_p
	from group_member_email_preferences 
	where group_id = :group_id 
	and user_id = :user_id
<ad:db_bind><%= group_id %></ad:db_bind>
<ad:db_bind><%= user_id %></ad:db_bind>
</ad:db_string>

<ad:db_query id="sqlSections" obj="dsSections">
    select section_key, section_pretty_name, section_type, section_id 
    from content_sections 
    where scope = 'group' 
    and group_id = :group_id 
    and (section_type = 'static' or 
    section_type = 'custom' or 
    (section_type = 'system' and module_key != 'custom-sections')) 
    and enabled_p = 't' 
    order by sort_key 
<ad:db_bind><%= group_id %></ad:db_bind>
</ad:db_query>

<%
if (user != null) {
 request.setAttribute("user", user);
 request.setAttribute("member_p", new Boolean(user.isGroupMember(group_id)));
 request.setAttribute("admin_p", new Boolean(user.isGroupAdmin(group_id)));
} 

ContextBar navbar = new ContextBar(pageContext);
navbar.add("One Group");
request.setAttribute("navbar", navbar);
%>

<ad:use_template/>

</ad:page>


