<%--
# File: /groups/group/spam-confirm.tcl
ad_page_contract {
    @param sendto recipient of the email
    @param subject:optional subject line
    @param message:optional the message

    @cvs-id $Id: spam-confirm.jsp,v 1.2 2000/09/26 15:34:43 bschneid Exp $
--%>

<%@include file="../../acs.jspi" %>

<ad:page>
<ad:page_contract id="pc" vars="sendto:multiple from_address subject:optional message:optional">
<% 
if (Utilities.emptyString(subject) && Utilities.emptyString(message)) {
    pc.addComplaint("<li>The contents of your message and subject line is the empty string. <br> You must send something in the message body or subject line.");
} 
%>
</ad:page_contract>
<ad:template_contract vars="group_name group_id"/>

<ad:get_user_info id="user"/>

<%
if (!user.isGroupMember(group_id)) { 
    throw new ForbiddenException("Not Group Member", 
    "You must be a member of this group before you can send spam!");
}

String sendto_string = sendto[0];
if (sendto_string.equals("members")) {
	sendto_string = "Group Members";
} else if (sendto_string.equals("all")) { 
	sendto_string =  "Everyone in the group";
} else if (sendto_string.startsWith("administrator")) { 
	sendto_string = "Group Administrators";
}

request.setAttribute("creation_date", db.queryToString("select to_char(sysdate, 'ddth Month,YYYY  HH:MI:SS am') from dual"));
request.setAttribute("from_address", from_address);
request.setAttribute("subject", subject);
%>

<ad:db_query id="get_count_emails">
    select count(*) from ( select  distinct email 
    from user_group_map ug, users_spammable u
	where ug.group_id = :group_id
        <% if (!sendto[0].equals("all")) { %>
            and (1=1 
          <% for (int i = 0 ; i < sendto.length; i++) { %>
	    or ug.role = '<%= sendto[i] %>'
          <% } %>
            )
        <% } %>
	and ug.user_id = u.user_id
	and not exists ( select 1 
	                 from group_member_email_preferences
                         where group_id = :group_id
	                 and user_id =  u.user_id 
                         and dont_spam_me_p = 't')
        and not exists ( select 1 
	                 from user_user_bozo_filter
                         where origin_user_id = u.user_id 
	                 and target_user_id =  :sender_id))
<ad:db_bind><%= group_id %></ad:db_bind>
<ad:db_bind><%= group_id %></ad:db_bind>
<ad:db_bind><%= user.getUserId() %></ad:db_bind>
</ad:db_query>

<%
String counter = db.queryToString(get_count_emails); 
if (counter.equals("0")) {
    throw new ACSException("There are no members in the group matching your selection " + sendto_string);
}
request.setAttribute("counter", counter);
request.setAttribute("sendto_string", sendto_string);
request.setAttribute("message", message);

// generate unique key here so we can handle the "user hit submit twice" case
request.setAttribute("spam_id", db.queryToString("select group_spam_id_sequence.nextval from dual"));

// strips ctrl-m's, makes linebreaks at >= 80 cols when possible, without
// destroying urls or other long strings
// message =  [spam_wrap_text $message 80]

%>

<ad:use_template/>
</ad:page>