<%@ include file="/acs.jspi" %>

<ad:page>

<ad:get_user_info id="user"/>

<ad:page_contract id="pc" vars="group_id:integer user_id_from_search:integer role:optional return_url:optional" />

<ad:db_1row id="user_group_properties" obj="group" 
 type="com.arsdigita.acs.ug.SingleGroupDataSource">
select group_name, multi_role_p 
from user_groups 
where group_id = :group_id
<ad:db_bind><%= group_id %></ad:db_bind>
</ad:db_1row>

<%
Vector oldRoleList = db.queryToList("select role from user_group_map where user_id = ? and group_id = ?", new Object[] {user_id_from_search, group_id});
UserInfo newMember = new UserInfo(user_id_from_search.toString());
String title = "";

if (!Utilities.emptyString(role)) {
    title = "Add " + newMember.getFullName() + " as " + role;
} else {
    title = "Specify Role and Any Extra Fields for " + newMember.getFullName();
}

%>

<ad:header><%= title %></ad:header>

<h2><%= title %></h2>

in <a href="group?group_id=<%= group_id %>"><%= group.get("group_name") %></a>

<hr>

<form method=get action="member-add-3">
<%= Utilities.exportFormVars(request, "group_id user_id_from_search return_url") %>

<table>

<%
if (oldRoleList.size() > 0 ) {
%>

Warning: <%= newMember.getFullName() %> already has the role: <%= Utilities.join(oldRoleList, ", ") %>, which will not be replaced by this operation.
<p>

<% } %>

<% if (!Utilities.emptyString(role)) { %>
   <%= Utilities.exportFormVars(request, "role") %>
<%
} else {
    
    if ("t".equals(group.get("multi_role_p"))) {
	Vector existingRoles = db.queryToList("select role from user_group_roles where group_id = ?", new Object[] {group_id});
	if (existingRoles.indexOf("administrator") == -1) {
	    existingRoles.addElement("administrator");
	}
	if (existingRoles.size() > 0 ) {
%>
	    <tr><th>Role<td><select name=existing_role>
	    <%= HtmlWidgets.htmlOptions(existingRoles, existingRoles, "") %>
	    </select>
<%
	}
%>
        </tr>
<%
    } else {
	Vector existingRoles = db.queryToList("select distinct role from user_group_map where group_id = :group_id", new Object[] {group_id});
	if (existingRoles.indexOf("administrator") == -1 ) {
	    existingRoles.addElement("administrator");
	}
	if (existingRoles.indexOf("all") == -1 ) {
	    existingRoles.addElement("all");
	}
	if (existingRoles.indexOf("member") == -1 ) {
	    existingRoles.addElement("member");
	}
%>
	
	<tr><th>Existing role</th><td>
	<select name=existing_role>
	<option value="">choose an existing role
        <option><%= Utilities.join(existingRoles, "\n<option>") %>
        </select>
	</tr>
	<tr><td colspan=2 align=center>or</tr>
	<tr>
	<td>
	Define a new role for this group:
	<td>
	<input type=text name=new_role size=30>
	</tr>
<%
    }
}
// Additional fields
%>

<ad:db_query id="user_group_member_fields">
select group_id, field_name, field_type
from all_member_fields_for_group
where group_id = :group_id
order by sort_key
<ad:db_bind><%= group_id %></ad:db_bind>
</ad:db_query>

<ad:db_foreach in="user_group_member_fields" row="rs">
  <tr>
   <th><%= rs.getString("field_name") %>
   <td><%= HtmlWidgets.fieldFormElement(rs.getString("field_name"), rs.getString("field_type"), "") %>
  </tr>
</ad:db_foreach>

</table>
<p>

<center>
<input type=submit value="Confirm">
</center>
</form>

<ad:footer />

</ad:page>