<%@ include file="/acs.jspi" %>

<ad:page>

<ad:get_user_info id="user"/>

<ad:page_contract id="pc" vars="group_id:integer user_id_from_search:integer role:optional existing_role:optional new_role:optional return_url:optional">

<%
if (Utilities.emptyString(role) && Utilities.emptyString(existing_role) && 
  Utilities.emptyString(new_role)) {
	pc.addComplaint("We couldn't figure out what role this new member is supposed to have; either you didn't choose one or there is a bug in our software.");
}
%>

</ad:page_contract>

<%

if (Utilities.emptyString(role)) {
    // we weren't just given a role so let's look at the user's choice
    if (!Utilities.emptyString(existing_role)) {
	role = existing_role;
    } else if (!Utilities.emptyString(new_role)) {
	role = new_role;
    } 
}

if (Utilities.emptyString(return_url)) {
    return_url = "/groups";
}

// make sure the user is authorized admin for this group, or
// that the group has an open enrollment policy

if (!user.isGroupAdmin(group_id) && !user.isSiteWideAdmin()) { 
	String newMemberPolicy = db.queryToString("select new_member_policy from user_groups where group_id = ?", new Object[] {group_id});
	if (!newMemberPolicy.equals("open")) { 
		throw new ForbiddenException("Group not open", "This group does not have an open enrollment policy.  Only administrators can add users.");
	}
}

Integer mapping_user = user.getUserId();
String mapping_ip_address = request.getRemoteAddr();


%>

<ad:db_transaction>
<ad:db_query id="ug_insert_user">
insert into user_group_map (group_id, user_id, role, mapping_user, 
    mapping_ip_address) 
select :group_id, :user_id_from_search, :role, :mapping_user, 
 :mapping_ip_address from dual
<ad:db_bind><%= group_id %></ad:db_bind>
<ad:db_bind><%= user_id_from_search %></ad:db_bind>
<ad:db_bind><%= role %></ad:db_bind>
<ad:db_bind><%= mapping_user %></ad:db_bind>
<ad:db_bind><%= mapping_ip_address %></ad:db_bind>
</ad:db_query>

<%
db.dml(ug_insert_user);
// Extra fields
%>

<ad:db_query id="all_field_name">
select field_name from all_member_fields_for_group 
where group_id = :group_id
<ad:db_bind><%= group_id %></ad:db_bind>
</ad:db_query>
    
<ad:db_foreach in="all_field_name" row="rs">
<%
String field_name = rs.getString("field_name");
if (!Utilities.emptyString(rs.getString("field_name"))) {
    String field_value = request.getParameter(field_name);
    db.dml("insert into user_group_member_field_map " +
	"(group_id, user_id, field_name, field_value) " +
	"values (?, ?, ?, ?)", 
	new Object[] {group_id, user_id_from_search, field_name, field_value});
}
%>
</ad:db_foreach>
</ad:db_transaction>

<%
response.sendRedirect(return_url);
%>

</ad:page>
