#!/bin/sh
#
# jspc.sh - Invokes the JSP precompiler on every jsp and tpl file in the acs-java project.
#
# xargs feeds 256 bytes of filenames to javac at one time.  if you encounter precompile errors 
# from the jasper precompiler, and you can't figure out which file it comes from, add the -i and -t
# switches to xargs (and the {} filename placeholder at the end), to force it to precompile one file 
# at a time (this is very slow).
#
# luke@arsdigita.com
#

cd $ACS_JAVA/jspBuild

echo 'removing all previously generated build files'
rm -rf jspc
mkdir jspc

echo 'Precompiling all .jsp files'
find $ACS_JAVA -name "*.jsp" | xargs $TOMCAT_HOME/bin/tomcat.sh jspc -d jspc

echo 'Precompiling all .tpl files'
find $ACS_JAVA -name "*.tpl" | xargs $TOMCAT_HOME/bin/tomcat.sh jspc -d jspc

echo 'Generating build script'
cd jspc
perl ../make-build.pl
cd ..

echo 'Now you can compile; use the command javac -J-mx100000000 jspc/Build.java'
echo 'Don\'t forget to add $ACS_JAVA/jspBuild/jspc to your classpath'

