#!/usr/bin/env perl

open (f, "find . -name '*.java' |");
open (output, "> Build.java");

print output "
/**
 * Build class to reference all other ACS-Java classes.
 * This class was auto-generated; do not edit!
 */
public class Build {
";

while ($classFile = <f>) { 
    # first see if this is a public class 
    chop $classFile;

    open (inp, "< $classFile");
    $ok = 0;
    while (<inp>) { 
	$ok = 1 if (/public.*class/) ;
    } 
    if ($ok) {
	# convert package/subpackage/Foo.java to package.subpackage.Foo
    $classFile =~ s@^\./@@;
	$classFile =~ s@/@.@g;
	$classFile =~ s@\.java$@@;
	$obj = $classFile;
	# and create a reference to it packageXsubpackageXFoo
	$obj =~ s/\.([a-zA-Z])/X\1/g;
	
	print output " $classFile $obj;\n";
    }
}

print output "}\n";
