<%--
  /links/add-3.jsp

  @cvs-id $Id: add-3.jsp,v 1.1 2000/10/25 14:57:09 jbank Exp $ 

--%>

<%@ include file="/acs.jspi" %>
<ad:page>
<ad:get_user_info id="user" />

<ad:page_contract id="pc" vars="page_id:integer link_description:html link_title url contact_p">
<%
if (url.equals("http://")) {
    pc.addComplaint("Please type in a URL.");
}
if (!Utilities.URLValidP(url)) {
    pc.addComplaint("You URL doesn't have the correct form.  A valid URL would be something like \"http://photo.net/philg/\"");
}
if (link_description.length() > 4000) {
    pc.addComplaint("Please limit your link description to 4000 characters.");
}
String link_count = db.queryToString("select count(url) from links where page_id = :page_id and lower(url)=lower(:url)", 
                                     new Object[] { page_id, url } );
if (!link_count.equals("0")) {
    pc.addComplaint(url+" has already been submitted.");
}
%>
</ad:page_contract>

<ad:db_query id="select_glob_patterns" obj="glob_patterns">
select glob_pattern 
from link_kill_patterns
where page_id = :page_id
or page_id is null
<ad:db_bind><%= page_id %></ad:db_bind>
</ad:db_query>

<%
while (glob_patterns.next()) {
    if (Utilities.stringGlobMatch(glob_patterns.get("glob_pattern"), url)) {
        throw new ACSException("Your submission matched one of this community's exclusion patterns:\n" +
                               "<blockquote>\n"+
                               "<code>\n"+
                               glob_patterns.get("glob_pattern") + "\n"+
                               "</code>\n"+
                               "</blockquote>\n\n"+
                               "These are installed by site administrators after noticing that someone is\n"+
                               "posting unrelated links.");
    }
}

String originating_ip = request.getRemoteAddr();
boolean already_submitted_p = false;

%>
    <ad:db_query id="link_insert">
    insert into links
    (page_id, user_id, url, link_title, link_description, contact_p, status,
    originating_ip, posting_time)
    values (
    :page_id, :user_id, :url, :link_title, :link_description, :contact_p, 'live', :originating_ip,SYSDATE)
     <ad:db_bind><%= page_id %></ad:db_bind>     
     <ad:db_bind><%= user.getUserId() %></ad:db_bind>     
     <ad:db_bind><%= url %></ad:db_bind>     
     <ad:db_bind><%= link_title %></ad:db_bind>     
     <ad:db_bind><%= link_description %></ad:db_bind>     
     <ad:db_bind><%= contact_p %></ad:db_bind>     
     <ad:db_bind><%= originating_ip %></ad:db_bind>     
    </ad:db_query>
<%

try {
    db.dml(link_insert);
} catch (Exception e) {
    String count = db.queryToString("select count(*) from links where page_id = :page_id and url=:url", new Object[] { page_id, url });
    if (!count.equals("0")) {
        already_submitted_p = true;
    } else {
        throw new ACSException ("There was an error with the link insert:" + e.getMessage() );
    }
}

String owner = Parameters.get("SystemOwner","staticcontent","");

%>

<ad:db_0or1row id="page_data_get" obj="page_data">
    select nvl(page_title,url_stub) as page_title,
           url_stub, 
           nvl(email,'<%= owner %>') as author_email
      from static_pages, users
     where static_pages.original_author = users.user_id (+)
       and page_id = :page_id
<ad:db_bind><%= page_id %></ad:db_bind>
</ad:db_0or1row>
<ad:if_no_rows><% throw new ACSException("Page id could not be found."); %></ad:if_no_rows>

<%
String author_email = page_data.get("author_email");
String page_title = page_data.get("page_title");
String url_stub = page_data.get("url_stub");
if (!already_submitted_p && Parameters.getBoolean("EmailNewLinks", "links")) {
    String name = user.getFullName();
    String email = user.getEmail();
    String wrapped_link_description = link_description; /* FIXME: wrap_string */
    String adurl = Parameters.get("URL", "");
    String subject = "link added to " + url_stub;
    String email_body = name + "("+email+") added a link to\n"+
        adurl+url_stub+"\n"+
        "("+page_title+"):\n\n"+
        "URL: " + url + "\n"+
        "Title: " + link_title + "\n"+
        "Description: " + wrapped_link_description;
    Log.note("Sending email to: " + author_email + " email: " + email + " subject: " + subject + " body: " + email_body);
    Utilities.sendMail(author_email, email, subject, email_body);
}


%>

<%-- No templat, page is so simple --%>

<ad:header>Link submitted</ad:header>
<h2>Link submitted</h2>

to <a href="<%= url_stub %>"><%= page_title %></a>

<hr> 

The following link is listed as a related link on the page <a href="<%= url_stub %>"><%= page_title %></a> page. 
<blockquote>
<A href="<%= url %>"><%= link_title %></a> - <%= link_description %>
</blockquote>

<ad:footer/>


