<%@ include file="/acs.jspi" %>
<%@ page import="com.arsdigita.acs.news.*, com.arsdigita.acs.generalcomments.*" %>

<ad:page>
<ad:page_contract id="pc" vars="archive_p:optional" />
<ad:get_user_info id="user" redirect="false" />

<%
 // set up scope object that knows how to do access control and
 // query limiting for group-scoped news.
 Scope scope = new Scope(pageContext);
 scope.scopeAuthorize("all", "group_member", "none");

 /* 
   title datasource
   checks value of form variable archive_p
   decides whether this is a "News" or "News Archive" page
 */
 String title = "News";
 if (archive_p!= null && archive_p.equalsIgnoreCase("1")) {
   title = "News Archive";	 
 }
 
 /*
   post_new_link datasource. 
   checks approval policy parameter.
   puts the correct verb (suggest or post) in thelink
   
 */
 String post_new_link = "<li><p><a href=\"post-new?\">suggest an item</a></p>";
  if ( parameters.get("ApprovalPolicy", "news").equals("open")) {
    post_new_link="<li><p><a href=\"post-new?\">post an item</a></p>";
  } else if ( parameters.get("ApprovalPolicy", "news").equals("wait")) {
    post_new_link="<li><p><a href=\"post-new?\">suggest an item</a></p>";
  }

  /* 
    back_link datasource. 
    sets the link to archives or current news at the bottom of the page
  */
 String back_link = "If you're looking for an old news article, <a href=\"index?archive_p=1\">view the message archive</a>";
 if (archive_p!= null && archive_p.equalsIgnoreCase("1")) {
   back_link = "<a href=\"index?\">Return to current messages</a>";	 
 }

 // setup the context bar
 ContextBar navbar = new ContextBar(pageContext); 
 navbar.add(title);
 


 // create clause for sql query to either get archived or current news items
 String archive_clause = "sysdate between release_date and expiration_date";
 if (archive_p!= null && archive_p.equalsIgnoreCase("1")) {
  archive_clause="sysdate > expiration_date";
 }

    // create clause to limit newsgroups to what's appropriate for this user and group.
    StringBuffer sb = new StringBuffer();
    sb.append("scope = 'all_users'");
    if (user != null) {
        sb.append(" or scope = 'registered_users'");
    }
    if (scope.getScope().equals("group")) {
        sb.append(" or (scope = 'group' and group_id = ").append(scope.getGroupId()).append(")");
    } else {
        sb.append(" or scope = 'public'");
    }
    String newsgroupLimitClause = sb.toString();
%>

<ad:db_query id="get_news" obj="news" type="com.arsdigita.acs.news.NewsDataSource">
  select news_item_id, title, 
    to_char(release_date, 'Month, DD, YYYY') as release_date, 
    body, html_p,
    (select count(1)
      from general_comments 
      where on_what_id = news_items.news_item_id
      and on_which_table = 'news_items') as n_comments
  from news_items
  where <%= archive_clause %>
    and approval_state = 'approved'
    and newsgroup_id in (select newsgroup_id from newsgroups where <%= newsgroupLimitClause %>)
  order by release_date desc, creation_date desc
</ad:db_query>

<%
 
 // set some form vars and database handles
 request.setAttribute("archive_p", archive_p);
 request.setAttribute("title", title);
 request.setAttribute("post_new_link", post_new_link);
 request.setAttribute("back_link", back_link);
 request.setAttribute("navbar", navbar);

%>
<ad:use_template />

</ad:page>

