<%@ include file="/acs.jspi" %>
<%@ page import="com.arsdigita.acs.portals.*" %>

<%
  /**
   * www/portals/admin/add-manager-2.jsp
   * 
   * adds a person to the list of portal administrators for the specified group_id
   *
   * @param user_id_from_search user id from the search page
   * @param first_names_from_search user first name from the search page
   * @param last_names_from_search user last name from the search page
   * @param email_from_search user e-mail from the search page
   * 
   * @author aure@arsdigita.com 
   * @author dh@arsdigita.com
   * @creation-date 10/8/1999
   * @cvs-id $Id: add-manager-2.jsp,v 1.3 2000/10/17 17:12:28 luke Exp $
   */
%>

<ad:page>
<ad:page_contract id="pc" vars="user_id_from_search:integer group_id:integer" />

<ad:get_user_info id="user" />

<% 
  Integer userId = user.getUserId();

  // cast the group id here as we'll need the string later
  String groupId = group_id.toString();

  // check if this person is already an administrator of this group
%>

<ad:db_query id="already_admin_p">
	select ad_user_has_role_p ( :user_id_from_search, :group_id, 'administrator' )
          from dual
  <ad:db_bind><%= user_id_from_search %></ad:db_bind>
  <ad:db_bind><%= groupId %></ad:db_bind>
</ad:db_query>

<ad:db_query id="insert_user_role_mapping">
        insert into user_group_map
        (user_id, group_id, role, mapping_user, mapping_ip_address)
        values
        (:user_id_from_search, :group_id, 'administrator', :user_id, :mapping_ip_address)
  <ad:db_bind><%= user_id_from_search %></ad:db_bind>
  <ad:db_bind><%= groupId %></ad:db_bind>
  <ad:db_bind><%= userId %></ad:db_bind>
  <ad:db_bind><%= request.getRemoteAddr() %></ad:db_bind>
</ad:db_query>


<%
    String alreadyAdminP = db.queryToString(already_admin_p);

    if (alreadyAdminP.equals("f")) {
	try {
           db.dml(insert_user_role_mapping);
	} catch(SQLException e) {
	    // Let's see if this was a double-click error
            alreadyAdminP = db.queryToString(already_admin_p);
	    if (alreadyAdminP.equals("f")) {
		// was a real error as the user is still not an admin... throw the exception
	        throw new SQLException(e.getMessage());
            }
        }
    }

    response.sendRedirect("index");
%>


</ad:page>
