<%
/**
 * /portals/admin/index-manager.jsp
 * 
 * Shows managers of several portals a list of their options
 * allows the user to delete managers from this portal group.
 * 
 * @author Aure aure@arsdigita.com 
 * @author Dave Hill dh@arsdigita.com
 * @author Mike Bryzek mbryzek@arsdigita.com (Java port)
 * @cvs-id $Id: index-manager.jsp,v 1.5 2000/10/17 17:12:30 luke Exp $
 * 
*/
%>
 
<%@ include file="/acs.jspi" %>
<%@ page import="com.arsdigita.acs.portals.*" %>

<ad:page>
<ad:get_user_info id="user" />

<%
    Integer userId = user.getUserId();

    // get all the group_ids where this user_id is an administrator of a portal
    // group. First find out how many groups this user can administer.

%>

<ad:db_query id="group_count">
        select count(ug.group_id) 
          from user_groups ug 
         where ad_user_has_role_p( :user_id, ug.group_id, 'administrator' ) = 't' 
           and group_type = 'portal_group'
  <ad:db_bind><%= userId %></ad:db_bind>
</ad:db_query>

<ad:db_query id="group_id">
        select min(ug.group_id) 
          from user_groups ug 
         where ad_user_has_role_p( :user_id, ug.group_id, 'administrator' ) = 't' 
           and group_type = 'portal_group'
  <ad:db_bind><%= userId %></ad:db_bind>
</ad:db_query>

<%
    
    String numberOfGroups = db.queryToString(group_count);

    if (numberOfGroups.equals("0")) {
	// if not an administrator then bounce to the public portals page
	response.sendRedirect(parameters.get("MainPublicURL","portals","/portals/"));
	return;
    }

    if (numberOfGroups.equals("1")) {
	// if not an administrator then bounce to the public portals page
	String groupId = db.queryToString(group_id);
	response.sendRedirect("manage-portal?group_id="+groupId);
	return;
    }

    // Now we know the user is an administrator of multiple groups... display 
    // them all so the user can pick
%>

<ad:db_query id="group_info_select">
        select ug.group_id, ug.group_name
          from user_groups ug 
         where ad_user_has_role_p( :user_id, ug.group_id, 'administrator' ) = 't' 
           and group_type = 'portal_group'
         order by lower(ug.group_name)
  <ad:db_bind><%= userId %></ad:db_bind>
</ad:db_query>

<%
   PortalsDataSource group_info = new PortalsDataSource(group_info_select, db);

   // set up request before including template
   request.setAttribute("group_info", group_info);
   request.setAttribute("db", db);

%>


<ad:use_template />

</ad:page>
