<%
/**
 *  /portals/admin/index.jsp
 * 
 *  Main index paage for the portals administration pages, which will
 *  redirect non-super-administrators to index-manager.tcl
 * 
 *  @author Aure aure@arsdigita.com 
 *  @author Dave Hill dh@arsdigita.com
 *  @cvs-id $Id: index.jsp,v 1.6 2000/10/17 17:12:30 luke Exp $
 */
%>

<%@ include file="/acs.jspi" %>
<%@ page import="com.arsdigita.acs.portals.*" %>

<ad:page>

<%
    UserInfo user = PortalsProcs.checkAdministratorMaybeRedirect(request, response, "", "index-manager");
    AdSet displayInfo = PortalsProcs.getDisplayInfo();

    // ---------------------------------------------------------------
    // Create a display of portals and their administrators (note the decode to
    // easily put super administrators near the bottom of the list
%>

<ad:db_query id="group_id_list"> 
    select ug.group_id, ug.group_name
    from   user_groups ug
    where  ug.group_type = 'portal_group' 
    order by decode(ug.group_name,'Super Administrators','zzzzzsuper administrators',lower(trim(ug.group_name)))
</ad:db_query>

<%
    Vector groupIdList = db.queryToList(group_id_list);
    Enumeration enum = groupIdList.elements();

    String portalTable = "";

    while ( enum.hasMoreElements() ) {
	String groupId = (String) enum.nextElement();
	
	// get the name of the portal group
	String groupName = PortalsProcs.groupName( groupId );

        // get a list of all authorized administrators
%>

<ad:db_query id="indexAdminList">
        select first_names||' '||last_name as name 
        from   users
        where  ad_group_member_p ( user_id, :groupId ) = 't'
  <ad:db_bind><%=groupId%></ad:db_bind>
</ad:db_query>

<%
    
    	Vector adminList = db.queryToList(indexAdminList);

	// special case for super administrators  - they have no portal page and a super administrator
	// may or may not be able to edit the list of super administrators
	String link = "";
	String addRemoveLink = "";
	
	if (! groupName.equals("Super Administrators") ) {
	    link = "<a href=manage-portal?group_id=" + groupId + ">" + groupName + "</a>\n";
	    addRemoveLink = "<a href=add-manager?group_id=" + groupId + ">Add</a> / <a href=delete-manager?group_id=" + groupId + ">Remove</a>";
	} else {
	  link = groupName;
	  if ( parameters.get("SuperAdminCanChangeSuperAdminP","portals","false").equals("true") ) {
  	    addRemoveLink = "<a href=add-manager?group_id=" + groupId + ">Add</a> / <a href=delete-manager?group_id=" + groupId + ">Remove</a>";
	  } else {
	    addRemoveLink = "&nbsp;";
	  }
	}
	
	portalTable += "<tr>\n";
	portalTable += displayInfo.get("NormalTD") + link + "</td>\n";
	portalTable += displayInfo.get("NormalTD") + Utilities.join(adminList, ", ") + " &nbsp;</td>\n";
	portalTable += displayInfo.get("NormalTD") + addRemoveLink + "</td>\n";
	portalTable += "</tr>\n";
    }

    // ------------------------------------------------------------
    // show a list of all tables in the portals


   String title = displayInfo.get("SystemName");
   ContextBar navbar = PortalsProcs.adminContextBar(pageContext, true);

%>

<ad:header><%= title %></ad:header>
<h2><%= title %></h2>
<%= navbar %>
<hr>

<%= displayInfo.get("FontTag") %>
<hr>
<table>
<tr>
<%= displayInfo.get("NormalTD") %>
Choose a group to manage or the edit the administration assignments. 
<p>
<%= displayInfo.get("BeginTable") %>
<tr>
<%= displayInfo.get("HeaderTD") %> GROUP</td>
<%= displayInfo.get("HeaderTD") %> ADMINISTRATORS </td>
<%= displayInfo.get("HeaderTD") %> </td>
</tr>
<%= portalTable %>
<%= displayInfo.get("EndTable") %>

<p>
<a href=create-table>Create a new table</a> or select one of the following portal elements to edit, delete or restore a previous version:
<p>


<ad:db_query id="adminTableList">
    select   pt.table_name, pt.table_id, count(map.table_id) as number_appearances
    from     portal_tables pt, portal_table_page_map map
    where    pt.table_id = map.table_id(+)
    group by pt.table_name, pt.table_id
    order by lower(pt.table_name)
</ad:db_query>

<%= displayInfo.get("BeginTable") %>
<tr>
<%= displayInfo.get("HeaderTD") %> ACTIVE TABLES (# OF APPEARANCES)</td>
<%= displayInfo.get("HeaderTD") %> ACTIONS</td>
</tr>

<ad:db_foreach row="rs" in="adminTableList">
<tr>
  <%= displayInfo.get("NormalTD") %>
      <%=rs.getString("table_name").toUpperCase()%> (<%=rs.getString("number_appearances")%>)
  </td>
  <%= displayInfo.get("NormalTD") %>
      <a href=edit-table?table_id=<%= rs.getString("table_id") %>>Edit</a> /
      <a href=delete-table?table_id=<%= rs.getString("table_id") %>>Delete</a> /
      <a href=restore?table_id=<%= rs.getString("table_id") %>>View Versions</a>
  </td>
</tr>
</ad:db_foreach>
<ad:if_no_rows>
<tr><td colspan=2><b>There are no html tables in the database.</b></td></tr>
</ad:if_no_rows>
    
<%= displayInfo.get("EndTable") %>
<p>
<a href=view-deleted>View deleted tables</a> and optionally restore them.

</td>
</tr>
</table>

<ad:footer/>

</ad:page>
