<%
  /**
   * portals/admin/manage-portal-2.jsp
   *
   * Updates the portal table page map given all of the users changes on manage-portal.tcl's GUI
   *
   * @author aure@arsdigita.com 
   * @author dh@arsdigita.com
   * @param left
   * @param right
   * @param group_id
   * @param hiddennames
   * @creation-date 10/8/1999
   * @cvs-id $Id: manage-portal-2.jsp,v 1.4 2000/10/17 17:12:30 luke Exp $
%>

<%@ include file="/acs.jspi" %>
<%@ page import="com.arsdigita.acs.portals.*" %>

<ad:page>

<ad:page_contract vars="group_id:integer left right hiddennames" /> 

<%

  // ---------------------------------------
  // verify user
  UserInfo user = PortalsProcs.checkAdministratorMaybeRedirect(request, response, group_id);
  Integer userId = user.getUserId();

  Perl5Util re = new Perl5Util();

  // ----------------------------------------
  //  good list is the list of tables on this group's portal pages after update
  Vector goodList = new Vector();
  // page_list is the resulting page_id's of pages having tables after update
  Vector pageList = new Vector();

  Vector leftVector = re.split(left);
  Vector rightVector = re.split(right);

  // Hidden names comes in as {name_1} {name_2} ... {name_n}
  // We remove the leading and trailing brackets then split on "} {"
  hiddennames = re.substitute("s/^\\s*\\{//", hiddennames);
  hiddennames = re.substitute("s/\\}\\s*$//", hiddennames);
  Vector hiddenNames = re.split("/\\} \\{/", hiddennames);

  Log.note("HIDDENNAMES BABY:\n"+hiddenNames.toString());

  String pageName = "";

  int total = leftVector.size();

%>
<ad:db_transaction>
<%

  // We increment in the loop since i is used for a few other things like page numbers
  for ( int i = 0; i < total;  ) {
	if ( Utilities.emptyString( (String) leftVector.elementAt(i) ) ) {
  	    i++;
	    continue;
	}
	Vector leftList = re.split((String) leftVector.elementAt(i));
	Vector rightList;
	if ( i < rightVector.size() ) {
	     rightList = re.split((String) rightVector.elementAt(i));
        } else {
	     rightList = new Vector();
        }
	i++;

        // this will keep track of the portal tables that we saw on this page.
        // anything not in this list at the end of the loop is removed from the
        // portal_table_page_map later.
	goodList.removeAllElements();
	
        // Get page_id for page i
%>

<ad:db_query id="getPageId">
        select page_id 
        from  portal_pages
        where group_id = :group_id
        and   page_number = :i
  <ad:db_bind><%= group_id %></ad:db_bind>
  <ad:db_bind><%= i %></ad:db_bind>
</ad:db_query>

<%
	String pageId = db.queryToString(getPageId, "");

        if ( Utilities.emptyString(pageId) ) {
            // the page is not already in the database
            if ( rightList.size() > 0 || leftList.size() > 0 ) {
                // Stuff is being moved onto this new page - create an entry for it in the database
		pageId = db.queryToString("select portal_page_id_sequence.nextval from dual");
		if ( (i-1) < hiddenNames.size() ) {
	            pageName = (String) hiddenNames.elementAt(i-1);
		} else {
	 	    throw new WarningException("Missing page name", "We're missing the name of page " + i );
   		}
		
%>

<ad:db_query id="insertNewPage">
	insert into portal_pages
	(page_id, group_id, page_number, page_name)
	values
        (:pageId, :group_id, :i, :pageName)
  <ad:db_bind><%= pageId %></ad:db_bind>
  <ad:db_bind><%= group_id %></ad:db_bind>
  <ad:db_bind><%= i %></ad:db_bind>
  <ad:db_bind><%= pageName %></ad:db_bind>
</ad:db_query>

<%
Log.note("db dml - insertnewpage");
		db.dml(insertNewPage);
	    }
        }

        if ( ! Utilities.emptyString(pageId) ) {
            // The page exists in the database

            // Update the name of the pre-existing page
	    pageName = (String) hiddenNames.elementAt(i-1);
	    Log.note("Page name is: " + pageName);
%>

<ad:db_query id="updatePageName">
	    update portal_pages
	    set    page_name = :pageName
	    where  group_id = :group_id
	    and    page_id = :pageId
  <ad:db_bind><%= pageName %></ad:db_bind>
  <ad:db_bind><%= group_id %></ad:db_bind>
  <ad:db_bind><%= pageId %></ad:db_bind>
</ad:db_query>

<%
Log.note("db dml - updatepagename");
	    db.dml(updatePageName);
	
	    pageList.addElement(pageId);

	    // do the left side
            int sortKey = 0;
	    Enumeration leftListEnum = leftList.elements();
	
	    while (leftListEnum.hasMoreElements()) {
		String tableId = (String) leftListEnum.nextElement();
		if (Utilities.emptyString(tableId)) {
		    continue;
		}
		goodList.addElement(tableId);
		sortKey++;                
		Integer sortKeyInteger = new Integer(sortKey);
%>

<ad:db_query id="originalPageIdQuery">
	        select p.page_id 
	        from   portal_pages p, portal_table_page_map m
	        where  group_id = :group_id
                and    page_number = :i
	        and    table_id  = :tableId
	        and    m.page_id = p.page_id
  <ad:db_bind><%= group_id %></ad:db_bind>
  <ad:db_bind><%= i %></ad:db_bind>
  <ad:db_bind><%= tableId %></ad:db_bind>
</ad:db_query>                

<%

		String originalPageId = db.queryToString(originalPageIdQuery,"");

		if (Utilities.emptyString(originalPageId)) {
%>

<ad:db_query id="insertNewPageWithSortKey">
	insert into portal_table_page_map
	(table_id, page_id, sort_key, page_side)
	values
	(:tableId, :pageId, :sortKeyInteger, 'l')
  <ad:db_bind><%= tableId %></ad:db_bind>
  <ad:db_bind><%= pageId %></ad:db_bind>
  <ad:db_bind><%= sortKeyInteger %></ad:db_bind>
</ad:db_query>                

<%
Log.note("db dml - insertnewpagewith sortkey. tableId: "+tableId+", pageid: "+pageId+", sortkey: " +sortKeyInteger);
			db.dml(insertNewPageWithSortKey);
Log.note("db dml - insertnewpagewith sortkey -- done");
 	         } else {
                    // Move this table
%>

<ad:db_query id="updateTableLocation">
	update portal_table_page_map
	set    page_id = :pageId,
               sort_key = :sortKeyInteger,
               page_side = 'l'
      where  table_id = :tableId
	and    page_id = :original_page_id
  <ad:db_bind><%= pageId %></ad:db_bind>
  <ad:db_bind><%= sortKeyInteger %></ad:db_bind>
  <ad:db_bind><%= tableId %></ad:db_bind>
  <ad:db_bind><%= originalPageId %></ad:db_bind>
</ad:db_query>                

<%
			db.dml(updateTableLocation);
		}
   	}

	    // do the right side
            sortKey = 0;
	    Enumeration rightListEnum = rightList.elements();
	
	    while (rightListEnum.hasMoreElements()) {
		String tableId = (String) rightListEnum.nextElement();
		if (Utilities.emptyString(tableId)) {
		    continue;
		}
		goodList.addElement(tableId);
		sortKey++;                
		Integer sortKeyInteger = new Integer(sortKey);
%>

<ad:db_query id="originalPageIdQuery2">
	        select p.page_id 
	        from   portal_pages p, portal_table_page_map m
	        where  group_id = :group_id
                and    page_number = :i
	        and    table_id  = :tableId
	        and    m.page_id = p.page_id
  <ad:db_bind><%= group_id %></ad:db_bind>
  <ad:db_bind><%= i %></ad:db_bind>
  <ad:db_bind><%= tableId %></ad:db_bind>
</ad:db_query>                

<%

		String originalPageId = db.queryToString(originalPageIdQuery2,"");

		if (Utilities.emptyString(originalPageId)) {
%>

<ad:db_query id="insertNewPageWithSortKey2">
	insert into portal_table_page_map
	(table_id, page_id, sort_key, page_side)
	values
	(:tableId, :pageId, :sortKeyInteger, 'r')
  <ad:db_bind><%= tableId %></ad:db_bind>
  <ad:db_bind><%= pageId %></ad:db_bind>
  <ad:db_bind><%= sortKeyInteger %></ad:db_bind>
</ad:db_query>                

<%
			db.dml(insertNewPageWithSortKey2);
 	         } else {
                    // Move this table
%>

<ad:db_query id="updateTableLocation2">
	update portal_table_page_map
	set    page_id = :pageId,
               sort_key = :sortKeyInteger,
               page_side = 'r'
      where  table_id = :tableId
	and    page_id = :original_page_id
  <ad:db_bind><%= pageId %></ad:db_bind>
  <ad:db_bind><%= sortKeyInteger %></ad:db_bind>
  <ad:db_bind><%= tableId %></ad:db_bind>
  <ad:db_bind><%= originalPageId %></ad:db_bind>
</ad:db_query>                

<%
			db.dml(updateTableLocation2);
		}
   	}
    }

    // update the database rep of this portal page.
    // moved it in here because we have to do this page by page, otherwise
    // bugs happen.

    if ( goodList.size() > 0 && pageList.size() > 0 ) {
        // delete tables that didn't appear in our list (hence they were javascript-deleted)
%>

<ad:db_query id="deleteTables">
        delete from portal_table_page_map
        where table_id not in (<%=Utilities.join( goodList, ",")%>)
        and page_id = :pageId
  <ad:db_bind><%=pageId%></ad:db_bind>
</ad:db_query>

<%
        db.dml(deleteTables);
    } 
  
    if ( goodList.size() == 0 && pageList.size() > 0 ) {
        // delete all tables
	db.dml("delete from portal_table_page_map where page_id = :pageId", new Object[] {pageId});
    }
}

%>
</ad:db_transaction>
<%

    // remove orphaned pages with no tables on them
    db.dml("delete from portal_pages where page_id not in (select page_id from portal_table_page_map)");

    /* STILL HAVE TO DO THE CACHE FLUSH STUFF
# ----------------------------------------------------------------------------------
# get all the page_ids for pages with stuff and flush memoization for them

set page_id_list [db_list portals_admin_manage_portal_get_page_id_list "
    select pp.page_id 
    from   portal_pages pp
    where  pp.group_id = :group_id
    and    pp.page_id in (select pm.page_id from portal_table_page_map pm)   
    order by page_number"]

set new_page_number 0
foreach page_id $page_id_list {
    incr new_page_number
    db_dml portals_admin_manage_portal_update_new_page_number "
        update portal_pages
        set page_number = :new_page_number
        where page_id = :pageId "
}

set page_list [db_list portals_admin_manage_portal_list_pages  "
    select page_number 
    from portal_pages 
    where group_id = :group_id"] 

foreach page_number $page_list {
    util_memoize_flush "portal_display_page $group_id $page_number group"
}
  */

   Utilities.sendRedirect(response, "manage-portal?group_id=" + group_id);
%>

</ad:page>
