<%
  /**
   * /portals/admin/manage-portal.jsp
   * 
   * GUI that facilitates page layout
   * 
   * @author Aurelius Prochazka (aure@arsdigita.com)
   * @author David Hill (dh@arsdigita.com)
   * @creation-date 10/8/1999
   * @cvs-id $Id: manage-portal.jsp,v 1.6 2000/10/17 17:12:30 luke Exp $
   */
%>

<%@ include file="/acs.jspi" %>
<%@ page import="com.arsdigita.acs.portals.*" %>

<ad:page>

  <ad:page_contract vars="group_id:integer" /> 

<%
  // ---------------------------------------
  // verify user
  UserInfo user = PortalsProcs.checkAdministratorMaybeRedirect(request, response, group_id);
  Integer userId = user.getUserId();


  // ----------------------------------------
  // set up group specific name
%>

<ad:db_query id="groupAndShortName">
    select ug.group_name, ug.short_name
      from user_groups ug
     where ug.group_id = :group_id
    <ad:db_bind><%= group_id %></ad:db_bind>
</ad:db_query>

<%
   ResultSet rs = db.query(groupAndShortName);
   if (! rs.next()) {
	throw new WarningException("Invalid group id", "The specified group id " + group_id + " could not be found");
   }
   String groupName = rs.getString(1);
   String shortName = rs.getString(2);
   rs.close();   

   // get number of existing pages + 1
%>

<ad:db_query id="getMaxPage">
    select max(page_number)+1 from portal_pages
    where  group_id = :group_id
  <ad:db_bind><%= group_id %></ad:db_bind>
</ad:db_query>

<%
     String maxPage = db.queryToString(getMaxPage);
     if (Utilities.emptyString(maxPage)) {
       maxPage = new String("1");
     }
     
%>

<ad:db_query id="portalTableCount">
	select count(*) from portal_tables
</ad:db_query>

<%
   String total = db.queryToString(portalTableCount);

   // a list of all tables in the portals you don't already have
%>

<ad:db_query id="portalsUnusedTables">
    select   pt.table_name, pt.table_id 
    from     portal_tables pt
    where    pt.table_id not in (select map.table_id from portal_table_page_map map, portal_pages pp
                                 where  pp.group_id = :group_id and map.page_id = pp.page_id)
    order by lower(pt.table_name)
  <ad:db_bind><%= group_id  %></ad:db_bind>
</ad:db_query>

<%
   PortalsDataSource unusedTables = new PortalsDataSource(portalsUnusedTables, db);
%>

<ad:db_query id="onePortalPage">
    select    p_t.table_name, map.page_side, map.table_id, p_p.page_name, p_p.page_number
    from      portal_table_page_map map, portal_tables p_t, portal_pages p_p
    where     p_p.group_id = :group_id
    and       map.page_id = p_p.page_id
    and       map.table_id = p_t.table_id
    order by  p_p.page_number asc, map.page_side, map.sort_key
  <ad:db_bind> <%= group_id %> </ad:db_bind>
</ad:db_query>

<%
   PortalsDataSource onePage = new PortalsDataSource(onePortalPage, db);

   // Set up the last pieces of information we need for the template
   String title = parameters.get("SystemName","portals","Portal") + "Administration for " + groupName;   
   ContextBar navbar = PortalsProcs.adminContextBar(pageContext, title);

   String spaces = "";
   for (int i = 0; i < 30; i++) {
	spaces += "&nbsp;";
   }
   String extraOptions = "";
   for (int i = 0; i < new Integer(total).intValue(); i++) {
	if ( i == 0 ) {
	    extraOptions += "<option value=\"null\">" + spaces + "</option>\n";
	} else {
	    extraOptions += "<option value=\"null\">&nbsp;</option>\n";
	}
    }

   request.setAttribute("title", title);
   request.setAttribute("navbar", navbar);
   request.setAttribute("shortName", shortName);
   request.setAttribute("total", total);
   request.setAttribute("max_page", maxPage);
   request.setAttribute("group_id", group_id.toString());
   request.setAttribute("extraOptions", extraOptions);
   request.setAttribute("onePage", onePage);
   request.setAttribute("unusedTables", unusedTables);
   request.setAttribute("displayInfo", PortalsProcs.getDisplayInfo());


%>

<ad:use_template />

</ad:page>

