<%@ include file="../acs.jspi" %>

<ad:page>
<ad:get_user_info id="user"/>
<ad:page_contract vars="first_names last_name email url screen_name bio return_url:optional" id="pc">
<%
//TODO ad_handle_spammers

if (first_names.equals("")) {
    pc.addComplaint("First name is empty");
}
if (last_name.equals("")) {
    pc.addComplaint("Last name is empty");
}

if (first_names.indexOf('<') >= 0) {
    pc.addComplaint("You can't have a &lt; in your first name because it will look like an HTML tag and confuse other users.");
}

if (last_name.indexOf('<') >= 0) {
    pc.addComplaint(" You can't have a &lt; in your last name because it will look like an HTML tag and confuse other users.");
}

if (!Utilities.emailValidP(email)) {
    pc.addComplaint("The email address that you typed doesn't look right to us.  Examples of valid email addresses are <ul><li>Alice1234@aol.com<li>joe_smith@hp.com<li>pierre@inria.fr</ul>");
}

if (url==null || url.equals("http://") ) {
    // the user left the default hint for the url
    url = "";
    pageContext.setAttribute("url", "");
}

if (!Utilities.emptyString(url) && !Utilities.URLValidP(url)) {
    // there is a URL but it doesn't match our REGEXP
    pc.addComplaint("You URL doesn't have the correct form.  A valid URL would be something like \"http://photo.net/philg/\".");
}

if (!Utilities.emptyString(bio) && (bio.length() >= 4000)) {
    pc.addComplaint("Your biography is too long.  Please limit it to 4000 characters.");
}

if (!Utilities.emptyString(screen_name)) {
    String sn_unique = db.queryToString("select count(*) from users where screen_name = :screen_name and user_id != :user_id",
                                        new Object[] { screen_name, user.getUserId() });
    if (!sn_unique.equals("0")) {
        pc.addComplaint("The screen name you have selected is already taken.");
    }
}

String email_unique = db.queryToString("select count(*) from users where upper(email) = upper(:email) and user_id != :user_id",
                                        new Object[] { email, user.getUserId() });
if (!email_unique.equals("0")) {
    pc.addComplaint("The email address you have selected is already taken.");
}
%>
</ad:page_contract>


<ad:db_query id="user_info_update">
    update users
    set first_names = :first_names,
    last_name = :last_name,
    email = :email,
    url = :url,
    screen_name=:screen_name,
    bio=:bio
    where user_id = :user_id
<ad:db_bind><%= first_names %></ad:db_bind>
<ad:db_bind><%= last_name %></ad:db_bind>
<ad:db_bind><%= email %></ad:db_bind>
<ad:db_bind><%= url %></ad:db_bind>
<ad:db_bind><%= screen_name %></ad:db_bind>
<ad:db_bind><%= bio %></ad:db_bind>
<ad:db_bind><%= user.getUserId() %></ad:db_bind>
</ad:db_query>

<%

db.dml(user_info_update);
pageContext.getSession().removeAttribute("user_info");

if (return_url != null ) {
    response.sendRedirect(return_url);
} else {
    response.sendRedirect("home");
}

%> 
