<%@ include file="../acs.jspi" %>

<ad:page>

<ad:get_user_info id="user"/>

<% 
Integer user_id = user.getUserId();

/* If there are requirements to fulfill */
String req = db.queryToString("select user_fulfills_requirements_p(:user_id) from dual", new Object[] { user_id });
if (req.equals("f")) {
    response.sendRedirect("fulfill-requirements");
    return;
}

/* if this user is part of intranet employees, send 'em over! */
/* TODO: WRITE ME WHEN INTRANET IS WORKING */
String system_name = Parameters.get("SystemName", "", "this server");
String title = user.getFullName() + "'s workspace at " +system_name;
ContextBar navbar = new ContextBar(); 
navbar.add("Your workspace");

request.setAttribute("user", user);
request.setAttribute("title", title);
request.setAttribute("navbar", navbar);
request.setAttribute("system_name", system_name);
%>

<%-- SETUP DATA SOURCES --%>

<ad:db_0or1row id="pvt_home_user_info" obj="user_info">
    select first_names, last_name, email, url, 
    nvl(screen_name,'&lt none set up &gt') as screen_name, bio
    from users 
    where user_id=:user_id
<ad:db_bind><%= user_id %></ad:db_bind>
</ad:db_0or1row>
<ad:if_no_rows><% throw new WarningException("Account Unavailable", "We can't find you (user #"+user_id+" in the users table. Probably your account was deleted for some reason.  You can visit <a href=\"/register/logout\">the log out page</a> and then start over."); %></ad:if_no_rows>

<ad:db_0or1row id="pvt_home_portrait_info" obj="portrait_info">
       select portrait_id, portrait_upload_date, portrait_client_file_name
        from general_portraits 
        where on_what_id = :user_id 
        and upper(on_which_table) = 'USERS'
        and approved_p = 't'
        and portrait_primary_p = 't'
<ad:db_bind><%= user_id %></ad:db_bind>
</ad:db_0or1row>

<ad:db_query id="pvt_home_content_sections_list" obj="content_sections">
    select section_id, section_url_stub, section_pretty_name, intro_blurb, help_blurb
    from content_sections
    where enabled_p = 't'
    and scope='public'
    order by sort_key, upper(section_pretty_name)
</ad:db_query>

<ad:db_query id="pvt_home_administration_group_info" obj="admin_groups">
    select ug.group_id, ug.group_name, ai.url as ai_url
    from  user_groups ug, administration_info ai
    where ug.group_id = ai.group_id
    and ad_group_member_p ( :user_id, ug.group_id ) = 't'
<ad:db_bind><%= user_id %></ad:db_bind>
</ad:db_query>

<ad:db_query id="pvt_home_non_administration_info" obj="non_admin_groups">
    select ug.group_id, ug.group_name, ug.short_name
    from user_groups ug
    where ug.group_type <> 'administration'
    and ad_group_member_p ( :user_id, ug.group_id ) = 't'
<ad:db_bind><%= user_id %></ad:db_bind>
</ad:db_query>

<ad:db_query id="pvt_home_categories_list" obj="categories">
    select c.category, c.category_id, 
    decode(ui.category_id,NULL,NULL,'t') as selected_p
    from categories c, (select * 
			from users_interests 
			where user_id = :user_id 
			and interest_level > 0) ui
    where c.enabled_p = 't' 
    and c.category_id = ui.category_id(+)
<ad:db_bind><%= user_id %></ad:db_bind>
</ad:db_query>


<ad:use_template/>
