<%@ include file="/acs.jspi" %>

<ad:page>

<ad:get_user_info id="user"/>

<ad:page_contract id="pc" vars="portrait_comment:optional,html return_url:optional upload_file:file"/>

<ad:db_query id="get_portrait_id">
   select portrait_id
     from general_portraits
    where on_what_id = :user_id
      and on_which_table = 'USERS' 
      and approved_p = 't'
      and portrait_primary_p = 't'
<ad:db_bind><%= user.getUserId() %></ad:db_bind>
</ad:db_query>

<%
Log.warn("Here1:" + upload_file_tmpfile);
String portrait_id = db.queryToString(get_portrait_id, "");
boolean add_p = (portrait_id.equals("")) ? true : false;

Perl5Util re =  new com.oroinc.text.perl.Perl5Util();

File uploadFile = new File(upload_file_tmpfile);

String fileExt = "";
if ( re.match("/(\\.[^\\.]+)/", upload_file) )
    fileExt = re.group(1).toLowerCase();

String guessed_file_type =
    (getServletContext().getMimeType(upload_file) == null)?"":getServletContext().getMimeType(upload_file);

long n_bytes = uploadFile.length();

Vector mime_types = parameters.getVector("AcceptablePortraitMIMETypes", "general-portraits");
if (mime_types != null && mime_types.size() != 0) {
    boolean found_ok = false;
    for (int i = 0; i<mime_types.size(); i++) {
        String mtype = (String)mime_types.elementAt(i);
        if (mtype.equals(guessed_file_type)) {
            found_ok = true;
            break;
        }
    }
    if (!found_ok) {
        throw new ACSException("Your image wasn't one of the acceptable MIME types:   " + Utilities.join(mime_types, ", "));
    }
}

// strip off the C:\directories... crud and just get the file name
String client_filename = upload_file;
if (re.match("@([^//\\\\]+)$@", upload_file))
    client_filename = re.group(1);

int max_n_bytes = parameters.getInt("MaxPortraitBytes", "general-portraits", -1);
if ( max_n_bytes != -1 && n_bytes > max_n_bytes ) {
    throw new ACSException("Your file is too large.  The publisher of " + parameters.get("SystemName","","this system") + "has chosen to limit portraits to " + max_n_bytes + " bytes.  You can use PhotoShop or the GIMP (free) to shrink your image.\n");
}

if ( n_bytes == 0 ) {
    Vector v = new Vector();
    v.add("Your file is zero-length. Either you attempted to upload a zero length file, a file which does not exist, or something went wrong during the transfer.");
    throw new PageValidationException(v);
}

// all this just to find the image size:
int original_height = -1;
int original_width = -1;
if ( guessed_file_type.equals("image/gif") || guessed_file_type.equals("image/jpeg") ) {
    try {
	Utilities.copyFile(uploadFile, new java.io.File("/tmp/myFile.jpg"));

	ImageSize imageSize = new ImageSize("/tmp/myFile.jpg");
	original_width = imageSize.getWidth();
	original_height = imageSize.getHeight();
    } catch (Exception e) {
	Log.error("get image size failed: " + e.getMessage());
    } 
}

String approved_policy = parameters.get("DefaultUploadApprovalPolicy", "general-portraits", "");
String approved_p = approved_policy.equals("open") ? "t" : "f";
// Various complex code to do thumbnails.  TODO: Do this
%>

<ad:db_query id= "portrait_insert">
  begin
   insert into general_portraits
      (portrait_id, on_which_table, on_what_id, upload_user_id, portrait_comment, portrait_upload_date, portrait,
       portrait_client_file_name, portrait_file_type, portrait_file_extension, 
       portrait_original_width, portrait_original_height, approved_p, portrait_primary_p)
   values
      (general_portraits_id_seq.nextval, 'USERS', :user_id, :user_id, :complete_portrait_comment, sysdate, empty_blob(),
       :client_filename, :guessed_file_type, 
       :file_extension, :portrait_original_width, :portrait_original_height, :approved_p, 't') returning portrait into :1;
  end;
<ad:db_bind><%= user.getUserId() %></ad:db_bind>
<ad:db_bind><%= user.getUserId() %></ad:db_bind>
<ad:db_bind><%= portrait_comment %></ad:db_bind>
<ad:db_bind><%= client_filename %></ad:db_bind>
<ad:db_bind><%= guessed_file_type %></ad:db_bind>
<ad:db_bind><%= fileExt %></ad:db_bind>
<ad:db_bind><%= original_width %></ad:db_bind>
<ad:db_bind><%= original_height %></ad:db_bind>
<ad:db_bind><%= approved_p %></ad:db_bind>
</ad:db_query>

<ad:db_query id= "portrait_update">
  begin
       update general_portraits
       set portrait = empty_blob(),
	   portrait_comment = :complete_portrait_comment,
	   portrait_client_file_name = :client_filename,
	   portrait_file_type = :guessed_file_type,
	   portrait_file_extension = :file_extension,
	   portrait_original_width = :portrait_original_width,
	   portrait_original_height = :portrait_original_height,
	   portrait_upload_date = sysdate
       where portrait_id = :portrait_id
       returning portrait into :1;
  end;
<ad:db_bind><%= portrait_comment %></ad:db_bind>
<ad:db_bind><%= client_filename %></ad:db_bind>
<ad:db_bind><%= guessed_file_type %></ad:db_bind>
<ad:db_bind><%= fileExt %></ad:db_bind>
<ad:db_bind><%= original_width %></ad:db_bind>
<ad:db_bind><%= original_height %></ad:db_bind>
<ad:db_bind><%= portrait_id %></ad:db_bind>
</ad:db_query>

<%
if (add_p) {
    db.blobDmlFile(portrait_insert,uploadFile);
} else {
    db.blobDmlFile(portrait_update,uploadFile);
}

if (!Utilities.emptyString(return_url)) {
    response.sendRedirect(return_url);
} else {
    response.sendRedirect("index");
}

%>


