<%@ include file="/acs.jspi" %>

<ad:page>
<ad:page_contract id="pc" vars="user_id email password password_confirmation first_names last_name url return_url:optional"> 

<%
//TODO ad_handle_spammers

if (first_names.equals("")) {
    pc.addComplaint("First name is empty");
}
if (last_name.equals("")) {
    pc.addComplaint("Last name is empty");
}

if (first_names.indexOf('<') >= 0) {
    pc.addComplaint("You can't have a &lt; in your first name because it will look like an HTML tag and confuse other users.");
}

if (last_name.indexOf('<') >= 0) {
    pc.addComplaint(" You can't have a &lt; in your last name because it will look like an HTML tag and confuse other users.");

}


if (!password.equals(password_confirmation)) {
    pc.addComplaint("Your two password entries do not match.");
}

if (url==null || url.equals("http://") ) {
    // the user left the default hint for the url
    url = "";
    pageContext.setAttribute("url", "");
}

if (url!="" && !Utilities.URLValidP(url)) {
    // there is a URL but it doesn't match our REGEXP
    pc.addComplaint("You URL doesn't have the correct form.  A valid URL would be something like \"http://photo.net/philg/\".");
}
%>
</ad:page_contract>

<%

/* 
   We've checked everything.
   If we have an error, return error page, otherwise, do the insert
*/ 

String user_state = "authorized";

if (parameters.getBoolean("RegistrationRequiresApprovalP", "", false) && 
   parameters.getBoolean("RegistrationRequiresEmailVerificationP", "", false)) {
     user_state = "need_email_verification_and_admin_approv";
} else if (parameters.getBoolean("RegistrationRequiresApprovalP", "", false)) {
     user_state = "need_admin_approv";
} else if (parameters.getBoolean("RegistrationRequiresEmailVerificationP", "",false)) {
     user_state = "need_email_verification";
} else {
     user_state = "authorized";
}

// Autogenerate a password
if  (parameters.getBoolean("RegistrationProvidesRandomPasswordP", "",false)) {
    password = Utilities.generateRandomString();    
}

// If we are encrypting passwords in the database, convert
String password_for_database;
if (parameters.getBoolean("EncryptPasswordsInDBP", "", false)) { 
    password_for_database = Crypt.crypt(password, parameters.get("EncryptPasswordsSalt", "","ab"));
} else {
    password_for_database = password;
}

String peeraddr = request.getRemoteAddr();
%>

<ad:db_query id="user_insert">
insert into users 
(user_id,
 email,
 password,
 first_names,
 last_name,
 url,
 registration_date,
 registration_ip, 
 user_state, 
 last_visit) 
values 
(:user_id,
 :email,
 :password_for_database,
 :first_names,
 :last_name,
 :url, 
  sysdate, 
 :peeraddr, 
 :user_state, 
  sysdate)
<ad:db_bind><%= user_id %></ad:db_bind>
<ad:db_bind><%= email %></ad:db_bind>
<ad:db_bind><%= password_for_database %></ad:db_bind>
<ad:db_bind><%= first_names %></ad:db_bind>
<ad:db_bind><%= last_name %></ad:db_bind>
<ad:db_bind><%= url %></ad:db_bind>
<ad:db_bind><%= peeraddr %></ad:db_bind>
<ad:db_bind><%= user_state %></ad:db_bind>
</ad:db_query>


<%
// let's look for other required tables
Vector insertStatementsSup = new Vector();

// need $user_id below because we want to pull that literal value out of dual.

//TODO : warning untested code
Vector otherTables= parameters.getVector("RequiredUserTable",null);
if (otherTables != null) {
    for (int i=0; i< otherTables.size(); i+=1) {
	insertStatementsSup.add(new String("insert into " + otherTables.elementAt(i) + " (user_id) select " + user_id + " from dual where not exists (select user_id from " + otherTables.elementAt(i) + " where user_id = " + user_id));
    }
}

db.dml(user_insert);

/*
set double_click_p 0
set failed_transaction_p 0

db_transaction {
    db_dml user_new_2_user_insert $insert_statement 
} on_error {
    if { [db_string user_new_2_user_count {
	select count(user_id) 
	from   users 
	where  user_id = :user_id
    }] == 0 } {
	db_release_unused_handles
	ad_return_error "Insert Failed" "We were unable to create your user record in the database."
	ns_log Error "Error insert new user: $errmsg"
	# slightly nicer than return.
	ad_script_abort 
    } else {
	# assume this was a double click
	set double_click_p 1
    }
}


if { $double_click_p == 0 } {
    db_transaction {
	foreach statement $insert_statements_sup {
	    db_dml user_new_user_insert_supplement_tables $statement
	}
    } on_error {
	db_release_unused_handles
	ad_return_error "Insert Failed" "We were unable to create your user record in the database.  Here's what the error looked like:
	<blockquote>
	<pre>
	$errmsg
	</pre>
	</blockquote>"
	ad_script_abort
    }
}

*/

UserInfo user = new UserInfo(user_id);
if  (user_state.equals("authorized")) {
    // user is ready to go
    
    // we have to be careful here with the password; we put a string-trimmed
    // version into the RDBMS so we must do the same here
    //set trimmed_password [string trim $password]
    session.setAttribute("user_info", user);
    if (return_url != null) {
       Utilities.sendRedirect(response, return_url);
       return;
    }
    Utilities.sendRedirect(response, "/pvt/home");
    return;
}
%>
} else if ( parameters.getBoolean("RegistrationRequiresEmailVerificationP", "", false)) { 

    // this user won't be able to use the system until he has answered his email
    // so don't give an auth cookie, but instead tell him 
    // to read your email

[ad_header "Please read your email"]

<h2>Please read your email</h2>

<hr>

Registration information for this service has been
sent to $email.
<p>
Please read and follow the instructions in this email.

[ad_footer]
"

} else if (parameters.getBoolean("RegistrationRequiresApprovalP", "", false)) {

    /* 
     this user won't be able to use the system until an admin has
     approved him, so don't give an auth cookie, but instead tell him 
     to wait
    */

[ad_header "Awaiting Approval"]

<h2>Awaiting Approval</h2>

<hr>

Your registration is in the database now.  A site administrator has
been notified of your request to use the system.  Once you're
approved, you'll get an email message and you can return to
[ad_site_home_link] to use the service.

[ad_footer]
"
} 

String notificationAddress = parameters.get("NewRegistrationEmailAddress", "", "");

if (parameters.getBoolean("NotifyAdminOfNewRegistrationsP", "", false)) {
    // we're supposed to notify the administrator when someone new registers
    ns_sendmail $notification_address $email "New registration at [ad_url]" "
$first_names $last_name ($email) registered as a user of 
[ad_url]
"
}

if { !$double_click_p } {   
    if { [ad_parameter RegistrationRequiresEmailVerificationP "" 0] } {
	set row_id [db_string user_new_2_rowid_for_email "select rowid from users where user_id = :user_id"]
	# the user has to come back and activate their account
	ns_sendmail $email $notification_address "Welcome to [ad_system_name]" "To confirm your registration, please go to [ad_parameter SystemURL]/register/email-confirm.tcl?[export_url_vars row_id]"
    } elseif { [ad_parameter RegistrationProvidesRandomPasswordP "" 0] ||  [ad_parameter EmailRegistrationConfirmationToUserP "" 0] } {
	with_catch errmsg {
	    ns_sendmail $email $notification_address "Thank you for visiting [ad_system_name]" "Here's how you can log in at [ad_url]:
Username:  $email
Password:  $password
"
	} {
	    ns_returnerror "error" "$error"
	    ns_log Warning "Error sending registration confirmation to $email in user-new-2.tcl"
	}
    }
}

