<%--    Searches the site

    @creation-date 2000-08-01
    @cvs-id 
--%>

<%@ include file="../acs.jspi" %>
<%@ page import="com.arsdigita.acs.search.*" %>

<ad:page>
<ad:page_contract id="pc" vars="query_string sections:multiple rows:optional"/>
<ad:get_user_info id="user" redirect="false"/>


<%
String display = Security.getClientProperty(pageContext, "search", "display_by_section_or_one_list", "by_section", true);
String num_results = Security.getClientProperty(pageContext, "search", "num_of_results_to_display", "50", true);

if (rows != null) {
    num_results = rows.toString();
}
String rowcount_clause = "and RowNum <= " + num_results;
if (num_results.equals("0") || num_results.equals("all")) {
   rowcount_clause = "";
}

sections = Search.returnValidTables(user, sections);
String sections_string = "";
for (int i = 0; i<sections.length; i++) {
    sections_string += "&sections=" + sections[i];
}

String results_base_url = Parameters.get("BounceQueriesTo", "site-wide-search");


String sections_clause = "";
if (sections.length == 1) {
    if ( sections[0].equals("fs_versions") ) {
        sections_clause = " and sws.table_name = ''";
    } else {
        sections_clause = " and sws.table_name = '" + sections[0] + "'";
    }
} else {
    Vector quoted_sections = new Vector();
    for (int i = 0; i<sections.length; i++) {
        if ( !sections[i].equals("fs_versions") ) {
            quoted_sections.add("'"+sections[i]+"'");
        } 
    }
    sections_clause = "and sws.table_name in (" + Utilities.join(quoted_sections, ", ") + ")";
}

String final_query_string = null;
try {
    final_query_string = db.queryToString("select im_convert(:query_string) from dual", new Object[] {query_string});
}  catch (SQLException sqle) { 
    throw new WarningException("Query Failed", "Query failed; you probably don't have site-wide-search installed.");
}

ContextBar navbar = new ContextBar(pageContext);
navbar.add("index", "Search");
navbar.add("Results");

String user_id = (user == null) ? "0" : user.getUserId().toString();
%>

<%-- This is the normal query, note that it is not executed yet --%>
<ad:db_query id="search_select_normal">
        select /*+ FIRST_ROWS */ score(10) as the_score, 
                        section_name, 
                        user_url_stub, 
                        the_key, 
                        one_line_description, 
                        sws.table_name,
                        RowNum
	from site_wide_index sws, sws_properties p
	where sws.table_name = p.table_name 
        and contains(sws.datastore, '({<%= query_string %>} within oneline)*6, <%= final_query_string %>', 10) > 0
	and sws_general_permissions(sws.user_id, sws.group_id, sws.scope, :user_id)='t'
        <%= rowcount_clause %>
        <%= sections_clause %>
	order by 1 desc
<ad:db_bind><%= user_id %></ad:db_bind>
</ad:db_query>

<%
int results_displayed = 0;
StringBuffer search_results = new StringBuffer();
if (!display.equals("by_section")) {
    SearchDataSource sds = new SearchDataSource(search_select_normal, db, 1000);
    
    while (sds.next()) {
        results_displayed++;
        search_results.append("<li><a href=\"");
        search_results.append(results_base_url);
        search_results.append(sds.getUserUrlStub());
        search_results.append(sds.getTheKey());
        search_results.append("\">");
        search_results.append(sds.getOneLineDescription());
        search_results.append("</a>\n");
        if (sections.length > 1 && display.equals("one_list")) {
            search_results.append("<font size=-1>(");
            search_results.append(sds.getSectionName());
            search_results.append(")</font>\n");
        }
    }
} else {
   /* Do by section wedges */
    for (int i = 0; i<sections.length; i++) {
        String section = sections[i];
%>
        <ad:db_query id="search_select_fs">
                   SELECT /*+ FIRST_ROWS */ SCORE(10) AS the_score, section_name, user_url_stub, f.file_id as the_key, f.file_title as one_line_description, RowNum 
                   from fs_files f, fs_versions v, sws_properties sws
                   where v.file_id=f.file_id
                   and sws.table_name=:section
                   and deleted_p='f'
                   and contains(v.version_content,'<%= final_query_string%>',10)>0  
                   <%= rowcount_clause %>
                   order by 1 desc
                   <ad:db_bind><%= section %></ad:db_bind>
        </ad:db_query>
        <ad:db_query id="search_select_other">
                   select /*+ FIRST_ROWS */ score(10) as the_score, section_name, user_url_stub, the_key, one_line_description, sws.table_name, RowNum
                   from site_wide_index sws, sws_properties p
                   where sws.table_name = p.table_name
                   and p.table_name=:section 
                   and contains(sws.datastore, '({<%= query_string %>} within oneline)*6, <%= final_query_string %>', 10) > 0
                   and sws_general_permissions(user_id,group_id,scope,:user_id)='t'
                   <%= rowcount_clause %>
                   order by 1 desc 
                   <ad:db_bind><%= section %></ad:db_bind>
                   <ad:db_bind><%= user_id %></ad:db_bind>
        </ad:db_query>
<%        
        /* Note that the above ad:db_query's don't execute till used as a DataSource */
        SearchDataSource sds;
        if (section.equals("fs_versions")) {
            sds = new SearchDataSource(search_select_fs, db, 1000);
        } else {
            sds = new SearchDataSource(search_select_other, db, 1000);
        }

        int section_counter = 0;
        while (sds.next()) {
            section_counter++;
            results_displayed++;
            if (section_counter == 1) {
                search_results.append("<h3>").append(sds.getSectionName()).append("</h3>");
            }
            search_results.append("<li><a href=\"");
            search_results.append(results_base_url);
            search_results.append(sds.getUserUrlStub());
            search_results.append(sds.getTheKey());
            search_results.append("\">");
            search_results.append(sds.getOneLineDescription());
            search_results.append("</a>\n");
        }
    /* End of for loop. */
    }
/* End of if/else. */
}

if (results_displayed == 0) {
    search_results.append("No hits found for your query.");
}

Search.recordQueryString(query_string, Utilities.join(sections, " "), results_displayed, user);

request.setAttribute("navbar", navbar);
request.setAttribute("query_string", query_string);
request.setAttribute("search_results", search_results.toString());
request.setAttribute("num_results_bar", Search.showNumResultsBar(num_results, display, query_string, sections_string));
request.setAttribute("search_widget", Search.siteWideSearchWidget(user, query_string));
%>

<ad:use_template/>
</ad:page>
