<%--
# /www/shared/community-member.tcl

ad_page_contract {
    shows User A what User B has contributed to the community
    
    March 9, 2000: 
    February 1, 2000: Added check so that if this is an IntranetEnabled acs,
    we only only authorized intranet users to view community members other
    than themselves
    March 1, 1999:  philg edited this to suppress display of links that weren't live
    September 26, 1999:  philg added display of user-uploaded portraits
    November 1, 1999: philg trashed 90% of the code and replaced it with
    a call to ad_summarize_user_contributions

    @param user_id defaults to currently logged in user if there is one

    @cvs-id $Id: community-member.jsp,v 1.2 2000/10/20 04:43:06 jbank Exp $
--%>

<%@ include file="/acs.jspi" %>

<ad:page>
<ad:page_contract vars="user_id:integer,optional"/>

<ad:get_user_info id="user" redirect="false"/>

<% 
if (user_id==null) {
	if (user != null) { 
		user_id = user.getUserId();
	} else {
		throw new WarningException("No user_id supplied", "We need a user_id to display the community page");
	}
}
%>

<ad:db_0or1row id="getUserInfo" obj="userInfo">
select u.first_names, u.last_name, u.email, u.priv_email, 
  u.url, u.banning_note, 
 to_char(u.registration_date, 'Month fmdd, yyyy') as pretty_registration_date,
 u.user_state, u.bio,
   gp.portrait_id,
   gp.portrait_upload_date, gp.portrait_original_width, gp.portrait_original_height, 
   gp.portrait_client_file_name,
   gp.portrait_thumbnail_width, gp.portrait_thumbnail_height
from users u, general_portraits gp
where u.user_id=:user_id and
 gp.on_what_id(+) = u.user_id and
 gp.on_which_table = 'USERS' and
 gp.approved_p = 't' and
 gp.portrait_primary_p = 't'
<ad:db_bind><%= user_id %></ad:db_bind>
</ad:db_0or1row>

<ad:if_no_rows>
<% if (true) throw new PageValidationException("There is no community member with the user_id of " + user_id); %>
</ad:if_no_rows>

<%
ContextBar navbar = new ContextBar(ContextBar.PERSONAL_OR_INDEX, user);
navbar.add("Community member");
request.setAttribute("navbar", navbar);
if (user != null) 
 request.setAttribute("user", user);
request.setAttribute("user_id",user_id);
%>

<ad:use_template/>
</ad:page>




