<%@ include file="../../../acs.jspi" %>

<ad:template_contract vars="object_name return_url permissions:datasource grant_permission_to_user_link grant_permission_to_group_link return_url_save navbar table_data:datasource column_data:datasource column_values:datasource"/>

<html>
<head>
<title>Administer Permissions</title>
<style type=text/css>
BODY {
  background-color: #FFFFFF;
  color: #000000
}

TH {
  background-color: #C0C0C0;
  color: #000000
}

TH.def {
  background-color: #FFFFFF;
  color: #000000
}

TR.odd {
  background-color: #FFFFFF;
  color: #000000
}

TR.even {
  background-color: #D0D0D0;
  color: #000000
}
</style>
</head>

<body>

<ad:scope sources="table_data">
<h2>Administer Permissions for a <ad:sub var="pretty_table_name_singular"/></h2>

<%= navbar %>

<hr>

<table>
<ad:loop ds="column_data">
 <tr><th class=def align=left><ad:sub var="column_pretty_name"/> 
     <td><%= column_values.get(column_data.get("column_name")) %>
 </tr>
</ad:loop>
</table>

<blockquote>

<table cellpadding=3>
<tr>
 <th>Scope</th>
 <th>Read?</th>
 <th>Comment?</th>
 <th>Write?</th>
 <th>Administer?</th>
</tr>

<% 
String row_class = "odd"; 
String permission_types[] = new String[] {"read", "comment", "write", "administer"};
%>

<ad:loop ds="permissions">
 <tr class=<%= row_class %>>
  <td><ad:sub var="permission_owner"/></td>
  <% for (int i = 0; i < permission_types.length; i++) { 
	// Read the value of "<permission_type>_permission_p" into a
	// generically-named variable.
	String permission_p = permissions.get(permission_types[i] + "_permission_p");
  %>

   <td align=center><%= Utilities.prettyBoolean(permission_p) %> (<a href="permission-toggle?permission_type=<%=permission_types[i] %>&<%= Utilities.exportURLVars(request, "on_what_id on_which_table object_name return_url") %>&<ad:export type="url" source="permissions" vars="scope user_id group_id role"/>"><%= permission_p.equals("t")? "revoke" : "grant" %></a>)</td>
  <% } %>

 </tr>
<% row_class = row_class.equals("odd")? "even": "odd"; %>
</ad:loop>
<ad:loop_empty>
 <tr><td>NO ROWS!</tr>
</ad:loop_empty>

</table>

<ul>
<li><%= grant_permission_to_user_link %>
<li><%= grant_permission_to_group_link %>
<li>Go <a href="<%= return_url_save %>">back</a> to where you were
</ul>

</blockquote>

<ad:footer/>
</ad:scope>