<%@ include file="/acs.jspi" %>

<ad:template_contract vars="title groups:class=GroupDataSource groupType:class=GroupTypeDataSource memberFields:class=MemberField groupFields:class=GroupField">

<ad:header><%= title %></ad:header>
<h2><%= title %></h2>

<h3>User groups in <%= title %></h3>

<ul>
<ad:loop ds="groups">
<li>
<a href="group?group_id=<%= groups.getGroupId() %>">
<%= groups.getGroupName() %></a>
</ad:loop>
<ad:loop_empty> 
 (no groups defined)
</ad:loop_empty>
<br>
<br>
<li><a href=group-new-2?group_type=<%= groupType.getGroupType() %>>create a new <%= title %></a>
</ul>

<h3>Properties of this type of group</h3>
<ul>
<li>Pretty Name: "<%= groupType.getPrettyName() %>" 
(plural: "<%= groupType.getPrettyPlural() %>")
<li>Approval Policy (how new groups get created): <%= groupType.getApprovalPolicy() %>
<li>Default New Member Policy (how users will join groups of this type): <%= groupType.getDefaultNewMemberPolicy() %>
<li>Group Module Administration: <%= groupType.getPrettyGroupModuleAdministration() %>
<br>
<br>
(<a href=group-type-edit?group_type=<%= groupType.getGroupType() %>>edit</a>)
</ul>

<h3>Data that we collect for this type of group</h3>
<ul>
<table width=80%>
<ad:loop ds="groupFields">
 <tr>
   <td><%= groupFields.getColumnName() %>(<%= groupFields.getPrettyName() %>),
     <%= groupFields.getColumnActualType() %> (<%= groupFields.getColumnType() %>)
     <%= groupFields.getColumnExtra() %>
 </tr>
</ad:loop>
<ad:loop_empty>
   <tr><td>no group-specific data currently collected
</ad:loop_empty>
</table>
<p><li><a href=field-add?group_type=<%= groupType.getGroupType() %>>add a field</a>
</ul>

<h3>Data that we collect for each user of this type of group</h3>
<ul>
<table width=80%>
<ad:loop ds="memberFields">
<tr>
 <td><%= memberFields.getFieldName() %> (<%= memberFields.getFieldType() %>)
</tr>
</ad:loop>
<ad:loop_empty>
   <tr><td>No group-type-specific member data currently collected.
</ad:loop_empty>
</table>
<p><li><a href=group-type-member-field-add?group_type=<%= groupType.getGroupType() %>>add a field</a>
</ul>

<h3>Extreme Actions</h3>
<ul>
<form method=post action="group-type-delete">
 <input type=submit value="Delete This Group Type">
 <input type=hidden name=group_type value=<%= groupType.get("group_type") %>>
</form>
</ul>

<ad:footer />