<%@ include file="/acs.jspi" %>

<ad:template_contract vars="group:class=GroupDataSource navbar supplemental_data:optional,datasource member_fields_from_group_type:class=MemberField member_fields_from_group:class=MemberField member_field_count:class=Integer pending_users:datasource members:datasource group_id:class=Integer group_module_administration modules_available modules:datasource" />

<ad:header><%= group.getGroupName() %></ad:header>
<h2><%= group.getGroupName() %></h2>
<%= navbar %>

<hr>

<p>

<ul>

<li>Created by <a href="/shared/community-member?user_id=<%= group.get("creation_user") %>"><%= group.get("first_names") %> <%= group.get("last_name") %></a> on <%= group.get("pretty_date") %>

<li><form action=new-member-policy-update method=post>
New Member Policy: <select name=new_member_policy>
 <%= HtmlWidgets.htmlOptions(new String[] { "open", "wait", "closed" },
                          new String[] { "open", "wait", "closed" },
                          group.get("new_member_policy")) %>
</select>
<input type=hidden name=group_id value=<%= group_id %>>
<input type=submit name=submit value="Edit">
<p>
</form>

<li><form action=spam-policy-update method=post>
Group Spam Policy: 
<select name=spam_policy>
 <%= HtmlWidgets.htmlOptions(new String[] { "open", "wait", "closed" },
                          new String[] { "open", "wait", "closed" },
                          group.get("spam_policy")) %>
</select>
<input type=hidden name=group_id value=<%= group_id %>>
<input type=submit name=submit value="Edit">
<p>
</form>

<li>Send email to admins on new membership request:
<%= Utilities.prettyBoolean(group.get("email_alert_p")) %>
(<a href="admin-email-alert-policy-update?group_id=<%= group_id %>">Toggle</a>)
<p>

<li>Use the multi-role permission system: 
<%= Utilities.prettyBoolean(group.get("multi_role_p")) %>
(<a href="multi-role-p-toggle?group_id=<%= group_id %>">Toggle</a>)
<p>

<%
if ("f".equals(group.get("approved_p"))) {
%>

    <blockquote>
    <font color=red>this group is awaiting approval</font>
    (<a href="approved-p-toggle?group_id=<%= group_id %>">approve right now</a>)
    </blockquote>

<% 
}
%>

<li>Group name:  <%= group.getGroupName() %> (<a href="group-name-edit?group_id=<%= group_id %>">edit</a>)
<li>Group short name:  <%= group.getShortName() %> (<a href="group-shortname-edit?group_id=<%= group_id %>">edit</a>)
<li>Group type:  <a href="group-type?group_type=<%= group.get("group_type") %>"><%= group.get("group_type") %></a>
<li>Existence Public?  <a href="existence-public-p-toggle?group_id=<%= group_id%>"><%= Utilities.prettyBoolean (group.get("existence_public_p")) %></a>

<%
int i = 0;
if (supplemental_data != null) {
	String[] keys = supplemental_data.keys();
	for (i = 0; i < keys.length; i++) {
	    // print out supplemental column /data
	%> 
    <li><%= keys[i] %>: <%= supplemental_data.get(keys[i]) %>
<%
	}
%>
<p>
<li><a href="group-info-edit?group_id=<%= group_id %>">Edit</a>
<% 
} else { 
%>
<P><li>we have no supplemental information on this group
<% 
}
%>

<li><a href="/admin/users/action-choose?group_id=<%= group_id %>">Download or spam members</a>
</ul>

<h3>Modules associated with groups in <%= group.getGroupName() %></h3>
<ul>
<table>

<ad:loop ds="modules">
<% if (group_module_administration.equals("full")) { %>

	<tr>
	<td><ad:sub var="module_pretty_name" />
	<td>&nbsp;&nbsp;<a href="group-module-remove?group_id=<ad:sub var="group_id" />&module_key=<ad:sub var="module_key" />">remove</a>
	</tr>

<% } else { %>

	<tr><td><ad:sub var="module_pretty_name" /></tr>

<% } %>
</ad:loop>
<ad:loop_empty>
	<tr><td>no modules are associated with this group</tr>
</ad:loop_empty>

</table>
<p>

<% if (!modules_available.equals("0")) { %>

    <li><a href="group-module-add?group_id=<ad:sub var="group_id" />">add module</a>

<% } else { %>

    This group has <%= group_module_administration.equals("enabling") ? "only enabling/disabling" : "no" %>
    module administration privileges.
    Modules can be added to or removed from the group only on the group type level."

<% } %>

</ul>


<h3>Member Fields From Group Type</h3>

<ul>

<ad:loop ds="member_fields_from_group_type">
  <li><%= member_fields_from_group_type.getFieldName() %> (<%= member_fields_from_group_type.getFieldType() %>)
</ad:loop>
<p>
<p>

<li>go to the user group type page to <a href="group-type?group_type=<%= group.getGroupType() %>">edit</a>
</ul>

<h3>Member Fields From Group</h3>

<table border=0 width=80%>
<%
i = 0;
%>

<ad:loop ds="member_fields_from_group">
<%
    if (i + 1 == member_field_count.intValue()) { 
	// last one 
%>
  <tr><td><%= member_fields_from_group.getFieldName() %> (<%= member_fields_from_group.getFieldType() %>)<td><font size=-1 face="arial">[&nbsp;<a href="group-member-field-add?group_id=<%= group_id %>&after=<%= member_fields_from_group.getSortKey() %>">insert&nbsp;after</a>&nbsp;]</font>
<%
    } else {
%>
  <tr><td><%= member_fields_from_group.getFieldName() %> (<%= member_fields_from_group.getFieldType() %>)<td><font size=-1 face="arial">[&nbsp;<a href="group-member-field-add?group_id=<%= group_id %>&after=<%= member_fields_from_group.getSortKey() %>">insert&nbsp;after</a>&nbsp;|&nbsp;<a href="group-member-field-swap?group_id=<%= group_id %>&sort_key=<%= member_fields_from_group.getSortKey() %>">swap&nbsp;with&nbsp;next</a>&nbsp;]</font>
<%
    }
    i++;
%>
</ad:loop>
<ad:loop_empty>
  <tr><td>No group-type-specific member data currently collected.
  <p>
</ad:loop_empty>
</table>
  <ul>
  <li><a href=group-member-field-add?group_id=<%= group_id %>>add a field</a>
  </ul>

<% i = 0; %>
<ad:loop ds="pending_users">
<%
   if (i++ == 0) { 
%>
<h3>Users who have asked for membership</h3>
 <ul>
<% 
   }
%>
<li><a href="/admin/users/one?user_id=<%= pending_users.get("user_id") %>"><%= pending_users.get("name") %></a> - <%= pending_users.get("pretty_queue_date") %>
&nbsp;<A href="membership-grant?<%= Utilities.exportURLVars(pending_users, "user_id group_id") %>"><font color=red>(grant membership)</font></a> &nbsp; | &nbsp;  <A href="membership-refuse?<%= Utilities.exportURLVars(pending_users, "user_id group_id") %>"><font color=red>(refuse membership)</font></a>
</ad:loop>

<% 
if (i > 0) { 
%>
</ul>
<% } %>

<h3>Group Members</h3>
<ul>
<% String lastRole = ""; %>

<ad:loop ds="members">
<% 
String exportVars = Utilities.exportURLVars(members, "user_id group_id role");
String role = members.get("role");
if (!lastRole.equals(role)) {
	lastRole = role;
%>
        <h4>Role: <%= role %></h4>
<%
    } // if
%>
    <li><a href="/admin/users/one?user_id=<%= members.get("user_id") %>"><%= members.get("name") %></a> &nbsp; &nbsp | <a href="member-remove?<%= exportVars %>">remove</a>
</ad:loop>
<ad:loop_empty>
    no members found
</ad:loop_empty>

<p>
<li><a href="member-add?group_id=<%= group_id %>">add a member in a role</a>
</ul>

<h3>Extreme Actions</h3>

<blockquote>
<form method=GET action="group-delete">
<input type=hidden name=group_id value=<%= group_id %>>
<input type=submit value="Delete This Group">
</form>
</blockquote>

<ad:footer />