<%@ include file="../../../acs.jspi" %>

<ad:template_contract vars="group_admin_url:string group:datasource dont_spam_me_p:string admin_p:class=Boolean member_p:class=Boolean navbar user:class=UserInfo group_public_url dsAdmins:datasource dsSections:datasource" />

<ad:header>Main Page</ad:header>

<h2>Main Page</h2>

<%= navbar %>

<ad:scope sources="group">

<hr>

<% if (group.get("approved_p").equals("f")) { %>
    <blockquote>
    <font color=red>this group is awaiting approval by <%= Parameters.get("SystemOwner", "") %></font>
    </blockquote>

<% } else { %>

<% if (admin_p.booleanValue() && !Utilities.emptyString(group_admin_url)) { %>
<table align=right>
 <tr><td><a href="<%= group_admin_url %>/">Administration Page</a>
</table>
<% } %>

<blockquote><h4>Preferences</h4>

<%
if (user == null) {
    if (!group.get("new_member_policy").equals("closed")) { 
	// there is at least some possibility of a member joining
%>
If you want to join this group, you'll need to <a href="/register?return_url=<%= Utilities.URLEncode(group_public_url + "/member-add") %>">log in </a>.
<% 
  }
} else { // the user is logged in
    if (member_p.booleanValue()) {
	// is already a member
%>
You are a member of this group.  You can <a href="member-remove">remove yourself</a>.

<br>Email settings:
    <font size=-1>

    <%= new ChoiceBar
	(new String[] {"Receive Group Emails", "Don't Spam Me"},
	 new String[] {
	"edit-preference?dont_spam_me_p=f&return_url=" + group_public_url + "/index",
	"edit-preference?dont_spam_me_p=t&return_url=" + group_public_url + "/index",
	},
	new String[] {"f", "t"},
	dont_spam_me_p) %>
    </font>
<%
} else {
	if (group.get("new_member_policy").equals("open")) {
%>
		This group has an open enrollment policy.  You can simply
		<a href="member-add">sign up</a>.
<%	} else if (group.get("new_member_policy").equals("wait")) { %>
		The administrator approves users who wish to join this group.
		<a href="member-add">Submit your name for approval</a>.
<%	} else if (group.get("new_member_policy").equals("closed")) { %>
This group has closed membership policy. You cannot become a member of this group.
<% 	
	}
   }
}
%>

<h4>Sections</h4>

<ad:loop ds="dsSections">
<%     
String sectionKey = Utilities.URLEncode(dsSections.get("section_key"));
if (dsSections.get("section_type").equals("system")) { 
%>
    <a href="<%= sectionKey %>/"><ad:sub var="section_pretty_name" /></a><br>

<% } else { %>

    <a href="<%= sectionKey %>/?section_id=<ad:sub var="section_id" />"><ad:sub var="section_pretty_name" /></a><br>
    
<% } %>

</ad:loop>

<a href="spam-index">Send e-mail to this group</a><br>

<h4>Group Administrators</h4>

<ad:loop ds="dsAdmins">
<a href="/shared/community-member?user_id=<ad:sub var="admin_user_id"/>"><ad:sub var="name"/></a><br>
</ad:loop>
<ad:loop_empty>
<i>none</i>
</ad:loop_empty>

<p>
Created by <a href="/shared/community-member?user_id=<ad:sub var="creation_user"/>"><ad:sub var="first_names"/> <ad:sub var="last_name"/></a> on <ad:sub var="registration_date"/>
</blockquote>
<ad:footer/>

<% } %>

</ad:scope>



