<%@ include file="/acs.jspi" %>

<ad:page>
<ad:template_contract vars="user:class=UserInfo title navbar user_info:datasource portrait_info:datasource,optional content_sections:datasource admin_groups:datasource non_admin_groups:datasource categories:datasource system_name"/>

<ad:header><%= title %></ad:header>

<h2><%= title %></h2>
<%= navbar %>

<hr>

<ul>

<p>

<ad:loop ds="content_sections">
  <li><a href="<ad:sub var="section_url_stub"/>"><ad:sub var="section_pretty_name"/></a>
  <% if (!Utilities.emptyString(content_sections.get("intro_blurb"))) {  %> - <ad:sub var="intro_blurb"/> <% } %>
  <% if (!Utilities.emptyString(content_sections.get("help_blurb"))) {  %>
       <font size=-1><a href="content-help?<ad:export type="url" source="content_sections" vars ="section_id"/>">help</a></font>
  <% } %>
  <br>
</ad:loop>

<% 
String site_map = parameters.get("SiteMap", "content");
if (!Utilities.emptyString(site_map)) {
%>
   <p><li><a href="<%= site_map%>">site map</a>
<%
}
%>

<ad:string id="admin_str">
<ad:loop ds="admin_groups">
  <li><a href="<ad:sub var="ai_url"/>"><ad:sub var="group_name"/></a>
</ad:loop>
</ad:string>

<% if (!Utilities.emptyString(admin_str.trim())) { %>
<li>You have the following administrative roles for this site:
<ul>
<%= admin_str %>
</ul>
<p>
<% } %>

<ad:string id="group_str">
<ad:loop ds="non_admin_groups">
  <li><a href="<%= UserGroups.getUrl() %>/<ad:sub encode="true" var="short_name"/>"><ad:sub var="group_name"/></a>
</ad:loop>
</ad:string>

<% if (!Utilities.emptyString(group_str.trim())) { %>
<li>You're a member of the following groups:
<ul>
<%= group_str %>
</ul>
<p>
<% } %>

<% 
if (parameters.getBoolean("StaffServerP", "", false)) {
%>
    <p>
    
    <li><a href=/file-storage/>Documentation</a>

    <p>

    <li><a href=/ticket/>Project and bug tracking</a>

    <P>

    <li><a href=/bboard/>Discussion forums</a>

    <P>
<%
}
%>


<p>

<li><a href="/register/logout">Log Out</a>

<p>

<li><a href="password-update">Change my Password</a>

</ul>

<% 
if (parameters.getBoolean("HomepageEnabledP", "users", false)) {
%>
    <h3>Homepages</h3>
    <ul>
    <li><a href=/homepage/>Homepage Maintenance</a> - Maintain your personal homepage at <%= system_name %>
    <p>
    <li><a href=/homepage/neighborhoods>Neighborhoods</a> - Browse homepage neighborhoods at <%= system_name %>
    <p>
    <li><a href=/homepage/all>User Homepages</a> - List user homepages at <%= system_name %>
    </ul>
<%
}
%>

<h3>What we tell other users about you</h3>

In general we identify content that you've posted by your full name.
In an attempt to protect you from unsolicited bulk email (spam), we
keep your email address hidden except from other registered users.
Total privacy is technically feasible but an important element of an
online community is that people can learn from each other.  So we try
to make it possible for users with common interests to contact each
other.

<p>

If you want to check what other users of this service are shown, visit
<a href="/shared/community-member?user_id=<%= user.getUserId() %>"><%= parameters.get("URL", "") %>/shared/community-member?user_id=<%= user.getUserId() %></a>.

<h4>Basic Information</h4>

<ul>
<li>Name:  <%= user.getFullName() %>
<li>email address:  <%= user.getEmail() %>
<ad:scope sources="user_info">
<li>personal URL:  <a target=new_window href="<ad:sub var="url"/>"><ad:sub var="url"/></a>
<li>screen name:  <ad:sub var="screen_name"/>
<li>biography:  <ad:sub var="bio"/>
</ad:scope>
<p>
(<a href="basic-info-update">update</a>)
</ul>

<% 
if (parameters.getBoolean("SolicitPortraitP", "user-info", false)) {
%>

<h4>Your Portrait</h4>
<% if (portrait_info != null) { %>

     <ad:scope sources="portrait_info">
     On <ad:sub var="portrait_upload_date"/>, you uploaded <a href="portrait"><ad:sub var="portrait_client_file_name"/></a>.
     </ad:scope>
<% } else {%>
     Show everyone else at <%= system_name %> how great looking you are: <a href="portrait/upload">upload a portrait</a>
<% } %>
<%
}
%>

<ad:string id="cat_str">
<ad:loop ds="categories">
  <% if (categories.get("selected_p").equals("t")) { %>
  <input name=category_id type=checkbox value="<ad:sub var="category_id"/>" CHECKED> <ad:sub var="category"/><br>
  <% } else { %>
  <input name=category_id type=checkbox value="<ad:sub var="category_id"/>"> <ad:sub var="category"/><br>
  <% } %>
</ad:loop>
</ad:string>

<% if (!Utilities.emptyString(cat_str.trim())) { %>

<h3>Your Interests (According to Us)</h3>

<form method=POST action="interests-update">
<blockquote>
<br>
<%= cat_str %>
<br>
<input type=submit value="Update Interests">
</blockquote>
</form>

<% } %>


<h3>If you're getting too much email from us</h3>

Then you should either 

<ul>
<li><a href="alerts">edit your alerts</a>

<p>

or

<p>

<li><a href="unsubscribe">Unsubscribe</a> (for a period of vacation or permanently)

</ul>

<ad:footer />
</ad:page>

